	program HCOUP_IDM
        use SM_const
	use pv
	use Gauge_boson_2p
	use SM_Hdecay
	use HCOUP_SM
        implicit none
        double precision:: mhp,mhn,mu2
	double precision:: nh = 2.d0,ng = 3.d0,gs,gp,lqt = 1.d0/2.d0
	complex (kind(0d0)):: vhZZ(3),vhWW(3),vhtt(8),vhbb(8),vhcc(8),vhll(8),vhhh
	complex (kind(0d0)):: vhZZ_sm(3),vhWW_sm(3),vhtt_sm(8),vhbb_sm(8),vhcc_sm(8),vhll_sm(8),vhhh_sm
	double precision:: p_hzz(3),p_hww(3),p_htt(3),p_hbb(3),p_hcc(3),p_hll(3),p_hhh(3)

        include "inputs/in_idm.txt"
        include "inputs/in_momentum.txt"
        include "modules/header.txt"
        call ltini
       gs = sqrt(alpha_s*4.d0*pi)
       gp = g*sw/cw
       mhp = mch
       mhn = mbh
       mu2 = mu2sq
!############# Constraints ################    
        if (pu(mhp,mhn,ma,mu2,lam2) .ne. 0.d0) then 
           write(*,*) 'Excluded by Unitarity'
        endif
        if (stu(mhp,mhn,ma,mu2,lam2) .ne. 0.d0) then 
           write(*,*) 'Excluded by ST Parameter'
        endif
        if (vs_rge(cutoff,mhp,mhn,ma,mu2,lam2) .ne. 0.d0) then 
           write(*,*) 'Excluded by Vacuum Stability'
        endif
        if (triviality(cutoff,mhp,mhn,ma,mu2,lam2) .ne. 0.d0) then        
           write(*,*) 'Excluded by Triviality'        
        endif 
           
        if (pu(mhp,mhn,ma,mu2,lam2) .eq. 0.d0       .and. &
            stu(mhp,mhn,ma,mu2,lam2) .eq. 0.d0                        .and. &
            vs_rge(cutoff,mhp,mhn,ma,mu2,lam2) .eq. 0.d0 .and. &
            triviality(cutoff,mhp,mhn,ma,mu2,lam2) .eq. 0.d0 ) then 
           write(*,*) 'Allowed!'
           endif
!############# OUTPUS ################    
	open(10,file="outputs/out_sm.txt")
        vhZZ_sm(1) = rGam1_hZZ_sm(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2)
        vhZZ_sm(2) = rGam2_hZZ_sm(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2)
        vhZZ_sm(3) = rGam3_hZZ_sm(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2)
        vhWW_sm(1) = rGam1_hWW_sm(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2)
        vhWW_sm(2) = rGam2_hWW_sm(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2)
        vhWW_sm(3) = rGam3_hWW_sm(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2)
        vhtt_sm(1) = rGamS_htt_sm(p_htt(1)**2,p_htt(2)**2,p_htt(3)**2)
        vhbb_sm(1) = rGamS_hbb_sm(p_hbb(1)**2,p_hbb(2)**2,p_hbb(3)**2)
        vhcc_sm(1) = rGamS_hcc_sm(p_hcc(1)**2,p_hcc(2)**2,p_hcc(3)**2)
        vhll_sm(1) = rGamS_htautau_sm(p_hll(1)**2,p_hll(2)**2,p_hll(3)**2)
        vhhh_sm      = rGam_hhh_sm(p_hhh(1)**2,p_hhh(2)**2,p_hhh(3)**2)

        write(10,100) 'Re[rGam_hZZ(1)]:', dble(vhZZ_sm(1)),'Im[rGam_hZZ(1)]:', imag(vhZZ_sm(1))
        write(10,100) 'Re[rGam_hZZ(2)]:', dble(vhZZ_sm(2)),'Im[rGam_hZZ(2)]:', imag(vhZZ_sm(2))
        write(10,100) 'Re[rGam_hZZ(3)]:', dble(vhZZ_sm(3)),'Im[rGam_hZZ(3)]:', imag(vhZZ_sm(3))
        write(10,100) 'Re[rGam_hWW(1)]:', dble(vhWW_sm(1)),'Im[rGam_hWW(1)]:', imag(vhWW_sm(1))
        write(10,100) 'Re[rGam_hWW(2)]:', dble(vhWW_sm(2)),'Im[rGam_hWW(2)]:', imag(vhWW_sm(2))
        write(10,100) 'Re[rGam_hWW(3)]:', dble(vhWW_sm(3)),'Im[rGam_hWW(3)]:', imag(vhWW_sm(3))
        write(10,100) 'Re[rGam_htt(S)]:', dble(vhtt_sm(1)),'Im[rGam_htt(S)]:', imag(vhtt_sm(1))
        write(10,100) 'Re[rGam_hbb(S)]:', dble(vhbb_sm(1)),'Im[rGam_hbb(S)]:', imag(vhbb_sm(1))
        write(10,100) 'Re[rGam_hcc(S)]:', dble(vhcc_sm(1)),'Im[rGam_hcc(S)]:', imag(vhcc_sm(1))
        write(10,100) 'Re[rGam_hll(S)]:', dble(vhll_sm(1)),'Im[rGam_hll(S)]:', imag(vhll_sm(1))
        write(10,100) 'Re[rGam_hhh]:'   , dble(vhhh_sm),'Im[rGam_hhh]:', imag(vhhh_sm)
        write(10,200) 'Gam(h->gamgam):',hgamgam_sm(mh)
        write(10,200) 'Gam(h->Zgam):'  ,hZgam_sm(mh)
        write(10,200) 'Gam(h->gg):'    ,hgg_sm(mh)

	open(11,file="outputs/out_idm.txt")
        vhZZ(1) = rGam1_hZZ(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2,mhp,mhn,ma,mu2,lam2)
        vhZZ(2) = rGam2_hZZ(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2,mhp,mhn,ma,mu2,lam2)
        vhZZ(3) = rGam3_hZZ(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2,mhp,mhn,ma,mu2,lam2)
        vhWW(1) = rGam1_hWW(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2,mhp,mhn,ma,mu2,lam2)
        vhWW(2) = rGam2_hWW(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2,mhp,mhn,ma,mu2,lam2)
        vhWW(3) = rGam3_hWW(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2,mhp,mhn,ma,mu2,lam2)
        vhtt(1) = rGamS_htt(p_htt(1)**2,p_htt(2)**2,p_htt(3)**2,mhp,mhn,ma,mu2,lam2)
        vhbb(1) = rGamS_hbb(p_hbb(1)**2,p_hbb(2)**2,p_hbb(3)**2,mhp,mhn,ma,mu2,lam2)
        vhcc(1) = rGamS_hcc(p_hcc(1)**2,p_hcc(2)**2,p_hcc(3)**2,mhp,mhn,ma,mu2,lam2)
        vhll(1) = rGamS_htautau(p_hll(1)**2,p_hll(2)**2,p_hll(3)**2,mhp,mhn,ma,mu2,lam2)
        vhhh      = rGam_hhh(p_hhh(1)**2,p_hhh(2)**2,p_hhh(3)**2,mhp,mhn,ma,mu2,lam2)

        write(11,100) 'Re[rGam_hZZ(1)]:', dble(vhZZ(1)),'Im[rGam_hZZ(1)]:', imag(vhZZ(1))
        write(11,100) 'Re[rGam_hZZ(2)]:', dble(vhZZ(2)),'Im[rGam_hZZ(2)]:', imag(vhZZ(2))
        write(11,100) 'Re[rGam_hZZ(3)]:', dble(vhZZ(3)),'Im[rGam_hZZ(3)]:', imag(vhZZ(3))
        write(11,100) 'Re[rGam_hWW(1)]:', dble(vhWW(1)),'Im[rGam_hWW(1)]:', imag(vhWW(1))
        write(11,100) 'Re[rGam_hWW(2)]:', dble(vhWW(2)),'Im[rGam_hWW(2)]:', imag(vhWW(2))
        write(11,100) 'Re[rGam_hWW(3)]:', dble(vhWW(3)),'Im[rGam_hWW(3)]:', imag(vhWW(3))
        write(11,100) 'Re[rGam_htt(S)]:', dble(vhtt(1)),'Im[rGam_htt(S)]:', imag(vhtt(1))
        write(11,100) 'Re[rGam_hbb(S)]:', dble(vhbb(1)),'Im[rGam_hbb(S)]:', imag(vhbb(1))
        write(11,100) 'Re[rGam_hcc(S)]:', dble(vhcc(1)),'Im[rGam_hcc(S)]:', imag(vhcc(1))
        write(11,100) 'Re[rGam_hll(S)]:', dble(vhll(1)),'Im[rGam_hll(S)]:', imag(vhll(1))
        write(11,100) 'Re[rGam_hhh]:'   , dble(vhhh),'Im[rGam_hhh]:', imag(vhhh)
        write(11,200) 'Gam(h->gamgam):' ,dble(Gam_hgamgam(mhp,mhn,ma,mu2,lam2))
        write(11,200) 'Gam(h->Zgam):'   ,dble(Gam_hZgam(mhp,mhn,ma,mu2,lam2))
        write(11,200) 'Gam(h->gg):'     ,dble(hgg_sm(mh))
        
 100 Format(A20,1PE18.8,A20,1PE18.8)
 200 Format(A20,1PE18.8)

 	contains
!-===============  FUNCTIONS ============================
!========= physical parameters -> lambda1-lambda5 =======
        double precision function lam1(mhp,mhn,ma,mu2,lam2)
        double precision, intent(in):: mhp,mhn,ma,mu2,lam2

        lam1 = mh**2/vev**2

        end function
        double precision function lam3(mhp,mhn,ma,mu2,lam2)
        double precision, intent(in):: mhp,mhn,ma,mu2,lam2

        lam3 = 2.d0/vev**2*(mhp**2-mu2)

        end function

        double precision function lam4(mhp,mhn,ma,mu2,lam2)
        double precision, intent(in):: mhp,mhn,ma,mu2,lam2

        lam4 = 1.d0/vev**2*(mhn**2+ma**2-2.d0*mhp**2)

        end function

        double precision function lam5(mhp,mhn,ma,mu2,lam2)
        double precision, intent(in):: mhp,mhn,ma,mu2,lam2

        lam5 = 1.d0/vev**2*(mhn**2-ma**2)

        end function

!========================================
!    SECTION II Tree-level couplings    !
!========================================
!========================================================   
! SSS Couplings
!========================================================
        double precision function g_hp_hm_h(mhp,mhn,ma,mu2,lam2)
        double precision  mhp,mhn,ma,mu2,lam2
        g_hp_hm_h = -2.d0/vev*(mhp**2-mu2)

        end function
 !-------------------------------------------------------
        double precision function g_hn_hn_h(mhp,mhn,ma,mu2,lam2)
        double precision mhp,mhn,ma,mu2,lam2
        g_hn_hn_h = -1.d0/vev*(mhn**2-mu2)

        end function
!-------------------------------------------------------
        double precision function g_a_a_h(mhp,mhn,ma,mu2,lam2)
        double precision mhp,mhn,ma,mu2,lam2
        g_a_a_h = -1.d0/vev*(ma**2-mu2)

        end function
!-------------------------------------------------------
        double precision function g_gp_gm_h(mhp,mhn,ma,mu2,lam2)
        double precision mhp,mhn,ma,mu2,lam2
        g_gp_gm_h = -1.d0/vev*mh**2

        end function
!-------------------------------------------------------
        double precision function g_g0_g0_h(mhp,mhn,ma,mu2,lam2)
        double precision mhp,mhn,ma,mu2,lam2
        g_g0_g0_h = -1.d0/(2.d0*vev)*mh**2

        end function
!-------------------------------------------------------
        double precision function g_h_h_h(mhp,mhn,ma,mu2,lam2)
        double precision mhp,mhn,ma,mu2,lam2
        g_h_h_h = -1.d0/(2.d0*vev)*mh**2

        end function
!========================================================   
! SSSS Couplings
!========================================================                       
        double precision function g_hp_hm_h_h(mhp,mhn,ma,mu2,lam2)
        double precision mhp,mhn,ma,mu2,lam2
        g_hp_hm_h_h = -1.d0/vev**2*(mhp**2-mu2)

        end function
!-------------------------------------------------------
        double precision function g_hn_hn_h_h(mhp,mhn,ma,mu2,lam2)
        double precision mhp,mhn,ma,mu2,lam2
        g_hn_hn_h_h = -1.d0/2.d0/vev**2*(mhn**2-mu2)

        end function
!-------------------------------------------------------
        double precision function g_a_a_h_h(mhp,mhn,ma,mu2,lam2)
        double precision mhp,mhn,ma,mu2,lam2
        g_a_a_h_h = -1.d0/2.d0/vev**2*(ma**2-mu2)

        end function
!-------------------------------------------------------
        double precision function g_gp_gm_h_h(mhp,mhn,ma,mu2,lam2)
        double precision mhp,mhn,ma,mu2,lam2
        g_gp_gm_h_h = -mh**2/2.d0/vev**2

        end function
!-------------------------------------------------------
        double precision function g_g0_g0_h_h(mhp,mhn,ma,mu2,lam2)
        double precision mhp,mhn,ma,mu2,lam2
        g_g0_g0_h_h = -mh**2/4.d0/vev**2

        end function
!-------------------------------------------------------
        double precision function g_h_h_h_h(mhp,mhn,ma,mu2,lam2)
        double precision mhp,mhn,ma,mu2,lam2
        g_h_h_h_h = -mh**2/8.d0/vev**2

        end function
!---------------------------------------------
!======= Unitarity and Vacuum stability ===================
	double precision function a0ap(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

      a0ap=(3.d0/2.d0*(lam1(mhp,mhn,ma,mu2,lam2)&
	+lam2)+&
	dsqrt(9.d0/4.d0*(&
	lam1(mhp,mhn,ma,mu2,lam2)&
	-lam2&
	)**2+(2.d0*lam3(mhp,mhn,ma,mu2,lam2)&
	+lam4(mhp,mhn,ma,mu2,lam2)&
	)**2)&
	 )/(16.d0*pi)

	 end function 
!------------------------------------
	double precision function a0am(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

      a0am=&
	(3.d0/2.d0*(lam1(mhp,mhn,ma,mu2,lam2)&
	+lam2)-&
	dsqrt(9.d0/4.d0*(lam1(mhp,mhn,ma,mu2,lam2)&
	-lam2)**2&
	+(2.d0*lam3(mhp,mhn,ma,mu2,lam2)&
	+lam4(mhp,mhn,ma,mu2,lam2))**2)&
	)/(16.d0*pi)

	 end function
!------------------------------------
	double precision function a0bp(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

      a0bp=(1.d0/2.d0*(lam1(mhp,mhn,ma,mu2,lam2)&
	+lam2)+&
	dsqrt(1.d0/4.d0*(lam1(mhp,mhn,ma,mu2,lam2)&
	-lam2)**2&
	+lam4(mhp,mhn,ma,mu2,lam2)**2)&
	)/(16.d0*pi)

	 end function 
!------------------------------------
	double precision function a0bm(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

      a0bm=(1.d0/2.d0*(lam1(mhp,mhn,ma,mu2,lam2)&
	+lam2)-&
	dsqrt(1.d0/4.d0*(lam1(mhp,mhn,ma,mu2,lam2)&
	-lam2)**2&
	+lam4(mhp,mhn,ma,mu2,lam2)**2)&
	)/(16.d0*pi)

	 end function 
!------------------------------------
	double precision function a0cp(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

      a0cp=(1.d0/2.d0*(lam1(mhp,mhn,ma,mu2,lam2)&
	+lam2)+&
	dsqrt(1.d0/4.d0*(lam1(mhp,mhn,ma,mu2,lam2)&
	-lam2)**2&
	+lam5(mhp,mhn,ma,mu2,lam2)**2)&
	)/(16.d0*pi)

	 end function 
!------------------------------------
	double precision function a0cm(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

        a0cm=&
       (1.d0/2.d0*(lam1(mhp,mhn,ma,mu2,lam2)&
	+lam2)-&
	dsqrt(1.d0/4.d0*(lam1(mhp,mhn,ma,mu2,lam2)&
	-lam2)**2&
	+lam5(mhp,mhn,ma,mu2,lam2)**2)&
	)/(16.d0*pi)

	 end function 
!------------------------------------
	double precision function a0e1(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

      a0e1=(lam3(mhp,mhn,ma,mu2,lam2)&
	+2.d0*lam4(mhp,mhn,ma,mu2,lam2)&
	-3.d0*lam5(mhp,mhn,ma,mu2,lam2)&
	)/(16.d0*pi)

	 end function
!------------------------------------
	double precision function a0e2(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

      a0e2=(lam3(mhp,mhn,ma,mu2,lam2)&
	-lam5(mhp,mhn,ma,mu2,lam2))/(16.d0*pi)

	 end function
!------------------------------------
	double precision function a0fp(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

      a0fp=(lam3(mhp,mhn,ma,mu2,lam2)&
	 +2.d0*lam4(mhp,mhn,ma,mu2,lam2)&
	 +3.d0*lam5(mhp,mhn,ma,mu2,lam2)&
	)/(16.d0*pi)

	 end function
!------------------------------------
	double precision function a0fm(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

      a0fm=(lam3(mhp,mhn,ma,mu2,lam2)&
	+lam5(mhp,mhn,ma,mu2,lam2))/(16.d0*pi)

	 end function
!------------------------------------
	double precision function a0f1(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

      a0f1=(lam3(mhp,mhn,ma,mu2,lam2)&
	+lam4(mhp,mhn,ma,mu2,lam2))/(16.d0*pi)

	 end function
!------------------------------------
	double precision function a0p(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

      a0p=(lam3(mhp,mhn,ma,mu2,lam2)&
	-lam4(mhp,mhn,ma,mu2,lam2))/(16.d0*pi)

	 end function
!------------------------------------
	double precision function pu(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

      if (dabs(a0ap(mhp,mhn,ma,mu2,lam2))&
   .gt.lqt) then
	pu=1.d0 
      else if (dabs(a0am(mhp,mhn,ma,mu2,lam2))&
   .gt.lqt) then
	pu=2.d0 
      else if (dabs(a0bp(mhp,mhn,ma,mu2,lam2))&
   .gt.lqt) then
	pu=3.d0 
      else if (dabs(a0bm(mhp,mhn,ma,mu2,lam2))&
   .gt.lqt) then
	pu=4.d0 
      else if (dabs(a0cp(mhp,mhn,ma,mu2,lam2))&
   .gt.lqt) then
	pu=5.d0 
      else if (dabs(a0cm(mhp,mhn,ma,mu2,lam2))&
   .gt.lqt) then
	pu=6.d0 
      else if (dabs(a0e1(mhp,mhn,ma,mu2,lam2))&
   .gt.lqt) then
	pu=7.d0 
      else if (dabs(a0e2(mhp,mhn,ma,mu2,lam2))&
   .gt.lqt) then
	pu=8.d0 
      else if (dabs(a0fp(mhp,mhn,ma,mu2,lam2))&
   .gt.lqt) then
	pu=9.d0 
      else if (dabs(a0fm(mhp,mhn,ma,mu2,lam2))&
   .gt.lqt) then
	pu=10.d0 
      else if (dabs(a0f1(mhp,mhn,ma,mu2,lam2))&
   .gt.lqt) then
	pu=11.d0 
      else if (dabs(a0p(mhp,mhn,ma,mu2,lam2))&
   .gt.lqt) then
	pu=12.d0 
	else
	pu=0.d0
	end if

	 end function
!------------------------------------
	double precision function vs(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	double precision:: tmp1,tmp2,stab

      tmp1=lam4(mhp,mhn,ma,mu2,lam2)&
     +lam5(mhp,mhn,ma,mu2,lam2)
      tmp2=lam4(mhp,mhn,ma,mu2,lam2)&
     -lam5(mhp,mhn,ma,mu2,lam2)

      stab=dsqrt(lam1(mhp,mhn,ma,mu2,lam2)*&
           lam2)&
            +lam3(mhp,mhn,ma,mu2,lam2)&
            +dmin1(0.d0,tmp1,tmp2)     
	if (lam1(mhp,mhn,ma,mu2,lam2) .lt. 0.d0) then
	vs=1.d0  
      else if (lam2 .lt. 0.d0) then
	vs=2.d0  
      else if (stab .lt. 0.d0) then 
	vs=3.d0  
      else 
 	vs=0.d0
      end if    

	 end function vs
!====== Loop Functions ==========================================
!========================================================              
! 1PI Diagrams
!========================================================
        double complex function PiWW_B(qsq,mhp,mhn,ma,mu2,lam2)
        double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2
        PiWW_B = PiWW_B_SM(qsq) &
         +1.d0/(16.d0*pi**2)*g**2/4.d0*(b5f(qsq,mhn,mhp)+b5f(qsq,ma,mhp))

        end function
!-------------------------------------------------------
        double complex function PiZZ_B(qsq,mhp,mhn,ma,mu2,lam2)
        double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2

        PiZZ_B = PiZZ_B_SM(qsq)&
               +1.d0/16.d0/pi**2*mz**2*(1.d0-4.d0*sw**2*cw**2)/vev**2&   
                              *b5f(qsq,mhp,mhp)&   
               +1.d0/16.d0/pi**2*mz**2/vev**2*b5f(qsq,mhn,ma)

       end function
!-------------------------------------------------------
        double complex function PiGG_B(qsq,mhp,mhn,ma,mu2,lam2)
        double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2
        PiGG_B = PiGG_B_WOH(qsq)&
              +1.d0/16.d0/pi**2*(g*sw)**2*b5f(qsq,mhp,mhp)   

        end function
!-------------------------------------------------------
        double complex function PiZG_B(qsq,mhp,mhn,ma,mu2,lam2)
        double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2
        PiZG_B = PiZG_B_WOH(qsq)&
               +1.d0/16.d0/pi**2*(g*sw)*(g/cw)/2.d0*(cw**2-sw**2)*b5f(qsq,mhp,mhp)   

        end function
!-------------------------------------------------------
        double complex function dPiGG_B(qsq,mhp,mhn,ma,mu2,lam2)
        double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2
        dPiGG_B =dPiGG_B_WOH(qsq)&
               +1.d0/16.d0/pi**2*(g*sw)**2*db5f(qsq,mhp,mhp)   

        end function
!====== Fermion two-point functions ========
	double complex function Pitt_S(qsq,mh)
	double precision, intent(in):: mh,qsq

	Pitt_S= -1.d0/(16.d0*pi**2)*(&
	2.d0*(g*sw)**2*Qt**2*(2.d0*b0f(qsq,mt,mphoton)-1.d0)&
	+2.d0*gz**2*(vt**2-at**2)*(2.d0*b0f(qsq,mt,mZ)-1.d0)&
	+mt**2/vev**2*(b0f(qsq,mt,mz)-b0f(qsq,mt,mh)&
	+2.d0*mb**2/mt**2*b0f(qsq,mb,mw)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	double complex function Picc_S(qsq,mh)
	double precision, intent(in):: mh,qsq

	Picc_S= -1.d0/(16.d0*pi**2)*(&
	2.d0*(g*sw)**2*Qt**2*(2.d0*b0f(qsq,mc,mphoton)-1.d0)&
	+2.d0*gz**2*(vt**2-at**2)*(2.d0*b0f(qsq,mc,mZ)-1.d0)&
	+mc**2/vev**2*(b0f(qsq,mc,mz)-b0f(qsq,mc,mh)&
	+2.d0*ms**2/mc**2*b0f(qsq,ms,mw)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	double complex function Pibb_S(qsq,mh)
	double precision, intent(in):: mh,qsq

	Pibb_S= -1.d0/(16.d0*pi**2)*(&
	2.d0*(g*sw)**2*Qb**2*(2.d0*b0f(qsq,mb,mphoton)-1.d0)&
	+2.d0*gz**2*(vb**2-ab**2)*(2.d0*b0f(qsq,mb,mZ)-1.d0)&
	+mb**2/vev**2*(b0f(qsq,mb,mz)-b0f(qsq,mb,mh)+2.d0*mt**2/mb**2*b0f(qsq,mt,mw))&
	)

	
	 end function
!---------------------------------------------
	double complex function Pitautau_S(qsq,mh)
	double precision, intent(in):: mh,qsq


	Pitautau_S= -1.d0/(16.d0*pi**2)*(&
	2.d0*(g*sw)**2*Qe**2*(2.d0*b0f(qsq,mtau,mphoton)-1.d0)&
	+2.d0*gz**2*(ve**2-ae**2)*(2.d0*b0f(qsq,mtau,mZ)-1.d0)&
	+mtau**2/vev**2*(b0f(qsq,mtau,mz)-b0f(qsq,mtau,mh)   )&
	)
	
	 end function
!---------------------------------------------
	double complex function Pitt_V(qsq,mh)
	double precision, intent(in):: mh,qsq

	Pitt_V= -1.d0/(16.d0*pi**2)*(&
	(g*sw)**2*Qt**2*(2.d0*b1f(qsq,mt,mphoton)+1.d0)&
	+gz**2*(vt**2+at**2)*(2.d0*b1f(qsq,mt,mZ)+1.d0)&
	+g**2/4.d0*(2.d0*b1f(qsq,mb,mW)+1.d0)&
	+mt**2/vev**2*(b1f(qsq,mt,mh)+b1f(qsq,mt,mz)&
	+(mb**2+mt**2)/mt**2*b1f(qsq,mb,mw)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	double complex function Picc_V(qsq,mh)
	double precision, intent(in):: mh,qsq

	Picc_V= -1.d0/(16.d0*pi**2)*(&
	(g*sw)**2*Qt**2*(2.d0*b1f(qsq,mc,mphoton)+1.d0)&
	+gz**2*(vt**2+at**2)*(2.d0*b1f(qsq,mc,mZ)+1.d0)&
	+g**2/4.d0*(2.d0*b1f(qsq,ms,mW)+1.d0)&
	+mc**2/vev**2*(b1f(qsq,mc,mh)+b1f(qsq,mc,mz)&
	+(ms**2+mc**2)/mc**2*b1f(qsq,ms,mw)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	double complex function Pibb_V(qsq,mh)
	double precision, intent(in):: mh,qsq

	Pibb_V= -1.d0/(16.d0*pi**2)*(&
	(g*sw)**2*Qb**2*(2.d0*b1f(qsq,mb,mphoton)+1.d0)&
	+gz**2*(vb**2+ab**2)*(2.d0*b1f(qsq,mb,mZ)+1.d0)&
	+g**2/4.d0*(2.d0*b1f(qsq,mt,mW)+1.d0)&
	+mb**2/vev**2*( b1f(qsq,mb,mh)+b1f(qsq,mb,mz)+(mb**2+mt**2)/mb**2*b1f(qsq,mt,mw) )&	
	)
	
	 end function
!---------------------------------------------
	double complex function Pitautau_V(qsq,mh)
	double precision, intent(in):: mh,qsq

	Pitautau_V= -1.d0/(16.d0*pi**2)*(&
	(g*sw)**2*Qe**2*(2.d0*b1f(qsq,mtau,mphoton)+1.d0)&
	+gz**2*(ve**2+ae**2)*(2.d0*b1f(qsq,mtau,mZ)+1.d0)&
	+g**2/4.d0*(2.d0*b1f(qsq,m0,mW)+1.d0)&
	+mtau**2/vev**2*(b1f(qsq,mtau,mh)+b1f(qsq,mtau,mz)+b1f(qsq,m0,mw) )&	        
	)
	
	 end function
!---------------------------------------------
	double complex function Pitt_A(qsq,mh)
	double precision, intent(in):: mh,qsq


	Pitt_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*vt*at*(2.d0*b1f(qsq,mt,mZ)+1.d0)&
	-g**2/4.d0*(2.d0*b1f(qsq,mb,mW)+1.d0)&
	+(mt**2-mb**2)/vev**2*b1f(qsq,mb,mw)&	
	)
	
	 end function
!---------------------------------------------
	double complex function Picc_A(qsq,mh)
	double precision, intent(in):: mh,qsq

	Picc_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*vt*at*(2.d0*b1f(qsq,mc,mZ)+1.d0)&
	-g**2/4.d0*(2.d0*b1f(qsq,ms,mW)+1.d0)&
	+(mc**2-ms**2)/vev**2*b1f(qsq,ms,mw)&	
	)
	
	 end function
!---------------------------------------------
	double complex function Pibb_A(qsq,mh)
	double precision, intent(in):: mh,qsq

	Pibb_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*vb*ab*(2.d0*b1f(qsq,mb,mZ)+1.d0)&
	-g**2/4.d0*(2.d0*b1f(qsq,mt,mW)+1.d0)&
	+(mb**2-mt**2)/vev**2*b1f(qsq,mt,mw)&	
	)
	
	 end function
!---------------------------------------------
	double complex function Pitautau_A(qsq,mh)
	double precision, intent(in):: mh,qsq

	Pitautau_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*ve*ae*(2.d0*b1f(qsq,mtau,mZ)+1.d0)&
	-g**2/4.d0*(2.d0*b1f(qsq,m0,mW)+1.d0)&
	+mtau**2/vev**2*b1f(qsq,m0,mW)&	
	)
	
	 end function
!===================================================
	double complex function dPitt_S(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPitt_S= -1.d0/(16.d0*pi**2)*(&
	2.d0*(g*sw)**2*Qt**2*(2.d0*db0f(qsq,mt,mphoton))&
	+2.d0*gz**2*(vt**2-at**2)*(2.d0*db0f(qsq,mt,mZ))&
	+mt**2/vev**2*(db0f(qsq,mt,mz)-db0f(qsq,mt,mh)&
	+2.d0*mb**2/mt**2*db0f(qsq,mb,mw)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	double complex function dPicc_S(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPicc_S= -1.d0/(16.d0*pi**2)*(&
	2.d0*(g*sw)**2*Qt**2*(2.d0*db0f(qsq,mc,mphoton))&
	+2.d0*gz**2*(vt**2-at**2)*(2.d0*db0f(qsq,mc,mZ))&
	+mc**2/vev**2*(db0f(qsq,mc,mz)-db0f(qsq,mc,mh)&
	+2.d0*ms**2/mc**2*db0f(qsq,ms,mw)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	double complex function dPibb_S(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPibb_S= -1.d0/(16.d0*pi**2)*(&
	2.d0*(g*sw)**2*Qb**2*(2.d0*db0f(qsq,mb,mphoton))&
	+2.d0*gz**2*(vb**2-ab**2)*(2.d0*db0f(qsq,mb,mZ))&
	+mb**2/vev**2*(db0f(qsq,mb,mz)-db0f(qsq,mb,mh)&
	+2.d0*mt**2/mb**2*db0f(qsq,mt,mw)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	double complex function dPitautau_S(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPitautau_S= -1.d0/(16.d0*pi**2)*(&
	2.d0*(g*sw)**2*Qe**2*(&
        2.d0*db0f(qsq,mtau,mphoton))&
	+2.d0*gz**2*(ve**2-ae**2)*(2.d0*db0f(qsq,mtau,mZ))&
	+mtau**2/vev**2*(db0f(qsq,mtau,mz)-db0f(qsq,mtau,mh)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	double complex function dPitt_V(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPitt_V= -1.d0/(16.d0*pi**2)*(&
	(g*sw)**2*Qt**2*(2.d0*db1f(qsq,mt,mphoton))&
	+gz**2*(vt**2+at**2)*(2.d0*db1f(qsq,mt,mZ))&
	+g**2/4.d0*(2.d0*db1f(qsq,mb,mW))&
	+mt**2/vev**2*(db1f(qsq,mt,mh)+db1f(qsq,mt,mz)&
	+(mb**2+mt**2)/mt**2*db1f(qsq,mb,mw)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	double complex function dPicc_V(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPicc_V= -1.d0/(16.d0*pi**2)*(&
	(g*sw)**2*Qt**2*(2.d0*db1f(qsq,mc,mphoton))&
	+gz**2*(vt**2+at**2)*(2.d0*db1f(qsq,mc,mZ))&
	+g**2/4.d0*(2.d0*db1f(qsq,ms,mW))&
	+mc**2/vev**2*(db1f(qsq,mc,mh)+db1f(qsq,mc,mz)&
	+(ms**2+mc**2)/mc**2*db1f(qsq,ms,mw)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	double complex function dPibb_V(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPibb_V= -1.d0/(16.d0*pi**2)*(&
	(g*sw)**2*Qb**2*(2.d0*db1f(qsq,mb,mphoton))&
	+gz**2*(vb**2+ab**2)*(2.d0*db1f(qsq,mb,mZ))&
	+g**2/4.d0*(2.d0*db1f(qsq,mt,mW))&
	+mb**2/vev**2*(db1f(qsq,mb,mh)+db1f(qsq,mb,mz)&
	+(mb**2+mt**2)/mb**2*db1f(qsq,mt,mw)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	double complex function dPitautau_V(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPitautau_V= -1.d0/(16.d0*pi**2)*(&
	(g*sw)**2*Qe**2*(2.d0*db1f(qsq,mtau,mphoton))&
	+gz**2*(ve**2+ae**2)*(2.d0*db1f(qsq,mtau,mZ))&
	+g**2/4.d0*(2.d0*db1f(qsq,m0,mW))&
	+mtau**2/vev**2*( db1f(qsq,mtau,mh)+db1f(qsq,mtau,mz)&
	+db1f(qsq,m0,mw)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	double complex function dPitt_A(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPitt_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*vt*at*(2.d0*db1f(qsq,mt,mZ))&
	-g**2/4.d0*(2.d0*db1f(qsq,mb,mW))&
	+(mt**2-mb**2)/vev**2*db1f(qsq,mb,mw)&	
	)
	
	 end function
!---------------------------------------------
	double complex function dPicc_A(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPicc_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*vt*at*(2.d0*db1f(qsq,mc,mZ))&
	-g**2/4.d0*(2.d0*db1f(qsq,ms,mW))&
	+(mc**2-ms**2)/vev**2*db1f(qsq,ms,mw)&	
	)
	
	 end function
!---------------------------------------------
	double complex function dPibb_A(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPibb_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*vb*ab*(2.d0*db1f(qsq,mb,mZ))&
	-g**2/4.d0*(2.d0*db1f(qsq,mt,mW))&
	+(mb**2-mt**2)/vev**2*db1f(qsq,mt,mw)&	
	)
	
	 end function
!---------------------------------------------
	double complex function dPitautau_A(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPitautau_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*ve*ae*(2.d0*db1f(qsq,mtau,mZ))&
	-g**2/4.d0*(2.d0*db1f(qsq,m0,mW))&
	+mtau**2/vev**2*db1f(qsq,m0,mw)&	
	)
	
	 end function
!-------- Scalar boson 1 and 2 point functions ----------- 
        double complex function Th_F(mh)
        double precision, intent(in):: mh

        Th_F= -4.d0*mt**2*3.d0/(16.d0*pi**2)*&
               1.d0/vev*a0f(mt)&
!
               -4.d0*mc**2*3.d0/(16.d0*pi**2)*&
               1.d0/vev*a0f(mc)&
!
              -4.d0*mb**2*3.d0/(16.d0*pi**2)*&
               1.d0/vev*a0f(mb)&
!
              -4.d0*mtau**2/(16.d0*pi**2)*&
               1.d0/vev*a0f(mtau)
!
         end function
!---------------------------------------------
        double complex function Th_B(mhp,mhn,ma,mu2,lam2)
        double precision, intent(in):: mhp,mhn,ma,mu2,lam2

        Th_B=  1.d0/(16.d0*pi**2)*&
               (&
                -3.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*a0f(mh)&
                -g_Gp_Gm_h(mhp,mhn,ma,mu2,lam2)*a0f(mw)&
                -g_g0_g0_h(mhp,mhn,ma,mu2,lam2)*a0f(mz)&
                +3.d0*g*mw*a0f(mw)+3.d0/2.d0*gz*mz*a0f(mz)-2.d0*g*mw**3-gz*mz**3&
                ) &
! !! contributions of new particles
              +1.d0/(16.d0*pi**2)*&
              (&
               -g_hp_hm_h(mhp,mhn,ma,mu2,lam2)*a0f(mhp)&
               -g_a_a_h(mhp,mhn,ma,mu2,lam2)*a0f(ma)&
               -g_hn_hn_h(mhp,mhn,ma,mu2,lam2)*a0f(mhn)&
              )
          end function
!---------------------------------------------
	double complex function Pihh_F(qsq,mh)
	double precision, intent(in):: qsq,mh

	Pihh_F=&
	 -4.d0*mt**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mt)&
	 +(2.d0*mt**2-qsq/2.d0)*b0f(qsq,mt,mt)&
	 )&
!
	 -4.d0*mc**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mc)&
	 +(2.d0*mc**2-qsq/2.d0)*b0f(qsq,mc,mc)&
	 )&
!
	 -4.d0*mb**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mb)&
	 +(2.d0*mb**2-qsq/2.d0)*b0f(qsq,mb,mb)&
	 )&
!
	 -4.d0*mtau**2/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mtau)&
	 +(2.d0*mtau**2-qsq/2.d0)*b0f(qsq,mtau,mtau)&
	 )
	
	 end function
!---------------------------------------------
	double complex function Pihh_B(qsq,mhp,mhn,ma,mu2,lam2)
        double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2

	Pihh_B=&
	 1.d0/(16.d0*pi**2)*&
	(&
	  g**2*(3.d0*mw**2-qsq)*b0f(qsq,mW,mW)&
	  +g**2/2.d0*(3.d0)*a0f(mW)&
	  +gz**2/2.d0*(3.d0*mz**2-qsq)*b0f(qsq,mZ,mZ)&
	  +gz**2/4.d0*(3.d0)*a0f(mZ)&
	  -(+3.d0/2.d0)*(2.d0*g**2*mW**2+gz**2*mZ**2)&
	)&
!
	+1.d0/(16.d0*pi**2)*&
	( -12.d0*g_h_h_h_h(mhp,mhn,ma,mu2,lam2)*a0f(mh)&
	  -2.d0*g_gp_gm_h_h(mhp,mhn,ma,mu2,lam2)*a0f(mw)&
          -2.d0*g_g0_g0_h_h(mhp,mhn,ma,mu2,lam2)*a0f(mz)&
	  +g_gp_gm_h(mhp,mhn,ma,mu2,lam2)**2*b0f(qsq,mw,mw)&
	  +2.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2)**2*b0f(qsq,mz,mz)&
          +18.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)**2*b0f(qsq,mh,mh)&
	 	) &
! ! ! contributions of new particles
        +1.d0/(16.d0*pi**2)*(&
          +2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)**2*b0f(qsq,mhn,mhn)&
          +g_hp_hm_h(mhp,mhn,ma,mu2,lam2)**2*b0f(qsq,mhp,mhp)&
          +2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)**2*b0f(qsq,ma,ma)&
          -2.d0*g_hn_hn_h_h(mhp,mhn,ma,mu2,lam2)*a0f(mhn)&
          -2.d0*g_a_a_h_h(mhp,mhn,ma,mu2,lam2)*a0f(ma)&
          -2.d0*g_hp_hm_h_h(mhp,mhn,ma,mu2,lam2)*a0f(mhp)&
         )
	 end function
!===========================================
	double complex function dPihh_F(qsq,mh)
	double precision, intent(in):: qsq,mh

	dPihh_F=&
	 -4.d0*mt**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	 +(2.d0*mt**2-qsq/2.d0)*db0f(qsq,mt,mt)&
	 +(-1.d0/2.d0)*b0f(qsq,mt,mt)&
	 )&	
!
	 -4.d0*mc**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	 +(2.d0*mc**2-qsq/2.d0)*db0f(qsq,mc,mc)&
	 +(-1.d0/2.d0)*b0f(qsq,mc,mc)&
	 )&	
!
 	 -4.d0*mb**2*3.d0/(16.d0*pi**2*vev**2)*&
 	(&
 	 +(2.d0*mb**2-qsq/2.d0)*db0f(qsq,mb,mb)&
 	 +(-1.d0/2.d0)*b0f(qsq,mb,mb)&
 	 )&
!
	 -4.d0*mtau**2*1.d0/(16.d0*pi**2*vev**2)*&
	(&
	 +(2.d0*mtau**2-qsq/2.d0)*db0f(qsq,mtau,mtau)&
	 +(-1.d0/2.d0)*b0f(qsq,mtau,mtau)&
	 )
	
	 end function
!---------------------------------------------
	double complex function dPihh_B(qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2

	dPihh_B=&
	 1.d0/(16.d0*pi**2)*&
	(&
	  g**2*(3.d0*mw**2-qsq)*db0f(qsq,mW,mW)&
	  +g**2*(-1.d0)*b0f(qsq,mW,mW)&
	  +gz**2/2.d0*(3.d0*mz**2-qsq)*db0f(qsq,mZ,mZ)&
	  +gz**2/2.d0*(-1.d0)*b0f(qsq,mZ,mZ)&
	) &

	+1.d0/(16.d0*pi**2)*&
	(&
	 +g_gp_gm_h(mhp,mhn,ma,mu2,lam2)**2*db0f(qsq,mw,mw)&
	 +2.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2)**2*db0f(qsq,mz,mz)&
	 +18.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)**2*db0f(qsq,mh,mh)&
	) &
! ! additional Higgs boson loop
        +1.d0/16.d0/pi**2*(&
          +2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)**2*db0f(qsq,mhn,mhn)&
          +g_hp_hm_h(mhp,mhn,ma,mu2,lam2)**2*db0f(qsq,mhp,mhp)&
          +2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)**2*db0f(qsq,ma,ma)&
         )
	
	 end function
!========== Three point functions =========================
	double complex function M1_hZZ_F(p1sq,p2sq,qsq)
	double precision, intent(in):: p1sq,p2sq,qsq

	M1_hZZ_F = Gam1_hZZ_F_SM(p1sq,p2sq,qsq)
	
	 end function
!--------------------------------------------
	double complex function M2_hZZ_F(p1sq,p2sq,qsq)
	double precision, intent(in):: p1sq,p2sq,qsq

	M2_hZZ_F =  Gam2_hZZ_F_SM(p1sq,p2sq,qsq)
	
	 end function
!--------------------------------------------
	double complex function M3_hZZ_F(p1sq,p2sq,qsq)
	double precision, intent(in):: p1sq,p2sq,qsq

	M3_hZZ_F = Gam3_hZZ_F_SM(p1sq,p2sq,qsq)

	 end function
!--------------------------------------------
	double complex function M1_hZZ_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2
	double precision:: p12
	p12=(qsq-p1sq-p2sq)/2.d0

	M1_hZZ_B = &
	 -gz**2*1.d0/(16.d0*pi**2)*&
	 (&
	 +2.d0*g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*(cw**2-sw**2)**2*c24f(p1sq,p2sq,qsq,mw,mw,mw)&
	 +2.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2)*c24f(p1sq,p2sq,qsq,mz,mh,mz)&
	 +6.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*c24f(p1sq,p2sq,qsq,mh,mz,mh)&
	 )&

	 +gz**2*1.d0/(16.d0*pi**2)*&
	 (&
	 +1.d0/2.d0*g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*(cw**2-sw**2)**2*b0f(qsq,mw,mw)&
	 +1.d0/2.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2)*b0f(qsq,mz,mz)&
	 +3.d0/2.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*b0f(qsq,mh,mh)&
	 )&
!~~~~~~~~~~~ Gauge Boson Loops ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
 	+1.d0/(16.d0*pi**2)*(&
 	 +2.d0*g**3*mw*cw**2*ChVV1_VVV(p1sq,p2sq,qsq,mW,mW,mW)&
 	 +g**3*mw*sw**2*ChVV1_SVV(p1sq,p2sq,qsq,mw,mW,mW)& 
 	 +g**3*mw*sw**2*ChVV1_VVS(p1sq,p2sq,qsq,mW,mW,mw)&	 
 	 -2.d0*g**3*mw**3/cw**2*sw**4*c0f(p1sq,p2sq,qsq,mW,mw,mW)&
 	 -2.d0*g**3*cw**2*mw*c24f(p1sq,p2sq,qsq,mw,mw,mw)&
 	 -g*gz**2*mw*(cw**2-sw**2)*sw**2*&
 	 ( c24f(p1sq,p2sq,qsq,mW,mw,mw)+c24f(p1sq,p2sq,qsq,mw,mw,mW) )&
 	 +2.d0*gz**2*g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*mw**2*sw**4*c0f(p1sq,p2sq,qsq,mw,mW,mw)&
 	 -6.d0*g**3*cw**2*mw*b0f(qsq,mW,mW)+4.d0*g**3*cw**2*mw&
 	 -g*gz**2*mw*sw**4*( b0f(p2sq,mW,mw)+b0f(p1sq,mw,mW) )&
! !
 	 +gz**3/2.d0*mz*( c24f(p1sq,p2sq,qsq,mZ,mh,mz)+c24f(p1sq,p2sq,qsq,mz,mh,mZ) )&
 	 -gz**3*mz**3*c0f(p1sq,p2sq,qsq,mZ,mh,mZ)&
 	 +6.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*gz**2*mz**2*c0f(p1sq,p2sq,qsq,mh,mZ,mh)&
 	 -1.d0/2.d0*gz**3*mz*( b0f(p1sq,mh,mZ)+b0f(p2sq,mh,mZ))&
 	 ) &
! additional Higgs boson loop
        +1.d0/16.d0/pi**2*mz**2/vev**2*(&
           2.d0*(cw**2-sw**2)**2*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)*b0f(qsq,mhp,mhp)&
           +2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)*b0f(qsq,ma,ma)&
           +2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)*b0f(qsq,mhn,mhn)&
           -8.d0*(cw**2-sw**2)**2*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)*c24f(p1sq,p2sq,qsq,mhp,mhp,mhp)&
           -8.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)*c24f(p1sq,p2sq,qsq,ma,mhn,ma)&
           -8.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)*c24f(p1sq,p2sq,qsq,mhn,ma,mhn)&
         )
 
	 end function
!--------------------------------------------
	double complex function M2_hZZ_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2
	double precision:: p12
	p12=(qsq-p1sq-p2sq)/2.d0

	M2_hZZ_B =  gz**2/(16.d0*pi**2)*mz**2*(&
                     +2.d0*g*mw*cw**4*(ChVV2_VVV(p1sq,p2sq,qsq,mW,mW,mW) - C1223(p1sq,p2sq,qsq,mw,mw,mw)) &
!
                     +g*mw*sw**2*cw**2*ChVV2_SVV(p1sq,p2sq,qsq,mw,mW,mW)&
                     +g*mw*sw**2*cw**2*ChVV2_VVS(p1sq,p2sq,qsq,mW,mW,mw)&
!
                     -g*mw*(cw**2-sw**2)*sw**2*ChVV2_VSS(p1sq,p2sq,qsq,mW,mw,mw)&
                     -g*mw*(cw**2-sw**2)*sw**2*ChVV2_SSV(p1sq,p2sq,qsq,mw,mw,mW)&
                     +gz/2.d0*mz*ChVV2_VSS(p1sq,p2sq,qsq,mZ,mh,mz)&
                     +gz/2.d0*mz*ChVV2_SSV(p1sq,p2sq,qsq,mz,mh,mZ)&
                ! 
                    -2.d0*g_Gp_Gm_h(mhp,mhn,ma,mu2,lam2)*(cw**2-sw**2)**2*c1223(p1sq,p2sq,qsq,mw,mw,mw)&  
                    -2.d0*g_G0_G0_h(mhp,mhn,ma,mu2,lam2)*c1223(p1sq,p2sq,qsq,mz,mh,mz)&
                    -2.d0*g_Hp_Hm_h(mhp,mhn,ma,mu2,lam2)*(cw**2-sw**2)**2*c1223(p1sq,p2sq,qsq,mhp,mhp,mhp)&
                    -2.d0*g_A_A_h(mhp,mhn,ma,mu2,lam2)*c1223(p1sq,p2sq,qsq,mA,mhn,mA)&
                    -6.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*c1223(p1sq,p2sq,qsq,mh,mz,mh)&
                    -2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)*c1223(p1sq,p2sq,qsq,mhn,mA,mhn)&
                                     )

	 end function
!--------------------------------------------
	double complex function M1_hWW_F(p1sq,p2sq,qsq)
	double precision, intent(in):: p1sq,p2sq,qsq

	M1_hWW_F =&
	 4.d0*mw**2*mt**2*3.d0/vev**3/&
	 (16.d0*pi**2)*&
	 (&
	 1.d0/2.d0*b0f(p2sq,mt,mb)+b0f(qsq,mt,mt)&
	 +1.d0/2.d0*b0f(p1sq,mt,mb)&
	 -4.d0*c24f(p1sq,p2sq,qsq,mt,mb,mt)&
	 +(mt**2+mb**2-p1sq/2.d0-p2sq/2.d0)*c0f(p1sq,p2sq,qsq,mt,mb,mt)&
	 )&
!
	 +4.d0*mw**2*mb**2*3.d0/vev**3/&
	 (16.d0*pi**2)*&
	 (&
	 1.d0/2.d0*b0f(p2sq,mb,mt)+b0f(qsq,mb,mb)&
	 +1.d0/2.d0*b0f(p1sq,mt,mb)&
	 -4.d0*c24f(p1sq,p2sq,qsq,mb,mt,mb)&
	 +(mt**2+mb**2-p1sq/2.d0-p2sq/2.d0)*&
	  c0f(p1sq,p2sq,qsq,mb,mt,mb)&
	 )&
!
	 +4.d0*mw**2*mc**2*3.d0/vev**3/&
	 (16.d0*pi**2)*&
	 (&
	 1.d0/2.d0*b0f(p2sq,mc,ms)+b0f(qsq,mc,mc)&
	 +1.d0/2.d0*b0f(p1sq,mc,ms)&
	 -4.d0*c24f(p1sq,p2sq,qsq,mc,ms,mc)&
	 +(mc**2+ms**2-p1sq/2.d0-p2sq/2.d0)*c0f(p1sq,p2sq,qsq,mc,ms,mc)&
	 )&
!
	 +4.d0*mw**2*ms**2*3.d0/vev**3/&
	 (16.d0*pi**2)*&
	 (&
	 1.d0/2.d0*b0f(p2sq,ms,mc)+b0f(qsq,ms,ms)&
	 +1.d0/2.d0*b0f(p1sq,mc,ms)&
	 -4.d0*c24f(p1sq,p2sq,qsq,ms,mc,ms)&
	 +(mc**2+ms**2-p1sq/2.d0-p2sq/2.d0)*&
	  c0f(p1sq,p2sq,qsq,ms,mc,ms)&
	 )&
!
	 +4.d0*mw**2*mtau**2/vev**3/&
	 (16.d0*pi**2)*&
	 (&
	 1.d0/2.d0*b0f(p2sq,mtau,m0)+b0f(qsq,mtau,mtau)&
	 +1.d0/2.d0*b0f(p1sq,m0,mtau)&
	 -4.d0*c24f(p1sq,p2sq,qsq,mtau,m0,mtau)&
	 +(m0**2+mtau**2-p1sq/2.d0-p2sq/2.d0)*&
	  c0f(p1sq,p2sq,qsq,mtau,m0,mtau)&
	 )

	 end function
!--------------------------------------------
	double complex function M1_hWW_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2
	double precision:: p12
	p12=(qsq-p1sq-p2sq)/2.d0

	M1_hWW_B =&
	  g**2*1.d0/(16.d0*pi**2)*&
	 (&
	 -2.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2)*c24f(p1sq,p2sq,qsq,mz,mw,mz)&
	 -6.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*(c24f(p1sq,p2sq,qsq,mh,mw,mh) )&
	 -g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*( c24f(p1sq,p2sq,qsq,mw,mz,mw)   )&
	 -g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*( c24f(p1sq,p2sq,qsq,mw,mh,mw)   )&
	 )&
!
	 +g**2/(16.d0*pi**2)*&
	 (&
	 +1.d0/2.d0*g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*b0f(qsq,mw,mw)&
	 +1.d0/2.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2)*b0f(qsq,mz,mz)&
	 +3.d0/2.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*b0f(qsq,mh,mh)&
	 )&
! !~~~~~~~~~~~ Gauge Boson Loops ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
 	  +1.d0/(16.d0*pi**2)*&
 	 (&
 	 +g**3*cw*mz*ChVV1_VVV(p1sq,p2sq,qsq,mZ,mW,mZ)&
 	 +g**3*cw**2*mw*ChVV1_VVV(p1sq,p2sq,qsq,mW,mZ,mW)&
 	 +g**3*sw**2*mw*ChVV1_VVV(p1sq,p2sq,qsq,mW,mphoton,mW)&
 	 -1.d0/2.d0*g**3*mw*sw**2*(ChVV1_SVV(p1sq,p2sq,qsq,mw,mZ,mW)-ChVV1_SVV(p1sq,p2sq,qsq,mw,mphoton,mW))& 
 	 -1.d0/2.d0*g**3*mw*sw**2*(ChVV1_VVS(p1sq,p2sq,qsq,mW,mZ,mw)-ChVV1_VVS(p1sq,p2sq,qsq,mW,mphoton,mw))& 
 	 -g**3/cw**3*mw**2*mZ*sw**4*c0f(p1sq,p2sq,qsq,mZ,mw,mZ)&
 	 -g**3*mw**3*c0f(p1sq,p2sq,qsq,mW,mh,mW)&
 	 +6.d0*g**2*g_h_h_h(mhp,mhn,ma,mu2,lam2)*mw**2*c0f(p1sq,p2sq,qsq,mh,mW,mh)& 
 	 +g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*g**2*mw**2*sw**4/cw**2*c0f(p1sq,p2sq,qsq,mw,mZ,mw)&
 	 +g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*g**2*sw**2*mw**2*c0f(p1sq,p2sq,qsq,mw,mphoton,mw)&
 	 +1.d0/2.d0*g**3*mw*( c24f(p1sq,p2sq,qsq,mW,mh,mw) + c24f(p1sq,p2sq,qsq,mw,mh,mW) )&
 	 +1.d0/2.d0*g**3*sw**2/cw**2*mw*( c24f(p1sq,p2sq,qsq,mz,mw,mZ) + c24f(p1sq,p2sq,qsq,mZ,mw,mz) )&
!
 	 -g**3*cw*mz*c24f(p1sq,p2sq,qsq,mz,mw,mz)&
 	 -g**3*cw**2*mw*c24f(p1sq,p2sq,qsq,mw,mz,mw)&
 	 -g**3*sw**2*mw*c24f(p1sq,p2sq,qsq,mw,mphoton,mw)&
 	 -3.d0*g**3*mw*b0f(qsq,mW,mW)+2.d0*g**3*mw&
 	 -3.d0*g**3*cw*mz*b0f(qsq,mZ,mZ)+2.d0*g**3*cw*mz&
 !
 	 -1.d0/2.d0*g**3*mw*( b0f(p1sq,mW,mh) + b0f(p2sq,mW,mh) )&
 	 -1.d0/2.d0*g**3*mw*sw**4/cw**2*( b0f(p1sq,mZ,mw) + b0f(p2sq,mZ,mw) )&
 	 -1.d0/2.d0*g**3*sw**2*mw*( b0f(p1sq,mphoton,mw) + b0f(p2sq,mphoton,mw) )&
 	 )&     
! inert particles contributions                                                                                                                               
       +1.d0/16.d0/pi**2*g**2/4.d0*(&
        +2.d0*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)&
                             *b0f(qsq,mhp,mhp)&
        +2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)&
                             *b0f(qsq,ma,ma)&
        +2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)&
                             *b0f(qsq,mhn,mhn)&
        -g_hp_hm_h(mhp,mhn,ma,mu2,lam2)&
                      *4.d0*c24f(p1sq,p2sq,qsq,mhp,mhn,mhp)&
        -g_hp_hm_h(mhp,mhn,ma,mu2,lam2)&
                      *4.d0*c24f(p1sq,p2sq,qsq,mhp,ma,mhp)&
        -2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)&
                      *4.d0*c24f(p1sq,p2sq,qsq,ma,mhp,ma)&
        -2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)&
                      *4.d0*c24f(p1sq,p2sq,qsq,mhn,mhp,mhn)&
       )

	 end function
!--------------------------------------------
	double complex function M2_hWW_F(p1sq,p2sq,qsq)
	double precision, intent(in):: p1sq,p2sq,qsq

	M2_hWW_F = Gam2_hWW_F_SM(p1sq,p2sq,qsq)

	 end function
!--------------------------------------------
	double complex function M3_hWW_F(p1sq,p2sq,qsq)
	double precision, intent(in):: p1sq,p2sq,qsq

	M3_hWW_F = Gam3_hWW_F_SM(p1sq,p2sq,qsq)

	 end function
!--------------------------------------------
	double complex function M2_hWW_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2
	double precision:: p12
	p12=(qsq-p1sq-p2sq)/2.d0

	M2_hWW_B = g**2/(16.d0*pi**2)*mw**2*(&
                    +g*cw*mz*(ChVV2_VVV(p1sq,p2sq,qsq,mZ,mW,mZ) - c1223(p1sq,p2sq,qsq,mz,mw,mz)) &
                    +g*mw*cw**2*(ChVV2_VVV(p1sq,p2sq,qsq,mW,mZ,mW)-c1223(p1sq,p2sq,qsq,mw,mz,mw))& 
                    +g*mw*sw**2*(ChVV2_VVV(p1sq,p2sq,qsq,mW,mphoton,mW)-c1223(p1sq,p2sq,qsq,mw,mphoton,mw)) &
!
          -g/2.d0*mw*(sw**2*ChVV2_SVV(p1sq,p2sq,qsq,mw,mZ,mW) - sw**2*ChVV2_SVV(p1sq,p2sq,qsq,mw,mphoton,mW))&
          -g/2.d0*mw*(sw**2*ChVV2_VVS(p1sq,p2sq,qsq,mW,mZ,mw) - sw**2*ChVV2_VVS(p1sq,p2sq,qsq,mW,mphoton,mw))&
!
                   +g/2.d0*mw*ChVV2_VSS(p1sq,p2sq,qsq,mW,mh,mw)&
                   +g/2.d0*mw*ChVV2_SSV(p1sq,p2sq,qsq,mw,mh,mW)&
                   +g/2.d0*mw*sw**2/cw**2*ChVV2_VSS(p1sq,p2sq,qsq,mZ,mw,mz)&
                   +g/2.d0*mw*sw**2/cw**2*ChVV2_SSV(p1sq,p2sq,qsq,mz,mw,mZ)&
!
                   -2.d0*g_G0_G0_h(mhp,mhn,ma,mu2,lam2)*c1223(p1sq,p2sq,qsq,mz,mw,mz)&
                   -1.d0*g_Gp_Gm_h(mhp,mhn,ma,mu2,lam2)*c1223(p1sq,p2sq,qsq,mw,mh,mw)&
                   -1.d0*g_Gp_Gm_h(mhp,mhn,ma,mu2,lam2)*c1223(p1sq,p2sq,qsq,mw,mz,mw)&
                   -2.d0*g_A_A_h(mhp,mhn,ma,mu2,lam2)*c1223(p1sq,p2sq,qsq,mA,mhp,mA)&
                   -1.d0*g_Hp_Hm_h(mhp,mhn,ma,mu2,lam2)*c1223(p1sq,p2sq,qsq,mhp,mhn,mhp)&
                   -1.d0*g_Hp_Hm_h(mhp,mhn,ma,mu2,lam2)*c1223(p1sq,p2sq,qsq,mhp,mA,mhp)&
                   -6.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*c1223(p1sq,p2sq,qsq,mh,mw,mh)&
                   -2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)*c1223(p1sq,p2sq,qsq,mhn,mhp,mhn)&
                                       )

	 end function
!============== hff 1PI  ================================
	double complex function Fhff_S(p1sq,p2sq,qsq,mh,mf)
	double precision, intent(in):: mh,p1sq,p2sq,qsq,mf
	double precision:: vf,af,qf,mfp

        if (mf .eq. mt) then 
        vf = vt
        af = at
        qf = qt
        mfp = mb
        elseif (mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        mfp = ms
        elseif (mf .eq. mb) then 
        vf  = vb
        af  = ab
        qf  = qb
        mfp = mt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        endif

	Fhff_S = 1.d0/(16.d0*pi**2)*mf/vev*(&
	-4.d0*gz**2*(vf**2-af**2)*Chff_FVF(p1sq,p2sq,qsq,mf,mz)&
	-4.d0*(g*sw)**2*Qf**2*Chff_FVF(p1sq,p2sq,qsq,mf,mphoton)&
	+mf**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mf,mh)&
	-mf**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mf,mz)&
	-2.d0*mfp**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mfp,mw)&
	-2.d0*gz**4*vev**2*(vf**2-af**2)*c0f(p1sq,p2sq,qsq,mZ,mf,mZ)&
	-6.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*mf**2/vev*c0f(p1sq,p2sq,qsq,mh,mf,mh)&
	+2.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2)*mf**2/vev*c0f(p1sq,p2sq,qsq,mz,mf,mz)&
	+2.d0*g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*mfp**2/vev*c0f(p1sq,p2sq,qsq,mw,mfp,mw)&
	-g**2/4.d0*Chff_VFS(p1sq,p2sq,qsq,mW,mfp,mw)&
	-g**2/4.d0*Chff_SFV(p1sq,p2sq,qsq,mw,mfp,mW)&
	-gz**2/8.d0*Chff_VFS(p1sq,p2sq,qsq,mZ,mf,mz)&
	-gz**2/8.d0*Chff_SFV(p1sq,p2sq,qsq,mz,mf,mZ)&
	)

	 end function
!------------------------------------------------------------
	double complex function Fhff_P(p1sq,p2sq,qsq,mh,mf)
	double precision, intent(in):: mh,p1sq,p2sq,qsq,mf
	double precision:: vf,af,qf,mfp

        if (mf .eq. mt) then 
        vf = vt
        af = at
        qf = qt
        mfp = mb
        elseif (mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        mfp = ms
        elseif (mf .eq. mb) then 
        vf  = vb
        af  = ab
        qf  = qb
        mfp = mt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        endif

    Fhff_P = 1.d0/(16.d0*pi**2)*mf/vev*(& 
           -g**2/4.d0*(Chff_VFS(p1sq,p2sq,qsq,mW,mfp,mw)&
                      -Chff_SFV(p1sq,p2sq,qsq,mw,mfp,mW))&
           -2.d0*gz**2*vf*af*(Chff_VFS(p1sq,p2sq,qsq,mZ,mf,mz)&
                      -Chff_SFV(p1sq,p2sq,qsq,mz,mf,mZ))&              
                                       )

	 end function
!------------------------------------------------------------
	double complex function Fhff_V1(p1sq,p2sq,qsq,mh,mf)
	double precision, intent(in):: mh,p1sq,p2sq,qsq,mf
	double precision:: vf,af,qf,mfp

        if (mf .eq. mt) then 
        vf = vt
        af = at
        qf = qt
        mfp = mb
        elseif (mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        mfp = ms
        elseif (mf .eq. mb) then 
        vf  = vb
        af  = ab
        qf  = qb
        mfp = mt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        endif

    Fhff_V1 = 1.d0/(16.d0*pi**2)*(& 
             2.d0*gz**2*(vf**2 + af**2)*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mZ,mf)&
                                              +2.d0*c11f(p1sq,p2sq,qsq,mf,mZ,mf))&
            +2.d0*(g*sw)**2*Qf**2*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mphoton,mf)&
                                      +2.d0*c11f(p1sq,p2sq,qsq,mf,mphoton,mf))&
            +g**2/2.d0*mfp**2/vev*(c0f(p1sq,p2sq,qsq,mfp,mW,mfp)&
                            +2.d0*c11f(p1sq,p2sq,qsq,mfp,mW,mfp))&
            +mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mh,mf)&
                            +2.d0*c11f(p1sq,p2sq,qsq,mf,mh,mf))&
            +mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mz,mf)&
                            +2.d0*c11f(p1sq,p2sq,qsq,mf,mz,mf))&
            +mfp**2/vev**3*(mf**2+mfp**2)*(c0f(p1sq,p2sq,qsq,mfp,mw,mfp)&
                             +2.d0*c11f(p1sq,p2sq,qsq,mfp,mw,mfp))&
            -gz**4*vev*(vf**2 + af**2)*(c0f(p1sq,p2sq,qsq,mZ,mf,mZ)&
                                      +c11f(p1sq,p2sq,qsq,mZ,mf,mZ))&
            -g**4/4.d0*vev*(c0f(p1sq,p2sq,qsq,mW,mfp,mW)&
                           +c11f(p1sq,p2sq,qsq,mW,mfp,mW))&
             -6.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*mf**2/vev**2*(c0f(p1sq,p2sq,qsq,mh,mf,mh)&
                            +c11f(p1sq,p2sq,qsq,mh,mf,mh))&
             -2.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2)*mf**2/vev**2*(c0f(p1sq,p2sq,qsq,mz,mf,mz)&
                            +c11f(p1sq,p2sq,qsq,mz,mf,mz))&
             -1.d0*g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*(mf**2+mfp**2)/vev**2*(c0f(p1sq,p2sq,qsq,mw,mfp,mw)&
                            +c11f(p1sq,p2sq,qsq,mw,mfp,mw))&
             -g**2/4.d0*mfp**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                        +c11f(p1sq,p2sq,qsq,mw,mfp,mw)&
                                   -c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                   +c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                   )&
             -gz**2/8.d0*mf**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                        +c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                   -c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                   +c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                   )&
                                       )

	 end function
!------------------------------------------------------------
	double complex function Fhff_V2(p1sq,p2sq,qsq,mh,mf)
	double precision, intent(in):: mh,p1sq,p2sq,qsq,mf
	double precision:: vf,af,qf,mfp

        if (mf .eq. mt) then 
        vf = vt
        af = at
        qf = qt
        mfp = mb
        elseif (mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        mfp = ms
        elseif (mf .eq. mb) then 
        vf  = vb
        af  = ab
        qf  = qb
        mfp = mt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        endif

    Fhff_V2 = 1.d0/(16.d0*pi**2)*(& 
             2.d0*gz**2*(vf**2 + af**2)*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mZ,mf)&
                                              +2.d0*c12f(p1sq,p2sq,qsq,mf,mZ,mf))&
            +2.d0*(g*sw)**2*Qf**2*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mphoton,mf)&
                                      +2.d0*c12f(p1sq,p2sq,qsq,mf,mphoton,mf))&
            +g**2/2.d0*mfp**2/vev*(c0f(p1sq,p2sq,qsq,mfp,mW,mfp)&
                            +2.d0*c12f(p1sq,p2sq,qsq,mfp,mW,mfp))&
            +mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mh,mf)&
                            +2.d0*c12f(p1sq,p2sq,qsq,mf,mh,mf))&
            +mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mz,mf)&
                            +2.d0*c12f(p1sq,p2sq,qsq,mf,mz,mf))&
            +mfp**2/vev**3*(mf**2+mfp**2)*(c0f(p1sq,p2sq,qsq,mfp,mw,mfp)&
                            +2.d0*c12f(p1sq,p2sq,qsq,mfp,mw,mfp))&
            -gz**4*vev*(vf**2 + af**2)*(c12f(p1sq,p2sq,qsq,mZ,mf,mZ))&
            -g**4/4.d0*vev*(c12f(p1sq,p2sq,qsq,mW,mfp,mW))&
            -6.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mh,mf,mh))&
            -2.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mz,mf,mz))&
            -1.d0*g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*(mf**2+mfp**2)/vev**2*(c12f(p1sq,p2sq,qsq,mw,mfp,mw))&
            -g**2/4.d0*mfp**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                       +c12f(p1sq,p2sq,qsq,mw,mfp,mw)&
                                  -c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                  +c12f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                  )&
            -gz**2/8.d0*mf**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                       +c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                  -c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                  +c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                  )&
                                       )

	 end function
!------------------------------------------------------------
	double complex function Fhff_A1(p1sq,p2sq,qsq,mh,mf)
	double precision, intent(in):: mh,p1sq,p2sq,qsq,mf
	double precision:: vf,af,qf,mfp

        if (mf .eq. mt) then 
        vf = vt
        af = at
        qf = qt
        mfp = mb
        elseif (mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        mfp = ms
        elseif (mf .eq. mb) then 
        vf  = vb
        af  = ab
        qf  = qb
        mfp = mt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        endif

    Fhff_A1 = 1.d0/(16.d0*pi**2)*(& 
             -4.d0*gz**2*vf*af*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mZ,mf)&
                                    +2.d0*c11f(p1sq,p2sq,qsq,mf,mZ,mf))&   
             -g**2/2.d0*mfp**2/vev*(c0f(p1sq,p2sq,qsq,mfp,mW,mfp)&
                                    +2.d0*c11f(p1sq,p2sq,qsq,mfp,mW,mfp))&
              +mfp**2*(mf**2 - mfp**2)/vev**3*(c0f(p1sq,p2sq,qsq,mfp,mw,mfp)&
                                     +2.d0*c11f(p1sq,p2sq,qsq,mfp,mw,mfp))&
              +2.d0*gz**4*vf*af*vev*(c0f(p1sq,p2sq,qsq,mZ,mf,mZ)&
                                    +c11f(p1sq,p2sq,qsq,mZ,mf,mZ))&
              +g**4/4.d0*vev*(c0f(p1sq,p2sq,qsq,mW,mfp,mW)&
                                    +c11f(p1sq,p2sq,qsq,mW,mfp,mW))&
              -g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*(mf**2-mfp**2)/vev**2*(c0f(p1sq,p2sq,qsq,mw,mfp,mw)&
                                    +c11f(p1sq,p2sq,qsq,mw,mfp,mw))&
             +g**2*mfp**2/(4.d0*vev)*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                      +c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                      -c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                       +c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                      )&
             +2.d0*gz**2*vf*af*mf**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                      +c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                      -c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                       +c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                      )&
         )

	 end function
!------------------------------------------------------------
	double complex function Fhff_A2(p1sq,p2sq,qsq,mh,mf)
	double precision, intent(in):: mh,p1sq,p2sq,qsq,mf
	double precision:: vf,af,qf,mfp

        if (mf .eq. mt) then 
        vf = vt
        af = at
        qf = qt
        mfp = mb
        elseif (mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        mfp = ms
        elseif (mf .eq. mb) then 
        vf  = vb
        af  = ab
        qf  = qb
        mfp = mt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        endif

    Fhff_A2 = 1.d0/(16.d0*pi**2)*(& 
             -4.d0*gz**2*vf*af*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mZ,mf)&
                                    +2.d0*c12f(p1sq,p2sq,qsq,mf,mZ,mf))&   
             -g**2/2.d0*mfp**2/vev*(c0f(p1sq,p2sq,qsq,mfp,mW,mfp)&
                                    +2.d0*c12f(p1sq,p2sq,qsq,mfp,mW,mfp))&
             +mfp**2*(mf**2- mfp**2)/vev**3*(c0f(p1sq,p2sq,qsq,mfp,mw,mfp)&
                                    +2.d0*c12f(p1sq,p2sq,qsq,mfp,mw,mfp))&
             +2.d0*gz**4*vf*af*vev*(c12f(p1sq,p2sq,qsq,mZ,mf,mZ))&
             +g**4/4.d0*vev*(c12f(p1sq,p2sq,qsq,mW,mfp,mW))&
             -g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*(mf**2-mfp**2)/vev**2*(c12f(p1sq,p2sq,qsq,mw,mfp,mw))&
             +g**2*mfp**2/(4.d0*vev)*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                      +c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                      -c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                       +c12f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                      )&
             +2.d0*gz**2*vf*af*mf**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                      +c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                      -c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                       +c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                      )&
         )

	 end function
!------------------------------------------------------------
	double complex function Fhff_T(p1sq,p2sq,qsq,mh,mf)
	double precision, intent(in):: mh,p1sq,p2sq,qsq,mf
	double precision:: vf,af,qf,mfp

        if (mf .eq. mt) then 
        vf = vt
        af = at
        qf = qt
        mfp = mb
        elseif (mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        mfp = ms
        elseif (mf .eq. mb) then 
        vf  = vb
        af  = ab
        qf  = qb
        mfp = mt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        endif

    Fhff_T = 1.d0/(16.d0*pi**2)*(mf/vev)*(&
            mf**2/vev**2*(c11f(p1sq,p2sq,qsq,mf,mh,mf)-c12f(p1sq,p2sq,qsq,mf,mh,mf))&
           -mf**2/vev**2*(c11f(p1sq,p2sq,qsq,mf,mz,mf)-c12f(p1sq,p2sq,qsq,mf,mz,mf))&
           -2.d0*mfp**2/vev**2*(c11f(p1sq,p2sq,qsq,mfp,mw,mfp)-c12f(p1sq,p2sq,qsq,mfp,mw,mfp))&
           +g**2/4.d0*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      +1.d0*c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                      +1.d0*c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
                      -2.d0*c12f(p1sq,p2sq,qsq,mw,mfp,mW) )&
           +gz**2/8.d0*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      +1.d0*c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      +1.d0*c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      -2.d0*c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      )&
                      )
 
	 end function
!------------------------------------------------------------
	double complex function Fhff_PT(p1sq,p2sq,qsq,mh,mf)
	double precision, intent(in):: mh,p1sq,p2sq,qsq,mf
	double precision:: vf,af,qf,mfp

        if (mf .eq. mt) then 
        vf = vt
        af = at
        qf = qt
        mfp = mb
        elseif (mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        mfp = ms
        elseif (mf .eq. mb) then 
        vf  = vb
        af  = ab
        qf  = qb
        mfp = mt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        endif

    Fhff_PT = 1.d0/(16.d0*pi**2)*(mf/vev)*(&
           +g**2/4.d0*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      -1.d0*c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                      -1.d0*c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
                      +2.d0*c12f(p1sq,p2sq,qsq,mw,mfp,mW) )&
           +2.d0*gz**2*af*vf*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      -1.d0*c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      -1.d0*c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      +2.d0*c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      )&
                      )
 
	 end function
!================ hhh 1PI  ====================
        double complex function Gam_hhh_F(p1sq,p2sq,qsq)
	double precision, intent(in):: p1sq,p2sq,qsq
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	Gam_hhh_F = &
      -8.d0*mt**4*3.d0/(16.d0*pi**2)/vev**3*&
      (&
       b0f(p1sq,mt,mt)+b0f(p2sq,mt,mt)+b0f(qsq,mt,mt)&
      +(&
         ( 4.d0*mt**2-qsq+(qsq-p1sq-p2sq)/2.d0 )*c0f(p1sq,p2sq,qsq,mt,mt,mt)&
        )&
      )&
! 
      -8.d0*mc**4*3.d0/(16.d0*pi**2)/vev**3*&
      (&
       b0f(p1sq,mc,mc)+b0f(p2sq,mc,mc)+b0f(qsq,mc,mc)&
      +(&
         ( 4.d0*mc**2-qsq+(qsq-p1sq-p2sq)/2.d0 )*c0f(p1sq,p2sq,qsq,mc,mc,mc)&
        )&
      )&
!
      -8.d0*mb**4*3.d0/(16.d0*pi**2)/vev**3*&
      (&
       b0f(p1sq,mb,mb)+b0f(p2sq,mb,mb)+b0f(qsq,mb,mb)&
      +(&
         ( 4.d0*mb**2-qsq+(qsq-p1sq-p2sq)/2.d0 )*c0f(p1sq,p2sq,qsq,mb,mb,mb)&
      )&
      )&
! 
      -8.d0*mtau**4/(16.d0*pi**2)/vev**3*&
      (&
       b0f(p1sq,mtau,mtau)+b0f(p2sq,mtau,mtau)+b0f(qsq,mtau,mtau)&
      +(&
         ( 4.d0*mtau**2-qsq+(qsq-p1sq-p2sq)/2.d0 )*c0f(p1sq,p2sq,qsq,mtau,mtau,mtau)&
      )&
      )
	
	 end function
!---------------------------------------------
	double complex function Gam_hhh_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	Gam_hhh_B =&
       1.d0/(16.d0*pi**2)*(&
!~~~~~~~~~~~ 3-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
       +8.d0*g**3*mw**3*c0f(p1sq,p2sq,qsq,mW,mW,mW)&
       -1.d0/2.d0*g**3*mw**3*c0f(p1sq,p2sq,qsq,mw,mw,mw)&
       +4.d0*gz**3*mz**3*c0f(p1sq,p2sq,qsq,mZ,mZ,mZ)&
       -1.d0/4.d0*gz**3*mz**3*c0f(p1sq,p2sq,qsq,mz,mz,mz)&
!~~~~~~~~~~~ 2-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
      -1.d0/2.d0*g**3*mw*Chhh_SVV(p1sq,p2sq,qsq,mw,mW,mW)&
      -1.d0/4.d0*gz**3*mz*Chhh_SVV(p1sq,p2sq,qsq,mz,mZ,mZ)&
!~~~~~~~~~~~ 1-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
      +1.d0/2.d0*g**2*g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*Chhh_VSS(p1sq,p2sq,qsq,mW,mw,mw)&
      +1.d0/2.d0*gz**2*g_g0_g0_h(mhp,mhn,ma,mu2,lam2)*Chhh_VSS(p1sq,p2sq,qsq,mZ,mz,mz)&
!~~~~~~~~~~~ 0-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
      -2.d0*g_gp_gm_h(mhp,mhn,ma,mu2,lam2)**3*c0f(p1sq,p2sq,qsq,mw,mw,mw)&
      -8.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2)**3*c0f(p1sq,p2sq,qsq,mz,mz,mz)&
      -216.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)**3*c0f(p1sq,p2sq,qsq,mh,mh,mh)&
!~~~~~~~~~~~ B function ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
      +2.d0*g**3*mw*(b0f(p1sq,mW,mW)+b0f(p2sq,mW,mW)+b0f(qsq,mW,mW))&        !! qsq can be separated into p1sq and p2sq and qsq
      +gz**3*mz*(b0f(p1sq,mZ,mZ)+b0f(p2sq,mZ,mZ)+b0f(qsq,mZ,mZ))&
      +2.d0*g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*g_gp_gm_h_h(mhp,mhn,ma,mu2,lam2)*&
        (b0f(p1sq,mw,mw)+b0f(p2sq,mw,mw)+b0f(qsq,mw,mw))&
      +4.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2)*g_g0_g0_h_h(mhp,mhn,ma,mu2,lam2)*&
        (b0f(p1sq,mz,mz)+b0f(p2sq,mz,mz)+b0f(qsq,mz,mz))&
      +72.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*g_h_h_h_h(mhp,mhn,ma,mu2,lam2)*&
        (b0f(p1sq,mh,mh)+b0f(p2sq,mh,mh)+b0f(qsq,mh,mh))&
     )&
	-1.d0/(16.d0*pi**2)*(3.d0*g**3*mW+3.d0/2.d0*gz**3*mZ)&
!New scalar loop contribution
!
        +1.d0/16.d0/pi**2*(&
          2.d0*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)&
           *g_hp_hm_h_h(mhp,mhn,ma,mu2,lam2)*(&
                b0f(p1sq,mhp,mhp)&
               +b0f(p2sq,mhp,mhp)&
               +b0f(qsq,mhp,mhp)          )&
          +4.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)&
           *g_a_a_h_h(mhp,mhn,ma,mu2,lam2)*(&
                b0f(p1sq,ma,ma)&
               +b0f(p2sq,ma,ma)&
               +b0f(qsq,ma,ma)          )&
          +4.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)&
           *g_hn_hn_h_h(mhp,mhn,ma,mu2,lam2)*(&
                b0f(p1sq,mhn,mhn)&
               +b0f(p2sq,mhn,mhn)&
               +b0f(qsq,mhn,mhn)          )&
         -2.d0*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)**3&
                    *c0f(p1sq,p2sq,qsq,mhp,mhp,mhp)&
          -8.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)**3&
                    *c0f(p1sq,p2sq,qsq,ma,ma,ma)&
          -8.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)**3&
                    *c0f(p1sq,p2sq,qsq,mhn,mhn,mhn)&
                         )
	 end function

!==================================
!    SECTION IV COUNTER TERMS     !
!==================================
!---------------------------------------------
	double complex function del_mt(mh)
	double precision, intent(in):: mh

	del_mt =&
	mt*( Pitt_V(mt**2,mh)+Pitt_S(mt**2,mh) )

	 end function
!---------------------------------------------
	double complex function del_mc(mh)
	double precision, intent(in):: mh

	del_mc =&
	mc*( Picc_V(mc**2,mh)+Picc_S(mc**2,mh) )

	 end function
!---------------------------------------------
	double complex function del_mb(mh)
	double precision, intent(in):: mh

	del_mb =&
	mb*( Pibb_V(mb**2,mh)+Pibb_S(mb**2,mh) )

	 end function
!---------------------------------------------
	double complex function del_mtau(mh)
	double precision, intent(in):: mh

	del_mtau =&
	mtau*(&
         Pitautau_V(mtau**2,mh)&
        +Pitautau_S(mtau**2,mh)&
                                  )

	 end function
!---------------------------------------------
	double complex function del_ZVt(mh)
	double precision, intent(in):: mh

	del_ZVt =&
	-Pitt_V(mt**2,mh)-2.d0*mt**2*(dPitt_V(mt**2,mh)+dPitt_S(mt**2,mh))

	 end function
!---------------------------------------------
	double complex function del_ZVc(mh)
	double precision, intent(in):: mh

	del_ZVc =&
	-Picc_V(mc**2,mh)-2.d0*mc**2*(dPicc_V(mc**2,mh)+dPicc_S(mc**2,mh))

	 end function
!---------------------------------------------
	double complex function del_ZVb(mh)
	double precision, intent(in):: mh

	del_ZVb =&
	-Pibb_V(mb**2,mh)-2.d0*mb**2*(dPibb_V(mb**2,mh)+dPibb_S(mb**2,mh))

	 end function
!---------------------------------------------
	double complex function del_ZVtau(mh)
	double precision, intent(in):: mh

	del_ZVtau =&
	-Pitautau_V(mtau**2,mh)&
	-2.d0*mtau**2*(&
         dPitautau_V(mtau**2,mh)&
         +dPitautau_S(mtau**2,mh)&
                            )

	 end function

!========================================================
	double precision function del_swsq_F(mh)
	double precision, intent(in):: mh

	del_swsq_F = cw**2*(PiZZ_F(mz**2)/mz**2-PiWW_F(mw**2)/mw**2)

	 end function
!---------------------------------------------
	double precision function del_swsq_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_swsq_B = cw**2*(PiZZ_B(mZ**2,mhp,mhn,ma,mu2,lam2)/mz**2&
                   -PiWW_B(mW**2,mhp,mhn,ma,mu2,lam2)/mw**2)

	end function
!---------------------------------------------
 	double precision function del_swsq_pinch(mh)
 	double precision, intent(in):: mh

 	del_swsq_pinch = cw**2*(PiZZ_pinch(mz**2)/mz**2-PiWW_pinch(mw**2)/mw**2)

 	 end function
!---------------------------------------------
	double precision function del_swsq(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_swsq = del_swsq_F(mh)+del_swsq_B(mhp,mhn,ma,mu2,lam2)

	 end function
!---------------------------------------------
	double complex function del_v_F(mh)
	double precision, intent(in):: mh

	del_v_F = &
	 vev/2.d0*(&
	 PiWW_F(mw**2)/mw**2&
	 +del_swsq_F(mh)/sw**2&
	 -delta_alpha &
	 -dPiGG_F(mz**2)&
	 -2.d0*sw/cw*PiZG_F(0.d0)/mz**2)

! KOSY scheme
!	del_v_F = vev/2.d0*(PiWW_F(0.d0)/mw**2)

	 end function
!---------------------------------------------
	double complex function del_v_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_v_B=&
	 vev/2.d0*(&
	 PiWW_B(mW**2,mhp,mhn,ma,mu2,lam2)/mw**2&
	 +del_swsq_B(mhp,mhn,ma,mu2,lam2)/sw**2&
	 -dPiGG_B(mz**2,mhp,mhn,ma,mu2,lam2)&
	 -2.d0*sw/cw*PiZG_B(0.d0,mhp,mhn,ma,mu2,lam2)/mz**2)

! KOSY scheme
!!	del_v_B = vev/2.d0*(PiWW_B(0.d0,mhp,mhn,ma,mu2,lam2)/mw**2)

	 end function
!---------------------------------------------
	double complex function del_v(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_v = del_v_F(mh)+del_v_B(mhp,mhn,ma,mu2,lam2)

	 end function
!--------------------------------------------
  	double precision function del_mZsq_F(mh)
	double precision, intent(in):: mh
	
	del_mZsq_F = PiZZ_F(mz**2)

	 end function
!--------------------------------------------
  	double precision function del_mZsq_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	
	del_mZsq_B = PiZZ_B(mz**2,mhp,mhn,ma,mu2,lam2)


	 end function
!--------------------------------------------
 	double complex function del_mWsq_F(mh)
	double precision, intent(in):: mh

	del_mWsq_F = PiWW_F(mw**2)

	 end function
!--------------------------------------------
  	double complex function del_mWsq_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	
	del_mWsq_B = PiWW_B(mw**2,mhp,mhn,ma,mu2,lam2)


	 end function

!===============================================
  	double complex function del_ZZ_F(mh)
	double precision, intent(in):: mh

	del_ZZ_F =& 
	 -delta_alpha&
         -dPiGG_F(mz**2)&
	   -2.d0*(cw**2-sw**2)/(cw*sw)*PiZG_F(0.d0)/mz**2&
	 +(cw**2-sw**2)/cw**2*&
	 del_swsq_F(mh)/sw**2

! KOSY scheme
!!        del_ZZ_F=-dPiZZ_F(mZ**2)
	 end function
!--------------------------------------------
  	double complex function del_ZZ_B(mhp,mhn,ma,mu2,lam2)
  	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	
    del_ZZ_B = &
           -(&
             dPiGG_B(mz**2,mhp,mhn,ma,mu2,lam2)&
             -dPiGG_pinch(mz**2)&
             )&
            +2.d0*(cw**2-sw**2)/(cw*sw)*(&
           PiZG_B(0.d0,mhp,mhn,ma,mu2,lam2)&
           -PiZG_pinch(0.d0)&
              )/mz**2&
          +(cw**2-sw**2)/cw**2*&
          (del_swsq_B(mhp,mhn,ma,mu2,lam2))/sw**2

! KOSY scheme
!!        del_ZZ_B=-dPiZZ_B(mz**2,mhp,mhn,ma,mu2,lam2)
	 end function

!--------------------------------------------
  	double complex function del_ZW_F(mh)
	double precision, intent(in):: mh

	del_ZW_F =&
	 -delta_alpha-dPiGG_F(mz**2)&
	   +2.d0*cw/sw*&
	 PiZG_F(0.d0)/mz**2&
	 +del_swsq_F(mh)/sw**2

! KOSY scheme
!!        del_ZW_F=-dPiWW_F(mW**2)

	 end function
!--------------------------------------------
  	double complex function del_ZW_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	
!!!	del_ZW_B =&
!!!	   -dPiGG_B(0.d0,mh)&
!!!	   -2.d0*cw/sw*&
!!!	 PiZG_B(0.d0,mh)/mz**2&
!!!	 +del_swsq_B(mh)/sw**2

	del_ZW_B =&
	   -(dPiGG_B(mz**2,mhp,mhn,ma,mu2,lam2)& 
           -dPiGG_pinch(mz**2))&
	   +2.d0*cw/sw*(PiZG_B(0.d0,mhp,mhn,ma,mu2,lam2)&
           -PiZG_pinch(0.d0))/mz**2&
	   +del_swsq_B(mhp,mhn,ma,mu2,lam2)/sw**2

! ! KOSY scheme
!!         del_ZW_B=-dPiWW_B(mW**2+0.01d0,mhp,mhn,ma,mu2,lam2)
! We deviate from  mW**2 because B2(mW**2,mW,mphoton) has divergence

	 end function

!--------------------------------------------
	double complex function del_mhsq_F(mh)
	double precision, intent(in):: mh
	
	del_mhsq_F = &
	  -(1.d0/vev)*Th_F(mh)&
	   +Pihh_F(mh**2,mh)

	 end function
!--------------------------------------------
	double complex function del_mhsq_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	
	del_mhsq_B = &
	  -(1.d0/vev)*Th_B(mhp,mhn,ma,mu2,lam2)&
	 +Pihh_B(mh**2,mhp,mhn,ma,mu2,lam2)
	
	 end function
!-------------------------------------------
	double complex function del_Zh_F(mh)
	double precision, intent(in):: mh

	del_Zh_F = -dPihh_F(mh**2,mh)

	 end function
!---------------------------------------------
	double complex function del_Zh_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_Zh_B = -dPihh_B(mh**2,mhp,mhn,ma,mu2,lam2)

	 end function
!---------------------------------------------
	double complex function del_Zh(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_Zh = del_Zh_F(mh)+del_Zh_B(mhp,mhn,ma,mu2,lam2)

	 end function
!============================================

!#############################
!
!  GAUGE BOSON-LOOP CONTRIBUTIONS
!
!#############################
	double complex function rGamS_hbb(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	rGamS_hbb =&
	+Fhff_S(p1sq,p2sq,qsq,mh,mb)&
	-mb/vev*(1.d0+&
	del_mb(mh)/mb&
        -del_v_F(mh)/vev&
	-del_v_B(mhp,mhn,ma,mu2,lam2)/vev&
	+del_ZVb(mh)&
        +1.d0/2.d0*del_Zh_F(mh)&
        +1.d0/2.d0*del_Zh_B(mhp,mhn,ma,mu2,lam2)&
	)

	end function
!---------------------------------------------
	double complex function rGamS_htt(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	rGamS_htt =&
	+Fhff_S(p1sq,p2sq,qsq,mh,mt)&
	-mt/vev*(1.d0+&
	del_mt(mh)/mt&
        -del_v_F(mh)/vev&
	-del_v_B(mhp,mhn,ma,mu2,lam2)/vev&
	+del_ZVt(mh)&
        +1.d0/2.d0*del_Zh_F(mh)&
        +1.d0/2.d0*del_Zh_B(mhp,mhn,ma,mu2,lam2)&
	)

	end function
!---------------------------------------------
	double complex function rGamS_hcc(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	rGamS_hcc =&
	+Fhff_S(p1sq,p2sq,qsq,mh,mc)&
	-mc/vev*(1.d0+&
	del_mc(mh)/mc&
        +del_ZVc(mh)&
        -del_v_F(mh)/vev&
	-del_v_B(mhp,mhn,ma,mu2,lam2)/vev&
        +1.d0/2.d0*del_Zh_F(mh)&
        +1.d0/2.d0*del_Zh_B(mhp,mhn,ma,mu2,lam2)&
	)

	end function
!---------------------------------------------
	double complex function rGamS_htautau(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	rGamS_htautau =&
	+Fhff_S(p1sq,p2sq,qsq,mh,mtau)&
	-mtau/vev*(1.d0+&
	del_mtau(mh)/mtau&
	+del_ZVtau(mh)&
       -del_v_F(mh)/vev&
	-del_v_B(mhp,mhn,ma,mu2,lam2)/vev&
        +1.d0/2.d0*del_Zh_F(mh)&
        +1.d0/2.d0*del_Zh_B(mhp,mhn,ma,mu2,lam2)&
	)

	end function
!--------------------------------------------
  	double complex function del_M1_hZZ_F(mh)
	double precision, intent(in):: mh

	del_M1_hZZ_F = 2.d0*mz**2/vev*&
	 (&
	 +del_mzsq_F(mh)/mz**2&
	 +1.d0/2.d0*del_Zh_F(mh)&
         +del_ZZ_F(mh) &
	 -del_v_F(mh)/vev&
	 )

	 end function
!--------------------------------------------
  	double complex function del_M1_hZZ_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_M1_hZZ_B = 2.d0*mz**2/vev*&
	 (&
	 +del_mZsq_B(mhp,mhn,ma,mu2,lam2)/mz**2&
	 +1.d0/2.d0*del_Zh_B(mhp,mhn,ma,mu2,lam2)&
         +del_ZZ_B(mhp,mhn,ma,mu2,lam2) &
	 -del_v_B(mhp,mhn,ma,mu2,lam2)/vev&
	 )

	 end function
!--------------------------------------------
  	double complex function Gamma_hZZ_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
  	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2
	
	Gamma_hZZ_loop = &
	 +M1_hZZ_F(p1sq,p2sq,qsq)&
	 +del_M1_hZZ_F(mh)&
	 +M1_hZZ_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)  &
	 +del_M1_hZZ_B(mhp,mhn,ma,mu2,lam2)

	 end function
!--------------------------------------------
  	double complex function rGam1_hZZ(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2
	
	rGam1_hZZ = 2.d0*mz**2/vev + Gamma_hZZ_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)

	 end function
!--------------------------------------------
  	double complex function rGam2_hZZ(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2
	
	rGam2_hZZ = M2_hZZ_F(p1sq,p2sq,qsq) + M2_hZZ_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)

	 end function
!--------------------------------------------
  	double complex function rGam3_hZZ(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2
	
	rGam3_hZZ = M3_hZZ_F(p1sq,p2sq,qsq)

	 end function
!--------------------------------------------
  	double complex function del_hhh_F(mh)
	double precision, intent(in):: mh

	del_hhh_F = &
	 -6.d0*(&
	   (1.d0/vev)*del_mhsq_F(mh)/2.d0&
	 +3.d0/4.d0*(mh**2/vev)*del_Zh_F(mh)&
	 +mh**2/(2.d0*vev**3)*(-vev*del_v_F(mh))&
	)

	 end function
!--------------------------------------------
  	double complex function del_hhh_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_hhh_B = &
	 -6.d0*(&
	   (1.d0/vev)*del_mhsq_B(mhp,mhn,ma,mu2,lam2)/2.d0&
	 +3.d0/4.d0*(mh**2/vev)*del_Zh_B(mhp,mhn,ma,mu2,lam2)&
	 +mh**2/(2.d0*vev**3)*(-vev*del_v_B(mhp,mhn,ma,mu2,lam2))&
	)

	 end function
!----------------------------------------------
  	double complex function rGam_hhh(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	rGam_hhh = & 
          6.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)&
	 +Gam_hhh_F(p1sq,p2sq,qsq)&
	 +del_hhh_F(mh)&
	 +Gam_hhh_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)&
	 +del_hhh_B(mhp,mhn,ma,mu2,lam2)

	 end function
!--------------------------------------------
  	double complex function del_M1_hWW_F(mh)
	double precision, intent(in):: mh

	del_M1_hWW_F = 2.d0*mw**2/vev*(&
	 +del_mWsq_F(mh)/mw**2&
	 +del_ZW_F(mh)&
	 +1.d0/2.d0*del_Zh_F(mh)&
	 -del_v_F(mh)/vev&
	 )

	 end function
!--------------------------------------------
  	double complex function del_M1_hWW_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_M1_hWW_B = mw**2/vev*(&
	 2.d0*del_mWsq_B(mhp,mhn,ma,mu2,lam2)/mw**2&
	 +2.d0*del_ZW_B(mhp,mhn,ma,mu2,lam2)&
	 +del_Zh_B(mhp,mhn,ma,mu2,lam2)&
	 -2.d0*del_v_B(mhp,mhn,ma,mu2,lam2)/vev&
	 )

	 end function
!--------------------------------------------
  	double complex function Gamma_hWW_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2
	
	Gamma_hWW_loop = &
	 +M1_hWW_F(p1sq,p2sq,qsq)&
	 +del_M1_hWW_F(mh)&
	 +M1_hWW_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)&
	 +del_M1_hWW_B(mhp,mhn,ma,mu2,lam2)

	 end function
!--------------------------------------------
  	double complex function rGam1_hWW(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2
	
	rGam1_hWW = 2.d0*mw**2/vev + Gamma_hWW_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)

	 end function
!--------------------------------------------
  	double complex function rGam2_hWW(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2
	
	rGam2_hWW = M2_hWW_F(p1sq,p2sq,qsq) + M2_hWW_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)

	 end function
!--------------------------------------------
  	double complex function rGam3_hWW(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2
	
	rGam3_hWW = M3_hWW_F(p1sq,p2sq,qsq)

	 end function
!===========  h-> 2*gamma/Zgamma ==========================
	double complex function Gam_hgamgam(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	Gam_hgamgam=alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mh**3*&
	ABS(Nc*Qt**2*I_f(mh,mt)&
	+Nc*Qb**2*I_f(mh,mb)&
	+Qe**2*I_f(mh,mtau)&
	+I_W(mh)&
	-I_S(mh,mhp)*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)/vev&
	)**2
        end function
!----------------------------------------
	double complex function Gam_hZgam(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	double precision:: g_HpHmZ
	g_HpHmZ=gz/2.d0*(cw**2-sw**2)

	Gam_hZgam=dsqrt(2.d0)*G_F*alpha_em**2*mh**3/(128.d0*pi**3)*&
	(1.d0-mz**2/mh**2)**3*&
	abs(&
	-g_hp_hm_h(mhp,mhn,ma,mu2,lam2)/vev*g_HpHmZ*J_S(mh,mhp)&
	+Nc*Qt*vt*J_f(mh,mt)&
	+Nc*Qb*vb*J_f(mh,mb)&
	+Qe*ve*J_f(mh,mtau)&
	+J_W(mh)&
	)**2

	 end function 
!================================================
!    SECTION VI RGE                             !
!================================================
!--------- g1 ------------------
	double precision function g1(t0,t)
	double precision, intent(in)::  t0,t
	double precision c1

        c1= 20.d0/9.d0*ng+1.d0/6.d0*nh
        g1= gp/sqrt(1.d0-2.d0*c1*gp**2*(t-t0)/(16.d0*pi**2))

	end function
!--------- g2 ------------------
	double precision function g2(t0,t)
	double precision, intent(in)::  t0,t
	double precision c2

        c2=(-22.d0/3.d0+4.d0/3.d0*ng+1.d0/6.d0*nh)
        g2=g/sqrt(1.d0-2.d0*c2*g**2*(t-t0)/(16.d0*pi**2))

	end function
!--------- g3 ------------------
	double precision function g3(t0,t)
	double precision, intent(in)::  t0,t
	double precision c3

        c3=(-11.d0+4.d0/3.d0*ng)
        g3=gs/sqrt(1.d0-2.d0*c3*gs**2*(t-t0)/(16.d0*pi**2))

	end function
!--------- beta(lam1) ------------------
	double precision function beta_lam1(t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision, intent(in)::  t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt

	beta_lam1=1.d0/(16.d0*pi**2)*(&
                    12.d0*vlam1**2&
                    +4.d0*vlam3**2&
                    +2.d0*vlam4**2&
                    +4.d0*vlam3*vlam4&
                    +2.d0*vlam5**2&
                    -12.d0*vyt**4&
                    +9.d0/4.d0*g2(t0,t)**4&
                    +3.d0/4.d0*g1(t0,t)**4&
                    +3.d0/2.d0*g1(t0,t)**2*g2(t0,t)**2&
                    -3.d0*vlam1*(3.d0*g2(t0,t)**2+g1(t0,t)**2-4.d0*vyt**2)&
                   )

	end function
!--------- beta(lam2) ------------------
	double precision function beta_lam2(t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision, intent(in)::  t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt

	beta_lam2=1.d0/(16.d0*pi**2)*(&
                    12.d0*vlam2**2&
                    +4.d0*vlam3**2&
                    +2.d0*vlam4**2&
                    +4.d0*vlam3*vlam4&
                    +2.d0*vlam5**2&
                    +9.d0/4.d0*g2(t0,t)**4&
                    +3.d0/4.d0*g1(t0,t)**4&
                    +3.d0/2.d0*g1(t0,t)**2*g2(t0,t)**2&
                    -3.d0*vlam2*(3.d0*g2(t0,t)**2+g1(t0,t)**2)&
                   )

	end function
!--------- beta(lam3) ------------------
	double precision function beta_lam3(t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision, intent(in)::  t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt

        beta_lam3 = 1.d0/(16.d0*pi**2)*(&
                    2.d0*(vlam1+vlam2)*(3.d0*vlam3+vlam4)&
                    +4.d0*vlam3**2+2.d0*vlam4**2+2.d0*vlam5**2&
                    +9.d0/4.d0*g2(t0,t)**4&
                    +3.d0/4.d0*g1(t0,t)**4&
                    -3.d0/2.d0*g1(t0,t)**2*g2(t0,t)**2&       
                    -3.d0*vlam3*(3.d0*g2(t0,t)**2 +g1(t0,t)**2-2.d0*vyt**2)&
                    )

	end function
!--------- beta(lam4) ------------------
	double precision function beta_lam4(t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision, intent(in)::  t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt

        beta_lam4 = 1.d0/(16.d0*pi**2)*(&
                    2.d0*vlam4*(vlam1+vlam2+4.d0*vlam3+2.d0*vlam4)&
                    +8.d0*vlam5**2&
                    +3.d0*g1(t0,t)**2*g2(t0,t)**2&
                    -3.d0*vlam4*(3.d0*g2(t0,t)**2 +g1(t0,t)**2-2.d0*vyt**2)&
                    )

	end function
!--------- beta(lam5) ------------------
	double precision function beta_lam5(t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision, intent(in)::  t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt

        beta_lam5 = 1.d0/(16.d0*pi**2)*(&
                    2.d0*vlam5*(vlam1+vlam2+4.d0*vlam3+6.d0*vlam4)&
                    -3.d0*vlam5*(3.d0*g2(t0,t)**2 +g1(t0,t)**2-2.d0*vyt**2)&
                    )

	end function
!--------- beta(yt) ------------------
	double precision function beta_yt(t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision, intent(in)::  t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt

        beta_yt = 1.d0/(16.d0*pi**2)*(&
                  +9.d0/2.d0*vyt**3&
                 -vyt*(8.d0*g3(t0,t)**2+9.d0/4.d0*g2(t0,t)**2+17.d0/12.d0*g1(t0,t)**2)&
                 )

	end function
!================================================
!    SECTION VI SUBROOTINES                     !
!================================================
	subroutine RGE(t0,tfin,h,t,no,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision:: rk_lam1(4),rk_lam2(4), rk_lam3(4), rk_lam4(4), rk_lam5(4),rk_yt(4) 
	double precision, intent(in):: t0,tfin,t,h
	double precision :: vlam1,vlam2,vlam3,vlam4,vlam5,vyt
	integer, intent(in):: no
! ----------------------------------------------------------------------------------
           rk_lam1(1)   = beta_lam1  (t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
           rk_lam2(1)   = beta_lam2  (t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
           rk_lam3(1)   = beta_lam3  (t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
           rk_lam4(1)   = beta_lam4  (t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
           rk_lam5(1)   = beta_lam5  (t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
           rk_yt(1)     = beta_yt    (t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
!--------------- STEP 2 ----------------------------------------------------------------------------------
           rk_lam1(2)   = beta_lam1  &
           (t0,t+h/2.d0,vlam1+rk_lam1(1)/2.d0,vlam2+rk_lam2(1)/2.d0,vlam3+rk_lam3(1)/2.d0,vlam4+rk_lam4(1)/2.d0,&
            vlam5+rk_lam5(1)/2.d0,vyt+rk_yt(1)/2.d0)
           rk_lam2(2)   = beta_lam2  &
           (t0,t+h/2.d0,vlam1+rk_lam1(1)/2.d0,vlam2+rk_lam2(1)/2.d0,vlam3+rk_lam3(1)/2.d0,vlam4+rk_lam4(1)/2.d0,&
           vlam5+rk_lam5(1)/2.d0,vyt+rk_yt(1)/2.d0)
           rk_lam3(2)   = beta_lam3  &
           (t0,t+h/2.d0,vlam1+rk_lam1(1)/2.d0,vlam2+rk_lam2(1)/2.d0,vlam3+rk_lam3(1)/2.d0,vlam4+rk_lam4(1)/2.d0,&
           vlam5+rk_lam5(1)/2.d0,vyt+rk_yt(1)/2.d0)
           rk_lam4(2)   = beta_lam4  &
           (t0,t+h/2.d0,vlam1+rk_lam1(1)/2.d0,vlam2+rk_lam2(1)/2.d0,vlam3+rk_lam3(1)/2.d0,vlam4+rk_lam4(1)/2.d0,&
           vlam5+rk_lam5(1)/2.d0,vyt+rk_yt(1)/2.d0)
           rk_lam5(2)   = beta_lam5  &
           (t0,t+h/2.d0,vlam1+rk_lam1(1)/2.d0,vlam2+rk_lam2(1)/2.d0,vlam3+rk_lam3(1)/2.d0,vlam4+rk_lam4(1)/2.d0,&
           vlam5+rk_lam5(1)/2.d0,vyt+rk_yt(1)/2.d0)
           rk_yt  (2)   = beta_yt    &
           (t0,t+h/2.d0,vlam1+rk_lam1(1)/2.d0,vlam2+rk_lam2(1)/2.d0,vlam3+rk_lam3(1)/2.d0,vlam4+rk_lam4(1)/2.d0,&
           vlam5+rk_lam5(1)/2.d0,vyt+rk_yt(1)/2.d0)
!--------------- STEP 3 ----------------------------------------------------------------------------------
           rk_lam1(3)   = beta_lam1  &
           (t0,t+h/2.d0,vlam1+rk_lam1(2)/2.d0,vlam2+rk_lam2(2)/2.d0,vlam3+rk_lam3(2)/2.d0,vlam4+rk_lam4(2)/2.d0,&
           vlam5+rk_lam5(2)/2.d0,vyt+rk_yt(2)/2.d0)
           rk_lam2(3)   = beta_lam2  &
           (t0,t+h/2.d0,vlam1+rk_lam1(2)/2.d0,vlam2+rk_lam2(2)/2.d0,vlam3+rk_lam3(2)/2.d0,vlam4+rk_lam4(2)/2.d0,&
           vlam5+rk_lam5(2)/2.d0,vyt+rk_yt(2)/2.d0)
           rk_lam3(3)   = beta_lam3  &
           (t0,t+h/2.d0,vlam1+rk_lam1(2)/2.d0,vlam2+rk_lam2(2)/2.d0,vlam3+rk_lam3(2)/2.d0,vlam4+rk_lam4(2)/2.d0,&
           vlam5+rk_lam5(2)/2.d0,vyt+rk_yt(2)/2.d0)
           rk_lam4(3)   = beta_lam4  &
           (t0,t+h/2.d0,vlam1+rk_lam1(2)/2.d0,vlam2+rk_lam2(2)/2.d0,vlam3+rk_lam3(2)/2.d0,vlam4+rk_lam4(2)/2.d0,&
           vlam5+rk_lam5(2)/2.d0,vyt+rk_yt(2)/2.d0)
           rk_lam5(3)   = beta_lam5  &
           (t0,t+h/2.d0,vlam1+rk_lam1(2)/2.d0,vlam2+rk_lam2(2)/2.d0,vlam3+rk_lam3(2)/2.d0,vlam4+rk_lam4(2)/2.d0,&
           vlam5+rk_lam5(2)/2.d0,vyt+rk_yt(2)/2.d0)
           rk_yt  (3)   = beta_yt    &
           (t0,t+h/2.d0,vlam1+rk_lam1(2)/2.d0,vlam2+rk_lam2(2)/2.d0,vlam3+rk_lam3(2)/2.d0,vlam4+rk_lam4(2)/2.d0,&
           vlam5+rk_lam5(2)/2.d0,vyt+rk_yt(2)/2.d0)
!--------------- STEP 4 ----------------------------------------------------------------------------------
           rk_lam1(4)   = beta_lam1  &
           (t0,t+h,vlam1+rk_lam1(3),vlam2+rk_lam2(3),vlam3+rk_lam3(3),vlam4+rk_lam4(3),vlam5+rk_lam5(3),vyt+rk_yt(3))
           rk_lam2(4)   = beta_lam2  &
           (t0,t+h,vlam1+rk_lam1(3),vlam2+rk_lam2(3),vlam3+rk_lam3(3),vlam4+rk_lam4(3),vlam5+rk_lam5(3),vyt+rk_yt(3))
           rk_lam3(4)   = beta_lam3  &
           (t0,t+h,vlam1+rk_lam1(3),vlam2+rk_lam2(3),vlam3+rk_lam3(3),vlam4+rk_lam4(3),vlam5+rk_lam5(3),vyt+rk_yt(3))
           rk_lam4(4)   = beta_lam4  &
           (t0,t+h,vlam1+rk_lam1(3),vlam2+rk_lam2(3),vlam3+rk_lam3(3),vlam4+rk_lam4(3),vlam5+rk_lam5(3),vyt+rk_yt(3))
           rk_lam5(4)   = beta_lam5  &
           (t0,t+h,vlam1+rk_lam1(3),vlam2+rk_lam2(3),vlam3+rk_lam3(3),vlam4+rk_lam4(3),vlam5+rk_lam5(3),vyt+rk_yt(3))
           rk_yt(4)     = beta_yt    &
           (t0,t+h,vlam1+rk_lam1(3),vlam2+rk_lam2(3),vlam3+rk_lam3(3),vlam4+rk_lam4(3),vlam5+rk_lam5(3),vyt+rk_yt(3))
!--------------- SUM ----------------------------------------------------------------------------------
           vlam1   = vlam1   + h/6.d0*(rk_lam1(1)   +2.d0*rk_lam1(2)   +2.d0*rk_lam1(3)   + rk_lam1(4))
           vlam2   = vlam2   + h/6.d0*(rk_lam2(1)   +2.d0*rk_lam2(2)   +2.d0*rk_lam2(3)   + rk_lam2(4))
           vlam3   = vlam3   + h/6.d0*(rk_lam3(1)   +2.d0*rk_lam3(2)   +2.d0*rk_lam3(3)   + rk_lam3(4))
           vlam4   = vlam4   + h/6.d0*(rk_lam4(1)   +2.d0*rk_lam4(2)   +2.d0*rk_lam4(3)   + rk_lam4(4))
           vlam5   = vlam5   + h/6.d0*(rk_lam5(1)   +2.d0*rk_lam5(2)   +2.d0*rk_lam5(3)   + rk_lam5(4))
           vyt     = vyt     + h/6.d0*(rk_yt  (1)   +2.d0*rk_yt  (2)   +2.d0*rk_yt  (3)   + rk_yt  (4))
	end subroutine 
!-----------------------------------------------------------------------------------------
	double precision function triviality(cutoff,mhp,mhn,ma,mu2,lam2)
	integer:: i,no
	double precision:: t0,tfin,max_coup,t,h
	double precision:: vlam1,vlam2,vlam3,vlam4,vlam5,vyt
	double precision, intent(in):: cutoff,mhp,mhn,ma,mu2,lam2

           vlam1 = lam1(mhp,mhn,ma,mu2,lam2)
           vlam2 = lam2
           vlam3 = lam3(mhp,mhn,ma,mu2,lam2)
           vlam4 = lam4(mhp,mhn,ma,mu2,lam2)
           vlam5 = lam5(mhp,mhn,ma,mu2,lam2)
           vyt   =  sqrt(2.d0)*mt/vev

	   no=1000
           t0= Log(mz)
	   tfin=Log(1.d10)
           h=(tfin-t0)/dble(no)
           do  i = 0,no
	   t=t0+h*dble(i)
     	   call RGE(t0,tfin,h,t,no,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
           max_coup = max(abs(vlam1),abs(vlam2),abs(vlam3),abs(vlam4),abs(vlam5),abs(vyt))
           if (exp(t) .lt. cutoff .and. max_coup .gt. 4.d0*pi) then 
           triviality = 1.d0
           exit
           else if  (exp(t) .gt. cutoff .and. max_coup .le. 4.d0*pi) then 
           triviality = 0.d0
           exit
           endif
           enddo

	end function
!-----------------------------------------------------------------------------------------
	double precision function vs_rge(cutoff,mhp,mhn,ma,mu2,lam2)
	integer:: i,no
	double precision:: t0,tfin,max_coup,t,h
	double precision:: vlam1,vlam2,vlam3,vlam4,vlam5,vyt,stab
	double precision, intent(in):: cutoff,mhp,mhn,ma,mu2,lam2

           vlam1 = lam1(mhp,mhn,ma,mu2,lam2)
           vlam2 = lam2
           vlam3 = lam3(mhp,mhn,ma,mu2,lam2)
           vlam4 = lam4(mhp,mhn,ma,mu2,lam2)
           vlam5 = lam5(mhp,mhn,ma,mu2,lam2)
           vyt   =  sqrt(2.d0)*mt/vev
           vs_rge=0.d0

	   no=1000
           t0= Log(mz)
	   tfin=Log(cutoff)
           h=(tfin-t0)/dble(no)
           do  i = 0,no
	   t=t0+h*dble(i)
     	   call RGE(t0,tfin,h,t,no,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
         stab = sqrt(vlam1*vlam2)+vlam3 + min1(0.d0,vlam4+vlam5,vlam4-vlam5)     
         if (vlam1 .lt. 0.d0) then
            vs_rge=1.d0  
         else if (vlam2 .lt. 0.d0) then
            vs_rge=2.d0 
         else if (stab .lt. 0.d0) then 
            vs_rge=3.d0  
         end if
         enddo
	end function
!============S,T parameters==================================

	! double complex function del_S_IDM(mhp,mhn,ma,mu2,lam2)
	! double precision, intent(in):: mhp,mhn,ma,mu2,lam2
        ! del_S_IDM = 1.d0/4.d0/pi*(db5f(0.d0,mhp,mhp)-db5f(0.d0,mh,ma))
        ! end function

        ! double complex function del_T_IDM(mhp,mhn,ma,mu2,lam2)
	! double precision, intent(in):: mhp,mhn,ma,mu2,lam2
        ! del_T_IDM =-dsqrt(2.d0)*G_F/16.d0/pi**2/alpha_em*(b5f(0.d0,mhp,mhp)-b5f(0.d0,mhn,mhp)&
        ! +b5f(0.d0,mhn,ma)-b5f(0.d0,ma,mhp))
        ! end function

!====== Gauge boson two point functions ========
	double complex function PiWW_SM_B(qsq,mh)
	double precision, intent(in):: qsq,mh
	
	PiWW_SM_B=PiWW_B_WOH(qsq)+g**2/(16.d0*pi**2)*( mw**2*b0f(qsq,mh,mW)+1.d0/4.d0*b5f(qsq,mh,mw) )

 	end function
!---------------------------------------------
	double complex function PiZZ_SM_B(qsq,mh)
	double precision, intent(in):: qsq,mh
	
	PiZZ_SM_B=PiZZ_B_WOH(qsq)+ g**2/cw**2/(16.d0*pi**2)*( mZ**2*b0f(qsq,mh,mZ)+1.d0/4.d0*b5f(qsq,mh,mZ) )

 	end function
!---------------------------------------------
	double complex function PiGG_SM_B(qsq,mh)
	double precision, intent(in):: qsq,mh
	
	PiGG_SM_B=PiGG_B_WOH(qsq)

 	end function
!---------------------------------------------
	double complex function PiZG_SM_B(qsq,mh)
	double precision, intent(in):: qsq,mh
	
	PiZG_SM_B=PiZG_B_WOH(qsq)

 	end function
!---------------------------------------------
	double complex function dPiGG_SM_B(qsq,mh)
	double precision, intent(in):: qsq,mh
	
	dPiGG_SM_B=dPiGG_B_WOH(qsq)

 	end function
!============== S-T parameters in the SM, THDM  ======================
	double complex function S_SM(mh)
	double precision, intent(in):: mh

	S_SM =& 
	4.d0*sw**2*cw**2/(alpha_em*mz**2)*(&
	  PiGG_F(mz**2)-PiGG_F(0.d0)&
	+(cw**2-sw**2)/(cw*sw)*(PiZG_F(mz**2)-PiZG_F(0.d0))&
	-(PiZZ_F(mz**2)-PiZZ_F(0.d0))&
	)&
!
	+4.d0*sw**2*cw**2/(alpha_em*mz**2)*(&
	  PiGG_SM_B(mz**2,mh)-PiGG_SM_B(0.d0,mh)&
	+(cw**2-sw**2)/(cw*sw)*(PiZG_SM_B(mz**2,mh)-PiZG_SM_B(0.d0,mh))&
	-(PiZZ_SM_B(mz**2,mh)-PiZZ_SM_B(0.d0,mh))&
	)
 
	 end function
!---------------------------------------------
	double complex function S_IDM(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in)::mhp,mhn,ma,mu2,lam2

	S_IDM =& 
	4.d0*sw**2*cw**2/(alpha_em*mz**2)*(&
	  PiGG_F(mz**2)-PiGG_F(0.d0)&
	+(cw**2-sw**2)/(cw*sw)*(PiZG_F(mz**2)-PiZG_F(0.d0))&
	-(PiZZ_F(mz**2)-PiZZ_F(0.d0))&
	)&
!
	+4.d0*sw**2*cw**2/(alpha_em*mz**2)*(&
	  PiGG_B(mz**2,mhp,mhn,ma,mu2,lam2)-PiGG_B(0.d0,mhp,mhn,ma,mu2,lam2)&
	+(cw**2-sw**2)/(cw*sw)*(PiZG_B(mz**2,mhp,mhn,ma,mu2,lam2)-PiZG_B(0.d0,mhp,mhn,ma,mu2,lam2))&
	-(PiZZ_B(mz**2,mhp,mhn,ma,mu2,lam2)-PiZZ_B(0.d0,mhp,mhn,ma,mu2,lam2))&
	)

	 end function
!---------------------------------------------
	double complex function T_SM(mh)
	double precision, intent(in):: mh
	
	T_SM =&
	1.d0/alpha_em*(&
	PiZZ_F(0.d0)/mz**2-PiWW_F(0.d0)/mw**2&
	+2.d0*sw/cw*PiZG_F(0.d0)/mz**2+sw**2/cw**2*PiGG_F(0.d0)/mz**2&
	)&
!
	+1.d0/alpha_em*(&
	PiZZ_SM_B(0.d0,mh)/mz**2-PiWW_SM_B(0.d0,mh)/mw**2&
	+2.d0*sw/cw*PiZG_SM_B(0.d0,mh)/mz**2+sw**2/cw**2*PiGG_SM_B(0.d0,mh)/mz**2&
	)
 
	 end function

!---------------------------------------------
        double complex function T_IDM(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	
	T_IDM =&
	1.d0/alpha_em*(&
	PiZZ_F(0.d0)/mz**2-PiWW_F(0.d0)/mw**2&
	+2.d0*sw/cw*PiZG_F(0.d0)/mz**2+sw**2/cw**2*PiGG_F(0.d0)/mz**2&
	)&
!
	+1.d0/alpha_em*(&
	PiZZ_B(0.d0,mhp,mhn,ma,mu2,lam2)/mz**2-PiWW_B(0.d0,mhp,mhn,ma,mu2,lam2)/mw**2&
	+2.d0*sw/cw*PiZG_B(0.d0,mhp,mhn,ma,mu2,lam2)/mz**2&
        +sw**2/cw**2*PiGG_B(0.d0,mhp,mhn,ma,mu2,lam2)/mz**2&
	)
 
	 end function
!---------------------------------------------
	double complex function del_S(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
        del_S = S_IDM(mhp,mhn,ma,mu2,lam2)-S_SM(mh)
	 end function
!---------------------------------------------
	double complex function del_T(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
        del_T = T_IDM(mhp,mhn,ma,mu2,lam2)-T_SM(mh)
	 end function
!---------------------------------------------
	double complex function stu(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
        double precision:: vdel_S,vdel_T,muS,muT,sigmaS,sigmaT,rhoST,tmp

        vdel_S = del_S(mhp,mhn,ma,mu2,lam2)
        vdel_T = del_T(mhp,mhn,ma,mu2,lam2)

        muS = 0.05d0
        sigmaS = 0.09d0
        muT = 0.08d0
        sigmaT = 0.07d0
        rhoST = +0.91d0

        tmp = (vdel_S-muS)*(&
        sigmaT**2*(vdel_S-muS)/(sigmaS**2*sigmaT**2-rhoST**2*sigmaS**2*sigmaT**2)&
        -rhoST*sigmaS*sigmaT*(vdel_T-muT)/(sigmaS**2*sigmaT**2-rhoST**2*sigmaS**2*sigmaT**2)&
        )&
        +(vdel_T-muT)*(&
        sigmaS**2*(vdel_T-muT)/(sigmaS**2*sigmaT**2-rhoST**2*sigmaS**2*sigmaT**2)&
        -rhoST*sigmaS*sigmaT*(vdel_S-muS)/(sigmaS**2*sigmaT**2-rhoST**2*sigmaS**2*sigmaT**2)&
        )

        if (tmp  .le. 5.99d0) then 
        stu = 0.d0
        else if (tmp .gt. 5.99d0) then 
        stu = 1.d0
        endif

      end function stu


 	end program HCOUP_IDM
