	module SM_const
        implicit none
        
!------   Fundermental constants ------------------------
         include "../inputs/in_sm.txt"
 

          double precision,parameter:: mphoton=0.d0
	  double precision,parameter:: Qt=2.d0/3.d0,Qb=-1.d0/3.d0,Qe=-1.d0,Nc=3.d0,It=1.d0/2.d0,Ib=-1.d0/2.d0,Ie=-1.d0/2.d0
	  double precision,parameter:: femtb=0.389d0*1.d12            ! 1/GeV^2 > fb
	  double precision,parameter:: second=1.519295d24             ! second > 1/GeV
	  double precision,parameter:: pi=atan(1.d0)*4.d0
          double precision,parameter:: m0=0.d0
	  complex, parameter        :: ii=(0.d0,1.d0)
!------   Outputs -------------------------------------------
	double precision,parameter :: sw=sqrt(1.d0/2.d0*(1.d0-sqrt(1.d0-4.d0*pi*(1.d0/(sqrt(2.d0)*G_F))*alpha_em/mz**2)))
	double precision,parameter :: cw= sqrt(1.d0-1.d0/2.d0*(1.d0-sqrt(1.d0-4.d0*pi*(1.d0/(sqrt(2.d0)*G_F))*alpha_em/mz**2)))
	double precision,parameter :: g=2.d0*mz&
        *sqrt(1.d0-1.d0/2.d0*(1.d0-sqrt(1.d0-4.d0*pi*(1.d0/(sqrt(2.d0)*G_F))*alpha_em/mz**2)))*(sqrt(sqrt(2.d0)*G_F))
	double precision,parameter :: gz=2.d0*mz&
        *sqrt(1.d0-1.d0/2.d0*(1.d0-sqrt(1.d0-4.d0*pi*(1.d0/(sqrt(2.d0)*G_F))*alpha_em/mz**2)))*(sqrt(sqrt(2.d0)*G_F))/&
	 sqrt(1.d0-1.d0/2.d0*(1.d0-sqrt(1.d0-4.d0*pi*(1.d0/(sqrt(2.d0)*G_F))*alpha_em/mz**2)))
	double precision :: mw=mz*sqrt(1.d0-1.d0/2.d0*(1.d0-sqrt(1.d0-4.d0*pi*(1.d0/(sqrt(2.d0)*G_F))*alpha_em/mz**2)))
!---------------------------------------------------------------------------------------------

!------   Fermion Masses ------------------------
   	  double precision,parameter :: mmu  = 0.105658367d0
	  double precision,parameter :: ms   = 0.d0                     
!---------------------------------------------------------------------------------------------

!------   STU  arXiv:1209.2716 [hep-ph]------------------------
	  double precision,parameter ::	Del_chisq68 = 2.30d0    ! Delta chisq value giving 68% CL with m=2
	  double precision,parameter ::	Del_chisq95 = 5.99d0    ! Delta chisq value giving 95% CL with m=2
	  double precision,parameter ::	s_cent=0.05d0           ! Central Value of S
	  double precision,parameter ::	t_cent=0.08d0           ! Central Value of T 
	  double precision,parameter ::	sigma_s=0.09d0          ! Standard Deviation of S
	  double precision,parameter ::	sigma_t=0.07d0          ! Standard Deviation of T
	  double precision,parameter ::	rho_st = 0.91d0         ! Correlation Factor in the case of Del U=0
!--------------------------------------------------------------

!-------  Other Paremeters Dependent Above ----------------------
        double precision:: vt=(It-2.d0*sw**2*Qt)/2.d0
        double precision:: vb=(Ib-2.d0*sw**2*Qb)/2.d0
        double precision:: ve=(Ie-2.d0*sw**2*Qe)/2.d0
        double precision:: at= It/2.d0
        double precision:: ab= Ib/2.d0
        double precision:: ae= Ie/2.d0
	double precision:: vev = 1.d0/(sqrt(sqrt(2.d0)*G_F))
!--------------------------------------------------------------
	contains
!#############################################################
	end module SM_const


