	Program HCOUP_HSM
        use SM_const
	use pv
	use Gauge_boson_2p
	use SM_Hdecay
	use HCOUP_SM
	implicit none

	integer:: i
	double precision:: nh = 1.d0,ng = 3.d0,gs,gp,yt
	complex (kind(0d0)):: vhZZ(3),vhWW(3),vhtt(8),vhbb(8),vhcc(8),vhll(8),vhhh
	complex (kind(0d0)):: vhZZ_sm(3),vhWW_sm(3),vhtt_sm(8),vhbb_sm(8),vhcc_sm(8),vhll_sm(8),vhhh_sm
	double precision:: p_hzz(3),p_hww(3),p_htt(3),p_hbb(3),p_hcc(3),p_hll(3),p_hhh(3)

        include "inputs/in_hsm.txt"
        include "inputs/in_momentum.txt"
        include "modules/header.txt"
        call ltini
           gs = sqrt(alpha_s*4.d0*pi)
           gp = g*sw/cw
           yt = sqrt(2.d0)*mt/vev
!############# Constraints ################    
        if (pu(mbH,alpha,lam_ps,lam_s,mu_s) .ne. 0.d0) then 
           write(*,*) 'Excluded by Unitarity'
        endif
        if (wrong(mbH,alpha,lam_ps,lam_s,mu_s) .ne. 0.d0) then 
           write(*,*) 'Excluded by Wrong Vacuum Condition'
        endif
        if (stu(mbh,alpha) .ne. 0.d0) then 
           write(*,*) 'Excluded by ST Parameter'
        endif
        if (vs_rge(cutoff,mbH,alpha,lam_ps,lam_s) .ne. 0.d0) then 
           write(*,*) 'Excluded by Vacuum Stability'
        endif
        if (triviality(cutoff,mbH,alpha,lam_ps,lam_s) .ne. 0.d0) then        
           write(*,*) 'Excluded by Triviality'        
        endif 
           
        if (pu(mbH,alpha,lam_ps,lam_s,mu_s) .eq. 0.d0       .and. &
            wrong(mbH,alpha,lam_ps,lam_s,mu_s) .eq. 0.d0    .and. &
            stu(mbh,alpha) .eq. 0.d0                        .and. &
            vs_rge(cutoff,mbH,alpha,lam_ps,lam_s) .eq. 0.d0 .and. &
            triviality(cutoff,mbH,alpha,lam_ps,lam_s) .eq. 0.d0 ) then 
           write(*,*) 'Allowed!'
           endif


!############# OUTPUS ################    
	open(10,file="outputs/out_sm.txt")
	open(11,file="outputs/out_hsm.txt")

        vhZZ_sm(1) = rGam1_hZZ_sm(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2)
        vhZZ_sm(2) = rGam2_hZZ_sm(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2)
        vhZZ_sm(3) = rGam3_hZZ_sm(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2)
        vhWW_sm(1) = rGam1_hWW_sm(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2)
        vhWW_sm(2) = rGam2_hWW_sm(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2)
        vhWW_sm(3) = rGam3_hWW_sm(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2)
        vhtt_sm(1) = rGamS_htt_sm(p_htt(1)**2,p_htt(2)**2,p_htt(3)**2)
        vhbb_sm(1) = rGamS_hbb_sm(p_hbb(1)**2,p_hbb(2)**2,p_hbb(3)**2)
        vhcc_sm(1) = rGamS_hcc_sm(p_hcc(1)**2,p_hcc(2)**2,p_hcc(3)**2)
        vhll_sm(1) = rGamS_htautau_sm(p_hll(1)**2,p_hll(2)**2,p_hll(3)**2)
        vhhh_sm      = rGam_hhh_sm(p_hhh(1)**2,p_hhh(2)**2,p_hhh(3)**2)


        write(10,100) 'Re[rGam_hZZ(1)]:', dble(vhZZ_sm(1)),'Im[rGam_hZZ(1)]:', imag(vhZZ_sm(1))
        write(10,100) 'Re[rGam_hZZ(2)]:', dble(vhZZ_sm(2)),'Im[rGam_hZZ(2)]:', imag(vhZZ_sm(2))
        write(10,100) 'Re[rGam_hZZ(3)]:', dble(vhZZ_sm(3)),'Im[rGam_hZZ(3)]:', imag(vhZZ_sm(3))
        write(10,100) 'Re[rGam_hWW(1)]:', dble(vhWW_sm(1)),'Im[rGam_hWW(1)]:', imag(vhWW_sm(1))
        write(10,100) 'Re[rGam_hWW(2)]:', dble(vhWW_sm(2)),'Im[rGam_hWW(2)]:', imag(vhWW_sm(2))
        write(10,100) 'Re[rGam_hWW(3)]:', dble(vhWW_sm(3)),'Im[rGam_hWW(3)]:', imag(vhWW_sm(3))
        write(10,100) 'Re[rGam_htt(S)]:', dble(vhtt_sm(1)),'Im[rGam_htt(S)]:', imag(vhtt_sm(1))
        write(10,100) 'Re[rGam_hbb(S)]:', dble(vhbb_sm(1)),'Im[rGam_hbb(S)]:', imag(vhbb_sm(1))
        write(10,100) 'Re[rGam_hcc(S)]:', dble(vhcc_sm(1)),'Im[rGam_hcc(S)]:', imag(vhcc_sm(1))
        write(10,100) 'Re[rGam_hll(S)]:', dble(vhll_sm(1)),'Im[rGam_hll(S)]:', imag(vhll_sm(1))
        write(10,100) 'Re[rGam_hhh]:'   , dble(vhhh_sm),'Im[rGam_hhh]:', imag(vhhh_sm)
        write(10,200) 'Gam(h->gamgam):',hgamgam_sm(mh)
        write(10,200) 'Gam(h->Zgam):'  ,hZgam_sm(mh)
        write(10,200) 'Gam(h->gg):'    ,hgg_sm(mh)


        vhZZ(1) = rGam1_hZZ(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2,mbH,alpha,lam_ps,lam_s,mu_s)
        vhZZ(2) = rGam2_hZZ(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2,mbH,alpha,lam_ps,lam_s,mu_s)
        vhZZ(3) = rGam3_hZZ(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2,mbH,alpha,lam_ps,lam_s,mu_s)
        vhWW(1) = rGam1_hWW(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2,mbH,alpha,lam_ps,lam_s,mu_s)
        vhWW(2) = rGam2_hWW(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2,mbH,alpha,lam_ps,lam_s,mu_s)
        vhWW(3) = rGam3_hWW(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2,mbH,alpha,lam_ps,lam_s,mu_s)
        vhtt(1) = rGamS_htt(p_htt(1)**2,p_htt(2)**2,p_htt(3)**2,mbH,alpha,lam_ps,lam_s,mu_s)
        vhbb(1) = rGamS_hbb(p_hbb(1)**2,p_hbb(2)**2,p_hbb(3)**2,mbH,alpha,lam_ps,lam_s,mu_s)
        vhcc(1) = rGamS_hcc(p_hcc(1)**2,p_hcc(2)**2,p_hcc(3)**2,mbH,alpha,lam_ps,lam_s,mu_s)
        vhll(1) = rGamS_htautau(p_hll(1)**2,p_hll(2)**2,p_hll(3)**2,mbH,alpha,lam_ps,lam_s,mu_s)
        vhhh      = rGam_hhh(p_hhh(1)**2,p_hhh(2)**2,p_hhh(3)**2,mbH,alpha,lam_ps,lam_s,mu_s)

        write(11,100) 'Re[rGam_hZZ(1)]:', dble(vhZZ(1)),'Im[rGam_hZZ(1)]:', imag(vhZZ(1))
        write(11,100) 'Re[rGam_hZZ(2)]:', dble(vhZZ(2)),'Im[rGam_hZZ(2)]:', imag(vhZZ(2))
        write(11,100) 'Re[rGam_hZZ(3)]:', dble(vhZZ(3)),'Im[rGam_hZZ(3)]:', imag(vhZZ(3))
        write(11,100) 'Re[rGam_hWW(1)]:', dble(vhWW(1)),'Im[rGam_hWW(1)]:', imag(vhWW(1))
        write(11,100) 'Re[rGam_hWW(2)]:', dble(vhWW(2)),'Im[rGam_hWW(2)]:', imag(vhWW(2))
        write(11,100) 'Re[rGam_hWW(3)]:', dble(vhWW(3)),'Im[rGam_hWW(3)]:', imag(vhWW(3))
        write(11,100) 'Re[rGam_htt(S)]:', dble(vhtt(1)),'Im[rGam_htt(S)]:', imag(vhtt(1))
        write(11,100) 'Re[rGam_hbb(S)]:', dble(vhbb(1)),'Im[rGam_hbb(S)]:', imag(vhbb(1))
        write(11,100) 'Re[rGam_hcc(S)]:', dble(vhcc(1)),'Im[rGam_hcc(S)]:', imag(vhcc(1))
        write(11,100) 'Re[rGam_hll(S)]:', dble(vhll(1)),'Im[rGam_hll(S)]:', imag(vhll(1))
        write(11,100) 'Re[rGam_hhh]:'   , dble(vhhh),'Im[rGam_hhh]:', imag(vhhh)
        write(11,200) 'Gam(h->gamgam):',Gam_hgamgam(mbH,alpha,lam_ps,lam_s,mu_s)
        write(11,200) 'Gam(h->Zgam):'  ,Gam_hZgam(mbH,alpha,lam_ps,lam_s,mu_s)
        write(11,200) 'Gam(h->gg):'    ,Gam_hgg(mbH,alpha,lam_ps,lam_s,mu_s)
        
 100 Format(A20,1PE18.8,A20,1PE18.8)
 200 Format(A20,1PE18.8)

 	contains
!#################################################
!
!    SECTION I Parameter translations 
!
!#################################################
	double precision function mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

        mu_phis = sin(2.d0*alpha)/(2.d0*vev)*(mbH**2-mh**2)

        end function
!---------------------------------------------
      double precision function lam(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      lam = 1.d0/(2.d0*vev**2)*( cos(alpha)**2* mh**2 + sin(alpha)**2* mbH**2) 

      end function
!---------------------------------------------
      double precision function mssq(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      mssq = 1.d0/2.d0*(sin(alpha)**2*mh**2 + cos(alpha)**2*mbH**2-vev**2*lam_ps)

        end function  

!#################################################
!
!    SECTION II Tree-level couplings
!
!#################################################    
!=================  VVS type =====================
        complex (kind(0d0)) function g_WZGp(alpha)
        double precision, intent(in):: alpha

        g_WZGp = -g*gz/2.d0*sw**2*vev

        end function
!------------------------------------------
        complex (kind(0d0)) function g_ZZh(alpha)
        double precision, intent(in):: alpha

        g_ZZh = gz**2/4.d0*vev*cos(alpha)

        end function
!------------------------------------------
        complex (kind(0d0)) function g_ZZbH(alpha)
        double precision, intent(in):: alpha

        g_ZZbH = gz**2/4.d0*vev*sin(alpha)

        end function
!------------------------------------------
        complex (kind(0d0)) function g_WWh(alpha)
        double precision, intent(in):: alpha

        g_WWh = g**2/2.d0*vev*cos(alpha)

        end function
!------------------------------------------
        complex (kind(0d0)) function g_WWbH(alpha)
        double precision, intent(in):: alpha

        g_WWbH = g**2/2.d0*vev*sin(alpha)

        end function
!========== SSV type ================================
        complex (kind(0d0)) function g_GpGmZ(alpha)
        double precision, intent(in):: alpha

        g_GpGmZ = -gz/2.d0*(cw**2-sw**2)

        end function
!--------------------------------------------------------
        complex (kind(0d0)) function g_GhZ(alpha)
        double precision, intent(in):: alpha

        g_GhZ = ii*gz/2.d0*cos(alpha)

        end function
!--------------------------------------------------------
        complex (kind(0d0)) function g_GbHZ(alpha)
        double precision, intent(in):: alpha

        g_GbHZ = ii*gz/2.d0*sin(alpha)

        end function
!--------------------------------------------------------
        complex (kind(0d0)) function g_GphW(alpha)
        double precision, intent(in):: alpha

        g_GphW = -g/2.d0*cos(alpha)

        end function
!--------------------------------------------------------
        complex (kind(0d0)) function g_GpbHW(alpha)
        double precision, intent(in):: alpha

        g_GpbHW = -g/2.d0*sin(alpha)

        end function
!======= VVSS type ======================================
        double precision function g_ZZbHbH(alpha)
        double precision, intent(in):: alpha

        g_ZZbHbH = gz**2/8.d0*sin(alpha)**2

        end function
!--------------------------------------------------------
        double precision function g_ZZhh(alpha)
        double precision, intent(in):: alpha

        g_ZZhh = gz**2/8.d0*cos(alpha)**2

        end function
!--------------------------------------------------------
        double precision function g_ZZbHh(alpha)
        double precision, intent(in):: alpha

        g_ZZbHh = gz**2/4.d0*cos(alpha)*sin(alpha)

        end function
!--------------------------------------------------------
        double precision function g_ZZGG(alpha)
        double precision, intent(in):: alpha

        g_ZZGG = gz**2/8.d0

        end function
!--------------------------------------------------------
        double precision function g_ZZGpGm(alpha)
        double precision, intent(in):: alpha

        g_ZZGpGm = gz**2/4.d0*(cw**2-sw**2)**2

        end function
!--------------------------------------------------------
        double precision function g_WZGph(alpha)
        double precision, intent(in):: alpha

        g_WZGph = -1.d0/2.d0*g*gz*sw**2*cos(alpha)

        end function
!======= VVVV type =================================================
        double precision function g_WWZZ(alpha)
        double precision, intent(in):: alpha

        g_WWZZ = -g**2*cw**2/2.d0

        end function
!======= SSS type =================================================
        double precision function lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)
        double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

       lam_hhh = -mh**2*cos(alpha)**3/(2.d0*vev)&
                 -vev*cos(alpha)*sin(alpha)**2*lam_ps&
                 +sin(alpha)**3*mu_s

        end function
!--------------------------------------------------------
      double precision function lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision mbH,alpha,lam_ps,lam_s,mu_s

      lam_bHbHh = - lam_ps /4.d0*vev *(cos(alpha) + 3.d0*cos(3.d0*alpha))&
          + 3.d0* mu_s *cos(alpha)**2 *sin(alpha)&
          - mh**2/2.d0/vev *cos(alpha)*sin(alpha)**2&
          - mbH**2/vev *cos(alpha)*sin(alpha)**2 

	end function
!--------------------------------------------------------
      double precision function lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision mbH,alpha,lam_ps,lam_s,mu_s

      lam_bHhh = - mh**2/vev *cos(alpha)**2 *sin(alpha)&
          - mbH**2/2.d0 /vev* cos(alpha)**2*sin(alpha)&
          + vev/2.d0 *lam_ps *(1.d0 + 3.d0*cos(2.d0*alpha))*sin(alpha)&
          - 3.d0*mu_s * cos(alpha)* sin(alpha)**2

	end function
!--------------------------------------------------------
      double precision function lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision mbH,alpha,lam_ps,lam_s,mu_s

      lam_bHbHbH = &
           - mu_s *cos(alpha)**3&
           - vev* lam_ps *cos(alpha)**2 *sin(alpha)&
           - ( mbH**2* sin(alpha)**3)/(2.d0* vev)

	end function
!--------------------------------------------------------
      double precision function lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision mbH,alpha,lam_ps,lam_s,mu_s

      lam_GGh = -mh**2* cos(alpha)/2.d0/vev  

	end function
!--------------------------------------------------------
      double precision function lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision mbH,alpha,lam_ps,lam_s,mu_s

      lam_GpGmh = -mh**2*cos(alpha)/vev  

	end function
!--------------------------------------------------------
      double precision function lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision mbH,alpha,lam_ps,lam_s,mu_s

       lam_GGbH = -mbH**2 * sin(alpha) /2.d0/vev  
 
	end function
!--------------------------------------------------------
      double precision function lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision mbH,alpha,lam_ps,lam_s,mu_s

      lam_GpGmbH = -mbH**2 *sin(alpha)/vev  

	end function

!====== SSSS type ==================================================
      double precision function lam_hhhh(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision mbH,alpha,lam_ps,lam_s,mu_s

      lam_hhhh =&
           - mh**2 /8.d0/vev**2 *cos(alpha)**6&
           - mbH**2 /8.d0/vev**2 *cos(alpha)**4 *sin(alpha)**2&
           - lam_s *sin(alpha)**4&
           - lam_ps /8.d0*sin(2.d0*alpha)**2 

	end function
!--------------------------------------------------------
      double precision function lam_bHhhh(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision mbH,alpha,lam_ps,lam_s,mu_s

      lam_bHhhh =&
           - mh**2 /2.d0/vev**2* cos(alpha)**5 *sin(alpha)&
           + 4.d0* lam_s* cos(alpha)*sin(alpha)**3&
           - mbH**2 *sin(2.d0*alpha)**3 /16.d0/vev**2&
           + lam_ps /4.d0* sin(4.d0*alpha) 

	end function
!--------------------------------------------------------
      double precision function lam_bHbHhh(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision mbH,alpha,lam_ps,lam_s,mu_s

      lam_bHbHhh =&
           - lam_ps/8.d0 *(1.d0 + 3.d0*cos(4.d0*alpha) )&
           - 3.d0* mh**2*cos(alpha)**4*sin(alpha)**2/4.d0/vev**2&
           - 3.d0* mbH**2*cos(alpha)**2* sin(alpha)**4/4.d0/vev**2&
           - 6.d0*cos(alpha)**2*sin(alpha)**2*lam_s     ! IT'S NOT INCLUDED IN KIKUCHI CODE!!

	end function
!--------------------------------------------------------
      double precision function lam_bHbHbHh(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision mbH,alpha,lam_ps,lam_s,mu_s

      lam_bHbHbHh =&
           4.d0* lam_s* cos(alpha)**3* sin(alpha)&
           - mbH**2 *cos(alpha)*sin(alpha)**5 /2.d0/vev**2&
           - mh**2 *sin(2.d0*alpha)**3 /16.d0/vev**2&
           - lam_ps /4.d0* sin(4.d0*alpha) 

	end function
!--------------------------------------------------------
      double precision function lam_GGhh(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision mbH,alpha,lam_ps,lam_s,mu_s

      lam_GGhh =&
           - mh**2 *cos(alpha)**4 /4.d0/vev**2&
           - lam_ps/ 2.d0* sin(alpha)**2&
           - mbH**2 *sin(2.d0*alpha)**2 /16.d0/vev**2 

	end function
!--------------------------------------------------------
      double precision function lam_GpGmhh(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision mbH,alpha,lam_ps,lam_s,mu_s

      lam_GpGmhh =&
           - mh**2 *cos(alpha)**4 /2.d0/vev**2&
           - lam_ps *sin(alpha)**2&
           - mbH**2 *sin(2.d0*alpha)**2 /8.d0/vev**2 

	end function
!--------------------------------------------------------
      double precision function lam_GGbHh(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision mbH,alpha,lam_ps,lam_s,mu_s

      lam_GGbHh =&
           lam_ps *cos(alpha) *sin(alpha)&
           - mh**2 *cos(alpha)**3 *sin(alpha) /2.d0/vev**2&
           - mbH**2 *cos(alpha) *sin(alpha)**3 /2.d0/vev**2 

	end function
!--------------------------------------------------------
      double precision function lam_GGbHbH(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision mbH,alpha,lam_ps,lam_s,mu_s

      lam_GGbHbH =  &
           - lam_ps /2.d0*cos(alpha)**2&
           - mbH**2* sin(alpha)**4 /4.d0/vev**2&
           - mh**2* sin(2.d0*alpha)**2 /16.d0/vev**2 

	end function
!--------------------------------------------------------
      double precision function lam_GpGmbHh(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision mbH,alpha,lam_ps,lam_s,mu_s

      lam_GpGmbHh =&
           2.d0* lam_ps*cos(alpha)*sin(alpha)&
           - mh**2 *cos(alpha)**3*sin(alpha) /vev**2&
           - mbH**2 *cos(alpha)* sin(alpha)**3/vev**2 

	end function
!--------------------------------------------------------
      double precision function lam_GpGmbHbH(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision mbH,alpha,lam_ps,lam_s,mu_s

      lam_GpGmbHbH =&
           - lam_ps *cos(alpha)**2&
           - mbH**2* sin(alpha)**4 /2.d0/vev**2&
           - mh**2* sin(2.d0*alpha)**2 /8.d0/vev**2 

	end function
!--------------------------------------------------------
      double precision function lam_GpGmGpGm(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision mbH,alpha,lam_ps,lam_s,mu_s

      lam_GpGmGpGm =&
      -  mh**2*cos(alpha)**2 /2.d0/vev**2&
      -  mbH**2*sin(alpha)**2 /2.d0/vev**2 

	end function
!--------------------------------------------------------
      double precision function lam_bHbHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision mbH,alpha,lam_ps,lam_s,mu_s

      lam_bHbHbHbH =&
           -sin(alpha)**4/(8.d0*vev**2)*(cos(alpha)**2*mh**2 + sin(alpha)**2*mbH**2)&
           -cos(alpha)**4*lam_s -sin(2.d0*alpha)**2/8.d0*lam_ps

	end function
!#################################################
!
!    SECTION III Constraints on parameter space
!
!#################################################    

!============== perturbative unitarity ========================
      double precision function x1p(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
           
      x1p = 1.d0/16.d0/pi*(  3.d0*lam(mbH,alpha,lam_ps,lam_s,mu_s)+ 6.d0*lam_s&
                        + sqrt((3.d0*lam(mbH,alpha,lam_ps,lam_s,mu_s)-6.d0*lam_s)**2 + 4.d0*lam_ps**2 )&
                          )

	end function      
!---------------------------------------------
      double precision function x1m(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      x1m = 1.d0/16.d0/pi*(  3.d0*lam(mbH,alpha,lam_ps,lam_s,mu_s)+ 6.d0*lam_s&
                        - sqrt((3.d0*lam(mbH,alpha,lam_ps,lam_s,mu_s)-6.d0*lam_s)**2 + 4.d0*lam_ps**2 )&
                          )

	end function      
!---------------------------------------------
      double precision function y1(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
           
      y1 = 1.d0/8.d0/pi*lam(mbH,alpha,lam_ps,lam_s,mu_s)

	end function 
!---------------------------------------------
      double precision function y2(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
           
      y2 = 1.d0/8.d0/pi*lam_ps

	end function 
!---------------------------------------------
      double precision function pu(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
           
      if (x1p(mbH,alpha,lam_ps,lam_s,mu_s) .ge. 1.d0/2.d0) then 
      pu = 1.d0
      elseif (x1m(mbH,alpha,lam_ps,lam_s,mu_s) .ge. 1.d0/2.d0) then 
      pu = 2.d0
      elseif (y1(mbH,alpha,lam_ps,lam_s,mu_s) .ge. 1.d0/2.d0) then 
      pu = 3.d0
      elseif (y2(mbH,alpha,lam_ps,lam_s,mu_s) .ge. 1.d0/2.d0) then 
      pu = 4.d0
      else
      pu = 0.d0
      endif

	end function 
!============== vacuum stability ========================
      double precision function vs(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
           
      if (lam(mbH,alpha,lam_ps,lam_s,mu_s) .lt. 0.d0) then 
      vs = 1.d0
      else if (lam_s .lt. 0.d0) then 
      vs = 2.d0
      else if (lam(mbH,alpha,lam_ps,lam_s,mu_s)*lam_s .lt. lam_ps**2/4.d0   .and. lam_ps .lt. 0.d0) then 
      vs = 3.d0
      else
      vs = 0.d0
      endif

	end function 
!================= wrong vacuum conditions =======================================
      complex (kind(0d0)) function vpot(mbH,alpha,lam_ps,lam_s,mu_s,phi0sq,s0)
      double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s,s0
      complex (kind(0d0)), intent(in):: phi0sq

      vpot  =  lam(mbH,alpha,lam_ps,lam_s,mu_s)*(phi0sq/2.d0 - vev**2/2.d0)**2& 
             + mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)*(phi0sq/2.d0 - vev**2/2.d0)*s0&
             + lam_ps*(phi0sq/2.d0 - vev**2/2.d0)*s0**2&
             + (mssq(mbH,alpha,lam_ps,lam_s,mu_s)+1.d0/2.d0*vev**2*lam_ps)*s0**2&
             + mu_s*s0**3& 
             + lam_s*s0**4  
             

	end function
!---------------------------------------------
      complex (kind(0d0)) function  kappa(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision:: Delta0
      double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

     Delta0 = -64.d0*mssq(mbH,alpha,lam_ps,lam_s,mu_s)**2*(9.d0*mu_s**2-32.d0*lam_s*mssq(mbH,alpha,lam_ps,lam_s,mu_s) )&
              -48.d0*mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)*mu_s*vev**2*&
              (18.d0*mu_s**2 -72.d0*lam_s*mssq(mbH,alpha,lam_ps,lam_s,mu_s) )&
              +27.d0*64.d0*lam_s**2*mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)**2*vev**4 

      if (Delta0 .ge. 0.d0) then
      kappa = -12.d0*mu_s*(18.d0*mu_s**2 - 72.d0*lam_s*mssq(mbH,alpha,lam_ps,lam_s,mu_s) )&
              +27.d0*32.d0*lam_s**2*mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)*vev**2&
              +12.d0*lam_s*sqrt(3.d0*Delta0)

      else 
      kappa = -12.d0*mu_s*(18.d0*mu_s**2 - 72.d0*lam_s*mssq(mbH,alpha,lam_ps,lam_s,mu_s) )&
              +27.d0*32.d0*lam_s**2*mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)*vev**2&
              +12.d0*lam_s*sqrt(3.d0*abs(Delta0))*ii
      endif 

	end function 
!---------------------------------------------
      double precision function del_vac(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
           
      del_vac = vev**2/64.d0*(3.d0*8.d0*mu_s*lam(mbH,alpha,lam_ps,lam_s,mu_s)&
      -3.d0*4.d0*mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)*lam_ps)**2&
     - 2.d0*mh**2*mbH**2*( 4.d0*lam(mbH,alpha,lam_ps,lam_s,mu_s)*lam_s -lam_ps**2 )

	end function 
!---------------------------------------------
      complex (kind(0d0)) function vpsq(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      vpsq = vev**2-1.d0/lam(mbH,alpha,lam_ps,lam_s,mu_s)*(&
                mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)*xp(mbH,alpha,lam_ps,lam_s,mu_s)&
                +lam_ps*xp(mbH,alpha,lam_ps,lam_s,mu_s)**2 &
                                     )

	end function
!---------------------------------------------
      complex (kind(0d0)) function vmsq(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
            
      vmsq =vev**2-1.d0/lam(mbH,alpha,lam_ps,lam_s,mu_s)*(&
                mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)*xm(mbH,alpha,lam_ps,lam_s,mu_s)&
      +lam_ps*xm(mbH,alpha,lam_ps,lam_s,mu_s)**2 &
                                     )
	end function
!---------------------------------------------
      complex (kind(0d0)) function xp(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      if (del_vac(mbH,alpha,lam_ps,lam_s,mu_s) .ge. 0.d0) then
      xp = (3.d0*vev*( mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)*lam_ps - 2.d0*mu_s*lam(mbH,alpha,lam_ps,lam_s,mu_s) )&
            +2.d0*sqrt(del_vac(mbH,alpha,lam_ps,lam_s,mu_s)) )&
             /(4.d0*vev*( 4.d0*lam(mbH,alpha,lam_ps,lam_s,mu_s)*lam_s - lam_ps**2 ))  
      else
      xp = (3.d0*vev*( mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)*lam_ps - 2.d0*mu_s*lam(mbH,alpha,lam_ps,lam_s,mu_s) )&
            +2.d0*ii*sqrt(abs(del_vac(mbH,alpha,lam_ps,lam_s,mu_s))) )&
             /(4.d0*vev*( 4.d0*lam(mbH,alpha,lam_ps,lam_s,mu_s)*lam_s - lam_ps**2 ))  
      endif

	end function
!---------------------------------------------
      complex (kind(0d0)) function xm(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      if (del_vac(mbH,alpha,lam_ps,lam_s,mu_s) .ge. 0.d0) then
      xm = (3.d0*vev*( mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)*lam_ps - 2.d0*mu_s*lam(mbH,alpha,lam_ps,lam_s,mu_s) )&
            -2.d0*sqrt(del_vac(mbH,alpha,lam_ps,lam_s,mu_s)) )&
             /(4.d0*vev*( 4.d0*lam(mbH,alpha,lam_ps,lam_s,mu_s)*lam_s - lam_ps**2 ))  
      else
      xm = (3.d0*vev*( mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)*lam_ps - 2.d0*mu_s*lam(mbH,alpha,lam_ps,lam_s,mu_s) )&
            -2.d0*ii*sqrt(abs(del_vac(mbH,alpha,lam_ps,lam_s,mu_s))) )&
             /(4.d0*vev*( 4.d0*lam(mbH,alpha,lam_ps,lam_s,mu_s)*lam_s - lam_ps**2 ))  
      endif
      
	end function
!---------------------------------------------
      complex (kind(0d0)) function x01(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
      
      x01 = ( (6.d0*mu_s-kappa(mbH,alpha,lam_ps,lam_s,mu_s)**(1.d0/3.d0))**2 &
              - 96.d0*mssq(mbH,alpha,lam_ps,lam_s,mu_s)*lam_s)/&
             (24.d0*lam_s*kappa(mbH,alpha,lam_ps,lam_s,mu_s)**(1.d0/3.d0))&
              + mu_s/4.d0/lam_s

	end function
!---------------------------------------------
      complex (kind(0d0)) function x02(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      x02 = ( (6.d0*mu_s-kappa(mbH,alpha,lam_ps,lam_s,mu_s)**(1.d0/3.d0)*exp(2.d0*pi*ii/3.d0))**2 &
              - 96.d0*mssq(mbH,alpha,lam_ps,lam_s,mu_s)*lam_s)/(24.d0*lam_s*&
              kappa(mbH,alpha,lam_ps,lam_s,mu_s)**(1.d0/3.d0)*exp(2.d0*pi*ii/3.d0))&
              + mu_s/4.d0/lam_s

	end function
!---------------------------------------------
      complex (kind(0d0)) function x03(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      x03 = (&
            (6.d0*mu_s-kappa(mbH,alpha,lam_ps,lam_s,mu_s)**(1.d0/3.d0)*exp(4.d0*pi*ii/3.d0))**2 &
             - 96.d0*mssq(mbH,alpha,lam_ps,lam_s,mu_s)*lam_s&
            )&
            /(24.d0*lam_s*kappa(mbH,alpha,lam_ps,lam_s,mu_s)**(1.d0/3.d0)*exp(4.d0*pi*ii/3.d0))&
            + mu_s/4.d0/lam_s

	end function
!---------------------------------------------
      double precision function wrong(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
      complex (kind(0d0)):: vvpsq,vvmsq,vv0
      double precision:: vxp,vxm,vx01,vx02,vx03
      double precision:: pot_p,pot_m,pot_1,pot_2,pot_3

      vv0 =  (0.d0,0.d0)
      vvpsq =  vpsq(mbH,alpha,lam_ps,lam_s,mu_s)
      vvmsq =  vmsq(mbH,alpha,lam_ps,lam_s,mu_s)
      vxp =    xp(mbH,alpha,lam_ps,lam_s,mu_s)
      vxm =    xm(mbH,alpha,lam_ps,lam_s,mu_s)
      vx01 =   x01(mbH,alpha,lam_ps,lam_s,mu_s)
      vx02 =   x02(mbH,alpha,lam_ps,lam_s,mu_s)
      vx03 =   x03(mbH,alpha,lam_ps,lam_s,mu_s)
      
      pot_p = vpot(mbH,alpha,lam_ps,lam_s,mu_s,vvpsq,vxp)
      pot_m = vpot(mbH,alpha,lam_ps,lam_s,mu_s,vvmsq,vxm)
      pot_1 = vpot(mbH,alpha,lam_ps,lam_s,mu_s,vv0,vx01)
      pot_2 = vpot(mbH,alpha,lam_ps,lam_s,mu_s,vv0,vx02)
      pot_3 = vpot(mbH,alpha,lam_ps,lam_s,mu_s,vv0,vx03)

      wrong = 0.d0

      if ( del_vac(mbH,alpha,lam_ps,lam_s,mu_s)  .gt. 0.d0) then 
      if ( pot_p  .lt. 0.d0) then 
      wrong =1.d0
      else if ( pot_m  .lt. 0.d0) then 
      wrong =2.d0 
      endif 
      endif 
         
      if ( pot_1  .lt. 0.d0) then 
      wrong =3.d0
      else if ( pot_2  .lt. 0.d0) then 
      wrong =4.d0
      else if (pot_3  .lt. 0.d0) then 
      wrong =5.d0
      endif 

	end function
!======= triviality =================================================
	double precision function triviality(cutoff,mbH,alpha,lam_ps,lam_s)
	double precision, intent(in):: cutoff,mbH,alpha,lam_ps,lam_s
	integer:: i,no
	double precision:: t0,tfin,max_coup,t,h,vlam,vlamps,vlams,vyt

           vlam   = lam(mbH,alpha,lam_ps,lam_s,mu_s)
           vlamps = lam_ps
           vlams  = lam_s
           vyt    = yt

	   no=1000
           t0= Log(mz)
	   tfin=Log(1.d10)
           h=(tfin-t0)/dble(no)
           do  i = 0,no
	   t=t0+h*dble(i)
     	   call RGE(t0,h,t,vlam,vlamPS,vlamS,vyt)
           max_coup = max(abs(vlam),abs(vlamPS),abs(vlamS),abs(vyt))
           if (exp(t) .lt. cutoff .and. max_coup .gt. 4.d0*pi) then 
           triviality = 1.d0
           exit
           else if  ( exp(t) .gt. cutoff .and. max_coup .le. 4.d0*pi) then 
           triviality = 0.d0
           exit
           endif

        enddo
	end function
!====== RGE improved vacuum stability ==================================
        double precision function vs_rge(cutoff,mbH,alpha,lam_ps,lam_s)
	integer:: i,no
	double precision:: t0,tfin,max_coup,t,h,vlam,vlamps,vlams,vyt
	double precision, intent(in):: cutoff,lam_ps,lam_s,mbH,alpha

           vlam   = lam(mbH,alpha,lam_ps,lam_s,mu_s)
           vlamps = lam_ps
           vlams  = lam_s
           vyt    = yt

	   no=1000
           t0= Log(mz)
	   tfin= Log(cutoff)
           h=(tfin-t0)/dble(no)
           vs_rge = 0.d0

           do  i = 0,no
	   t=t0+h*dble(i)
     	   call RGE(t0,h,t,vlam,vlamps,vlamS,vyt)

            if (vlam .lt. 0.d0) then 
            vs_rge = 1.d0
            else if (vlams .lt. 0.d0) then 
            vs_rge = 2.d0
            else if (vlam*vlams .lt. vlamps**2/4.d0   .and. vlamps .lt. 0.d0) then 
            vs_rge = 3.d0
            endif

        enddo
	end function
!====== ST parameters ====================================
	complex (kind(0d0)) function  F_stu(qsq,m1,m2)
	double precision, intent(in):: qsq,m1,m2

	F_stu = -B5f(qsq,m1,m2)

	end function
!---------------------------------------------------
	complex (kind(0d0)) function  G_stu(qsq,m1,m2)
	double precision, intent(in):: qsq,m1,m2

	G_stu = -4.d0*m2**2*B0f(qsq,m1,m2) - B5f(qsq,m1,m2)

	end function
!---------------------------------------------------
	complex (kind(0d0)) function  Fp_stu(qsq,m1,m2)
	double precision, intent(in):: qsq,m1,m2

	Fp_stu = (F_stu(qsq,m1,m2)-F_stu(0.d0,m1,m2))/qsq

	end function
!---------------------------------------------------
	complex (kind(0d0)) function  Gp_stu(qsq,m1,m2)
	double precision, intent(in):: qsq,m1,m2

	Gp_stu = (G_stu(qsq,m1,m2)-G_stu(0.d0,m1,m2))/qsq

	end function
!---------------------------------------------------
	complex (kind(0d0)) function  Del_S_HSM(mbh,alpha)
	double precision, intent(in):: mbh,alpha

	Del_S_HSM = sin(alpha)**2/(4.d0*pi)*(& 
         Gp_stu(mz**2,mbh,mz) - Gp_stu(mz**2,mh,mz)&
         )

	end function
!---------------------------------------------------
	complex (kind(0d0)) function  Del_T_HSM(mbh,alpha)
	double precision, intent(in):: mbh,alpha

	Del_T_HSM = sin(alpha)**2/(16.d0*pi**2*alpha_em*vev**2)*(& 
        - G_stu(0.d0,mh,mw)+G_stu(0.d0,mbh,mw)+G_stu(0.d0,mh,mz)-G_stu(0.d0,mbh,mz) &
        )

	end function
 !--------------------------------------------------------
 	double precision function stu(mbh,alpha)
        double precision:: V_inv(2,2),del_chisq,dels,delt
 	double precision, intent(in):: mbh,alpha 

        dels = Del_S_HSM(mbh,alpha)
        delt = Del_T_HSM(mbh,alpha)
        V_inv(1,1) = 1.d0/(sigma_s**2*sigma_t**2)*1.d0/(1.d0-rho_st**2)*sigma_t**2
        V_inv(2,2) = 1.d0/(sigma_s**2*sigma_t**2)*1.d0/(1.d0-rho_st**2)*sigma_s**2
        V_inv(1,2) = -1.d0/(sigma_s**2*sigma_t**2)*1.d0/(1.d0-rho_st**2)*sigma_s*sigma_t*rho_st
        V_inv(2,1) = -1.d0/(sigma_s**2*sigma_t**2)*1.d0/(1.d0-rho_st**2)*sigma_s*sigma_t*rho_st
  
        del_chisq = (dels-s_cent)**2*V_inv(1,1)+(delt-t_cent)**2*V_inv(2,2)+2.d0*(dels-s_cent)*(delt-t_cent)*V_inv(1,2)
        if (del_chisq  .le. 5.99d0) then 
        stu = 0.d0
        else if (del_chisq  .gt. 5.99d0) then 
        stu = 1.d0
        endif
        end function

!#################################################
!
!    SECTION IV 1PI diagrams
!
!#################################################

!====== Loop Functions ==================================================
	complex (kind(0d0)) function Chhh_VSS_full(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	Chhh_VSS_full= &
       +p1sq*c21f(p1sq,p2sq,qsq,m1,m2,m3)&
       +p2sq*c22f(p1sq,p2sq,qsq,m1,m2,m3)&
       +2.d0*p12*c23f(p1sq,p2sq,qsq,m1,m2,m3)&
        +4.d0*c24f(p1sq,p2sq,qsq,m1,m2,m3)-1.d0/2.d0&
       +(4.d0*p1sq+2.d0*p12)*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
       +(4.d0*p12+2.d0*p2sq)*c12f(p1sq,p2sq,qsq,m1,m2,m3)&
       +4.d0*(p1sq+p12)*c0f(p1sq,p2sq,qsq,m1,m2,m3)&
! 
       +p1sq*c21f(p1sq,p2sq,qsq,m3,m1,m2)&
       +p2sq*c22f(p1sq,p2sq,qsq,m3,m1,m2)&
       +2.d0*p12*c23f(p1sq,p2sq,qsq,m3,m1,m2)&
       +4.d0*c24f(p1sq,p2sq,qsq,m3,m1,m2)-1.d0/2.d0&
       +(2.d0*p12)*c11f(p1sq,p2sq,qsq,m3,m1,m2)&
       +(2.d0*p2sq)*c12f(p1sq,p2sq,qsq,m3,m1,m2)&
       -(p1sq+2.d0*p12)*c0f(p1sq,p2sq,qsq,m3,m1,m2)&
! 
       +p1sq*c21f(p1sq,p2sq,qsq,m2,m3,m1)&
       +p2sq*c22f(p1sq,p2sq,qsq,m2,m3,m1)&
       +2.d0*p12*c23f(p1sq,p2sq,qsq,m2,m3,m1)&
       +4.d0*c24f(p1sq,p2sq,qsq,m2,m3,m1)-1.d0/2.d0&
       -(2.d0*p12)*c11f(p1sq,p2sq,qsq,m2,m3,m1)&
       -(2.d0*p2sq)*c12f(p1sq,p2sq,qsq,m2,m3,m1)&
       -(p1sq-p2sq)*c0f(p1sq,p2sq,qsq,m2,m3,m1)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function Chhh_SSV(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	Chhh_SSV= &
       +p1sq*c21f(p1sq,p2sq,qsq,m1,m2,m3)&
       +p2sq*c22f(p1sq,p2sq,qsq,m1,m2,m3)&
       +2.d0*p12*c23f(p1sq,p2sq,qsq,m1,m2,m3)&
       +4.d0*c24f(p1sq,p2sq,qsq,m1,m2,m3)-1.d0/2.d0&
       -(2.d0*p12)*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
       -(2.d0*p2sq)*c12f(p1sq,p2sq,qsq,m1,m2,m3)&
       -(p1sq-p2sq)*c0f(p1sq,p2sq,qsq,m1,m2,m3)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function Chhh_SVS(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	Chhh_SVS= &
       +p1sq*c21f(p1sq,p2sq,qsq,m1,m2,m3)&
       +p2sq*c22f(p1sq,p2sq,qsq,m1,m2,m3)&
       +2.d0*p12*c23f(p1sq,p2sq,qsq,m1,m2,m3)&
       +4.d0*c24f(p1sq,p2sq,qsq,m1,m2,m3)-1.d0/2.d0&
       +(2.d0*p12)*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
       +(2.d0*p2sq)*c12f(p1sq,p2sq,qsq,m1,m2,m3)&
       -(p1sq+2.d0*p12)*c0f(p1sq,p2sq,qsq,m1,m2,m3)

	 end function

!===============================================
	complex (kind(0d0)) function ChVV1_VSV(p1sq,p2sq,qsq,m1,m2,m3,g_V1V3h,g_V1VaS2,g_V3VbS2)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
        complex (kind(0d0)), intent(in):: g_V1V3h,g_V1VaS2,g_V3VbS2
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	ChVV1_VSV = -g_V1V3h*g_V1VaS2*g_V3VbS2*c0f(p1sq,p2sq,qsq,m1,m2,m3)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function ChVV1_VSS(p1sq,p2sq,qsq,m1,m2,m3,g_V1VaS2,g_S2S3Vb,g_S3hV1)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
        complex (kind(0d0)), intent(in):: g_V1VaS2,g_S2S3Vb,g_S3hV1
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	ChVV1_VSS = 2.d0*g_V1VaS2*g_S2S3Vb*g_S3hV1*c24f(p1sq,p2sq,qsq,m1,m2,m3)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function ChVV1_SSV(p1sq,p2sq,qsq,m1,m2,m3,g_V3VbS2,g_S1S2Va,g_S1hV3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
        complex (kind(0d0)), intent(in):: g_V3VbS2,g_S1S2Va,g_S1hV3
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	ChVV1_SSV = -2.d0*g_V3VbS2*g_S1S2Va*g_S1hV3*c24f(p1sq,p2sq,qsq,m1,m2,m3)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function ChVV1_SVS(p1sq,p2sq,qsq,m1,m2,m3,lam,g_V2VaS1,g_V2VbS3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3,lam
        complex (kind(0d0)), intent(in):: g_V2VaS1,g_V2VbS3
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	ChVV1_SVS = lam*g_V2VaS1*g_V2VbS3*c0f(p1sq,p2sq,qsq,m1,m2,m3)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function ChVV1_SSS(p1sq,p2sq,qsq,m1,m2,m3,lam,g_S1S2Va,g_S2S3Vb)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3,lam
        complex (kind(0d0)), intent(in):: g_S1S2Va,g_S2S3Vb
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	ChVV1_SSS = -4.d0*lam*g_S1S2Va*g_S2S3Vb*c24f(p1sq,p2sq,qsq,m1,m2,m3)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function ChVV1_SS(qsq,m1,m2,lam,g_vvss)
	double precision, intent(in):: qsq,m1,m2,lam,g_vvss

	ChVV1_SS = lam*g_vvss*b0f(qsq,m1,m2)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function ChVV1_VS(qsq,m1,m2,g_vvss,g_vvs)
	double precision, intent(in):: qsq,m1,m2,g_vvss
	complex (kind(0d0)), intent(in):: g_vvs

	ChVV1_VS = -g_vvss*g_vvs*b0f(qsq,m1,m2)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function ChVV1_VV(qsq,m1,m2,g_vvvv,g_vvs)
	double precision, intent(in):: qsq,m1,m2,g_vvvv
	complex (kind(0d0)), intent(in):: g_vvs

	ChVV1_VV = g_vvvv*g_vvs*(6.d0*b0f(qsq,m1,m2)-4.d0)

	 end function

!========================================================
	complex (kind(0d0)) function PiWW_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	PiWW_S=&
	 g**2/(16.d0*pi**2)*(&
	+cos(alpha)**2*( mw**2*b0f(qsq,mh,mW)+1.d0/4.d0*b5f(qsq,mh,mw) )&
	+sin(alpha)**2*( mw**2*b0f(qsq,mbh,mW)+1.d0/4.d0*b5f(qsq,mbh,mw) )&	
	)

	end function
!---------------------------------------------
	complex (kind(0d0)) function PiZZ_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	PiZZ_S=&
	 g**2/cw**2/(16.d0*pi**2)*(&
	 +cos(alpha)**2*(mZ**2*b0f(qsq,mh,mZ)+1.d0/4.d0*b5f(qsq,mh,mZ))&
	 +sin(alpha)**2*(mZ**2*b0f(qsq,mbh,mZ)+1.d0/4.d0*b5f(qsq,mbh,mZ))&
	 )
 
	end function
!---------------------------------------------
	complex (kind(0d0)) function PiWW_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s
	
	PiWW_B = PiWW_B_WOH(qsq)+PiWW_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)

 	end function
!---------------------------------------------
	complex (kind(0d0)) function PiGG_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s
	
	PiGG_B = PiGG_B_WOH(qsq)

 	end function
!---------------------------------------------
	complex (kind(0d0)) function PiZG_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s
	
	PiZG_B = PiZG_B_WOH(qsq)

 	end function
!---------------------------------------------
	complex (kind(0d0)) function PiZZ_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s
	
	PiZZ_B = PiZZ_B_WOH(qsq)+PiZZ_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiGG_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s
	
	dPiGG_B = dPiGG_B_WOH(qsq)

 	end function
!-------- Scalar boson 1, 2 and 3 point functions -----------
	complex (kind(0d0)) function Pih_F(mbH,alpha)
	double precision, intent(in):: mbH,alpha

	Pih_F=&
	      -4.d0*mt**2*3.d0/(16.d0*pi**2)*&
	       1.d0/vev*a0f(mt)*&
	       cos(alpha)&        
!
	      -4.d0*mc**2*3.d0/(16.d0*pi**2)*&
	       1.d0/vev*a0f(mc)*&
	       cos(alpha)&        
!
	      -4.d0*mb**2*3.d0/(16.d0*pi**2)*&
	       1.d0/vev*a0f(mb)*&
	       cos(alpha)&
!
	      -4.d0*mtau**2*1.d0/(16.d0*pi**2)*&
	       1.d0/vev*a0f(mtau)*&
	       cos(alpha)

	 end function
!---------------------------------------------
      complex (kind(0d0)) function Pih_B(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s      

      Pih_B =  1.d0/(16.d0*pi**2)*(&
         -  3.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*  a0f(mh)&
         -  lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*     a0f(mbH)&
         -  lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*     a0f(mw)&
         -  lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*       a0f(mz)&
         -  2.d0*mw**2/vev*cos(alpha)*a0f(mw)&
         -  mz**2/vev*cos(alpha)     *a0f(mz)&
         +  2.d0*mw**2/vev*cos(alpha)*(4.d0*a0f(mw) -2.d0*mw**2)&
         +  mz**2/vev*cos(alpha)     *(4.d0*a0f(mz) -2.d0*mz**2)&
                               ) 

       end function
!--------------------------------------------------------
	complex (kind(0d0)) function PibH_F(mbH,alpha)
	double precision, intent(in):: mbH,alpha

	PibH_F=&
	      -4.d0*mt**2*3.d0/(16.d0*pi**2)*&
	       1.d0/vev*a0f(mt)*&
	       sin(alpha)&        
!
	      -4.d0*mc**2*3.d0/(16.d0*pi**2)*&
	       1.d0/vev*a0f(mc)*&
	       sin(alpha)&        
!
	      -4.d0*mb**2*3.d0/(16.d0*pi**2)*&
	       1.d0/vev*a0f(mb)*&
	       sin(alpha)&
!
	      -4.d0*mtau**2*1.d0/(16.d0*pi**2)*&
	       1.d0/vev*a0f(mtau)*&
	       sin(alpha)


	 end function
!---------------------------------------------
      complex (kind(0d0)) function PibH_B(mbH,alpha,lam_ps,lam_s,mu_s)  
      double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s      

      PibH_B =  1.d0/(16.d0*pi**2)*(&
         -  lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)         *a0f(mh)  &
         -  3.d0*lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)  *a0f(mbH) &
         -  lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)       *a0f(mw)  &
         -  lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s)         *a0f(mz)  &
         -  2.d0*mw**2/vev*sin(alpha)   *a0f(mw)  &
         -  mz**2/vev*sin(alpha)        *a0f(mz)  &
         +  2.d0*mw**2/vev*sin(alpha)   *(4.d0*a0f(mw) -2.d0*mw**2)  &
         +  mz**2/vev*sin(alpha)        *(4.d0*a0f(mz) -2.d0*mz**2)  &
          ) 

   end function
!--------------------------------------------------------
	complex (kind(0d0)) function Pihh_F(qsq,mbH,alpha)
	double precision, intent(in):: qsq,mbH,alpha

	Pihh_F=&
	 -4.d0*mt**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mt)&
	 +(2.d0*mt**2-qsq/2.d0)*b0f(qsq,mt,mt)&
	 )*&
	cos(alpha)**2&
!
	 -4.d0*mc**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mc)&
	 +(2.d0*mc**2-qsq/2.d0)*b0f(qsq,mc,mc)&
	 )*&
	cos(alpha)**2&
!
	 -4.d0*mb**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mb)&
	 +(2.d0*mb**2-qsq/2.d0)*b0f(qsq,mb,mb)&
	 )*&
	cos(alpha)**2&
!
	 -4.d0*mtau**2*1.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mtau)&
	 +(2.d0*mtau**2-qsq/2.d0)*b0f(qsq,mtau,mtau)&
	 )*&
	cos(alpha)**2

	 end function
!--------------------------------------------------------
      complex (kind(0d0)) function Pihh_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)  
      double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s      
      
      Pihh_B = 1.d0/(16.d0*pi**2)*(                  &
      - 2.d0  *lam_bHbHhh(mbH,alpha,lam_ps,lam_s,mu_s)     *a0f(mbH)  &
      - 12.d0 *lam_hhhh(mbH,alpha,lam_ps,lam_s,mu_s)       *a0f(mh)   &
      - 2.d0  *lam_GpGmhh(mbH,alpha,lam_ps,lam_s,mu_s)     *a0f(mw)   &
      - 2.d0  *lam_GGhh(mbH,alpha,lam_ps,lam_s,mu_s)       *a0f(mz)   &
      + 2.d0  *mw**2/vev**2*cos(alpha)**2*(4.d0*a0f(mw) -2.d0*mw**2)  &
      + 1.d0  *mz**2/vev**2*cos(alpha)**2*(4.d0*a0f(mz) -2.d0*mz**2)  &
      + 1.d0  *lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)**2   *b0f(qsq,mw,mw)             &
      + 2.d0  *lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)**2   *b0f(qsq,mbH,mbH)           &
      + 18.d0 *lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)**2     *b0f(qsq,mh,mh)             &
      + 4.d0  *lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)**2    *b0f(qsq,mh,mbH)            &
      + 2.d0  *lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)**2     *b0f(qsq,mz,mz)             &
      + 4.d0*mw**4/vev**2*cos(alpha)**2  *(4.d0*b0f(qsq,mw,mw) -2.d0)&
      + 2.d0*mz**4/vev**2*cos(alpha)**2  *(4.d0*b0f(qsq,mz,mz) -2.d0)&
      - 2.d0*mw**2/vev**2*cos(alpha)**2  *(a0f(mw)+(2.d0*qsq+mw**2)*b0f(qsq,mw,mw) )   &
      - 1.d0*mz**2/vev**2*cos(alpha)**2  *(a0f(mz)+(2.d0*qsq+mz**2)*b0f(qsq,mz,mz) )  &
      - 2.d0*mw**4/vev**2*cos(alpha)**2  *b0f(qsq,mw,mw)             &
      - 1.d0*mz**4/vev**2*cos(alpha)**2  *b0f(qsq,mz,mz)             &
                )

     end function
!--------------------------------------------------------
	complex (kind(0d0)) function dPihh_F(qsq,mbH,alpha)
	double precision, intent(in):: qsq,alpha,mbH

	dPihh_F=&
	 -4.d0*mt**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	 +(2.d0*mt**2-qsq/2.d0)*db0f(qsq,mt,mt)&
	 +(-1.d0/2.d0)*b0f(qsq,mt,mt)&
	 )*&
	cos(alpha)**2&
!
	 -4.d0*mc**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	 +(2.d0*mc**2-qsq/2.d0)*db0f(qsq,mc,mc)&
	 +(-1.d0/2.d0)*b0f(qsq,mc,mc)&
	 )*&
	cos(alpha)**2&
!
	 -4.d0*mb**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	 +(2.d0*mb**2-qsq/2.d0)*db0f(qsq,mb,mb)&
	 +(-1.d0/2.d0)*b0f(qsq,mb,mb)&
	 )*&
	cos(alpha)**2&
!
	 -4.d0*mtau**2*1.d0/(16.d0*pi**2*vev**2)*&
	(&
	 +(2.d0*mtau**2-qsq/2.d0)*db0f(qsq,mtau,mtau)&
	 +(-1.d0/2.d0)*b0f(qsq,mtau,mtau)&
	 )*&
	cos(alpha)**2

	 end function
!--------------------------------------------------------
      complex (kind(0d0)) function dPihh_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)  
      double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s      
      
      dPihh_B = 1.d0/(16.d0*pi**2)*(                                         &
      + 1.d0  *lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)**2  *db0f(qsq,mw,mw)                   &
      + 2.d0  *lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)**2  *db0f(qsq,mbH,mbH)                 &
      + 18.d0 *lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)**2    *db0f(qsq,mh,mh)                   &
      + 4.d0  *lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)**2   *db0f(qsq,mh,mbH)                  &
      + 2.d0  *lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)**2    *db0f(qsq,mz,mz)                   &
      + 4.d0*mw**4/vev**2*cos(alpha)**2 *4.d0*db0f(qsq,mw,mw)              &
      + 2.d0*mz**4/vev**2*cos(alpha)**2 *4.d0*db0f(qsq,mz,mz)              &
      - 2.d0*mw**2/vev**2*cos(alpha)**2 *(2.d0*qsq+mw**2)*db0f(qsq,mw,mw)  &
      - 2.d0*mw**2/vev**2*cos(alpha)**2 *2.d0*b0f(qsq,mw,mw)               &
      - 1.d0*mz**2/vev**2*cos(alpha)**2 *(2.d0*qsq+mz**2)*db0f(qsq,mz,mz)  &
      - 1.d0*mz**2/vev**2*cos(alpha)**2 *2.d0*b0f(qsq,mz,mz)               &
      - 2.d0*mw**4/vev**2*cos(alpha)**2 *db0f(qsq,mw,mw)                   &
      - 1.d0*mz**4/vev**2*cos(alpha)**2 *db0f(qsq,mz,mz)                   &
                )

     end function
!--------------------------------------------------------
	complex (kind(0d0)) function PibHbH_F(qsq,mbH,alpha)
	double precision, intent(in):: qsq,mbH,alpha

	PibHbH_F=&
	 -4.d0*mt**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mt)&
	 +(2.d0*mt**2-qsq/2.d0)*b0f(qsq,mt,mt)&
	 )*&
	sin(alpha)**2&
!
	 -4.d0*mc**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mc)&
	 +(2.d0*mc**2-qsq/2.d0)*b0f(qsq,mc,mc)&
	 )*&
	sin(alpha)**2&
!
	 -4.d0*mb**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mb)&
	 +(2.d0*mb**2-qsq/2.d0)*b0f(qsq,mb,mb)&
	 )*&
	sin(alpha)**2&
!
	 -4.d0*mtau**2*1.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mtau)&
	 +(2.d0*mtau**2-qsq/2.d0)*b0f(qsq,mtau,mtau)&
	 )*&
	sin(alpha)**2

	 end function
!--------------------------------------------------------
      complex (kind(0d0)) function PibHbH_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)  
      double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s      
      
      PibHbH_B = 1.d0/(16.d0*pi**2)*(                  &
      - 12.d0  *lam_bHbHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)  *a0f(mbH)  &
      - 2.d0   *lam_bHbHhh(mbH,alpha,lam_ps,lam_s,mu_s)    *a0f(mh)   &
      - 2.d0  *lam_GpGmbHbH(mbH,alpha,lam_ps,lam_s,mu_s)   *a0f(mw)   &
      - 2.d0  *lam_GGbHbH(mbH,alpha,lam_ps,lam_s,mu_s)     *a0f(mz)   &
      + 2.d0  *mw**2/vev**2*sin(alpha)**2*(4.d0*a0f(mw) -2.d0*mw**2)  &
      + 1.d0  *mz**2/vev**2*sin(alpha)**2*(4.d0*a0f(mz) -2.d0*mz**2)  &
      + 1.d0  *lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)**2  *b0f(qsq,mw,mw)             &
      + 18.d0 *lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)**2  *b0f(qsq,mbH,mbH)           &
      + 2.d0  *lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)**2    *b0f(qsq,mh,mh)             &
      + 4.d0  *lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)**2   *b0f(qsq,mh,mbH)            &
      + 2.d0  *lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s)**2    *b0f(qsq,mz,mz)             &
      + 4.d0*mw**4/vev**2*sin(alpha)**2  *(4.d0*b0f(qsq,mw,mw) -2.d0)&
      + 2.d0*mz**4/vev**2*sin(alpha)**2  *(4.d0*b0f(qsq,mz,mz) -2.d0)&
      - 2.d0*mw**2/vev**2*sin(alpha)**2  *(a0f(mw)+(2.d0*qsq+mw**2)*b0f(qsq,mw,mw) )   &
      - 1.d0*mz**2/vev**2*sin(alpha)**2  *(a0f(mz)+(2.d0*qsq+mz**2)*b0f(qsq,mz,mz) )  &
      - 2.d0*mw**4/vev**2*sin(alpha)**2  *b0f(qsq,mw,mw)             &
      - 1.d0*mz**4/vev**2*sin(alpha)**2  *b0f(qsq,mz,mz)             &
                )

     end function
!--------------------------------------------------------
      complex (kind(0d0)) function dPibHbH_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)  
      double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s      
      
      dPibHbH_B = 1.d0/(16.d0*pi**2)*(                  &
      + 1.d0  *lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)**2  *db0f(qsq,mw,mw)             &
      + 18.d0 *lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)**2  *db0f(qsq,mbH,mbH)           &
      + 2.d0  *lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)**2    *db0f(qsq,mh,mh)             &
      + 4.d0  *lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)**2   *db0f(qsq,mh,mbH)            &
      + 2.d0  *lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s)**2    *db0f(qsq,mz,mz)             &
      + 4.d0*mw**4/vev**2*sin(alpha)**2  *(4.d0*db0f(qsq,mw,mw) )&
      + 2.d0*mz**4/vev**2*sin(alpha)**2  *(4.d0*db0f(qsq,mz,mz) )&
      - 2.d0*mw**2/vev**2*sin(alpha)**2  *(2.d0*qsq+mw**2)*db0f(qsq,mw,mw)  &
      - 1.d0*mz**2/vev**2*sin(alpha)**2  *(2.d0*qsq+mz**2)*db0f(qsq,mz,mz)  &
      - 2.d0*mw**2/vev**2*sin(alpha)**2  *(2.d0)*b0f(qsq,mw,mw)  &
      - 1.d0*mz**2/vev**2*sin(alpha)**2  *(2.d0)*b0f(qsq,mz,mz)  &
      - 2.d0*mw**4/vev**2*sin(alpha)**2  *db0f(qsq,mw,mw)             &
      - 1.d0*mz**4/vev**2*sin(alpha)**2  *db0f(qsq,mz,mz)             &
                )



     end function
!---------------------------------------------
	complex (kind(0d0)) function PibHh_F(qsq,mbH,alpha)
	double precision, intent(in):: qsq,mbH,alpha

	PibHh_F=&
	 -4.d0*mt**2*3.d0/(16.d0*pi**2*vev**2)*&
	(a0f(mt)&
	 +(2.d0*mt**2-qsq/2.d0)*b0f(qsq,mt,mt)&
	 )*cos(alpha)*sin(alpha)&	
!
	 -4.d0*mc**2*3.d0/(16.d0*pi**2*vev**2)*&
	(a0f(mc)&
	 +(2.d0*mc**2-qsq/2.d0)*b0f(qsq,mc,mc)&
	 )*cos(alpha)*sin(alpha)&	
!
	 -4.d0*mb**2*3.d0/(16.d0*pi**2*vev**2)*&
	( a0f(mb)&
	 +(2.d0*mb**2-qsq/2.d0)*b0f(qsq,mb,mb)&
	 )*cos(alpha)*sin(alpha)&
!
	 -4.d0*mtau**2*1.d0/(16.d0*pi**2*vev**2)*&
	( a0f(mtau)&
	 +(2.d0*mtau**2-qsq/2.d0)*b0f(qsq,mtau,mtau)&
	 )*cos(alpha)*sin(alpha)


	
	 end function
!--------------------------------------------------------
	complex (kind(0d0)) function dPibHbH_F(qsq,mbH,alpha)
	double precision, intent(in):: qsq,alpha,mbH

	dPibHbH_F=&
	 -4.d0*mt**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	 +(2.d0*mt**2-qsq/2.d0)*db0f(qsq,mt,mt)&
	 +(-1.d0/2.d0)*b0f(qsq,mt,mt)&
	 )*&
	sin(alpha)**2&
!
	 -4.d0*mc**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	 +(2.d0*mc**2-qsq/2.d0)*db0f(qsq,mc,mc)&
	 +(-1.d0/2.d0)*b0f(qsq,mc,mc)&
	 )*&
	sin(alpha)**2&
!
	 -4.d0*mb**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	 +(2.d0*mb**2-qsq/2.d0)*db0f(qsq,mb,mb)&
	 +(-1.d0/2.d0)*b0f(qsq,mb,mb)&
	 )*&
	sin(alpha)**2&
!
	 -4.d0*mtau**2*1.d0/(16.d0*pi**2*vev**2)*&
	(&
	 +(2.d0*mtau**2-qsq/2.d0)*db0f(qsq,mtau,mtau)&
	 +(-1.d0/2.d0)*b0f(qsq,mtau,mtau)&
	 )*&
	sin(alpha)**2

	 end function
!--------------------------------------------------------
      complex (kind(0d0)) function PibHh_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s      
      
      PibHh_B = 1.d0/(16.d0*pi**2)*(  &
      - 3.d0* lam_bHbHbHh(mbH,alpha,lam_ps,lam_s,mu_s)                   *a0f(mbH)                    &   
      - 3.d0* lam_bHhhh(mbH,alpha,lam_ps,lam_s,mu_s)                     *a0f(mh)                     &
      - 1.d0* lam_GpGmbHh(mbH,alpha,lam_ps,lam_s,mu_s)                   *a0f(mw)                     &
      - 1.d0* lam_GGbHh(mbH,alpha,lam_ps,lam_s,mu_s)                     *a0f(mz)                     &
      + 4.d0*mw**2/vev**2*cos(alpha)*sin(alpha)        *(4.d0*a0f(mw) -2.d0*mw**2)  &
      + 2.d0*mz**2/vev**2*cos(alpha)*sin(alpha)        *(4.d0*a0f(mz) -2.d0*mz**2)  &
      + 1.d0*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)*b0f(qsq,mw,mw)             &
      + 6.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)*b0f(qsq,mbH,mbH)           &
      + 6.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)    *b0f(qsq,mh,mh)             &
      + 4.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)  *b0f(qsq,mh,mbH)            &
      + 2.d0*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s)    *b0f(qsq,mz,mz)             &
      + 4.d0*mw**4/vev**2 *cos(alpha)*sin(alpha)       *(4.d0*b0f(qsq,mw,mw) -2.d0) &
      + 2.d0*mz**4/vev**2 *cos(alpha)*sin(alpha)       *(4.d0*b0f(qsq,mz,mz) -2.d0) &
      - 2.d0*mw**2/vev**2 *cos(alpha)*sin(alpha)       *(a0f(mw)+(2.d0*qsq+mw**2 )*b0f(qsq,mw,mw)) &
      - 1.d0*mz**2/vev**2 *cos(alpha)*sin(alpha)       *(a0f(mz)+(2.d0*qsq+mz**2 )*b0f(qsq,mz,mz)) &
      - 2.d0*mw**4/vev**2*cos(alpha)*sin(alpha)        *b0f(qsq,mw,mw)   &
      - 1.d0*mz**4/vev**2*cos(alpha)*sin(alpha)        *b0f(qsq,mz,mz)   &
                )

     end function
!--------------------------------------------------------
      complex (kind(0d0)) function PibHh_PT(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s      
      
      PibHh_PT = -g**2/(32.d0*pi**2)*(  &
           (2.d0*qsq-mh**2-mbH**2)*cos(alpha)*sin(alpha)*b0f(qsq,mW,mW)&
                                     )&
                 -gz**2/(64.d0*pi**2)*(  &
           (2.d0*qsq-mh**2-mbH**2)*cos(alpha)*sin(alpha)*b0f(qsq,mZ,mZ)&
                                     )

     end function
!====== Fermion two-point functions ========
	complex (kind(0d0)) function Piff_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf,mfp)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf,mfp
	double precision:: vf,af,qf
        if (mf .eq. mb) then 
        vf = vb
        af = ab
        qf = qb
        elseif (mf .eq. mt .or. mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        endif

	Piff_S= -1.d0/(16.d0*pi**2)*(&
	2.d0*(g*sw)**2*Qf**2*(2.d0*b0f(qsq,mf,mphoton)-1.d0)&
	+2.d0*gz**2*(vf**2-af**2)*(2.d0*b0f(qsq,mf,mZ)-1.d0)&
	+mf**2/vev**2*(b0f(qsq,mf,mz)-cos(alpha)**2*b0f(qsq,mf,mh)-sin(alpha)**2*b0f(qsq,mf,mbh)&
	+2.d0*mfp**2/mf**2*b0f(qsq,mfp,mw)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function dPiff_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf,mfp)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf,mfp
	double precision:: vf,af,qf
        if (mf .eq. mb) then 
        vf = vb
        af = ab
        qf = qb
        elseif (mf .eq. mt .or. mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        endif

	dPiff_S= -1.d0/(16.d0*pi**2)*(&
	2.d0*(g*sw)**2*Qf**2*(2.d0*db0f(qsq,mf,mphoton))&
	+2.d0*gz**2*(vf**2-af**2)*(2.d0*db0f(qsq,mf,mZ))&
	+mf**2/vev**2*(db0f(qsq,mf,mz)-cos(alpha)**2*db0f(qsq,mf,mh)-sin(alpha)**2*db0f(qsq,mf,mbh)&
	+2.d0*mfp**2/mf**2*db0f(qsq,mfp,mw)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function Piff_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf,mfp)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf,mfp
	double precision:: vf,af,qf
        if (mf .eq. mb) then 
        vf = vb
        af = ab
        qf = qb
        elseif (mf .eq. mt .or. mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        endif

	Piff_V= -1.d0/(16.d0*pi**2)*(&
	(g*sw)**2*Qf**2*(2.d0*b1f(qsq,mf,mphoton)+1.d0)&
	+gz**2*(vf**2+af**2)*(2.d0*b1f(qsq,mf,mZ)+1.d0)&
	+g**2/4.d0*(2.d0*b1f(qsq,mfp,mW)+1.d0)&
	+mf**2/vev**2*(cos(alpha)**2*b1f(qsq,mf,mh)+sin(alpha)**2*b1f(qsq,mf,mbh)+b1f(qsq,mf,mz)&
	+(mfp**2+mf**2)/mf**2*b1f(qsq,mfp,mw)&	
	            )&
	)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function dPiff_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf,mfp)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf,mfp
	double precision:: vf,af,qf
        if (mf .eq. mb) then 
        vf = vb
        af = ab
        qf = qb
        elseif (mf .eq. mt .or. mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        endif

	dPiff_V= -1.d0/(16.d0*pi**2)*(&
	(g*sw)**2*Qf**2*(2.d0*db1f(qsq,mf,mphoton))&
	+gz**2*(vf**2+af**2)*(2.d0*db1f(qsq,mf,mZ))&
	+g**2/4.d0*(2.d0*db1f(qsq,mfp,mW))&
	+mf**2/vev**2*(cos(alpha)**2*db1f(qsq,mf,mh)+sin(alpha)**2*db1f(qsq,mf,mbh)+db1f(qsq,mf,mz)&
	+(mfp**2+mf**2)/mf**2*db1f(qsq,mfp,mw)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function Pitt_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Pitt_S = Piff_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mt,mb)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function Pibb_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Pibb_S = Piff_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mb,mt)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function Pitautau_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Pitautau_S = Piff_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mtau,0.d0)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function Picc_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Picc_S = Piff_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mc,ms)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function dPitt_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	dPitt_S = dPiff_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mt,mb)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function dPibb_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	dPibb_S = dPiff_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mb,mt)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function dPitautau_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	dPitautau_S = dPiff_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mtau,0.d0)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function dPicc_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	dPicc_S = dPiff_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mc,ms)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function Pitt_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Pitt_V = Piff_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mt,mb)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function Pibb_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Pibb_V = Piff_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mb,mt)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function Pitautau_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Pitautau_V = Piff_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mtau,0.d0)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function Picc_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Picc_V = Piff_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mc,ms)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function dPitt_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	dPitt_V = dPiff_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mt,mb)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function dPibb_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	dPibb_V = dPiff_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mb,mt)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function dPitautau_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	dPitautau_V = dPiff_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mtau,0.d0)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function dPicc_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	dPicc_V = dPiff_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mc,ms)

	 end function
!--------------------------------------------------------
        complex (kind(0d0)) function Gam_hhh_F(p1sq,p2sq,qsq,mbH,alpha)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha

	Gam_hhh_F = &
                    -cos(alpha)**3*8.d0*mt**4*3.d0/(16.d0*pi**2)/vev**3*&
                   (   b0f(p1sq,mt,mt)+b0f(p2sq,mt,mt)+b0f(qsq,mt,mt)&
                    +( (4.d0*mt**2-qsq+(qsq-p1sq-p2sq)/2.d0 )*c0f(p1sq,p2sq,qsq,mt,mt,mt) )&
                   )&

                    -cos(alpha)**3*8.d0*mc**4*3.d0/(16.d0*pi**2)/vev**3*&
                   (   b0f(p1sq,mc,mc)+b0f(p2sq,mc,mc)+b0f(qsq,mc,mc)&
                    +( (4.d0*mc**2-qsq+(qsq-p1sq-p2sq)/2.d0 )*c0f(p1sq,p2sq,qsq,mc,mc,mc) )&
                   )&
!
                    -cos(alpha)**3*8.d0*mb**4*3.d0/(16.d0*pi**2)/vev**3*&
                   (   b0f(p1sq,mb,mb)+b0f(p2sq,mb,mb)+b0f(qsq,mb,mb)&
                    +( (4.d0*mb**2-qsq+(qsq-p1sq-p2sq)/2.d0 )*c0f(p1sq,p2sq,qsq,mb,mb,mb) )&
                   )&
!
                    -cos(alpha)**3*8.d0*mtau**4*1.d0/(16.d0*pi**2)/vev**3*&
                   (   b0f(p1sq,mtau,mtau)+b0f(p2sq,mtau,mtau)+b0f(qsq,mtau,mtau)&
                    +( (4.d0*mtau**2-qsq+(qsq-p1sq-p2sq)/2.d0 )*c0f(p1sq,p2sq,qsq,mtau,mtau,mtau) )&
                   )
	
	 end function
!---------------------------------------------
      complex (kind(0d0)) function Gam_hhh_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

      Gam_hhh_B =&
      1.d0/(16.d0*pi**2)*(&
        16.d0*mw**4/vev**3*  cos(alpha)**3*(b0f(qsq,mw,mw)+b0f(p1sq,mw,mw)+ b0f(p2sq,mw,mw) ) &
        - 4.d0*mw**6/vev**3* cos(alpha)**3*c0f(p1sq,p2sq,qsq,mw,mw,mw) &
        - 4.d0*mw**4/vev**3* cos(alpha)**3*2.d0*3.d0&
        + 8.d0*mz**4/vev**3* cos(alpha)**3*(b0f(qsq,mz,mz)+b0f(p1sq,mz,mz)+b0f(p2sq,mz,mz)) &
        - 2.d0*mz**6/vev**3* cos(alpha)**3*c0f(p1sq,p2sq,qsq,mz,mz,mz) &
        - 2.d0*mz**4/vev**3* cos(alpha)**3*2.d0*3.d0&
!
         +2.d0*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_GpGmhh(mbH,alpha,lam_ps,lam_s,mu_s)*&
         (b0f(qsq,mw,mw) + b0f(p1sq,mw,mw) + b0f(p2sq,mw,mw) )&
         +4.d0*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_GGhh(mbH,alpha,lam_ps,lam_s,mu_s)*&
         (b0f(qsq,mz,mz) + b0f(p1sq,mz,mz) + b0f(p2sq,mz,mz) )&
         +72.d0* lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_hhhh(mbH,alpha,lam_ps,lam_s,mu_s)*&
         (b0f(qsq,mh,mh) + b0f(p1sq,mh,mh) + b0f(p2sq,mh,mh) )&
!
         + 16.d0* mw**6/vev**3*cos(alpha)**3*4.d0*c0f(p1sq,p2sq,qsq,mw,mw,mw)&
         + 8.d0* mz**6/vev**3* cos(alpha)**3*4.d0*c0f(p1sq,p2sq,qsq,mz,mz,mz)&
         - 2.d0*mz**4/vev**3*  cos(alpha)**3*Chhh_SVV(p1sq,p2sq,qsq,mz,mz,mz)&
         - 4.d0* mw**4/vev**3* cos(alpha)**3*Chhh_SVV(p1sq,p2sq,qsq,mw,mw,mw) &
         + 2.d0* mw**2/vev**2* cos(alpha)**2*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*Chhh_VSS_full(p1sq,p2sq,qsq,mw,mw,mw) &
         + 2.d0* mz**2/vev**2* cos(alpha)**2*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*Chhh_VSS_full(p1sq,p2sq,qsq,mz,mz,mz) &
         - 2.d0* lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)**3*c0f(p1sq,p2sq,qsq,mw,mw,mw)&
         - 8.d0* lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)**3*  c0f(p1sq,p2sq,qsq,mz,mz,mz)&
         - 216.d0* lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)**3*c0f(p1sq,p2sq,qsq,mh,mh,mh)&
! 
        - 24.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)**2*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*&
         (  c0f(p1sq,p2sq,qsq,mh,mh,mbH)&
                                                           + c0f(p1sq,p2sq,qsq,mh,mbH,mh) &
                                                           + c0f(p1sq,p2sq,qsq,mbH,mh,mh) )&
        - 8.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)**2*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*( &
      c0f(p1sq,p2sq,qsq,mh,mbH,mbH)&
                                                          + c0f(p1sq,p2sq,qsq,mbH,mbH,mh) &
                                                          + c0f(p1sq,p2sq,qsq,mbH,mh,mbH) )&
        - 8.d0* lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)**3*c0f(p1sq,p2sq,qsq,mbH,mbH,mbH)&
!
         +12.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_bHhhh(mbH,alpha,lam_ps,lam_s,mu_s)* &
      (b0f(qsq,mbH,mh) + b0f(p1sq,mbH,mh) + b0f(p2sq,mbH,mh) )&
         +4.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_bHbHhh(mbH,alpha,lam_ps,lam_s,mu_s)*&
      (b0f(qsq,mbH,mbH)+ b0f(p1sq,mbH,mbH)+ b0f(p2sq,mbH,mbH) )&
              ) 
    
	end function
!--------------------------------------------------------
        complex (kind(0d0)) function Gam_bHhh_F(p1sq,p2sq,qsq,mbH,alpha)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha

	Gam_bHhh_F = &
                    -cos(alpha)**2*sin(alpha)*8.d0*mt**4*3.d0/(16.d0*pi**2)/vev**3*&
                   (   b0f(p1sq,mt,mt)+b0f(p2sq,mt,mt)+b0f(qsq,mt,mt)&
                    +( (4.d0*mt**2-qsq+(qsq-p1sq-p2sq)/2.d0 )*c0f(p1sq,p2sq,qsq,mt,mt,mt) )&
                   )&
!
                    -cos(alpha)**2*sin(alpha)*8.d0*mc**4*3.d0/(16.d0*pi**2)/vev**3*&
                   (   b0f(p1sq,mc,mc)+b0f(p2sq,mc,mc)+b0f(qsq,mc,mc)&
                    +( (4.d0*mc**2-qsq+(qsq-p1sq-p2sq)/2.d0 )*c0f(p1sq,p2sq,qsq,mc,mc,mc) )&
                   )&
!
                    -cos(alpha)**2*sin(alpha)*8.d0*mb**4*3.d0/(16.d0*pi**2)/vev**3*&
                   (   b0f(p1sq,mb,mb)+b0f(p2sq,mb,mb)+b0f(qsq,mb,mb)&
                    +( (4.d0*mb**2-qsq+(qsq-p1sq-p2sq)/2.d0 )*c0f(p1sq,p2sq,qsq,mb,mb,mb) )&
                   )&
!
                    -cos(alpha)**2*sin(alpha)*8.d0*mtau**4*1.d0/(16.d0*pi**2)/vev**3*&
                   (   b0f(p1sq,mtau,mtau)+b0f(p2sq,mtau,mtau)+b0f(qsq,mtau,mtau)&
                    +( (4.d0*mtau**2-qsq+(qsq-p1sq-p2sq)/2.d0 )*c0f(p1sq,p2sq,qsq,mtau,mtau,mtau) )&
                   )
	
	 end function
!---------------------------------------------
      complex (kind(0d0)) function Gam_bHhh_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

      Gam_bHhh_B =&
      1.d0/(16.d0*pi**2)*(&
        16.d0*mw**4/vev**3*  cos(alpha)**2*sin(alpha)*(b0f(qsq,mw,mw)+b0f(p1sq,mw,mw)+ b0f(p2sq,mw,mw) ) &
        - 4.d0*mw**6/vev**3* cos(alpha)**2*sin(alpha)*c0f(p1sq,p2sq,qsq,mw,mw,mw) &
        - 4.d0*mw**4/vev**3* cos(alpha)**2*sin(alpha)*2.d0*3.d0&
        + 8.d0*mz**4/vev**3* cos(alpha)**2*sin(alpha)*(b0f(qsq,mz,mz)+b0f(p1sq,mz,mz)+b0f(p2sq,mz,mz)) &
        - 2.d0*mz**6/vev**3* cos(alpha)**2*sin(alpha)*c0f(p1sq,p2sq,qsq,mz,mz,mz) &
        - 2.d0*mz**4/vev**3* cos(alpha)**2*sin(alpha)*2.d0*3.d0&
!
         +2.d0*lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)*lam_GpGmhh(mbH,alpha,lam_ps,lam_s,mu_s)*b0f(qsq,mw,mw) &
         +lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_GpGmbHh(mbH,alpha,lam_ps,lam_s,mu_s)*&
         (b0f(p1sq,mw,mw) + b0f(p2sq,mw,mw) )&
         +4.d0*lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s)*lam_GGhh(mbH,alpha,lam_ps,lam_s,mu_s)*b0f(qsq,mz,mz)&
         +2.d0*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_GGbHh(mbH,alpha,lam_ps,lam_s,mu_s)*(b0f(p1sq,mz,mz)+b0f(p2sq,mz,mz))&
         +24.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_hhhh(mbH,alpha,lam_ps,lam_s,mu_s)*b0f(qsq,mh,mh)&
         +18.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_bHhhh(mbH,alpha,lam_ps,lam_s,mu_s)*(b0f(p1sq,mh,mh) + b0f(p2sq,mh,mh))&
         +12.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_bHhhh(mbH,alpha,lam_ps,lam_s,mu_s)*b0f(qsq,mbH,mh)&
         +8.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_bHbHhh(mbH,alpha,lam_ps,lam_s,mu_s)*(b0f(p1sq,mbH,mh) + b0f(p2sq,mbH,mh))&
         +12.d0*lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)*lam_bHbHhh(mbH,alpha,lam_ps,lam_s,mu_s)*b0f(qsq,mbH,mbH)&
         +6.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_bHbHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*&
                                                           (b0f(p1sq,mbH,mbH) + b0f(p2sq,mbH,mbH))&
!
         + 16.d0* mw**6/vev**3*cos(alpha)**2*sin(alpha)*4.d0*c0f(p1sq,p2sq,qsq,mW,mW,mW)&
         + 8.d0* mz**6/vev**3* cos(alpha)**2*sin(alpha)*4.d0*c0f(p1sq,p2sq,qsq,mZ,mZ,mZ)&
!
         - 4.d0*mw**4/vev**3*  cos(alpha)**2*sin(alpha)*Chhh_SVV(p1sq,p2sq,qsq,mW,mW,mw)&
         - 2.d0*mz**4/vev**3*  cos(alpha)**2*sin(alpha)*Chhh_SVV(p1sq,p2sq,qsq,mZ,mZ,mz)&
!
         + 2.d0*mw**2/vev**2*  cos(alpha)*sin(alpha)*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*&
                          (Chhh_VSS(p1sq,p2sq,qsq,mW,mw,mw)+Chhh_SSV(p1sq,p2sq,qsq,mw,mw,mW))&
         + 2.d0*mw**2/vev**2*  cos(alpha)**2*lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)*Chhh_SVS(p1sq,p2sq,qsq,mw,mW,mw)&
         + 2.d0*mz**2/vev**2*  cos(alpha)*sin(alpha)*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*&
                                                  (Chhh_VSS(p1sq,p2sq,qsq,mZ,mz,mz)+Chhh_SSV(p1sq,p2sq,qsq,mz,mz,mZ))&
         + 2.d0*mz**2/vev**2*  cos(alpha)**2*lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s)*Chhh_SVS(p1sq,p2sq,qsq,mz,mZ,mz)&
!
         - 2.d0*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)**2*lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)*c0f(p1sq,p2sq,qsq,mw,mw,mw)&
         - 8.d0*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)**2  *lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s)*c0f(p1sq,p2sq,qsq,mz,mz,mz)&
         - 72.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)**2*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*c0f(p1sq,p2sq,qsq,mh,mh,mh)&
         - 24.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*&
                 (c0f(p1sq,p2sq,qsq,mbH,mh,mh) + c0f(p1sq,p2sq,qsq,mh,mh,mbH))&
         - 8.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)**3*c0f(p1sq,p2sq,qsq,mh,mbH,mh)&
         - 24.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)**2*lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)*c0f(p1sq,p2sq,qsq,mbH,mbH,mbH)&
         - 8.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)**2*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*&
                                                                   (c0f(p1sq,p2sq,qsq,mh,mbH,mbH) + c0f(p1sq,p2sq,qsq,mbH,mbH,mh))&
         - 24.d0*lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)**2*c0f(p1sq,p2sq,qsq,mbH,mh,mbH)&
              ) 
    
	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam1_hWW_F(p1sq,p2sq,qsq,mbH,alpha)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha

	Gam1_hWW_F = cos(alpha)*Gam1_hWW_F_SM(p1sq,p2sq,qsq)

	 end function
!--------------------------------------------
	complex (kind(0d0)) function Gam2_hWW_F(p1sq,p2sq,qsq,mbH,alpha)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha

	Gam2_hWW_F = cos(alpha)*Gam2_hWW_F_SM(p1sq,p2sq,qsq)

	 end function
!--------------------------------------------
	complex (kind(0d0)) function Gam3_hWW_F(p1sq,p2sq,qsq,mbH,alpha)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha

	Gam3_hWW_F = cos(alpha)*Gam3_hWW_F_SM(p1sq,p2sq,qsq)

	 end function
!--------------------------------------------
	complex (kind(0d0)) function Gam1_hZZ_F(p1sq,p2sq,qsq,mbH,alpha)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha

	Gam1_hZZ_F = cos(alpha)*Gam1_hZZ_F_SM(p1sq,p2sq,qsq)
	
	 end function
!--------------------------------------------
	complex (kind(0d0)) function Gam2_hZZ_F(p1sq,p2sq,qsq,mbH,alpha)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha

	Gam2_hZZ_F =  cos(alpha)*Gam2_hZZ_F_SM(p1sq,p2sq,qsq)
	
	 end function
!--------------------------------------------
	complex (kind(0d0)) function Gam3_hZZ_F(p1sq,p2sq,qsq,mbH,alpha)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha

	Gam3_hZZ_F = cos(alpha)*Gam3_hZZ_F_SM(p1sq,p2sq,qsq)

	 end function
!--------------------------------------------
	complex (kind(0d0)) function Gam1_hWW_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)  
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s
	double precision:: p12
	p12=(qsq-p1sq-p2sq)/2.d0

	Gam1_hWW_B = 1.d0/(16.d0*pi**2)*&
	 (&
!~~~~~~~~~~~ 3-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	 +cos(alpha)*g**3*cw*mz*ChVV1_VVV(p1sq,p2sq,qsq,mZ,mW,mZ)&
	 +cos(alpha)*g**3*cw**2*mw*ChVV1_VVV(p1sq,p2sq,qsq,mW,mZ,mW)&
	 +cos(alpha)*g**3*sw**2*mw*ChVV1_VVV(p1sq,p2sq,qsq,mW,mphoton,mW)&
	 -cos(alpha)*g**3*sw**2*mw*c24f(p1sq,p2sq,qsq,mw,mphoton,mw)& ! Ghost
	 -cos(alpha)*g**3*cw*mz*c24f(p1sq,p2sq,qsq,mz,mw,mz)&     ! Ghost
	 -cos(alpha)*g**3*cw**2*mw*c24f(p1sq,p2sq,qsq,mw,mz,mw)&  ! Ghost
!~~~~~~~~~~~ 2-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	 -cos(alpha)*1.d0/2.d0*g**3*mw*sw**2*(ChVV1_SVV(p1sq,p2sq,qsq,mw,mZ,mW)-ChVV1_SVV(p1sq,p2sq,qsq,mw,mphoton,mW))& 
	 -cos(alpha)*1.d0/2.d0*g**3*mw*sw**2*(ChVV1_VVS(p1sq,p2sq,qsq,mW,mZ,mw)-ChVV1_VVS(p1sq,p2sq,qsq,mW,mphoton,mw))& 
	 -cos(alpha)*g**3/cw**3*mw**2*mZ*sw**4*c0f(p1sq,p2sq,qsq,mZ,mw,mZ)&
	 -cos(alpha)**3*g**3*mw**3*c0f(p1sq,p2sq,qsq,mW,mh,mW)&
	 -cos(alpha)*sin(alpha)**2*g**3*mw**3*c0f(p1sq,p2sq,qsq,mW,mbh,mW)&
!~~~~~~~~~~~ 1-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	 +lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*mw**2*sw**4/cw**2*c0f(p1sq,p2sq,qsq,mw,mZ,mw)&
	 +lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*sw**2*mw**2*c0f(p1sq,p2sq,qsq,mw,mphoton,mw)&
	 +cos(alpha)**2*6.d0*g**2*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*mw**2*c0f(p1sq,p2sq,qsq,mh,mW,mh)& 
	 +sin(alpha)**2*2.d0*g**2*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*mw**2*c0f(p1sq,p2sq,qsq,mbH,mW,mbH)& 
	 +sin(alpha)*cos(alpha)*2.d0*g**2*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*&
	   mw**2*(c0f(p1sq,p2sq,qsq,mh,mW,mbH)+c0f(p1sq,p2sq,qsq,mbH,mW,mh))& 
	 +cos(alpha)**3*1.d0/2.d0*g**3*mw*( c24f(p1sq,p2sq,qsq,mW,mh,mw) + c24f(p1sq,p2sq,qsq,mw,mh,mW) )&
	 +cos(alpha)*sin(alpha)**2*1.d0/2.d0*g**3*mw*(c24f(p1sq,p2sq,qsq,mW,mbH,mw) + c24f(p1sq,p2sq,qsq,mw,mbH,mW) )&
	 +cos(alpha)*1.d0/2.d0*g**3*sw**2/cw**2*mw*( c24f(p1sq,p2sq,qsq,mz,mw,mZ) + c24f(p1sq,p2sq,qsq,mZ,mw,mz) )&
!~~~~~~~~~~~ 0-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	 -cos(alpha)**2*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*( c24f(p1sq,p2sq,qsq,mw,mh,mw) )&
	 -sin(alpha)**2*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*( c24f(p1sq,p2sq,qsq,mw,mbh,mw) )&
	 -lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*( c24f(p1sq,p2sq,qsq,mw,mz,mw) )&
	 -cos(alpha)**2*6.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*(c24f(p1sq,p2sq,qsq,mh,mw,mh) )&
	 -sin(alpha)**2*2.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*(c24f(p1sq,p2sq,qsq,mbh,mw,mbh) )&
	 -sin(alpha)*cos(alpha)*2.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*&
	    (c24f(p1sq,p2sq,qsq,mh,mw,mbh)+c24f(p1sq,p2sq,qsq,mbh,mw,mh))&
!
	 -2.d0*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*c24f(p1sq,p2sq,qsq,mz,mw,mz)&
!~~~~~~~~~~~ B function-like ~~~~~~~~~~~~~~~~~~~~~~!
	 -cos(alpha)*3.d0*g**3*mw*b0f(qsq,mW,mW)+cos(alpha)*2.d0*g**3*mW&
	 -cos(alpha)*3.d0*g**3*cw*mz*b0f(qsq,mZ,mZ)+cos(alpha)*2.d0*g**3*cw*mZ&
	 +1.d0/2.d0*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*b0f(qsq,mw,mw)&
	 +1.d0/2.d0*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*b0f(qsq,mz,mz)&
	 +3.d0/2.d0*cos(alpha)**2*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*b0f(qsq,mh,mh)&
         +1.d0/2.d0*sin(alpha)**2*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*b0f(qsq,mbh,mbh)&
	 +sin(alpha)*cos(alpha)*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*b0f(qsq,mbH,mh)&
	 -cos(alpha)**3*1.d0/2.d0*g**3*mw*( b0f(p1sq,mW,mh) + b0f(p2sq,mW,mh) )&
	 -cos(alpha)*sin(alpha)**2*1.d0/2.d0*g**3*mw*( b0f(p1sq,mW,mbH) + b0f(p2sq,mW,mbH) )&
	 -cos(alpha)*1.d0/2.d0*g**3*mw*sw**4/cw**2*( b0f(p1sq,mZ,mw) + b0f(p2sq,mZ,mw) )&
	 -cos(alpha)*1.d0/2.d0*g**3*sw**2*mw*( b0f(p1sq,mphoton,mw) + b0f(p2sq,mphoton,mw) )&
	 )

	 end function
!--------------------------------------------
	complex (kind(0d0)) function Gam2_hWW_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s
	double precision:: p12
	p12=(qsq-p1sq-p2sq)/2.d0

	Gam2_hWW_B = g**2/(16.d0*pi**2)*mw**2*(&
                   +cos(alpha)*g*cw*mz*(ChVV2_VVV(p1sq,p2sq,qsq,mZ,mW,mZ) - c1223(p1sq,p2sq,qsq,mz,mw,mz)) &
                   +cos(alpha)*g*mw*cw**2*(ChVV2_VVV(p1sq,p2sq,qsq,mW,mZ,mW)-c1223(p1sq,p2sq,qsq,mw,mz,mw))& 
                   +cos(alpha)*g*mw*sw**2*(ChVV2_VVV(p1sq,p2sq,qsq,mW,mphoton,mW)-c1223(p1sq,p2sq,qsq,mw,mphoton,mw)) &
!
                     -cos(alpha)*g/2.d0*mw*(sw**2*ChVV2_SVV(p1sq,p2sq,qsq,mw,mZ,mW) - sw**2*ChVV2_SVV(p1sq,p2sq,qsq,mw,mphoton,mW))&
                     -cos(alpha)*g/2.d0*mw*(sw**2*ChVV2_VVS(p1sq,p2sq,qsq,mW,mZ,mw) - sw**2*ChVV2_VVS(p1sq,p2sq,qsq,mW,mphoton,mw))&
 !
                     +cos(alpha)**3*g/2.d0*mw*ChVV2_VSS(p1sq,p2sq,qsq,mW,mh,mw)&
                     +cos(alpha)**3*g/2.d0*mw*ChVV2_SSV(p1sq,p2sq,qsq,mw,mh,mW)&
                     +cos(alpha)*sin(alpha)**2*g/2.d0*mw*ChVV2_VSS(p1sq,p2sq,qsq,mW,mbH,mw)&
                     +cos(alpha)*sin(alpha)**2*g/2.d0*mw*ChVV2_SSV(p1sq,p2sq,qsq,mw,mbH,mW)&
                     +cos(alpha)*g/2.d0*mw*sw**2/cw**2*ChVV2_VSS(p1sq,p2sq,qsq,mZ,mw,mz)&
                     +cos(alpha)*g/2.d0*mw*sw**2/cw**2*ChVV2_SSV(p1sq,p2sq,qsq,mz,mw,mZ)&
! 
                     -2.d0*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*c1223(p1sq,p2sq,qsq,mz,mw,mz)&
                     -1.d0*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*cos(alpha)**2*c1223(p1sq,p2sq,qsq,mw,mh,mw)&
                     -1.d0*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*sin(alpha)**2*c1223(p1sq,p2sq,qsq,mw,mbH,mw)&
                     -1.d0*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*c1223(p1sq,p2sq,qsq,mw,mz,mw)&
                     -6.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*cos(alpha)**2*c1223(p1sq,p2sq,qsq,mh,mw,mh)&
                     -2.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*sin(alpha)**2*c1223(p1sq,p2sq,qsq,mbH,mw,mbH)&
                     -2.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*sin(alpha)*cos(alpha)*c1223(p1sq,p2sq,qsq,mbH,mw,mh)&
                     -2.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*sin(alpha)*cos(alpha)*c1223(p1sq,p2sq,qsq,mh,mw,mbH)&
                    )

	 end function
!--------------------------------------------
	complex (kind(0d0)) function Gam1_hZZ_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)  
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s
	double precision:: p12
	p12=(qsq-p1sq-p2sq)/2.d0

	Gam1_hZZ_B =1.d0/(16.d0*pi**2)*(&
	 +2.d0*g_WWh(alpha)*g**2*cw**2*ChVV1_VVV(p1sq,p2sq,qsq,mW,mW,mW)&
	 -2.d0*g_WWh(alpha)*g**2*cw**2*C24f(p1sq,p2sq,qsq,mw,mw,mw)&
!
	 +2.d0*(-g*cw)*g_WZGp(alpha)*(-g_GphW(alpha))*ChVV1_SVV(p1sq,p2sq,qsq,mw,mW,mW)&		
	 +2.d0*g*cw*g_WZGp(alpha)*g_GphW(alpha)*ChVV1_VVS(p1sq,p2sq,qsq,mW,mW,mw)&	 	
         +2.d0*ChVV1_VSV(p1sq,p2sq,qsq,mW,mw,mW,g_WWh(alpha),g_WZGp(alpha),g_WZGp(alpha))&
         +8.d0*ChVV1_VSV(p1sq,p2sq,qsq,mZ,mh,mZ,g_ZZh(alpha),g_ZZh(alpha),g_ZZh(alpha))&
         +8.d0*ChVV1_VSV(p1sq,p2sq,qsq,mZ,mbH,mZ,g_ZZh(alpha),g_ZZbH(alpha),g_ZZbH(alpha))&
!
         +2.d0*ChVV1_SSV(p1sq,p2sq,qsq,mw,mw,mW,g_WZGp(alpha),g_GpGmZ(alpha),-g_GphW(alpha))&
         +2.d0*ChVV1_SSV(p1sq,p2sq,qsq,mz,mh,mZ,g_ZZh(alpha),g_GhZ(alpha),g_GhZ(alpha))&
         +2.d0*ChVV1_SSV(p1sq,p2sq,qsq,mz,mbH,mZ,g_ZZbH(alpha),g_GhZ(alpha),g_GbHZ(alpha))&
         +2.d0*ChVV1_VSS(p1sq,p2sq,qsq,mW,mw,mw,g_WZGp(alpha),g_GpGmZ(alpha),g_GphW(alpha)) &
         +2.d0*ChVV1_VSS(p1sq,p2sq,qsq,mZ,mh,mz, g_ZZh(alpha), -g_GhZ(alpha), g_GhZ(alpha))&
         +2.d0*ChVV1_VSS(p1sq,p2sq,qsq,mZ,mbH,mz,g_ZZbH(alpha),-g_GbHZ(alpha),g_GhZ(alpha))&
!
         +2.d0*ChVV1_SVS(p1sq,p2sq,qsq,mw,mW,mw,lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s),g_WZGp(alpha),g_WZGp(alpha))&
         +24.d0*ChVV1_SVS(p1sq,p2sq,qsq,mh,mZ,mh,lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZh(alpha),g_ZZh(alpha))&
         +8.d0*ChVV1_SVS(p1sq,p2sq,qsq,mbh,mZ,mbh,lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZbH(alpha),g_ZZbH(alpha))&
         +8.d0*ChVV1_SVS(p1sq,p2sq,qsq,mbh,mZ,mh,lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZbH(alpha),g_ZZh(alpha))&
         +8.d0*ChVV1_SVS(p1sq,p2sq,qsq,mh,mZ,mbh,lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZbH(alpha),g_ZZh(alpha))&
!
         +2.d0*ChVV1_SSS(p1sq,p2sq,qsq,mw,mw,mw,  lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s),g_GpGmZ(alpha), g_GpGmZ(alpha))&
         +6.d0*ChVV1_SSS(p1sq,p2sq,qsq,mh,mz,mh,  lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s),  g_GhZ(alpha),  -g_GhZ(alpha))&
         +2.d0*ChVV1_SSS(p1sq,p2sq,qsq,mbH,mz,mbH,lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s),g_GbHZ(alpha), -g_GbHZ(alpha))&
         +2.d0*ChVV1_SSS(p1sq,p2sq,qsq,mbH,mz,mh, lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s), g_GbHZ(alpha), -g_GhZ(alpha))&
         +2.d0*ChVV1_SSS(p1sq,p2sq,qsq,mh,mz,mbH, lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s), g_GhZ(alpha),  -g_GbHZ(alpha))&
         +2.d0*ChVV1_SSS(p1sq,p2sq,qsq,mz,mh,mz,  lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s),  g_GhZ(alpha),  -g_GhZ(alpha))&
         +2.d0*ChVV1_SSS(p1sq,p2sq,qsq,mz,mbh,mz, lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s),  g_GbHZ(alpha), -g_GbHZ(alpha))&
!
         +2.d0*ChVV1_VV(qsq,mW,mW,g_WWZZ(alpha),g_WWh(alpha))&
         +4.d0*ChVV1_SS(qsq,mz,mz,lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZGG(alpha))&
         +2.d0*ChVV1_SS(qsq,mw,mw,lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZGpGm(alpha))&
         +4.d0*ChVV1_SS(qsq,mbH,mbH,lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZbHbH(alpha))&
         +12.d0*ChVV1_SS(qsq,mh,mh,lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZhh(alpha))&
         +4.d0*ChVV1_SS(qsq,mh,mbH,lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZbHh(alpha))&
         +2.d0*ChVV1_VS(p1sq,mW,mw,g_WZGph(alpha),g_WZGp(alpha))&
         +2.d0*ChVV1_VS(p2sq,mW,mw,g_WZGph(alpha),g_WZGp(alpha))&
         +8.d0*ChVV1_VS(p1sq,mZ,mh,g_ZZhh(alpha),g_ZZh(alpha))&
         +8.d0*ChVV1_VS(p2sq,mZ,mh,g_ZZhh(alpha),g_ZZh(alpha))&
         +4.d0*ChVV1_VS(p1sq,mZ,mbH,g_ZZbHh(alpha),g_ZZbH(alpha))&
         +4.d0*ChVV1_VS(p2sq,mZ,mbH,g_ZZbHh(alpha),g_ZZbH(alpha))&
	 )

	 end function
!--------------------------------------------
	complex (kind(0d0)) function Gam2_hZZ_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s
	double precision:: p12
	p12=(qsq-p1sq-p2sq)/2.d0

	Gam2_hZZ_B = gz**2/(16.d0*pi**2)*mz**2*(&
                   +cos(alpha)*2.d0*g*mw*cw**4*(ChVV2_VVV(p1sq,p2sq,qsq,mW,mW,mW) - C1223(p1sq,p2sq,qsq,mw,mw,mw)) &
!
                    +cos(alpha)*g*mw*sw**2*cw**2*ChVV2_SVV(p1sq,p2sq,qsq,mw,mW,mW)&
                    +cos(alpha)*g*mw*sw**2*cw**2*ChVV2_VVS(p1sq,p2sq,qsq,mW,mW,mw)&
!
                    -cos(alpha)*g*mw*(cw**2-sw**2)*sw**2*ChVV2_VSS(p1sq,p2sq,qsq,mW,mw,mw)&
                    -cos(alpha)*g*mw*(cw**2-sw**2)*sw**2*ChVV2_SSV(p1sq,p2sq,qsq,mw,mw,mW)&
                    +cos(alpha)**3*gz/2.d0*mz*ChVV2_VSS(p1sq,p2sq,qsq,mZ,mh,mz)&
                    +cos(alpha)**3*gz/2.d0*mz*ChVV2_SSV(p1sq,p2sq,qsq,mz,mh,mZ)&
                    +cos(alpha)*sin(alpha)**2*gz/2.d0*mz*ChVV2_VSS(p1sq,p2sq,qsq,mZ,mbH,mz)&
                    +cos(alpha)*sin(alpha)**2*gz/2.d0*mz*ChVV2_SSV(p1sq,p2sq,qsq,mz,mbH,mZ)&
! 
                   -2.d0*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*(cw**2-sw**2)**2*c1223(p1sq,p2sq,qsq,mw,mw,mw)&
                    -2.d0*cos(alpha)**2*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*c1223(p1sq,p2sq,qsq,mz,mh,mz)&
                    -2.d0*sin(alpha)**2*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*c1223(p1sq,p2sq,qsq,mz,mbH,mz)&
                    -6.d0*cos(alpha)**2*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*c1223(p1sq,p2sq,qsq,mh,mz,mh)&
                    -2.d0*sin(alpha)**2*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*c1223(p1sq,p2sq,qsq,mbH,mz,mbH)&
                    -2.d0*sin(alpha)*cos(alpha)*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*c1223(p1sq,p2sq,qsq,mbH,mz,mh)&
                    -2.d0*sin(alpha)*cos(alpha)*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*c1223(p1sq,p2sq,qsq,mh,mz,mbH)&
                    )

	 end function
!========================================================================================
	complex (kind(0d0)) function Gam_hff(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf,mfp)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf,mfp
	double precision:: vf,af,qf

        if (mf .eq. mb) then 
        vf = vb
        af = ab
        qf = qb
        elseif (mf .eq. mt .or. mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        endif

	Gam_hff = 1.d0/(16.d0*pi**2)*mf/vev*(&
	-cos(alpha)*4.d0*gz**2*(vf**2-af**2)*Chff_FVF(p1sq,p2sq,qsq,mf,mz)&
	-cos(alpha)*4.d0*(g*sw)**2*Qf**2*Chff_FVF(p1sq,p2sq,qsq,mf,mphoton)&
	+cos(alpha)**3*mf**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mf,mh)&
	+cos(alpha)*sin(alpha)**2*mf**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mf,mbH)&
	-cos(alpha)*mf**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mf,mz)&
	-cos(alpha)*2.d0*mfp**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mfp,mw)&
	-cos(alpha)*2.d0*gz**4*vev**2*(vf**2-af**2)*c0f(p1sq,p2sq,qsq,mZ,mf,mZ)&
!
	-6.d0*cos(alpha)**2*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*mf**2/vev*c0f(p1sq,p2sq,qsq,mh,mf,mh)&
	-2.d0*sin(alpha)**2*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*mf**2/vev*c0f(p1sq,p2sq,qsq,mbH,mf,mbH)&
	-2.d0*cos(alpha)*sin(alpha)*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*mf**2/vev*&
        (c0f(p1sq,p2sq,qsq,mbH,mf,mh) + c0f(p1sq,p2sq,qsq,mh,mf,mbH))&
	+2.d0*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*mf**2/vev*c0f(p1sq,p2sq,qsq,mz,mf,mz)&
	+2.d0*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*mfp**2/vev*c0f(p1sq,p2sq,qsq,mw,mfp,mw)&
!
	-cos(alpha)*g**2/4.d0*Chff_VFS(p1sq,p2sq,qsq,mW,mfp,mw)&
	-cos(alpha)*g**2/4.d0*Chff_SFV(p1sq,p2sq,qsq,mw,mfp,mW)&
	-cos(alpha)*gz**2/8.d0*Chff_VFS(p1sq,p2sq,qsq,mZ,mf,mz)&
	-cos(alpha)*gz**2/8.d0*Chff_SFV(p1sq,p2sq,qsq,mz,mf,mZ)&
	)

	 end function
!------------------------------------------------------------
	complex (kind(0d0)) function Fhff_P(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf
	double precision:: vf,af,qf,mfp

        if (mf .eq. mt) then 
        vf = vt
        af = at
        qf = qt
        mfp = mb
        elseif (mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        mfp = ms
        elseif (mf .eq. mb) then 
        vf  = vb
        af  = ab
        qf  = qb
        mfp = mt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        endif

    Fhff_P = 1.d0/(16.d0*pi**2)*mf/vev*cos(alpha)*(& 
           -g**2/4.d0*(Chff_VFS(p1sq,p2sq,qsq,mW,mfp,mw)&
                      -Chff_SFV(p1sq,p2sq,qsq,mw,mfp,mW))&
           -2.d0*gz**2*vf*af*(Chff_VFS(p1sq,p2sq,qsq,mZ,mf,mz)&
                      -Chff_SFV(p1sq,p2sq,qsq,mz,mf,mZ))&              
                                       )

	 end function
!------------------------------------------------------------
	complex (kind(0d0)) function Fhff_V1(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf
	double precision:: vf,af,qf,mfp

        if (mf .eq. mt) then 
        vf = vt
        af = at
        qf = qt
        mfp = mb
        elseif (mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        mfp = ms
        elseif (mf .eq. mb) then 
        vf  = vb
        af  = ab
        qf  = qb
        mfp = mt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        endif

    Fhff_V1 = 1.d0/(16.d0*pi**2)*(& 
             cos(alpha)*2.d0*gz**2*(vf**2 + af**2)*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mZ,mf)&
                                              +2.d0*c11f(p1sq,p2sq,qsq,mf,mZ,mf))&
            +cos(alpha)*2.d0*(g*sw)**2*Qf**2*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mphoton,mf)&
                                      +2.d0*c11f(p1sq,p2sq,qsq,mf,mphoton,mf))&
            +cos(alpha)*g**2/2.d0*mfp**2/vev*(c0f(p1sq,p2sq,qsq,mfp,mW,mfp)&
                            +2.d0*c11f(p1sq,p2sq,qsq,mfp,mW,mfp))&
            +cos(alpha)**3*mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mh,mf)&
                            +2.d0*c11f(p1sq,p2sq,qsq,mf,mh,mf))&
            +cos(alpha)*sin(alpha)**2*mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mbH,mf)&
                            +2.d0*c11f(p1sq,p2sq,qsq,mf,mbH,mf))&
            +cos(alpha)*mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mz,mf)&
                            +2.d0*c11f(p1sq,p2sq,qsq,mf,mz,mf))&
            +cos(alpha)*mfp**2/vev**3*(mf**2+mfp**2)*(c0f(p1sq,p2sq,qsq,mfp,mw,mfp)&
                             +2.d0*c11f(p1sq,p2sq,qsq,mfp,mw,mfp))&
            -cos(alpha)*gz**4*vev*(vf**2 + af**2)*(c0f(p1sq,p2sq,qsq,mZ,mf,mZ)&
                                      +c11f(p1sq,p2sq,qsq,mZ,mf,mZ))&
            -cos(alpha)*g**4/4.d0*vev*(c0f(p1sq,p2sq,qsq,mW,mfp,mW)&
                           +c11f(p1sq,p2sq,qsq,mW,mfp,mW))&
             -cos(alpha)**2*6.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*mf**2/vev**2*(c0f(p1sq,p2sq,qsq,mh,mf,mh)&
                            +c11f(p1sq,p2sq,qsq,mh,mf,mh))&
             -sin(alpha)**2*2.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*mf**2/vev**2*(c0f(p1sq,p2sq,qsq,mbH,mf,mbH)&
                            +c11f(p1sq,p2sq,qsq,mbH,mf,mbH))&
             -cos(alpha)*sin(alpha)*2.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*mf**2/vev**2*(c0f(p1sq,p2sq,qsq,mbH,mf,mh)&
                            +c11f(p1sq,p2sq,qsq,mbH,mf,mh) + c0f(p1sq,p2sq,qsq,mh,mf,mbH) + c11f(p1sq,p2sq,qsq,mh,mf,mbH))&
             -2.d0*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*mf**2/vev**2*(c0f(p1sq,p2sq,qsq,mz,mf,mz)&
                            +c11f(p1sq,p2sq,qsq,mz,mf,mz))&
             -1.d0*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*(mf**2+mfp**2)/vev**2*(c0f(p1sq,p2sq,qsq,mw,mfp,mw)&
                            +c11f(p1sq,p2sq,qsq,mw,mfp,mw))&
             -cos(alpha)*g**2/4.d0*mfp**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                        +c11f(p1sq,p2sq,qsq,mw,mfp,mw)&
                                   -c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                   +c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                   )&
             -cos(alpha)*gz**2/8.d0*mf**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                        +c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                   -c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                   +c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                   )&
                                       )

	 end function
!------------------------------------------------------------
	complex (kind(0d0)) function Fhff_V2(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf
	double precision:: vf,af,qf,mfp

        if (mf .eq. mt) then 
        vf = vt
        af = at
        qf = qt
        mfp = mb
        elseif (mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        mfp = ms
        elseif (mf .eq. mb) then 
        vf  = vb
        af  = ab
        qf  = qb
        mfp = mt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        endif

    Fhff_V2 = 1.d0/(16.d0*pi**2)*(& 
             cos(alpha)*2.d0*gz**2*(vf**2 + af**2)*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mZ,mf)&
                                              +2.d0*c12f(p1sq,p2sq,qsq,mf,mZ,mf))&
            +cos(alpha)*2.d0*(g*sw)**2*Qf**2*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mphoton,mf)&
                                      +2.d0*c12f(p1sq,p2sq,qsq,mf,mphoton,mf))&
            +cos(alpha)*g**2/2.d0*mfp**2/vev*(c0f(p1sq,p2sq,qsq,mfp,mW,mfp)&
                            +2.d0*c12f(p1sq,p2sq,qsq,mfp,mW,mfp))&
            +cos(alpha)**3*mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mh,mf)&
                            +2.d0*c12f(p1sq,p2sq,qsq,mf,mh,mf))&
            +cos(alpha)*sin(alpha)**2*mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mbH,mf)&
                            +2.d0*c12f(p1sq,p2sq,qsq,mf,mbH,mf))&
            +cos(alpha)*mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mz,mf)&
                            +2.d0*c12f(p1sq,p2sq,qsq,mf,mz,mf))&
            +cos(alpha)*mfp**2/vev**3*(mf**2+mfp**2)*(c0f(p1sq,p2sq,qsq,mfp,mw,mfp)&
                             +2.d0*c12f(p1sq,p2sq,qsq,mfp,mw,mfp))&
            -cos(alpha)*gz**4*vev*(vf**2 + af**2)*(c12f(p1sq,p2sq,qsq,mZ,mf,mZ))&
            -cos(alpha)*g**4/4.d0*vev*(c12f(p1sq,p2sq,qsq,mW,mfp,mW))&
             -cos(alpha)**2*6.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mh,mf,mh))&
             -sin(alpha)**2*2.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mbH,mf,mbH))&
             -cos(alpha)*sin(alpha)*2.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*mf**2/vev**2*(&
               c12f(p1sq,p2sq,qsq,mbH,mf,mh) + c12f(p1sq,p2sq,qsq,mh,mf,mbH))&
             -2.d0*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mz,mf,mz))&
             -1.d0*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*(mf**2+mfp**2)/vev**2*(c12f(p1sq,p2sq,qsq,mw,mfp,mw))&
             -cos(alpha)*g**2/4.d0*mfp**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                        +c12f(p1sq,p2sq,qsq,mw,mfp,mw)&
                                   -c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                   +c12f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                   )&
             -cos(alpha)*gz**2/8.d0*mf**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                        +c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                   -c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                   +c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                   )&
                                       )

	 end function
!------------------------------------------------------------
	complex (kind(0d0)) function Fhff_A1(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf
	double precision:: vf,af,qf,mfp

        if (mf .eq. mt) then 
        vf = vt
        af = at
        qf = qt
        mfp = mb
        elseif (mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        mfp = ms
        elseif (mf .eq. mb) then 
        vf  = vb
        af  = ab
        qf  = qb
        mfp = mt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        endif

    Fhff_A1 = 1.d0/(16.d0*pi**2)*(& 
             -cos(alpha)*4.d0*gz**2*vf*af*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mZ,mf)&
                                    +2.d0*c11f(p1sq,p2sq,qsq,mf,mZ,mf))&   
             -cos(alpha)*g**2/2.d0*mfp**2/vev*(c0f(p1sq,p2sq,qsq,mfp,mW,mfp)&
                                    +2.d0*c11f(p1sq,p2sq,qsq,mfp,mW,mfp))&
              +cos(alpha)*mfp**2*(mf**2 - mfp**2)/vev**3*(c0f(p1sq,p2sq,qsq,mfp,mw,mfp)&
                                     +2.d0*c11f(p1sq,p2sq,qsq,mfp,mw,mfp))&
              +cos(alpha)*2.d0*gz**4*vf*af*vev*(c0f(p1sq,p2sq,qsq,mZ,mf,mZ)&
                                    +c11f(p1sq,p2sq,qsq,mZ,mf,mZ))&
              +cos(alpha)*g**4/4.d0*vev*(c0f(p1sq,p2sq,qsq,mW,mfp,mW)&
                                    +c11f(p1sq,p2sq,qsq,mW,mfp,mW))&
              -lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*(mf**2-mfp**2)/vev**2*(c0f(p1sq,p2sq,qsq,mw,mfp,mw)&
                                    +c11f(p1sq,p2sq,qsq,mw,mfp,mw))&
             +cos(alpha)*g**2*mfp**2/(4.d0*vev)*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                      +c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                      -c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                       +c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                      )&
             +cos(alpha)*2.d0*gz**2*vf*af*mf**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                      +c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                      -c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                       +c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                      )&
         )

	 end function
!------------------------------------------------------------
	complex (kind(0d0)) function Fhff_A2(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf
	double precision:: vf,af,qf,mfp

        if (mf .eq. mt) then 
        vf = vt
        af = at
        qf = qt
        mfp = mb
        elseif (mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        mfp = ms
        elseif (mf .eq. mb) then 
        vf  = vb
        af  = ab
        qf  = qb
        mfp = mt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        endif

    Fhff_A2 = 1.d0/(16.d0*pi**2)*(& 
             -cos(alpha)*4.d0*gz**2*vf*af*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mZ,mf)&
                                    +2.d0*c12f(p1sq,p2sq,qsq,mf,mZ,mf))&   
             -cos(alpha)*g**2/2.d0*mfp**2/vev*(c0f(p1sq,p2sq,qsq,mfp,mW,mfp)&
                                    +2.d0*c12f(p1sq,p2sq,qsq,mfp,mW,mfp))&
              +cos(alpha)*mfp**2*(mf**2 - mfp**2)/vev**3*(c0f(p1sq,p2sq,qsq,mfp,mw,mfp)&
                                     +2.d0*c12f(p1sq,p2sq,qsq,mfp,mw,mfp))&
              +cos(alpha)*2.d0*gz**4*vf*af*vev*(c12f(p1sq,p2sq,qsq,mZ,mf,mZ))&
              +cos(alpha)*g**4/4.d0*vev*(c12f(p1sq,p2sq,qsq,mW,mfp,mW))&
              -lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*(mf**2-mfp**2)/vev**2*(c12f(p1sq,p2sq,qsq,mw,mfp,mw))&
             +cos(alpha)*g**2*mfp**2/(4.d0*vev)*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                      +c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                      -c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                       +c12f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                      )&
             +cos(alpha)*2.d0*gz**2*vf*af*mf**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                      +c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                      -c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                       +c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                      )&
         )

	 end function
!------------------------------------------------------------
	complex (kind(0d0)) function Fhff_T(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf
	double precision:: vf,af,qf,mfp

        if (mf .eq. mt) then 
        vf = vt
        af = at
        qf = qt
        mfp = mb
        elseif (mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        mfp = ms
        elseif (mf .eq. mb) then 
        vf  = vb
        af  = ab
        qf  = qb
        mfp = mt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        endif

    Fhff_T = 1.d0/(16.d0*pi**2)*(mf/vev)*(&
            cos(alpha)**3*mf**2/vev**2*(c11f(p1sq,p2sq,qsq,mf,mh,mf)-c12f(p1sq,p2sq,qsq,mf,mh,mf))&
            +cos(alpha)*sin(alpha)**2*mf**2/vev**2*(c11f(p1sq,p2sq,qsq,mf,mbH,mf)-c12f(p1sq,p2sq,qsq,mf,mbH,mf))&
           -cos(alpha)*mf**2/vev**2*(c11f(p1sq,p2sq,qsq,mf,mz,mf)-c12f(p1sq,p2sq,qsq,mf,mz,mf))&
           -cos(alpha)*2.d0*mfp**2/vev**2*(c11f(p1sq,p2sq,qsq,mfp,mw,mfp)-c12f(p1sq,p2sq,qsq,mfp,mw,mfp))&
           +cos(alpha)*g**2/4.d0*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      +1.d0*c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                      +1.d0*c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
                      -2.d0*c12f(p1sq,p2sq,qsq,mw,mfp,mW) )&
           +cos(alpha)*gz**2/8.d0*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      +1.d0*c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      +1.d0*c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      -2.d0*c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      )&
                      )
 
	 end function
!------------------------------------------------------------
	complex (kind(0d0)) function Fhff_PT(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf
	double precision:: vf,af,qf,mfp

        if (mf .eq. mt) then 
        vf = vt
        af = at
        qf = qt
        mfp = mb
        elseif (mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        mfp = ms
        elseif (mf .eq. mb) then 
        vf  = vb
        af  = ab
        qf  = qb
        mfp = mt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        endif

    Fhff_PT = 1.d0/(16.d0*pi**2)*(mf/vev)*cos(alpha)*(&
           +g**2/4.d0*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      -1.d0*c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                      -1.d0*c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
                      +2.d0*c12f(p1sq,p2sq,qsq,mw,mfp,mW) )&
           +2.d0*gz**2*af*vf*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      -1.d0*c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      -1.d0*c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      +2.d0*c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      )&
                      )
 
	 end function
!========================================================================================
	complex (kind(0d0)) function Gam_htautau(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

        Gam_htautau = Gam_hff(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mtau,0.d0)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function Gam_hbb(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

        Gam_hbb = Gam_hff(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mb,mt)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function Gam_hcc(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

        Gam_hcc = Gam_hff(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mc,ms)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function Gam_htt(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

        Gam_htt = Gam_hff(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mt,mb)

	 end function

!========================================================
! Counter terms
!========================================================
	complex (kind(0d0)) function del_Th_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

        del_Th_F =  -Pih_F(mbH,alpha) 

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function del_TbH_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

        del_TbH_F = -PibH_F(mbH,alpha)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function del_Ts_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

         del_Ts_F = cos(alpha)*del_TbH_F(mbH,alpha,lam_ps,lam_s,mu_s) - sin(alpha)*del_Th_F(mbH,alpha,lam_ps,lam_s,mu_s)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function del_Tphi_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

         del_Tphi_F =  sin(alpha)*del_TbH_F(mbH,alpha,lam_ps,lam_s,mu_s) + cos(alpha)*del_Th_F(mbH,alpha,lam_ps,lam_s,mu_s)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function del_mhsq_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

        del_mhsq_F = Pihh_F(mh**2,mbH,alpha)+cos(alpha)**2*del_Tphi_F(mbH,alpha,lam_ps,lam_s,mu_s)/vev

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function del_mbHsq_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

        del_mbHsq_F = PibHbH_F(mbH**2,mbH,alpha)+sin(alpha)**2*del_Tphi_F(mbH,alpha,lam_ps,lam_s,mu_s)/vev 

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function del_Zh_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

        del_Zh_F =  -dPihh_F(mh**2,mbH,alpha)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function del_ZbH_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

        del_ZbH_F = -dPibHbH_F(mbH**2,mbH,alpha)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function del_alpha_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

        del_alpha_F = 1.d0/2.d0/(mbH**2-mh**2)*(PibHh_F(mh**2,mbH,alpha)&
          +PibHh_F(mbH**2,mbH,alpha)+ 2.d0*sin(alpha)*cos(alpha)/vev*del_Tphi_F(mbH,alpha,lam_ps,lam_s,mu_s)&
                                           )

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

        del_Ch_F = 1.d0/2.d0/(mbH**2-mh**2)*(PibHh_F(mh**2,mbH,alpha)-PibHh_F(mbH**2,mbH,alpha))

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function del_vev_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

        del_vev_F = vev/2.d0*(PiWW_F(mw**2)/mw**2&
                 +cw**2/sw**2* (PiZZ_F(mz**2)/mz**2-PiWW_F(mw**2)/mw**2 ) &
 	         -dPiGG_F(mz**2)-2.d0*sw/cw*PiZG_F(0.d0)/mz**2-delta_alpha)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function del_M_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

        del_M_F = -1.d0/(16.d0*pi**2)*cos(alpha)*sin(alpha)**2*(mt**2 + mb**2 + mc**2 + mtau**2/3.d0)*36.d0*lam_ps/vev*div

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function del_Mp_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_Mp_F = sin(alpha)/(16.d0*pi**2)*(mt**2 + mb**2 + mc**2 + mtau**2/3.d0 )*6.d0*(1.d0 + 3.d0*cos(2.d0*alpha))*lam_ps/vev*div

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_lam_hhh_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

         del_lam_hhh_F = 9.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*del_Zh_F(mbH,alpha,lam_ps,lam_s,mu_s)&
                      + 6.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)&
                      -3.d0*cos(alpha)**3/vev*del_mhsq_F(mbH,alpha,lam_ps,lam_s,mu_s)&
                      +3.d0*cos(alpha)/vev**2*&
                       (mh**2*cos(alpha)**2 -2.d0*sin(alpha)**2*vev**2*lam_ps)*del_vev_F(mbH,alpha,lam_ps,lam_s,mu_s)&
                      +3.d0*cos(alpha)**2*sin(alpha)*(mh**2-mbH**2)/vev*del_alpha_F(mbH,alpha,lam_ps,lam_s,mu_s)&
                      +del_M_F(mbH,alpha,lam_ps,lam_s,mu_s)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_lam_bHhh_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_lam_bHhh_F = + 2.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*&
                        (del_Zh_F(mbH,alpha,lam_ps,lam_s,mu_s) + del_ZbH_F(mbH,alpha,lam_ps,lam_s,mu_s)/2.d0)&
                       + (6.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s) + 4.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s))*&
                        del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)&
                       - 2.d0*cos(alpha)**2*sin(alpha)/vev*(&
                        del_mhsq_F(mbH,alpha,lam_ps,lam_s,mu_s) + del_mbHsq_F(mbH,alpha,lam_ps,lam_s,mu_s)/2.d0)&
                       + sin(alpha)/vev**2*&
                       ((2.d0*mh**2+mbH**2)*cos(alpha)**2 + vev**2*lam_ps*(1.d0 + 3.d0*cos(2.d0*alpha)))*&
                        del_vev_F(mbH,alpha,lam_ps,lam_s,mu_s)&
                       +(mbH**2-mh**2)/(4.d0*vev)*(cos(3.d0*alpha)-5.d0*cos(alpha))*del_alpha_F(mbH,alpha,lam_ps,lam_s,mu_s)&
                       + del_Mp_F(mbH,alpha,lam_ps,lam_s,mu_s)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_mWsq_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_mWsq_F = PiWW_F(mw**2)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_ZW_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_ZW_F =&
	 -delta_alpha-dPiGG_F(mz**2)&
	   +2.d0*cw/sw*&
	 PiZG_F(0.d0)/mz**2&
	 +cw**2/sw**2*( PiZZ_F(mz**2)/mz**2-PiWW_F(mw**2)/mw**2 ) 

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_hWW_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_hWW_F   = 2.d0*mW**2/vev*cos(alpha)*(&
                   del_mWsq_F(mbH,alpha,lam_ps,lam_s,mu_s)/mW**2 &
                 + del_ZW_F(mbH,alpha,lam_ps,lam_s,mu_s) &
                 +1.d0/2.d0*del_Zh_F(mbH,alpha,lam_ps,lam_s,mu_s) &
                 -del_vev_F(mbH,alpha,lam_ps,lam_s,mu_s)/vev &
                   )+2.d0*mW**2/vev*sin(alpha)*del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_mZsq_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_mZsq_F = PiZZ_F(mz**2)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_ZZ_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_ZZ_F =  -delta_alpha-dPiGG_F(mz**2)&
	   -2.d0*(cw**2-sw**2)/(cw*sw)*PiZG_F(0.d0)/mz**2&
	 +(cw**2-sw**2)/cw**2*&
	 (cw**2*(PiZZ_F(mz**2)/mz**2-PiWW_F(mw**2)/mw**2))/sw**2

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_hZZ_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

         del_hZZ_F   = 2.d0*mZ**2/vev*cos(alpha)*(&
                   del_mZsq_F(mbH,alpha,lam_ps,lam_s,mu_s)/mZ**2& 
                 + del_ZZ_F(mbH,alpha,lam_ps,lam_s,mu_s) &
                 + 1.d0/2.d0*del_Zh_F(mbH,alpha,lam_ps,lam_s,mu_s)& 
                 - del_vev_F(mbH,alpha,lam_ps,lam_s,mu_s)/vev &
                   )+2.d0*mZ**2/vev*sin(alpha)*del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_Th_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

        del_Th_B  = -Pih_B(mbH,alpha,lam_ps,lam_s,mu_s) 

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_TbH_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

       del_TbH_B   = -PibH_B(mbH,alpha,lam_ps,lam_s,mu_s) 

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function del_Ts_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_Ts_B    = cos(alpha)*del_TbH_B(mbH,alpha,lam_ps,lam_s,mu_s) - sin(alpha)*del_Th_B(mbH,alpha,lam_ps,lam_s,mu_s)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function del_Tphi_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_Tphi_B  = sin(alpha)*del_TbH_B(mbH,alpha,lam_ps,lam_s,mu_s) + cos(alpha)*del_Th_B(mbH,alpha,lam_ps,lam_s,mu_s)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function del_mhsq_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_mhsq_B  = Pihh_B(mh**2,mbH,alpha,lam_ps,lam_s,mu_s)+cos(alpha)**2*del_Tphi_B(mbH,alpha,lam_ps,lam_s,mu_s)/vev 

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function del_Zh_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
 
     del_Zh_B  = -dPihh_B(mh**2,mbH,alpha,lam_ps,lam_s,mu_s)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function del_mbHsq_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
 
     del_mbHsq_B  = PibHbH_B(mbH**2,mbH,alpha,lam_ps,lam_s,mu_s)+sin(alpha)**2*del_Tphi_B(mbH,alpha,lam_ps,lam_s,mu_s)/vev 

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_ZbH_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_ZbH_B = -dPibHbH_B(mbh**2,mbH,alpha,lam_ps,lam_s,mu_s)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_alpha_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_alpha_B = 1.d0/2.d0/(mbH**2-mh**2)*(PibHh_B(mh**2,mbH,alpha,lam_ps,lam_s,mu_s)&
      +PibHh_B(mbH**2,mbH,alpha,lam_ps,lam_s,mu_s)&
      + 2.d0*sin(alpha)*cos(alpha)/vev*del_Tphi_B(mbH,alpha,lam_ps,lam_s,mu_s)&
                                           )

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_Ch_B = 1.d0/2.d0/(mbH**2-mh**2)*(PibHh_B(mh**2,mbH,alpha,lam_ps,lam_s,mu_s)&
      -PibHh_B(mbH**2,mbH,alpha,lam_ps,lam_s,mu_s))

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_vev_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
 
     del_vev_B  =  vev/2.d0*(PiWW_B( mw**2,mbH,alpha,lam_ps,lam_s,mu_s)/mw**2&
                 +cw**2/sw**2* ( PiZZ_B(mz**2,mbH,alpha,lam_ps,lam_s,mu_s)/mz**2&
                 -PiWW_B(mw**2,mbH,alpha,lam_ps,lam_s,mu_s)/mw**2 )&
 	         -dPiGG_B(mz**2,mbH,alpha,lam_ps,lam_s,mu_s)-2.d0*sw/cw*PiZG_B(0.d0,mbH,alpha,lam_ps,lam_s,mu_s)/mz**2)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function del_M_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

        del_M_B =  (3.d0*Sin(alpha)**2*((6.d0*(2.d0*mW**4 + mZ**4) - 16.d0*lam_ps**2*vev**4 - &
              lam_ps*vev**2*(11.d0*mh**2 + mbH**2 - 12.d0*(2.d0*mW**2 + mZ**2 - 4.d0*lam_s*vev**2)))*Cos(alpha) +& 
           (4.d0*mW**4 + 2.d0*mZ**4 + lam_ps*(-mh**2 + mbH**2)*vev**2)*Cos(3.d0*alpha) + 144.d0*lam_s*mu_s*vev**3*Sin(alpha)))/&
       (32.d0*pi**2*vev**3)*div

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function del_Mp_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_Mp_B = sin(alpha)/(16.d0*pi**2)*(&
      -2.d0*cos(alpha)**2/vev**3*(2.d0*mw**4 + mz**4)*(cos(2.d0*alpha)-3.d0) &
      -3.d0/vev*lam_ps*(2.d0*mw**2 + mz**2)*(1.d0 + 3.d0*cos(2.d0*alpha))&
      +3.d0*mh**2/vev*lam_ps*cos(alpha)**2*(3.d0+cos(2.d0*alpha))-6.d0*mbH**2/vev*lam_ps*sin(alpha)**4 &
      + 4.d0*lam_ps*(3.d0*lam_s + lam_ps)*vev*(1.d0 + 3.d0*cos(2.d0*alpha)) -216.d0*mu_s*lam_s*cos(alpha)*sin(alpha)&
      )*div

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function del_lam_hhh_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_lam_hhh_B = + 9.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*del_Zh_B(mbH,alpha,lam_ps,lam_s,mu_s)&
                      + 6.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s)&
                      -3.d0*cos(alpha)**3/vev*del_mhsq_B(mbH,alpha,lam_ps,lam_s,mu_s)&
                      +3.d0*cos(alpha)/vev**2*&
                       (mh**2*cos(alpha)**2 -2.d0*sin(alpha)**2*vev**2*lam_ps)*del_vev_B(mbH,alpha,lam_ps,lam_s,mu_s)&
                      +3.d0*cos(alpha)**2*sin(alpha)*(mh**2-mbH**2)/vev*del_alpha_B(mbH,alpha,lam_ps,lam_s,mu_s)&
                      +del_M_B(mbH,alpha,lam_ps,lam_s,mu_s)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_lam_bHhh_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_lam_bHhh_B = + 2.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*&
      (del_Zh_B(mbH,alpha,lam_ps,lam_s,mu_s) + del_ZbH_B(mbH,alpha,lam_ps,lam_s,mu_s)/2.d0)&
                       + (6.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s) + 4.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s))*&
      del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s)&
                       - 2.d0*cos(alpha)**2*sin(alpha)/vev*(&
      del_mhsq_B(mbH,alpha,lam_ps,lam_s,mu_s) + del_mbHsq_B(mbH,alpha,lam_ps,lam_s,mu_s)/2.d0)&
                       + sin(alpha)/vev**2*&
                       ((2.d0*mh**2+mbH**2)*cos(alpha)**2 + vev**2*lam_ps*(&
           1.d0 + 3.d0*cos(2.d0*alpha)))*del_vev_B(mbH,alpha,lam_ps,lam_s,mu_s)&
                       +(mbH**2-mh**2)/(4.d0*vev)*(cos(3.d0*alpha)-5.d0*cos(alpha))*del_alpha_B(mbH,alpha,lam_ps,lam_s,mu_s)&
                       + del_Mp_B(mbH,alpha,lam_ps,lam_s,mu_s)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function   del_mWsq_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_mWsq_B =   PiWW_B(mw**2,mbH,alpha,lam_ps,lam_s,mu_s)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_ZW_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

       del_ZW_B   = &
	   -(dPiGG_B(mz**2,mbH,alpha,lam_ps,lam_s,mu_s) -dPiGG_pinch(mz**2))&
	   +2.d0*cw/sw*(PiZG_B(0.d0,mbH,alpha,lam_ps,lam_s,mu_s)-PiZG_pinch(0.d0))/mz**2&
   	   +cw**2/sw**2*( PiZZ_B(mz**2,mbH,alpha,lam_ps,lam_s,mu_s)/mz**2-PiWW_B(mw**2,mbH,alpha,lam_ps,lam_s,mu_s)/mw**2 ) 

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function   del_mZsq_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_mZsq_B =   PiZZ_B(mz**2,mbH,alpha,lam_ps,lam_s,mu_s)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_ZZ_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_ZZ_B   = -(dPiGG_B(mz**2,mbH,alpha,lam_ps,lam_s,mu_s)-dPiGG_pinch(mz**2))&
	           +2.d0*(cw**2-sw**2)/(cw*sw)*( PiZG_B(0.d0,mbH,alpha,lam_ps,lam_s,mu_s)-PiZG_pinch(0.d0) )/mz**2&
                   +(cw**2-sw**2)/cw**2*(cw**2*(PiZZ_B(mz**2,mbH,alpha,lam_ps,lam_s,mu_s)/mz**2&
                   -PiWW_B(mw**2,mbH,alpha,lam_ps,lam_s,mu_s)/mw**2))/sw**2

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_hWW_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_hWW_B   = 2.d0*mW**2/vev*cos(alpha)*(&
                   del_mWsq_B(mbH,alpha,lam_ps,lam_s,mu_s)/mW**2 &
                 + del_ZW_B(mbH,alpha,lam_ps,lam_s,mu_s) &
                 +1.d0/2.d0*del_Zh_B(mbH,alpha,lam_ps,lam_s,mu_s) &
                 -del_vev_B(mbH,alpha,lam_ps,lam_s,mu_s)/vev &
                   )+2.d0*mW**2/vev*sin(alpha)*del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_hZZ_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_hZZ_B   = 2.d0*mZ**2/vev*cos(alpha)*(&
                   del_mZsq_B(mbH,alpha,lam_ps,lam_s,mu_s)/mZ**2 &
                 + del_ZZ_B(mbH,alpha,lam_ps,lam_s,mu_s) &
                 +1.d0/2.d0*del_Zh_B(mbH,alpha,lam_ps,lam_s,mu_s) &
                 -del_vev_B(mbH,alpha,lam_ps,lam_s,mu_s)/vev &
                   )+2.d0*mZ**2/vev*sin(alpha)*del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s)

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_mb(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_mb = mb*( Pibb_V(mb**2,mbh,alpha,lam_ps,lam_s,mu_s)+Pibb_S(mb**2,mbh,alpha,lam_ps,lam_s,mu_s) )

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_ZVb(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_ZVb = -Pibb_V(mb**2,mbh,alpha,lam_ps,lam_s,mu_s)&
                -2.d0*mb**2*(dPibb_V(mb**2,mbh,alpha,lam_ps,lam_s,mu_s)&
                +dPibb_S(mb**2,mbh,alpha,lam_ps,lam_s,mu_s))

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_hbb(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

        del_hbb = -mb/vev*cos(alpha)*&
                (del_mb(mbH,alpha,lam_ps,lam_s,mu_s)/mb&
               -(del_vev_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_vev_B(mbH,alpha,lam_ps,lam_s,mu_s))/vev&
               +del_ZVb(mbH,alpha,lam_ps,lam_s,mu_s)+(del_Zh_F(mbH,alpha,lam_ps,lam_s,mu_s)&
               +del_Zh_B(mbH,alpha,lam_ps,lam_s,mu_s))/2.d0 &
               +tan(alpha)*(del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s))&
                )

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_mtau(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_mtau = mtau*( Pitautau_V(mtau**2,mbh,alpha,lam_ps,lam_s,mu_s)+Pitautau_S(mtau**2,mbh,alpha,lam_ps,lam_s,mu_s) )

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_ZVtau(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_ZVtau = -Pitautau_V(mtau**2,mbh,alpha,lam_ps,lam_s,mu_s)&
                -2.d0*mtau**2*(dPitautau_V(mtau**2,mbh,alpha,lam_ps,lam_s,mu_s)&
                +dPitautau_S(mtau**2,mbh,alpha,lam_ps,lam_s,mu_s))

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_htautau(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

        del_htautau = -mtau/vev*cos(alpha)*&
                (del_mtau(mbH,alpha,lam_ps,lam_s,mu_s)/mtau&
               -(del_vev_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_vev_B(mbH,alpha,lam_ps,lam_s,mu_s))/vev&
               +del_ZVtau(mbH,alpha,lam_ps,lam_s,mu_s)+(del_Zh_F(mbH,alpha,lam_ps,lam_s,mu_s)&
               +del_Zh_B(mbH,alpha,lam_ps,lam_s,mu_s))/2.d0 &
               +tan(alpha)*(del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s))&
                )

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_mt(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

       del_mt = mt*( Pitt_V(mt**2,mbh,alpha,lam_ps,lam_s,mu_s)+Pitt_S(mt**2,mbh,alpha,lam_ps,lam_s,mu_s) )

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_ZVt(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_ZVt = -Pitt_V(mt**2,mbh,alpha,lam_ps,lam_s,mu_s)&
                -2.d0*mt**2*(dPitt_V(mt**2,mbh,alpha,lam_ps,lam_s,mu_s)&
                +dPitt_S(mt**2,mbh,alpha,lam_ps,lam_s,mu_s))

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_htt(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

        del_htt = -mt/vev*cos(alpha)*&
                (del_mt(mbH,alpha,lam_ps,lam_s,mu_s)/mt&
               -(del_vev_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_vev_B(mbH,alpha,lam_ps,lam_s,mu_s))/vev&
               +del_ZVt(mbH,alpha,lam_ps,lam_s,mu_s)+(del_Zh_F(mbH,alpha,lam_ps,lam_s,mu_s)&
               +del_Zh_B(mbH,alpha,lam_ps,lam_s,mu_s))/2.d0 &
               +tan(alpha)*(del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s))&
                )

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_mc(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_mc = mc*( Picc_V(mc**2,mbh,alpha,lam_ps,lam_s,mu_s)+Picc_S(mc**2,mbh,alpha,lam_ps,lam_s,mu_s) )

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_ZVc(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      del_ZVc = -Picc_V(mc**2,mbh,alpha,lam_ps,lam_s,mu_s)&
                -2.d0*mc**2*(dPicc_V(mc**2,mbh,alpha,lam_ps,lam_s,mu_s)&
                +dPicc_S(mc**2,mbh,alpha,lam_ps,lam_s,mu_s))

	 end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_hcc(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

        del_hcc = -mc/vev*cos(alpha)*&
                (del_mc(mbH,alpha,lam_ps,lam_s,mu_s)/mc&
               -(del_vev_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_vev_B(mbH,alpha,lam_ps,lam_s,mu_s))/vev&
               +del_ZVc(mbH,alpha,lam_ps,lam_s,mu_s)+(del_Zh_F(mbH,alpha,lam_ps,lam_s,mu_s)&
               +del_Zh_B(mbH,alpha,lam_ps,lam_s,mu_s))/2.d0 &
               +tan(alpha)*(del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s))&
                )

	 end function
!========================================================
! Renormalized 2-point functions
!========================================================
	complex (kind(0d0)) function  hat_Pihh(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

        hat_Pihh = Pihh_F(qsq,mbH,alpha)+cos(alpha)**2*del_Tphi_F(mbH,alpha,lam_ps,lam_s,mu_s)/vev & 
                 + Pihh_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)+cos(alpha)**2*del_Tphi_B(mbH,alpha,lam_ps,lam_s,mu_s)/vev  &
                   + (qsq-mh**2)*( del_Zh_F(mbH,alpha,lam_ps,lam_s,mu_s) + del_Zh_B(mbH,alpha,lam_ps,lam_s,mu_s) )&
                   - del_mhsq_F(mbH,alpha,lam_ps,lam_s,mu_s) - del_mhsq_B(mbH,alpha,lam_ps,lam_s,mu_s)

	 end function
!--------------------------------------------------------------------
	complex (kind(0d0)) function  hat_PibHbH(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

        hat_PibHbH = PibHbH_F(qsq,mbH,alpha)+sin(alpha)**2*del_Tphi_F(mbH,alpha,lam_ps,lam_s,mu_s)/vev & 
                 + PibHbH_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)+sin(alpha)**2*del_Tphi_B(mbH,alpha,lam_ps,lam_s,mu_s)/vev  &
                   + (qsq-mbH**2)*( del_ZbH_F(mbH,alpha,lam_ps,lam_s,mu_s) + del_ZbH_B(mbH,alpha,lam_ps,lam_s,mu_s) )&
                   - del_mbHsq_F(mbH,alpha,lam_ps,lam_s,mu_s) - del_mbHsq_B(mbH,alpha,lam_ps,lam_s,mu_s)

	 end function
!--------------------------------------------------------------------
	complex (kind(0d0)) function  hat_PibHh(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

        hat_PibHh =  PibHh_F(qsq,mbH,alpha)+sin(alpha)*cos(alpha)*del_Tphi_F(mbH,alpha,lam_ps,lam_s,mu_s)/vev& 
                   + PibHh_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)+sin(alpha)*cos(alpha)*del_Tphi_B(mbH,alpha,lam_ps,lam_s,mu_s)/vev&
                   + 2.d0*qsq*(del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s) + del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s) )&
                   + mh**2*(del_alpha_F(mbH,alpha,lam_ps,lam_s,mu_s) + del_alpha_B(mbH,alpha,lam_ps,lam_s,mu_s)&
                          - del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)    - del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s)&
                          )&
                   - mbH**2*(del_alpha_F(mbH,alpha,lam_ps,lam_s,mu_s)  + del_alpha_B(mbH,alpha,lam_ps,lam_s,mu_s)&
                          +del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)       + del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s)&
                          )

	 end function
!========================================================
! Renormalized hWW coupling
!========================================================
      complex (kind(0d0)) function Gam1_hWW_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

      Gam1_hWW_loop = Gam1_hWW_F(p1sq,p2sq,qsq,mbH,alpha) + del_hWW_F(mbH,alpha,lam_ps,lam_s,mu_s)&
      +Gam1_hWW_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)+del_hWW_B(mbH,alpha,lam_ps,lam_s,mu_s)
                                            
      end function
!------------------------------------------
      complex (kind(0d0)) function rGam1_hWW(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

      rGam1_hWW = g**2/2.d0*vev*cos(alpha) + Gam1_hWW_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)

      end function
!------------------------------------------
      complex (kind(0d0)) function rGam2_hWW(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

      rGam2_hWW = Gam2_hWW_F(p1sq,p2sq,qsq,mbH,alpha) + Gam2_hWW_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)

      end function
!------------------------------------------
      complex (kind(0d0)) function rGam3_hWW(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

      rGam3_hWW = Gam3_hWW_F(p1sq,p2sq,qsq,mbH,alpha)

      end function
!========================================================
! Renormalized hZZ coupling
!========================================================
      complex (kind(0d0)) function Gam1_hZZ_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

      Gam1_hZZ_loop = Gam1_hZZ_F(p1sq,p2sq,qsq,mbH,alpha) + del_hZZ_F(mbH,alpha,lam_ps,lam_s,mu_s)& 
      +Gam1_hZZ_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)+del_hZZ_B(mbH,alpha,lam_ps,lam_s,mu_s)
                                            
      end function
!------------------------------------------
      complex (kind(0d0)) function rGam1_hZZ(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

      rGam1_hZZ = gz**2/2.d0*vev*cos(alpha) + Gam1_hZZ_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
                                            
      end function
!------------------------------------------
      complex (kind(0d0)) function rGam2_hZZ(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

      rGam2_hZZ = Gam2_hZZ_F(p1sq,p2sq,qsq,mbH,alpha) + Gam2_hZZ_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)

      end function
!------------------------------------------
      complex (kind(0d0)) function rGam3_hZZ(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

      rGam3_hZZ = Gam3_hZZ_F(p1sq,p2sq,qsq,mbH,alpha)

      end function
!========================================================
! Renormalized htt coupling
!========================================================
      complex (kind(0d0)) function Gam_htt_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

      Gam_htt_loop = Gam_htt(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)+del_htt(mbH,alpha,lam_ps,lam_s,mu_s)
                                            
      end function
!------------------------------------------
      complex (kind(0d0)) function rGamS_htt(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

      rGamS_htt = -mt/vev*cos(alpha) + Gam_htt_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
                                            
      end function
!========================================================
! Renormalized hbb coupling
!========================================================
      complex (kind(0d0)) function Gam_hbb_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

      Gam_hbb_loop = Gam_hbb(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)+del_hbb(mbH,alpha,lam_ps,lam_s,mu_s)
                                            
      end function
!------------------------------------------
      complex (kind(0d0)) function rGamS_hbb(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

      rGamS_hbb = -mb/vev*cos(alpha) + Gam_hbb_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
                                            
      end function
!========================================================
! Renormalized hcc coupling
!========================================================
      complex (kind(0d0)) function Gam_hcc_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

      Gam_hcc_loop = Gam_hcc(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)+del_hcc(mbH,alpha,lam_ps,lam_s,mu_s)
                                            
      end function
!------------------------------------------
      complex (kind(0d0)) function rGamS_hcc(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

      rGamS_hcc =  -mc/vev*cos(alpha) + Gam_hcc_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
                                            
      end function
!========================================================
! Renormalized htautau coupling
!========================================================
      complex (kind(0d0)) function Gam_htautau_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

      Gam_htautau_loop = Gam_htautau(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)&
                          +del_htautau(mbH,alpha,lam_ps,lam_s,mu_s)
                                            
      end function
!------------------------------------------
      complex (kind(0d0)) function rGamS_htautau(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

      rGamS_htautau = -mtau/vev*cos(alpha) + Gam_htautau_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
                                            
      end function
!========================================================
!     Renormalized hhh coupling
!========================================================
      complex (kind(0d0)) function Gam_hhh_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

      Gam_hhh_loop = +Gam_hhh_F(p1sq,p2sq,qsq,mbH,alpha) + del_lam_hhh_F(mbH,alpha,lam_ps,lam_s,mu_s)&
      +Gam_hhh_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s) + del_lam_hhh_B(mbH,alpha,lam_ps,lam_s,mu_s)&
!........ Terms for gauge invariance  ................
         +24.d0*lam_s*sin(alpha)**3*(cos(alpha)/mbH**2*(PibH_F(mbH,alpha)+PibH_B(mbH,alpha,lam_ps,lam_s,mu_s))&
                      -sin(alpha)/mh**2*(Pih_F(mbH,alpha)+Pih_B(mbH,alpha,lam_ps,lam_s,mu_s))&
                      )&
         -sin(alpha)*cos(alpha)**2/(4.d0*vev)*(PibHh_PT(mbH**2,mbH,alpha,lam_ps,lam_s,mu_s) + &
                                               PibHh_PT(mh**2,mbH,alpha,lam_ps,lam_s,mu_s))

      end function
!------------------------------------------
      complex (kind(0d0)) function rGam_hhh(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

      rGam_hhh = 6.d0*lam_hhh(mbh,alpha,lam_ps,lam_s,mu_s) &
                      + Gam_hhh_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)

      end function
!========================================================
! Renormalized Hhh coupling
!========================================================
      complex (kind(0d0)) function Gam_bHhh_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

      Gam_bHhh_loop = +Gam_bHhh_F(p1sq,p2sq,qsq,mbH,alpha) + del_lam_bHhh_F(mbH,alpha,lam_ps,lam_s,mu_s) &
      +Gam_bHhh_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s) + del_lam_bHhh_B(mbH,alpha,lam_ps,lam_s,mu_s) 

      end function
!------------------------------------------
      complex (kind(0d0)) function Gam_bHhh_ren(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

      Gam_bhhh_ren = 2.d0*lam_bhhh(mbh,alpha,lam_ps,lam_s,mu_s) &
                      + Gam_bhhh_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)

      end function
!========================================================
! Loop induced decay rates
!========================================================
      double precision function Gam_hgamgam(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      Gam_hgamgam = hgamgam_sm(mh)*cos(alpha)**2

      end function
!----------------------------------------------------------------
      double precision function Gam_hZgam(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      Gam_hZgam = hZgam_sm(mh)*cos(alpha)**2

      end function
!----------------------------------------------------------------
      double precision  function Gam_hgg(mbH,alpha,lam_ps,lam_s,mu_s)
      double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

      Gam_hgg = hgg_sm(mh)*cos(alpha)**2

      end function
!========================================================
! Higgs Width
!========================================================
	double precision function decay_bHhh_ren(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

        if (mbH .gt. 2.d0*mh) then 
        decay_bHhh_ren = +abs(Gam_bHhh_loop(mh**2,mh**2,mbH**2,mbH,alpha,lam_ps,lam_s,mu_s))**2/(32.d0*pi*mbH)*&
                    sqrt(1.d0-4.d0*mh**2/mbh**2)
        
        else
        decay_bHhh_ren = 1.d-10
        endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_bHhh_tree(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

       if (mbH .gt. 2.d0*mh) then 
        decay_bHhh_tree = lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)**2/(8.d0*pi*mbH)*&
                    sqrt(1.d0-4.d0*mh**2/mbh**2)
        else
        decay_bHhh_tree = 1.d-10
        endif


	end function
!--------------------------------------------------------------------------
	double precision function width_bH_ren(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

        width_bH_ren = width_sm(mbH)*sin(alpha)**2 + decay_bHhh_ren(mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!--------------------------------------------------------------------------
	double precision function width_bH_tree(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

        width_bH_tree = width_sm(mbH)*sin(alpha)**2 + decay_bHhh_tree(mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!========================================================
! RGE
!========================================================
!--------- g1 ------------------
	double precision function g1(t0,t)
	double precision, intent(in):: t0,t
	double precision c1

        c1= 20.d0/9.d0*ng+1.d0/6.d0*nh
        g1= gp/sqrt(1.d0-2.d0*c1*gp**2*(t-t0)/(16.d0*pi**2))

	end function
!--------- g2 ------------------
	double precision function g2(t0,t)
	double precision, intent(in):: t0,t
	double precision c2

        c2=(-22.d0/3.d0+4.d0/3.d0*ng+1.d0/6.d0*nh)
        g2=g/sqrt(1.d0-2.d0*c2*g**2*(t-t0)/(16.d0*pi**2))

	end function
!--------- g3 ------------------
	double precision function g3(t0,t)
	double precision, intent(in):: t0,t
	double precision c3

        c3=(-11.d0+4.d0/3.d0*ng)
        g3=gs/sqrt(1.d0-2.d0*c3*gs**2*(t-t0)/(16.d0*pi**2))

	end function
!--------- beta(lam) ------------------
	double precision function beta_lam(t0,t,lam,lamPS,lamS,yt)
	double precision, intent(in)::  t0,t,lam,lamPS,lamS,yt

	beta_lam=1.d0/(16.d0*pi**2)*(&
                    24.d0*lam**2&
                    +2.d0*lamPS**2&
                    -6.d0*yt**4&
                    +9.d0/8.d0*g2(t0,t)**4&
                    +3.d0/8.d0*g1(t0,t)**4&
                    +3.d0/4.d0*g1(t0,t)**2*g2(t0,t)**2&
                    -3.d0*lam*(3.d0*g2(t0,t)**2+g1(t0,t)**2-4.d0*yt**2)&
                    )

	end function
!--------- beta(lamPS) ------------------
	double precision function beta_lamPS(t0,t,lam,lamPS,lamS,yt)
	double precision, intent(in)::  t0,t,lam,lamPS,lamS,yt

        beta_lamPS = 1.d0/(16.d0*pi**2)*(&
                   12.d0*lam*lamPS&
                  +8.d0*lamPS**2&
                  +24.d0*lamPS*lamS&
                  -lamPS*(9.d0/2.d0*g2(t0,t)**2+3.d0/2.d0*g1(t0,t)**2-6.d0*yt**2)&
                    )

	end function
!--------- beta(lamS) ------------------
	double precision function beta_lamS(t0,t,lam,lamPS,lamS,yt)
	double precision, intent(in)::  t0,t,lam,lamPS,lamS,yt

        beta_lamS = 1.d0/(16.d0*pi**2)*(2.d0*lamPS**2 + 72.d0*lamS**2)

	end function
!--------- beta(yt) ------------------
	double precision function beta_yt(t0,t,lam,lamPS,lamS,yt)
	double precision, intent(in)::  t0,t,lam,lamPS,lamS,yt

        beta_yt = 1.d0/(16.d0*pi**2)*(&
                  +9.d0/2.d0*yt**3&
                 -yt*(8.d0*g3(t0,t)**2+9.d0/4.d0*g2(t0,t)**2+17.d0/12.d0*g1(t0,t)**2)&
                 )

	end function
!================= SUBROUTINE ==================
	subroutine RGE(t0,h,t,vlam,vlamPS,vlamS,vyt)
	double precision:: rk_lam(4),rk_lamPS(4),rk_lamS(4),rk_yt(4) 
	double precision, intent(in):: t0,t,h
	double precision ::  vlam,vlamPS,vlamS,vyt
!--------------- STEP 1 ----------------------------------------------------------------------------------
           rk_lam(1)   = beta_lam  (t0,t,vlam,vlamPS,vlamS,vyt)
           rk_lamPS(1) = beta_lamPS(t0,t,vlam,vlamPS,vlamS,vyt)
           rk_lamS(1)  = beta_lamS (t0,t,vlam,vlamPS,vlamS,vyt)
           rk_yt(1)    = beta_yt   (t0,t,vlam,vlamPS,vlamS,vyt)
!--------------- STEP 2 ----------------------------------------------------------------------------------
       rk_lam(2)   = beta_lam  (t0,t+h/2.d0,vlam+rk_lam(1)/2.d0,vlamPS+rk_lamPS(1)/2.d0,vlamS+rk_lamS(1)/2.d0,vyt+rk_yt(1)/2.d0)
       rk_lamPS(2) = beta_lamPS(t0,t+h/2.d0,vlam+rk_lam(1)/2.d0,vlamPS+rk_lamPS(1)/2.d0,vlamS+rk_lamS(1)/2.d0,vyt+rk_yt(1)/2.d0)
       rk_lamS(2)  = beta_lamS (t0,t+h/2.d0,vlam+rk_lam(1)/2.d0,vlamPS+rk_lamPS(1)/2.d0,vlamS+rk_lamS(1)/2.d0,vyt+rk_yt(1)/2.d0)
       rk_yt(2)    = beta_yt   (t0,t+h/2.d0,vlam+rk_lam(1)/2.d0,vlamPS+rk_lamPS(1)/2.d0,vlamS+rk_lamS(1)/2.d0,vyt+rk_yt(1)/2.d0)
!--------------- STEP 3 ----------------------------------------------------------------------------------
       rk_lam(3)   = beta_lam  (t0,t+h/2.d0,vlam+rk_lam(2)/2.d0,vlamPS+rk_lamPS(2)/2.d0,vlamS+rk_lamS(2)/2.d0,vyt+rk_yt(2)/2.d0)
       rk_lamPS(3) = beta_lamPS(t0,t+h/2.d0,vlam+rk_lam(2)/2.d0,vlamPS+rk_lamPS(2)/2.d0,vlamS+rk_lamS(2)/2.d0,vyt+rk_yt(2)/2.d0)
       rk_lamS(3)  = beta_lamS (t0,t+h/2.d0,vlam+rk_lam(2)/2.d0,vlamPS+rk_lamPS(2)/2.d0,vlamS+rk_lamS(2)/2.d0,vyt+rk_yt(2)/2.d0)
       rk_yt(3)    = beta_yt   (t0,t+h/2.d0,vlam+rk_lam(2)/2.d0,vlamPS+rk_lamPS(2)/2.d0,vlamS+rk_lamS(2)/2.d0,vyt+rk_yt(2)/2.d0)
!--------------- STEP 4 ----------------------------------------------------------------------------------
       rk_lam(4)   = beta_lam  (t0,t+h,vlam+rk_lam(3),vlamPS+rk_lamPS(3),vlamS+rk_lamS(3),vyt+rk_yt(3))
       rk_lamPS(4) = beta_lamPS(t0,t+h,vlam+rk_lam(3),vlamPS+rk_lamPS(3),vlamS+rk_lamS(3),vyt+rk_yt(3))
       rk_lamS(4)  = beta_lamS (t0,t+h,vlam+rk_lam(3),vlamPS+rk_lamPS(3),vlamS+rk_lamS(3),vyt+rk_yt(3))
       rk_yt(4)    = beta_yt   (t0,t+h,vlam+rk_lam(3),vlamPS+rk_lamPS(3),vlamS+rk_lamS(3),vyt+rk_yt(3))
!--------------- SUM ----------------------------------------------------------------------------------
           vlam   = vlam   + h/6.d0*(rk_lam(1)   +2.d0*rk_lam(2)   +2.d0*rk_lam(3)   + rk_lam(4))
           vlamPS = vlamPS + h/6.d0*(rk_lamPS(1) +2.d0*rk_lamPS(2) +2.d0*rk_lamPS(3) + rk_lamPS(4))
           vlamS  = vlamS  + h/6.d0*(rk_lamS(1)  +2.d0*rk_lamS(2)  +2.d0*rk_lamS(3)  + rk_lamS(4))
           vyt    = vyt    + h/6.d0*(rk_yt(1)    +2.d0*rk_yt(2)    +2.d0*rk_yt(3)    + rk_yt(4)  )
           end subroutine
!-----------------------------------------------------------------------------------------
   end program HCOUP_HSM


