	program HCOUP_THDM
        use SM_const
	use pv
	use Gauge_boson_2p
	use SM_Hdecay
	use HCOUP_SM

	implicit none
	double precision:: lqt = 1.d0/2.d0,nh = 2.d0,ng = 3.d0,gs,gp
	double precision:: beta,alpha
	complex (kind(0d0)):: vhZZ(3),vhWW(3),vhtt(8),vhbb(8),vhcc(8),vhll(8),vhhh
	complex (kind(0d0)):: vhZZ_sm(3),vhWW_sm(3),vhtt_sm(8),vhbb_sm(8),vhcc_sm(8),vhll_sm(8),vhhh_sm
	double precision:: p_hzz(3),p_hww(3),p_htt(3),p_hbb(3),p_hcc(3),p_hll(3),p_hhh(3)

        include "inputs/in_thdm.txt"
        include "inputs/in_momentum.txt"
        include "modules/header.txt"
        call ltini
        gs = sqrt(alpha_s*4.d0*pi)
        gp = g*sw/cw
        beta = atan(tanb)
        alpha = alpha_f(beta,1.d0-sin_ba,sig) 
!############# Constraints ################    
        if (pu(mch,mA,mbh,bmsq,alpha,beta) .ne. 0.d0) then 
           write(*,*) 'Excluded by Unitarity'
        endif
        if (stu(mch,ma,mbh,alpha,beta) .ne. 0.d0) then 
           write(*,*) 'Excluded by ST Parameter'
        endif
        if (vs_rge(cutoff,mch,mA,mbh,bmsq,alpha,beta) .ne. 0.d0) then 
           write(*,*) 'Excluded by Vacuum Stability'
        endif
        if (triviality(cutoff,mch,mA,mbh,bmsq,alpha,beta) .ne. 0.d0) then        
           write(*,*) 'Excluded by Triviality'        
        endif 
           
        if ( pu(mch,mA,mbh,bmsq,alpha,beta) .eq. 0.d0 .and. & 
             stu(mch,mA,mbh,alpha,beta)     .eq. 0.d0 .and. &
             vs_rge(cutoff,mch,mA,mbh,bmsq,alpha,beta)     .eq. 0.d0    .and. &
             triviality(cutoff,mch,mA,mbh,bmsq,alpha,beta) .eq. 0.d0 )  then 
           write(*,*) 'Allowed!'
           endif
!############# OUTPUS ################    
	open(10,file="outputs/out_sm.txt")
	open(11,file="outputs/out_thdm.txt")

        vhZZ_sm(1) = rGam1_hZZ_sm(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2)
        vhZZ_sm(2) = rGam2_hZZ_sm(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2)
        vhZZ_sm(3) = rGam3_hZZ_sm(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2)
        vhWW_sm(1) = rGam1_hWW_sm(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2)
        vhWW_sm(2) = rGam2_hWW_sm(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2)
        vhWW_sm(3) = rGam3_hWW_sm(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2)
        vhtt_sm(1) = rGamS_htt_sm(p_htt(1)**2,p_htt(2)**2,p_htt(3)**2)
        vhbb_sm(1) = rGamS_hbb_sm(p_hbb(1)**2,p_hbb(2)**2,p_hbb(3)**2)
        vhcc_sm(1) = rGamS_hcc_sm(p_hcc(1)**2,p_hcc(2)**2,p_hcc(3)**2)
        vhll_sm(1) = rGamS_htautau_sm(p_hll(1)**2,p_hll(2)**2,p_hll(3)**2)
        vhhh_sm      = rGam_hhh_sm(p_hhh(1)**2,p_hhh(2)**2,p_hhh(3)**2)

        write(10,100) 'Re[rGam_hZZ(1)]:', dble(vhZZ_sm(1)),'Im[rGam_hZZ(1)]:', imag(vhZZ_sm(1))
        write(10,100) 'Re[rGam_hZZ(2)]:', dble(vhZZ_sm(2)),'Im[rGam_hZZ(2)]:', imag(vhZZ_sm(2))
        write(10,100) 'Re[rGam_hZZ(3)]:', dble(vhZZ_sm(3)),'Im[rGam_hZZ(3)]:', imag(vhZZ_sm(3))
        write(10,100) 'Re[rGam_hWW(1)]:', dble(vhWW_sm(1)),'Im[rGam_hWW(1)]:', imag(vhWW_sm(1))
        write(10,100) 'Re[rGam_hWW(2)]:', dble(vhWW_sm(2)),'Im[rGam_hWW(2)]:', imag(vhWW_sm(2))
        write(10,100) 'Re[rGam_hWW(3)]:', dble(vhWW_sm(3)),'Im[rGam_hWW(3)]:', imag(vhWW_sm(3))
        write(10,100) 'Re[rGam_htt(S)]:', dble(vhtt_sm(1)),'Im[rGam_htt(S)]:', imag(vhtt_sm(1))
        write(10,100) 'Re[rGam_hbb(S)]:', dble(vhbb_sm(1)),'Im[rGam_hbb(S)]:', imag(vhbb_sm(1))
        write(10,100) 'Re[rGam_hcc(S)]:', dble(vhcc_sm(1)),'Im[rGam_hcc(S)]:', imag(vhcc_sm(1))
        write(10,100) 'Re[rGam_hll(S)]:', dble(vhll_sm(1)),'Im[rGam_hll(S)]:', imag(vhll_sm(1))
        write(10,100) 'Re[rGam_hhh]:'   , dble(vhhh_sm),'Im[rGam_hhh]:', imag(vhhh_sm)
        write(10,200) 'Gam(h->gamgam):',hgamgam_sm(mh)
        write(10,200) 'Gam(h->Zgam):'  ,hZgam_sm(mh)
        write(10,200) 'Gam(h->gg):'    ,hgg_sm(mh)

        vhZZ(1) = rGam1_hZZ(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2,mch,mA,mbh,bmsq,alpha,beta,n)
        vhZZ(2) = rGam2_hZZ(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2,mch,mA,mbh,bmsq,alpha,beta,n)
        vhZZ(3) = rGam3_hZZ(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2,mch,mA,mbh,bmsq,alpha,beta,n)
        vhWW(1) = rGam1_hWW(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2,mch,mA,mbh,bmsq,alpha,beta,n)
        vhWW(2) = rGam2_hWW(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2,mch,mA,mbh,bmsq,alpha,beta,n)
        vhWW(3) = rGam3_hWW(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2,mch,mA,mbh,bmsq,alpha,beta,n)
        vhtt(1) = rGamS_htt(p_htt(1)**2,p_htt(2)**2,p_htt(3)**2,mch,mA,mbh,bmsq,alpha,beta,n)
        vhbb(1) = rGamS_hbb(p_hbb(1)**2,p_hbb(2)**2,p_hbb(3)**2,mch,mA,mbh,bmsq,alpha,beta,n)
        vhcc(1) = rGamS_hcc(p_hcc(1)**2,p_hcc(2)**2,p_hcc(3)**2,mch,mA,mbh,bmsq,alpha,beta,n)
        vhll(1) = rGamS_htautau(p_hll(1)**2,p_hll(2)**2,p_hll(3)**2,mch,mA,mbh,bmsq,alpha,beta,n)
        vhhh    = rGam_hhh(p_hhh(1)**2,p_hhh(2)**2,p_hhh(3)**2,mch,mA,mbh,bmsq,alpha,beta,n)

        write(11,100) 'Re[rGam_hZZ(1)]:', dble(vhZZ(1)),'Im[rGam_hZZ(1)]:', imag(vhZZ(1))
        write(11,100) 'Re[rGam_hZZ(2)]:', dble(vhZZ(2)),'Im[rGam_hZZ(2)]:', imag(vhZZ(2))
        write(11,100) 'Re[rGam_hZZ(3)]:', dble(vhZZ(3)),'Im[rGam_hZZ(3)]:', imag(vhZZ(3))
        write(11,100) 'Re[rGam_hWW(1)]:', dble(vhWW(1)),'Im[rGam_hWW(1)]:', imag(vhWW(1))
        write(11,100) 'Re[rGam_hWW(2)]:', dble(vhWW(2)),'Im[rGam_hWW(2)]:', imag(vhWW(2))
        write(11,100) 'Re[rGam_hWW(3)]:', dble(vhWW(3)),'Im[rGam_hWW(3)]:', imag(vhWW(3))
        write(11,100) 'Re[rGam_htt(S)]:', dble(vhtt(1)),'Im[rGam_htt(S)]:', imag(vhtt(1))
        write(11,100) 'Re[rGam_hbb(S)]:', dble(vhbb(1)),'Im[rGam_hbb(S)]:', imag(vhbb(1))
        write(11,100) 'Re[rGam_hcc(S)]:', dble(vhcc(1)),'Im[rGam_hcc(S)]:', imag(vhcc(1))
        write(11,100) 'Re[rGam_hll(S)]:', dble(vhll(1)),'Im[rGam_hll(S)]:', imag(vhll(1))
        write(11,100) 'Re[rGam_hhh]:'   , dble(vhhh),'Im[rGam_hhh]:', imag(vhhh)
        write(11,200) 'Gam(h->gamgam):',Gam_hgamgam(mch,mA,mbh,bmsq,alpha,beta,n)
        write(11,200) 'Gam(h->Zgam):'  ,Gam_hZgam(mch,mA,mbh,bmsq,alpha,beta,n)
        write(11,200) 'Gam(h->gg):'    ,Gam_hgg(mch,mA,mbh,bmsq,alpha,beta,n)
        
 100 Format(A20,1PE18.8,A20,1PE18.8)
 200 Format(A20,1PE18.8)        
	contains
!#################################################
!
!    SECTION I Parameter translations 
!
!#################################################

!================= Mixing Angle ==================
	double precision function alpha_f(beta,delta,sig)
	double precision, intent(in):: beta,delta
	integer, intent(in):: sig
        ! delta is defined by sin(beta-alpha) = 1-delta
	
	if (sig .eq. 1) then 
	alpha_f = beta - asin(1.d0-delta)
	else if (sig .eq. -1) then
	alpha_f = beta + asin(1.d0-delta)-pi
	else
	alpha_f=0.d0
	end if 

	end function
!========= physical parameters -> lambda1-lambda5 =======
	double precision function lam1(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

        lam1=&
	((-dsin(beta)**2*bmsq+&
	dsin(alpha)**2*mh**2+dcos(alpha)**2*mbH**2)/dcos(beta)**2 &
	)/vev**2

	 end function 
!------------------------------------
	double precision function lam2(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

      lam2=&
	((-dcos(beta)**2*bmsq+&
	dcos(alpha)**2*mh**2+dsin(alpha)**2*mbH**2)/dsin(beta)**2 &
	)/vev**2

	 end function 
!------------------------------------
	double precision function lam3(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

      lam3=(-bmsq+2.d0*mch**2+&
	dsin(2.d0*alpha)/dsin(2.d0*beta)*(mbH**2-mh**2))/vev**2

	 end function 
!------------------------------------
	double precision function lam4(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

      lam4=(bmsq+mA**2-2.d0*mch**2)/vev**2

	 end function 
!------------------------------------
	double precision function lam5(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

      lam5=(bmsq-mA**2)/vev**2

	 end function
!#################################################
!
!    SECTION II Tree-level couplings
!
!#################################################
!---------------  Type up -------------------
	double precision function xiu(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	if (n.EQ.1) then
	xiu=cos(alpha)/sin(beta)
	else if (n.EQ.2) then
	xiu=cos(alpha)/sin(beta)
	else if (n.EQ.3) then
	xiu=cos(alpha)/sin(beta)
	else if (n.EQ.4) then
	xiu=cos(alpha)/sin(beta)
	else
	xiu=1.d-10
	end if

	end function
!---------------  Type down -------------------
	double precision function xid(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	if (n.EQ.1) then
	xid=cos(alpha)/sin(beta)
	else if (n.EQ.2) then
	xid=-sin(alpha)/cos(beta)
	else if (n.EQ.3) then
	xid=cos(alpha)/sin(beta)
	else if (n.EQ.4) then
	xid=-sin(alpha)/cos(beta)
	else
	xid=1.d-10
	end if

	end function
!---------------  Type lepton -------------------
	double precision function xil(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	if (n.EQ.1) then
	xil=cos(alpha)/sin(beta)*n
	else if (n.EQ.2) then
	xil=-sin(alpha)/cos(beta)*n/2
	else if (n.EQ.3) then
	xil=-sin(alpha)/cos(beta)*n/3
	else if (n.EQ.4) then
	xil=cos(alpha)/sin(beta)*n/4
	else
	xil= 1.d-10
	end if

	end function
!---------------  Type up -------------------
	double precision function xiu_H(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	if (n.EQ.1) then
	xiu_H=sin(alpha)/sin(beta)
	else if (n.EQ.2) then
	xiu_H=sin(alpha)/sin(beta)
	else if (n.EQ.3) then
	xiu_H=sin(alpha)/sin(beta)
	else if (n.EQ.4) then
	xiu_H=sin(alpha)/sin(beta)
	else
	xiu_H=1.d-10
	end if

	end function
!---------------  Type down -------------------
	double precision function xid_H(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	if (n.EQ.1) then
	xid_H=sin(alpha)/sin(beta)
	else if (n.EQ.2) then
	xid_H=cos(alpha)/cos(beta)
	else if (n.EQ.3) then
	xid_H=sin(alpha)/sin(beta)
	else if (n.EQ.4) then
	xid_H=cos(alpha)/cos(beta)
	else
	xid_H=1.d-10
	end if

	end function
!---------------  Type lepton -------------------
	double precision function xil_H(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	if (n.EQ.1) then
	xil_H=sin(alpha)/sin(beta)
	else if (n.EQ.2) then
	xil_H=cos(alpha)/cos(beta)
	else if (n.EQ.3) then
	xil_H=cos(alpha)/cos(beta)
	else if (n.EQ.4) then
	xil_H=sin(alpha)/sin(beta)
	else
	xil_H=1.d-10
	end if

	end function
!---------------  Type up -------------------
	double precision function xiu_A(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	if (n.EQ.1) then
	xiu_A=1.d0/tan(beta)
	else if (n.EQ.2) then
	xiu_A=1.d0/tan(beta)
	else if (n.EQ.3) then
	xiu_A=1.d0/tan(beta)
	else if (n.EQ.4) then
	xiu_A=1.d0/tan(beta)
	else
	xiu_A= 1.d-10
	end if

	end function
!---------------  Type down -------------------
	double precision function xid_A(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	if (n.EQ.1) then
	xid_A=1.d0/tan(beta)
	else if (n.EQ.2) then
	xid_A=-tan(beta)
	else if (n.EQ.3) then
	xid_A=1.d0/tan(beta)
	else if (n.EQ.4) then
	xid_A=-tan(beta)
	else
	xid_A=1.d-10
	end if

	end function
!---------------  Type lepton -------------------
	double precision function xil_A(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	if (n.EQ.1) then
	xil_A=1.d0/tan(beta)
	else if (n.EQ.2) then
	xil_A=-tan(beta)
	else if (n.EQ.3) then
	xil_A=-tan(beta)
	else if (n.EQ.4) then
	xil_A=1.d0/tan(beta)
	else
	xil_A=1.d-10
	end if

	end function
!========== Scalar 3-point couplings ==========
!    The scalar 3 and 4 point couplings are defined as the coefficient of Lagrangian: 
!    L = + lam_ijk phi_i phi_j phi_k + ... 

 	double precision function lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_HpHmh=-1.d0/(vev*dsin(2.d0*beta))*(&
	2.d0*cos(alpha+beta)*(mh**2-bmsq)+dsin(beta-alpha)*dsin(2.d0*beta)*(2.d0*mch**2-mh**2))

	 end function 
!----------------------------------------------------
	double precision function lam_AAh(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_AAh=-(1.d0/(2.d0*vev))*(&
	(dcos(alpha)*dcos(beta)**2.d0/dsin(beta)&
	-dsin(alpha)*dsin(beta)**2.d0/dcos(beta))*mh**2.d0&
	-2.d0*dsin(alpha-beta)*mA**2.d0&
	-bmsq*dcos(alpha+beta)/(dsin(beta)*dcos(beta)))

	 end function 
!----------------------------------------------------
	double precision function lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_bHbHh=-(-1.d0/(4.d0*vev))*dsin(alpha-beta)*&
	(bmsq*(3.d0*dsin(2.d0*alpha)+dsin(2.d0*beta))&
	-dsin(2.d0*alpha)*mh**2-2.d0*dsin(2.d0*alpha)*mbh**2)/(dsin(beta)*dcos(beta))

	 end function 
!----------------------------------------------------
	double precision function lam_HpHmbH(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_HpHmbH=&
	 1.d0/(2.d0*vev*sin(2.d0*beta))*&
	 ( 4.d0*bmsq*sin(alpha+beta)&
	    -(&
	     sin(alpha-3.d0*beta)+3.d0*sin(alpha+beta)&
	     )*mbh**2&
	-4.d0*cos(alpha-beta)*sin(2.d0*beta)*mch**2)

	end function
!----------------------------------------------------
	double precision function lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_bHhh= -(1.d0/(4.d0*vev))*cos(alpha-beta)*&
	(bmsq*(-3.d0*sin(2.d0*alpha)+sin(2.d0*beta))&
	+2.d0*sin(2.d0*alpha)*mh**2+sin(2.d0*alpha)*mbH**2)/&
	 (sin(beta)*cos(beta))

	end function
!----------------------------------------------------
	double precision function lam_AAbH(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_AAbH=-(1.d0/(8.d0*vev))*(-4.d0*bmsq*sin(alpha+beta)&
	+4.d0*cos(alpha-beta)*sin(2.d0*beta)*mA**2&
	 +(sin(alpha-3.d0*beta)+3.d0*sin(alpha+beta))&
	*mbH**2)/(sin(beta)*cos(beta))

	end function
!----------------------------------------------------
 	double precision function lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_HpGmh=-1.d0/vev*cos(beta-alpha)*(mh**2-mch**2)

	 end function 
!----------------------------------------------------
	double precision function lam_AGh(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_AGh= -1.d0/vev*cos(beta-alpha)*(mh**2-mA**2)

	 end function 
!----------------------------------------------------
	double precision function lam_HpGmbH(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_HpGmbH= -1.d0/vev*sin(beta-alpha)*(mch**2-mbH**2)

	end function
!----------------------------------------------------
	double precision function lam_AGbH(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_AGbH=-1.d0/vev*sin(beta-alpha)*(mA**2-mbH**2)

	end function
!----------------------------------------------------
	double precision function lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_GpGmh = -1.d0/vev*sin(beta-alpha)*mh**2

	end function
!----------------------------------------------------
	double precision function lam_GGh(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_GGh = -1.d0/(2.d0*vev)*sin(beta-alpha)*mh**2

	end function
!----------------------------------------------------
	double precision function lam_hhh(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_hhh = &
	-mh**2/(2.d0*vev)*sin(beta-alpha)-1.d0/(vev*sin(2.d0*beta))*cos(beta-alpha)**2*cos(beta+alpha)*(mh**2-bmsq)
	 
	end function
!----------------------------------------------------
	double precision function lam_bHbHbH(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_bHbHbH = 1.d0/(4.d0*sin(2.d0*beta)*vev)*(&
		 sin(3.d0*alpha-beta)*mbH**2+sin(alpha+beta)*(4.d0*sin(beta-alpha)**2*bmsq-3.d0*mbH**2)&
		 )

	end function
!----------------------------------------------------
	double precision function lam_GpGmbH(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_GpGmbH = -1.d0/vev*cos(beta-alpha)*mbH**2

	end function
!----------------------------------------------------
	double precision function lam_GGbH(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_GGbH = -1.d0/(2.d0*vev)*cos(beta-alpha)*mbH**2

	end function
!========== Scalar 4-point couplings ========== 
	double precision function lam_HpHmAG(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_HpHmAG = -1.d0/(4.d0*vev**2)*(&
	+cos(2.d0*alpha)*(3.d0+cos(4.d0*beta))/sin(2.d0*beta)*(mh**2-mbH**2)&
	+2.d0*cos(2.d0*beta)*sin(2.d0*alpha)*(mh**2-mbH**2)&
	+4.d0*(-2.d0*bmsq+mh**2+mbH**2)/tan(2.d0*beta)&
	)

	end function
!----------------------------------------------------
	double precision function lam_HpHmbHbH(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_HpHmbHbH = -1.d0/(16.d0*vev**2)*(&
	+16.d0*cos(alpha-beta)**2*mch**2&
	+4.d0*cos(2.d0*alpha)/tan(2.d0*beta)/sin(2.d0*beta)*( (3.d0+cos(4.d0*beta))*bmsq-4.d0*mbH**2 )&
	-(3.d0+cos(4.d0*beta))/sin(2.d0*beta)**2*(4.d0*bmsq-mh**2-3.d0*mbH**2)&
	-cos(4.d0*alpha)*(3.d0+cos(4.d0*beta))/sin(2.d0*beta)**2*(mh**2-mbH**2)&
	+2.d0/tan(2.d0*beta)*sin(4.d0*alpha)*(mbH**2-mh**2)&
	+4.d0/sin(2.d0*beta)*sin(2.d0*alpha)*((-1.d0+cos(4.d0*beta))*bmsq-mh**2+mbH**2)&
	)

	end function
!----------------------------------------------------
	double precision function lam_HpHmbHh(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_HpHmbHh = -1.d0/(8.d0*vev**2)*(&
	+8.d0*cos(2.d0*alpha)*sin(2.d0*beta)*(mch**2-bmsq)+2.d0/tan(2.d0*beta)*(mh**2-mbH**2)&
	+(3.d0+cos(4.d0*beta))/sin(2.d0*beta)**2*sin(4.d0*alpha)*(mh**2-mbH**2)&
	+2.d0*cos(4.d0*alpha)/tan(2.d0*beta)*(mbH**2-mh**2)&
	-4.d0/tan(2.d0*beta)/sin(2.d0*beta)*sin(2.d0*alpha)*(&
	                  (3.d0+cos(4.d0*beta))*bmsq+2.d0*sin(2.d0*beta)**2*mch**2-2.d0*(mh**2+mbH**2)&
							    )&
	)

	end function
!----------------------------------------------------
	double precision function lam_HpHmhh(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_HpHmhh = -1.d0/(16.d0*sin(2.d0*beta)**2*vev**2)*(&
	-2.d0*( cos(2.d0*alpha-6.d0*beta) + 2.d0*(3.d0+cos(2.d0*alpha-2.d0*beta)+cos(4.d0*beta) )&
               +5.d0*(cos(2.d0*alpha+2.d0*beta))  )*bmsq&
	+16.d0*sin(beta-alpha)**2*sin(2.d0*beta)**2*mch**2&
	+(9.d0+3.d0*cos(4.d0*alpha)+6.d0*cos(2.d0*alpha-2.d0*beta)&
	+cos(4.d0*alpha-4.d0*beta)+3.d0*cos(4.d0*beta)+10.d0*cos(2.d0*alpha+2.d0*beta))*mh**2&
	+2.d0*sin(2.d0*alpha)*(3.d0*sin(2.d0*alpha)+sin(2.d0*alpha-4.d0*beta)+2.d0*sin(2.d0*beta))*mbH**2&
	)

	end function
!----------------------------------------------------
	double precision function lam_GpGmAG(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_GpGmAG = -1.d0/(2.d0*vev**2)*sin(2.d0*alpha-2.d0*beta)*(mbH**2-mh**2)

	end function
!----------------------------------------------------
	double precision function lam_GpGmbHbH(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_GpGmbHbH = -1.d0/(8.d0*vev**2)*(&
	+(-4.d0*sin(alpha-beta)**2)*(&
	+2.d0*bmsq-2.d0*mch**2+sin(2.d0*alpha)/sin(2.d0*beta)*mh**2)&
	+(3.d0+cos(4.d0*alpha)+2.d0*sin(2.d0*alpha)/sin(2.d0*beta)-sin(4.d0*alpha)/tan(2.d0*beta))*mbH**2&
	)

	end function
!----------------------------------------------------
	double precision function lam_GpGmbHh(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_GpGmbHh = -1.d0/(2.d0*vev**2)*(&
	sin(2.d0*alpha-2.d0*beta)*(-2.d0*bmsq+2.d0*mch**2+sin(2.d0*alpha)/sin(2.d0*beta)*(mbH**2-mh**2))&
	)

	end function
!----------------------------------------------------
	double precision function lam_GpGmhh(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_GpGmhh = -1.d0/(8.d0*vev**2)*(&
	-(-3.d0+(2.d0*sin(2.d0*alpha)+sin(4.d0*alpha-2.d0*beta))/sin(2.d0*beta))*mh**2&
	+4.d0*cos(alpha-beta)**2*(-2.d0*bmsq+2.d0*mch**2+sin(2.d0*alpha)/sin(2.d0*beta)*mbH**2)&
	)

	end function
!----------------------------------------------------
	double precision function lam_AAAG(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_AAAG = -1.d0/(24.d0*vev**2)*(&
	+3.d0*cos(2.d0*alpha)/sin(2.d0*beta)*(3.d0+cos(4.d0*beta))*(mh**2-mbH**2)&
	+6.d0*cos(2.d0*beta)*sin(2.d0*alpha)*(mh**2-mbH**2)&
	+12.d0/tan(2.d0*beta)*(-2.d0*bmsq+mh**2+mbH**2)&
	)

	end function
!----------------------------------------------------
	double precision function lam_AAbHbH(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_AAbHbH = -1.d0/(32.d0*vev**2)*(&
	16.d0*cos(alpha-beta)**2*mA**2+4.d0*cos(2.d0*alpha)/tan(2.d0*beta)/sin(2.d0*beta)*(&
	(3.d0+cos(4.d0*beta))*bmsq-4.d0*mbH**2)&
	-(3.d0+cos(4.d0*beta))/sin(2.d0*beta)**2*(4.d0*bmsq-mh**2-3.d0*mbH**2)&
	-cos(4.d0*alpha)*(3.d0+cos(4.d0*beta))/sin(2.d0*beta)**2*(mh**2-mbH**2)&
	+2.d0/tan(2.d0*beta)*sin(4.d0*alpha)*(mbH**2-mh**2)&
	+4.d0/sin(2.d0*beta)*sin(2.d0*alpha)*((-1.d0+cos(4.d0*beta))*bmsq-mh**2+mbH**2)&
	)

	end function
!----------------------------------------------------
	double precision function lam_AAbHh(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_AAbHh = -1.d0/(16.d0*vev**2)*(&
	8.d0*cos(2.d0*alpha)*sin(2.d0*beta)*(-bmsq+mA**2)+2.d0/tan(2.d0*beta)*(mh**2-mbH**2)&
	+(3.d0+cos(4.d0*beta))/sin(2.d0*beta)**2*sin(4.d0*alpha)*(mh**2-mbH**2)&
	+2.d0*cos(4.d0*alpha)/tan(2.d0*beta)*(mbH**2-mh**2)&
	-4.d0/tan(2.d0*beta)/sin(2.d0*beta)*sin(2.d0*alpha)*((3.d0+cos(4.d0*beta))*bmsq&
	+2.d0*sin(2.d0*beta)**2*mA**2-2.d0*(mh**2+mbH**2))&
	)

	end function
!----------------------------------------------------
	double precision function lam_AAhh(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_AAhh = -1.d0/(32.d0*sin(2.d0*beta)**2*vev**2)*(&
	-2.d0*( cos(2.d0*alpha-6.d0*beta) + 2.d0*(3.d0+cos(2.d0*alpha-2.d0*beta)+cos(4.d0*beta) )&
               +5.d0*(cos(2.d0*alpha+2.d0*beta))  )*bmsq&
	+16.d0*sin(beta-alpha)**2*sin(2.d0*beta)**2*mA**2&
	+(9.d0+3.d0*cos(4.d0*alpha)+6.d0*cos(2.d0*alpha-2.d0*beta)&
	+cos(4.d0*alpha-4.d0*beta)+3.d0*cos(4.d0*beta)+10.d0*cos(2.d0*alpha+2.d0*beta))*mh**2&
	+2.d0*sin(2.d0*alpha)*(3.d0*sin(2.d0*alpha)+sin(2.d0*alpha-4.d0*beta)+2.d0*sin(2.d0*beta))*mbH**2&
	)

	end function
!----------------------------------------------------
	double precision function lam_AGGG(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_AGGG = -1.d0/(4.d0*vev**2)*sin(2.d0*alpha-2.d0*beta)*(mbH**2-mh**2)

	end function
!----------------------------------------------------
	double precision function lam_AGbHbH(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_AGbHbH = 1.d0/(4.d0*vev**2)*(&
	sin(alpha-beta)/sin(2.d0*beta)*(&
	4.d0*cos(2.d0*beta)*sin(alpha-beta)*bmsq+2.d0*cos(alpha-beta)*(2.d0*sin(2.d0*beta)*mA**2-sin(2.d0*alpha)*mh**2)&
	+(sin(3.d0*alpha-beta)-3.d0*sin(alpha+beta))*mbH**2&
					)&
	)

	end function
!----------------------------------------------------
	double precision function lam_AGhh(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_AGhh = -1.d0/(8.d0*vev**2)*(&
	cos(alpha-beta)/sin(beta)/cos(beta)*(&
	-4.d0*cos(alpha-beta)*cos(2.d0*beta)*bmsq+2.d0*sin(alpha-beta)*(2.d0*sin(2.d0*beta)*mA**2+sin(2.d0*alpha)*mbH**2)&
	+(cos(3.d0*alpha-beta)+3.d0*cos(alpha+beta))*mh**2&
					)&
	)

	end function
!----------------------------------------------------
	double precision function lam_GGbHbH(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_GGbHbH = -1.d0/(16.d0*vev**2)*(&
	(-4.d0*sin(alpha-beta)**2)*(&
	2.d0*bmsq-2.d0*mA**2+sin(2.d0*alpha)/sin(2.d0*beta)*mh**2&
	)&
	+(3.d0+cos(4.d0*alpha)+2.d0*sin(2.d0*alpha)/sin(2.d0*beta)-sin(4.d0*alpha)/tan(2.d0*beta))*mbH**2&
	)

	end function
!----------------------------------------------------
	double precision function lam_GGbHh(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_GGbHh = -1.d0/(4.d0*vev**2)*sin(2.d0*alpha-2.d0*beta)*(&
	-2.d0*bmsq+2.d0*mA**2+sin(2.d0*alpha)/sin(2.d0*beta)*(mbH**2-mh**2)&
	)

	end function
!----------------------------------------------------
	double precision function lam_GGhh(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_GGhh = -1.d0/(16.d0*vev**2)*(&
	-(-3.d0+(2.d0*sin(2.d0*alpha)+sin(4.d0*alpha-2.d0*beta))/sin(2.d0*beta))*mh**2&
	+4.d0*cos(alpha-beta)**2*(-2.d0*bmsq+2.d0*mA**2+sin(2.d0*alpha)/sin(2.d0*beta)*mbH**2)&
	)

	end function
!----------------------------------------------------
	double precision function lam_bHbHbHbH(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_bHbHbHbH = -1.d0/(32.d0*vev**2)/sin(2.d0*beta)**2*(&
		4.d0*sin(alpha-beta)**2*( -4.d0*sin(alpha+beta)**2*bmsq+sin(2.d0*alpha)**2*mh**2 )&
		+(sin(3.d0*alpha-beta)-3.d0*sin(alpha+beta))**2*mbH**2&
	)

	end function
!----------------------------------------------------
	double precision function lam_bHbHbHh(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_bHbHbHh = -1.d0/(2.d0*vev**2)/sin(2.d0*beta)**2*sin(2.d0*alpha)*sin(alpha-beta)*(&
	-2.d0*sin(alpha+beta)*bmsq+cos(alpha-beta)*sin(2.d0*alpha)*mh**2&
	+2.d0*(cos(beta)*sin(alpha)**3+cos(alpha)**3*sin(beta))*mbH**2&
	)

	end function
!----------------------------------------------------
	double precision function lam_bHbHhh(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_bHbHhh = -1.d0/(16.d0*sin(2.d0*beta)**2*vev**2)*(&
	+( 6.d0*cos(4.d0*alpha)-2.d0*(2.d0+cos(4.d0*beta)) )*bmsq&
	+sin(2.d0*alpha)*(&
	   3.d0*cos(2.d0*beta)*sin(4.d0*alpha)*(mh**2-mbH**2)&
	   -(1.d0+3.d0*cos(4.d0*alpha))*sin(2.d0*beta)*(mh**2-mbH**2)&
	   +6.d0*sin(2.d0*alpha)*(mh**2+mbH**2)&
			 )&
	)

	end function
!----------------------------------------------------
	double precision function lam_bHhhh(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_bHhhh = -1.d0/(4.d0*vev**2)*cos(alpha-beta)/sin(2.d0*beta)**2*sin(2.d0*alpha)*(&
	cos(3.d0*alpha-beta)*mh**2+cos(alpha+beta)*(-4.d0*bmsq+3.d0*mh**2)&
	+2.d0*sin(2.d0*alpha)*sin(alpha-beta)*mbH**2&
	)

	end function
!----------------------------------------------------
	double precision function lam_hhhh(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_hhhh = -1.d0/(32.d0*sin(2.d0*beta)**2*vev**2)*(&
	-4.d0*(cos(2.d0*alpha)+cos(2.d0*beta))**2*bmsq&
	+(cos(3.d0*alpha-beta)+3.d0*cos(alpha+beta))**2*mh**2&
	+4.d0*cos(alpha-beta)**2*sin(2.d0*alpha)**2*mbH**2&
	)

	end function
!----------------------------------------------------
	double precision function lam_HpGmhh(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	lam_HpGmhh = cos(beta-alpha)/vev**2*(&
	-1.d0/(4.d0*sin(2.d0*beta))*( cos(3.d0*alpha-beta)+3.d0*cos(alpha+beta))*mh**2&
	+1.d0/(2.d0*sin(2.d0*beta))*sin(2.d0*alpha)*sin(beta-alpha)*mbH**2&
	+cos(beta-alpha)/tan(2.d0*beta)*bmsq&
	+sin(beta-alpha)*mch**2&
	)

	end function

!#################################################
!
!    SECTION III Constraints on parameter space
!
!#################################################

!============ Perturbative unitarity ===================
	double precision function a0ap(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

      a0ap=(3.d0/2.d0*(lam1(mch,mA,mbh,bmsq,alpha,beta)&
	+lam2(mch,mA,mbh,bmsq,alpha,beta))+&
	dsqrt(9.d0/4.d0*(&
	lam1(mch,mA,mbh,bmsq,alpha,beta)&
	-lam2(mch,mA,mbh,bmsq,alpha,beta)&
	)**2+(2.d0*lam3(mch,mA,mbh,bmsq,alpha,beta)&
	+lam4(mch,mA,mbh,bmsq,alpha,beta)&
	)**2)&
	 )/(16.d0*pi)

	 end function 
!------------------------------------
	double precision function a0am(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

      a0am=&
	(3.d0/2.d0*(lam1(mch,mA,mbh,bmsq,alpha,beta)&
	+lam2(mch,mA,mbh,bmsq,alpha,beta))-&
	dsqrt(9.d0/4.d0*(lam1(mch,mA,mbh,bmsq,alpha,beta)&
	-lam2(mch,mA,mbh,bmsq,alpha,beta))**2&
	+(2.d0*lam3(mch,mA,mbh,bmsq,alpha,beta)&
	+lam4(mch,mA,mbh,bmsq,alpha,beta))**2)&
	)/(16.d0*pi)

	 end function
!------------------------------------
	double precision function a0bp(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

      a0bp=(1.d0/2.d0*(lam1(mch,mA,mbh,bmsq,alpha,beta)&
	+lam2(mch,mA,mbh,bmsq,alpha,beta))+&
	dsqrt(1.d0/4.d0*(lam1(mch,mA,mbh,bmsq,alpha,beta)&
	-lam2(mch,mA,mbh,bmsq,alpha,beta))**2&
	+lam4(mch,mA,mbh,bmsq,alpha,beta)**2)&
	)/(16.d0*pi)

	 end function 
!------------------------------------
	double precision function a0bm(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

      a0bm=(1.d0/2.d0*(lam1(mch,mA,mbh,bmsq,alpha,beta)&
	+lam2(mch,mA,mbh,bmsq,alpha,beta))-&
	dsqrt(1.d0/4.d0*(lam1(mch,mA,mbh,bmsq,alpha,beta)&
	-lam2(mch,mA,mbh,bmsq,alpha,beta))**2&
	+lam4(mch,mA,mbh,bmsq,alpha,beta)**2)&
	)/(16.d0*pi)

	 end function 
!------------------------------------
	double precision function a0cp(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

      a0cp=(1.d0/2.d0*(lam1(mch,mA,mbh,bmsq,alpha,beta)&
	+lam2(mch,mA,mbh,bmsq,alpha,beta))+&
	dsqrt(1.d0/4.d0*(lam1(mch,mA,mbh,bmsq,alpha,beta)&
	-lam2(mch,mA,mbh,bmsq,alpha,beta))**2&
	+lam5(mch,mA,mbh,bmsq,alpha,beta)**2)&
	)/(16.d0*pi)

	 end function 
!------------------------------------
	double precision function a0cm(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

      a0cm=(1.d0/2.d0*(lam1(mch,mA,mbh,bmsq,alpha,beta)&
	+lam2(mch,mA,mbh,bmsq,alpha,beta))-&
	dsqrt(1.d0/4.d0*(lam1(mch,mA,mbh,bmsq,alpha,beta)&
	-lam2(mch,mA,mbh,bmsq,alpha,beta))**2&
	+lam5(mch,mA,mbh,bmsq,alpha,beta)**2)&
	)/(16.d0*pi)

	 end function 
!------------------------------------
	double precision function a0e1(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

      a0e1=(lam3(mch,mA,mbh,bmsq,alpha,beta)&
	+2.d0*lam4(mch,mA,mbh,bmsq,alpha,beta)&
	-3.d0*lam5(mch,mA,mbh,bmsq,alpha,beta)&
	)/(16.d0*pi)

	 end function
!------------------------------------
	double precision function a0e2(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

      a0e2=(lam3(mch,mA,mbh,bmsq,alpha,beta)&
	-lam5(mch,mA,mbh,bmsq,alpha,beta))/(16.d0*pi)

	 end function
!------------------------------------
	double precision function a0fp(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

      a0fp=(lam3(mch,mA,mbh,bmsq,alpha,beta)&
	 +2.d0*lam4(mch,mA,mbh,bmsq,alpha,beta)&
	 +3.d0*lam5(mch,mA,mbh,bmsq,alpha,beta)&
	)/(16.d0*pi)

	 end function
!------------------------------------
	double precision function a0fm(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

      a0fm=(lam3(mch,mA,mbh,bmsq,alpha,beta)&
	+lam5(mch,mA,mbh,bmsq,alpha,beta))/(16.d0*pi)

	 end function
!------------------------------------
	double precision function a0f1(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

      a0f1=(lam3(mch,mA,mbh,bmsq,alpha,beta)&
	+lam4(mch,mA,mbh,bmsq,alpha,beta))/(16.d0*pi)

	 end function
!------------------------------------
	double precision function a0p(mch,ma,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,ma,mbh,bmsq,alpha,beta

      a0p=(lam3(mch,ma,mbh,bmsq,alpha,beta)&
	-lam4(mch,ma,mbh,bmsq,alpha,beta))/(16.d0*pi)

	 end function
!------------------------------------
	double precision function pu(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

      if (dabs(a0ap(mch,mA,mbh,bmsq,alpha,beta))&
   .gt.lqt) then
	pu=1.d0 
      else if (dabs(a0am(mch,mA,mbh,bmsq,alpha,beta))&
   .gt.lqt) then
	pu=2.d0 
      else if (dabs(a0bp(mch,mA,mbh,bmsq,alpha,beta))&
   .gt.lqt) then
	pu=3.d0 
      else if (dabs(a0bm(mch,mA,mbh,bmsq,alpha,beta))&
   .gt.lqt) then
	pu=4.d0 
      else if (dabs(a0cp(mch,mA,mbh,bmsq,alpha,beta))&
   .gt.lqt) then
	pu=5.d0 
      else if (dabs(a0cm(mch,mA,mbh,bmsq,alpha,beta))&
   .gt.lqt) then
	pu=6.d0 
      else if (dabs(a0e1(mch,mA,mbh,bmsq,alpha,beta))&
   .gt.lqt) then
	pu=7.d0 
      else if (dabs(a0e2(mch,mA,mbh,bmsq,alpha,beta))&
   .gt.lqt) then
	pu=8.d0 
      else if (dabs(a0fp(mch,mA,mbh,bmsq,alpha,beta))&
   .gt.lqt) then
	pu=9.d0 
      else if (dabs(a0fm(mch,mA,mbh,bmsq,alpha,beta))&
   .gt.lqt) then
	pu=10.d0 
      else if (dabs(a0f1(mch,mA,mbh,bmsq,alpha,beta))&
   .gt.lqt) then
	pu=11.d0 
      else if (dabs(a0p(mch,mA,mbh,bmsq,alpha,beta))&
   .gt.lqt) then
	pu=12.d0 
	else
	pu=0.d0
	end if

	 end function
!============= Vacuum stability ===============================
	double precision function vs(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	double precision:: tmp1,tmp2,stab

      tmp1=lam4(mch,mA,mbh,bmsq,alpha,beta)&
     +lam5(mch,mA,mbh,bmsq,alpha,beta)
      tmp2=lam4(mch,mA,mbh,bmsq,alpha,beta)&
     -lam5(mch,mA,mbh,bmsq,alpha,beta)

      stab=dsqrt(lam1(mch,mA,mbh,bmsq,alpha,beta)*&
           lam2(mch,mA,mbh,bmsq,alpha,beta))&
            +lam3(mch,mA,mbh,bmsq,alpha,beta)&
            +dmin1(0.d0,tmp1,tmp2)     
	if (lam1(mch,mA,mbh,bmsq,alpha,beta) .lt. 0.d0) then
	vs=1.d0  
      else if (lam2(mch,mA,mbh,bmsq,alpha,beta) .lt. 0.d0) then
	vs=2.d0  
      else if (stab .lt. 0.d0) then 
	vs=3.d0  
      else 
 	vs=0.d0
      end if    

	 end function 
!=============== Triviality bound ==============================================
	double precision function triviality(cutoff,mch,mA,mbh,bmsq,alpha,beta)
	integer:: i,no
	double precision:: t0,tfin,max_coup,t,h
	double precision:: vlam1,vlam2,vlam3,vlam4,vlam5,vyt
	double precision, intent(in):: cutoff,mch,mA,mbh,bmsq,alpha,beta

           vlam1 = lam1(mch,mA,mbh,bmsq,alpha,beta)
           vlam2 = lam2(mch,mA,mbh,bmsq,alpha,beta)
           vlam3 = lam3(mch,mA,mbh,bmsq,alpha,beta)
           vlam4 = lam4(mch,mA,mbh,bmsq,alpha,beta)
           vlam5 = lam5(mch,mA,mbh,bmsq,alpha,beta)
           vyt   =  sqrt(2.d0)*mt/vev/sin(beta)

	   no=100
           t0= Log(mz)
	   tfin=Log(1.d10)
           h=(tfin-t0)/dble(no)
           do  i = 0,no
	   t=t0+h*dble(i)
     	   call RGE(t0,tfin,h,t,no,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
           max_coup = max(abs(vlam1),abs(vlam2),abs(vlam3),abs(vlam4),abs(vlam5),abs(vyt))
           if (exp(t) .lt. cutoff .and. max_coup .gt. 4.d0*pi) then 
           triviality = 1.d0
           exit
           else if  (exp(t) .gt. cutoff .and. max_coup .le. 4.d0*pi) then 
           triviality = 0.d0
           exit
           endif
           enddo

	end function
!============= RGE improved vacuum stability ====================
	double precision function vs_rge(cutoff,mch,mA,mbh,bmsq,alpha,beta)
	integer:: i,no
	double precision:: t0,tfin,max_coup,t,h
	double precision:: vlam1,vlam2,vlam3,vlam4,vlam5,vyt,stab
	double precision, intent(in):: cutoff,mch,mA,mbh,bmsq,alpha,beta

           vlam1 = lam1(mch,mA,mbh,bmsq,alpha,beta)
           vlam2 = lam2(mch,mA,mbh,bmsq,alpha,beta)
           vlam3 = lam3(mch,mA,mbh,bmsq,alpha,beta)
           vlam4 = lam4(mch,mA,mbh,bmsq,alpha,beta)
           vlam5 = lam5(mch,mA,mbh,bmsq,alpha,beta)
           vyt   =  sqrt(2.d0)*mt/vev/sin(beta)
           vs_rge = 0.d0

	   no=100
           t0= Log(mz)
	   tfin=Log(cutoff)
           h=(tfin-t0)/dble(no)
           do  i = 0,no
	   t=t0+h*dble(i)
     	   call RGE(t0,tfin,h,t,no,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
           stab = sqrt(vlam1*vlam2)+vlam3 + min1(0.d0,vlam4+vlam5,vlam4-vlam5)     
           if (vlam1 .lt. 0.d0) then
            vs_rge = 1.d0  
         else if (vlam2 .lt. 0.d0) then
            vs_rge = 2.d0 
         else if (stab .lt. 0.d0) then 
            vs_rge = 3.d0  
         end if
         enddo

	end function
!=============== ST parameters===================
	complex (kind(0d0)) function  F_stu(psq,m1,m2)
	double precision, intent(in):: psq,m1,m2

	F_stu = -B5f(psq,m1,m2)

	end function
!---------------------------------------------------
	complex (kind(0d0)) function  G_stu(psq,m1,m2)
	double precision, intent(in):: psq,m1,m2

	G_stu = -4.d0*m2**2*B0f(psq,m1,m2) - B5f(psq,m1,m2)

	end function
!---------------------------------------------------
	complex (kind(0d0)) function  Fp_stu(psq,m1,m2)
	double precision, intent(in):: psq,m1,m2

	Fp_stu = (F_stu(psq,m1,m2)-F_stu(0.d0,m1,m2))/psq

	end function
!---------------------------------------------------
	complex (kind(0d0)) function  Gp_stu(psq,m1,m2)
	double precision, intent(in):: psq,m1,m2

	Gp_stu = (G_stu(psq,m1,m2)-G_stu(0.d0,m1,m2))/psq

	end function
!---------------------------------------------------
	complex (kind(0d0)) function  Del_S_2HDM(mch,ma,mbh,alpha,beta)
	double precision, intent(in):: mch,ma,mbh,alpha,beta

	Del_S_2HDM = 1.d0/(4.d0*pi)*(& 
        -Fp_stu(mz**2,mch,mch) + sin(beta-alpha)**2*Fp_stu(mz**2,mbh,ma) &
        +cos(beta-alpha)**2*(&
         Fp_stu(mz**2,mh,ma) + Gp_stu(mz**2,mbh,mz) - Gp_stu(mz**2,mh,mz)&
                            )&
        )

	end function
!---------------------------------------------------
	complex (kind(0d0)) function  Del_T_2HDM(mch,ma,mbh,alpha,beta)
	double precision, intent(in):: mch,ma,mbh,alpha,beta

	Del_T_2HDM = 1.d0/(16.d0*pi**2*alpha_em*vev**2)*(& 
        F_stu(0.d0,mch,ma)& 
        +sin(beta-alpha)**2*( F_stu(0.d0,mch,mbh) - F_stu(0.d0,mbh,ma) )& 
        +cos(beta-alpha)**2*( F_stu(0.d0,mch,mh) - F_stu(0.d0,ma,mh) &
        - G_stu(0.d0,mh,mw)+G_stu(0.d0,mbh,mw)+G_stu(0.d0,mh,mz)-G_stu(0.d0,mbh,mz) &
        )&
        )

	end function
 !--------------------------------------------------------
 	double precision function stu(mch,ma,mbh,alpha,beta)
        double precision:: V_inv(2,2),del_chisq,dels,delt
	double precision, intent(in):: mch,ma,mbh,alpha,beta

        dels = Del_S_2HDM(mch,ma,mbh,alpha,beta)
        delt = Del_T_2HDM(mch,ma,mbh,alpha,beta)

        V_inv(1,1) = 1.d0/(sigma_s**2*sigma_t**2)*1.d0/(1.d0-rho_st**2)*sigma_t**2
        V_inv(2,2) = 1.d0/(sigma_s**2*sigma_t**2)*1.d0/(1.d0-rho_st**2)*sigma_s**2
        V_inv(1,2) = -1.d0/(sigma_s**2*sigma_t**2)*1.d0/(1.d0-rho_st**2)*sigma_s*sigma_t*rho_st
        V_inv(2,1) = -1.d0/(sigma_s**2*sigma_t**2)*1.d0/(1.d0-rho_st**2)*sigma_s*sigma_t*rho_st
  
        del_chisq = (dels-s_cent)**2*V_inv(1,1)+(delt-t_cent)**2*V_inv(2,2)+2.d0*(dels-s_cent)*(delt-t_cent)*V_inv(1,2)
        if (del_chisq  .le. 5.99d0) then 
        stu = 0.d0
        else if (del_chisq  .gt. 5.99d0) then 
        stu = 1.d0
        endif
        end function

!#################################################
!
!    SECTION IV 1PI diagrams
!
!#################################################

!====== Gauge boson two point functions ========
	complex (kind(0d0)) function PiWW_S(qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbh,bmsq,alpha,beta

	PiWW_S=&
	 g**2/(16.d0*pi**2)*(&
	1.d0/4.d0*( b5f(qsq,mA,mch)+sin(beta-alpha)**2*b5f(qsq,mbh,mch)+cos(beta-alpha)**2*b5f(qsq,mh,mch) )&
	+sin(beta-alpha)**2*( mw**2*b0f(qsq,mh,mW)+1.d0/4.d0*b5f(qsq,mh,mw) )&
	+cos(beta-alpha)**2*( mw**2*b0f(qsq,mbh,mW)+1.d0/4.d0*b5f(qsq,mbh,mw) )&	
	)

	end function
!---------------------------------------------
	complex (kind(0d0)) function PiGG_S(qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbh,bmsq,alpha,beta

	PiGG_S=&
	 g**2*sw**2/(16.d0*pi**2)*(&
	 b5f(qsq,mch,mch)&
	)
 
	end function
!---------------------------------------------
	complex (kind(0d0)) function PiZG_S(qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbh,bmsq,alpha,beta

	PiZG_S=&
	 g**2*sw/cw/(16.d0*pi**2)*(&
	 1.d0/2.d0*b5f(qsq,mch,mch)&
	)&
	-sw/cw*PiGG_S(qsq,mch,mA,mbh,bmsq,alpha,beta)
 
	end function
!---------------------------------------------
	complex (kind(0d0)) function PiZZ_S(qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbh,bmsq,alpha,beta

	PiZZ_S=&
	 g**2/cw**2/(16.d0*pi**2)*(&
	 1.d0/4.d0*( b5f(qsq,mch,mch) + sin(beta-alpha)**2*b5f(qsq,mbh,mA) + cos(beta-alpha)**2*b5f(qsq,mh,mA) )&
	 +sin(beta-alpha)**2*(mZ**2*b0f(qsq,mh,mZ)+1.d0/4.d0*b5f(qsq,mh,mZ))&
	 +cos(beta-alpha)**2*(mZ**2*b0f(qsq,mbh,mZ)+1.d0/4.d0*b5f(qsq,mbh,mZ))&
	)&
	-2.d0*sw/cw*PiZG_S(qsq,mch,mA,mbh,bmsq,alpha,beta)&
	-sw**2/cw**2*PiGG_S(qsq,mch,mA,mbh,bmsq,alpha,beta)
 
	end function
!==================================================
	complex (kind(0d0)) function dPiWW_S(qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbh,bmsq,alpha,beta

	dPiWW_S=&
	 g**2/(16.d0*pi**2)*(&
	1.d0/4.d0*( db5f(qsq,mA,mch)+sin(beta-alpha)**2*db5f(qsq,mbh,mch)+cos(beta-alpha)**2*db5f(qsq,mh,mch) )&
	+sin(beta-alpha)**2*( mw**2*db0f(qsq,mh,mW)+1.d0/4.d0*db5f(qsq,mh,mw) )&
	+cos(beta-alpha)**2*( mw**2*db0f(qsq,mbh,mW)+1.d0/4.d0*db5f(qsq,mbh,mw) )&	
	)

	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiGG_S(qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbh,bmsq,alpha,beta

	dPiGG_S=&
	 g**2*sw**2/(16.d0*pi**2)*(&
	 db5f(qsq,mch,mch)&
	)
 
	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiZG_S(qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbh,bmsq,alpha,beta

	dPiZG_S=&
	 g**2*sw/cw/(16.d0*pi**2)*(&
	 1.d0/2.d0*db5f(qsq,mch,mch)&
	)&
	-sw/cw*dPiGG_S(qsq,mch,mA,mbh,bmsq,alpha,beta)
 
	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiZZ_S(qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbh,bmsq,alpha,beta

	dPiZZ_S=&
	 g**2/cw**2/(16.d0*pi**2)*(&
	 1.d0/4.d0*( db5f(qsq,mch,mch) + sin(beta-alpha)**2*db5f(qsq,mbh,mA) + cos(beta-alpha)**2*db5f(qsq,mh,mA) )&
	 +sin(beta-alpha)**2*(mZ**2*db0f(qsq,mh,mZ)+1.d0/4.d0*db5f(qsq,mh,mZ))&
	 +cos(beta-alpha)**2*(mZ**2*db0f(qsq,mbh,mZ)+1.d0/4.d0*db5f(qsq,mbh,mZ))&
	)&
	-2.d0*sw/cw*dPiZG_S(qsq,mch,mA,mbh,bmsq,alpha,beta)&
	-sw**2/cw**2*dPiGG_S(qsq,mch,mA,mbh,bmsq,alpha,beta)
 
	end function
!==================================================
	complex (kind(0d0)) function PiWW_B(qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbh,bmsq,alpha,beta
	
	PiWW_B = PiWW_B_WOH(qsq)+PiWW_S(qsq,mch,mA,mbh,bmsq,alpha,beta)

 	end function
!---------------------------------------------
	complex (kind(0d0)) function PiGG_B(qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbh,bmsq,alpha,beta
	
	PiGG_B = PiGG_B_WOH(qsq)+PiGG_S(qsq,mch,mA,mbh,bmsq,alpha,beta)

 	end function
!---------------------------------------------
	complex (kind(0d0)) function PiZG_B(qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbh,bmsq,alpha,beta
	
	PiZG_B = PiZG_B_WOH(qsq)+PiZG_S(qsq,mch,mA,mbh,bmsq,alpha,beta)

 	end function
!---------------------------------------------
	complex (kind(0d0)) function PiZZ_B(qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbh,bmsq,alpha,beta
	
	PiZZ_B = PiZZ_B_WOH(qsq)+PiZZ_S(qsq,mch,mA,mbh,bmsq,alpha,beta)

 	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiWW_B(qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbh,bmsq,alpha,beta
	
	dPiWW_B = dPiWW_B_WOH(qsq)+dPiWW_S(qsq,mch,mA,mbh,bmsq,alpha,beta)

 	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiGG_B(qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbh,bmsq,alpha,beta
	
	dPiGG_B = dPiGG_B_WOH(qsq)+dPiGG_S(qsq,mch,mA,mbh,bmsq,alpha,beta)

 	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiZG_B(qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbh,bmsq,alpha,beta
	
	dPiZG_B = dPiZG_B_WOH(qsq)+dPiZG_S(qsq,mch,mA,mbh,bmsq,alpha,beta)

 	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiZZ_B(qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbh,bmsq,alpha,beta
	
	dPiZZ_B = dPiZZ_B_WOH(qsq)+dPiZZ_S(qsq,mch,mA,mbh,bmsq,alpha,beta)

 	end function
!====== Higgs boson one and two point functions ========
	complex (kind(0d0)) function Th_F(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	Th_F=&
	      -4.d0*mt**2*3.d0/(16.d0*pi**2)*&
	       1.d0/vev*a0f(mt)*&
	       xiu(alpha,beta,n)&        
!
	      -4.d0*mc**2*3.d0/(16.d0*pi**2)*&
	       1.d0/vev*a0f(mc)*&
	       xiu(alpha,beta,n)&   
!
	      -4.d0*mb**2*3.d0/(16.d0*pi**2)*&
	       1.d0/vev*a0f(mb)*&
	       xid(alpha,beta,n)&
!    
	      -4.d0*mtau**2/(16.d0*pi**2)*&
	       1.d0/vev*a0f(mtau)*&
	       xil(alpha,beta,n)
!
	 end function
!---------------------------------------------
	complex (kind(0d0)) function Th_B(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	Th_B=  1.d0/(16.d0*pi**2)*&
	       (&
		-lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)*a0f(mch) - lam_AAh(mch,mA,mbh,bmsq,alpha,beta)*a0f(mA)& 	
		-lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*a0f(mbh) - 3.d0*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*a0f(mh)& 
		-lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*a0f(mw) - lam_GGh(mch,mA,mbh,bmsq,alpha,beta)*a0f(mz)&

	+sin(beta-alpha)*(&
			3.d0*g*mW*a0f(mW)+3.d0/2.d0*gz*mZ*a0f(mZ)&
			-2.d0*g*mW**3-gz*mZ**3&
			  )&
		)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function TbH_F(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	TbH_F=&
	      -4.d0*mt**2*3.d0/(16.d0*pi**2)*&
	       1.d0/vev*a0f(mt)*&
	       xiu_H(alpha,beta,n)&        
!
	      -4.d0*mc**2*3.d0/(16.d0*pi**2)*&
	       1.d0/vev*a0f(mc)*&
	       xiu_H(alpha,beta,n)&   
!
	      -4.d0*mb**2*3.d0/(16.d0*pi**2)*&
	       1.d0/vev*a0f(mb)*&
	       xid_H(alpha,beta,n)&
!    
	      -4.d0*mtau**2/(16.d0*pi**2)*&
	       1.d0/vev*a0f(mtau)*&
	       xil_H(alpha,beta,n)
!
	 end function
!---------------------------------------------
	complex (kind(0d0)) function TbH_B(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	TbH_B=  1.d0/(16.d0*pi**2)*&
	       (&
		-lam_HpHmbH(mch,mA,mbh,bmsq,alpha,beta)*a0f(mch) - lam_AAbH(mch,mA,mbh,bmsq,alpha,beta)*a0f(mA)& 	
		-3.d0*lam_bHbHbH(mch,mA,mbh,bmsq,alpha,beta)*a0f(mbh) - lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*a0f(mh)& 
		-lam_GpGmbH(mch,mA,mbh,bmsq,alpha,beta)*a0f(mw) - lam_GGbH(mch,mA,mbh,bmsq,alpha,beta)*a0f(mz)&
!
	+cos(beta-alpha)*(&
			3.d0*g*mW*a0f(mW)+3.d0/2.d0*gz*mZ*a0f(mZ)&
			-2.d0*g*mW**3-gz*mZ**3&
			  )&
		)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function T1_F(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	T1_F= cos(alpha)*TbH_F(alpha,beta,n)-sin(alpha)*Th_F(alpha,beta,n)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function T2_F(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	T2_F= sin(alpha)*TbH_F(alpha,beta,n)+cos(alpha)*Th_F(alpha,beta,n)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function T1_B(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	T1_B= cos(alpha)*TbH_B(mch,mA,mbh,bmsq,alpha,beta)-sin(alpha)*Th_B(mch,mA,mbh,bmsq,alpha,beta)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function T2_B(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	T2_B= sin(alpha)*TbH_B(mch,mA,mbh,bmsq,alpha,beta)+cos(alpha)*Th_B(mch,mA,mbh,bmsq,alpha,beta)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function Pihh_F(qsq,alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: qsq,alpha,beta

	Pihh_F=&
	 -4.d0*mt**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mt)&
	 +(2.d0*mt**2-qsq/2.d0)*b0f(qsq,mt,mt)&
	 )*&
	xiu(alpha,beta,n)**2&
!
	 -4.d0*mc**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mc)&
	 +(2.d0*mc**2-qsq/2.d0)*b0f(qsq,mc,mc)&
	 )*&
	xiu(alpha,beta,n)**2&	
!
	 -4.d0*mb**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mb)&
	 +(2.d0*mb**2-qsq/2.d0)*b0f(qsq,mb,mb)&
	 )*&
	xid(alpha,beta,n)**2&
!
	 -4.d0*mtau**2/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mtau)&
	 +(2.d0*mtau**2-qsq/2.d0)*b0f(qsq,mtau,mtau)&
	 )*&
	xil(alpha,beta,n)**2
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function Pihh_B(qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq

	Pihh_B=&
	 1.d0/(16.d0*pi**2)*&
	(&
	  g**2*sin(beta-alpha)**2*(3.d0*mw**2-qsq)*b0f(qsq,mW,mW)&
	  +g**2/2.d0*(4.d0-sin(beta-alpha)**2)*a0f(mW)&
	  +gz**2/2.d0*sin(beta-alpha)**2*(3.d0*mz**2-qsq)*b0f(qsq,mZ,mZ)&
	  +gz**2/4.d0*(4.d0-sin(beta-alpha)**2)*a0f(mZ)&
	  -g**2/2.d0*cos(beta-alpha)**2*(2.d0*a0f(mW)-a0f(mch)+(2.d0*mch**2-mW**2+2.d0*qsq)*b0f(qsq,mW,mch))&
	  -gz**2/4.d0*cos(beta-alpha)**2*(2.d0*a0f(mZ)-a0f(mA)+(2.d0*mA**2-mZ**2+2.d0*qsq)*b0f(qsq,mZ,mA))&
	  -(sin(beta-alpha)**2+1.d0/2.d0)*(2.d0*g**2*mW**2+gz**2*mZ**2)&
	)&
!
	+1.d0/(16.d0*pi**2)*&
	(&
	  -2.d0*lam_HpHmhh(mch,mA,mbh,bmsq,alpha,beta)*a0f(mch)-2.d0*lam_AAhh(mch,mA,mbh,bmsq,alpha,beta)*a0f(mA)&
	 -2.d0*lam_bHbHhh(mch,mA,mbh,bmsq,alpha,beta)*a0f(mbH)-12.d0*lam_hhhh(mch,mA,mbh,bmsq,alpha,beta)*a0f(mh)&
	 -2.d0*lam_GpGmhh(mch,mA,mbh,bmsq,alpha,beta)*a0f(mw)-2.d0*lam_GGhh(mch,mA,mbh,bmsq,alpha,beta)*a0f(mz)&
	 +lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)**2*b0f(qsq,mch,mch)+lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)**2*b0f(qsq,mw,mw)&
	 +2.d0*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)**2*b0f(qsq,mch,mw)+2.d0*lam_AAh(mch,mA,mbh,bmsq,alpha,beta)**2*b0f(qsq,mA,mA)&
	 +2.d0*lam_GGh(mch,mA,mbh,bmsq,alpha,beta)**2*b0f(qsq,mz,mz)+lam_AGh(mch,mA,mbh,bmsq,alpha,beta)**2*b0f(qsq,mA,mz)&
	 +2.d0*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)**2*b0f(qsq,mbH,mbH)+18.d0*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)**2*b0f(qsq,mh,mh)&
	 +4.d0*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)**2*b0f(qsq,mbH,mh)&
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function PibHbH_F(qsq,alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: qsq,alpha,beta

	PibHbH_F=&
	 -4.d0*mt**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mt)&
	 +(2.d0*mt**2-qsq/2.d0)*b0f(qsq,mt,mt)&
	 )*&
	xiu_H(alpha,beta,n)**2&	
!
	 -4.d0*mc**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mc)&
	 +(2.d0*mc**2-qsq/2.d0)*b0f(qsq,mc,mc)&
	 )*&
	xiu_H(alpha,beta,n)**2&
!
	 -4.d0*mb**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mb)&
	 +(2.d0*mb**2-qsq/2.d0)*b0f(qsq,mb,mb)&
	 )*&
	xid_H(alpha,beta,n)**2
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function PibHbH_B(qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq

	PibHbH_B=&
	 1.d0/(16.d0*pi**2)*&
	(&
	  g**2*cos(beta-alpha)**2*(3.d0*mw**2-qsq)*b0f(qsq,mW,mW)&
	  +g**2/2.d0*(4.d0-cos(beta-alpha)**2)*a0f(mW)&
	  +gz**2/2.d0*cos(beta-alpha)**2*(3.d0*mz**2-qsq)*b0f(qsq,mZ,mZ)&
	  +gz**2/4.d0*(4.d0-cos(beta-alpha)**2)*a0f(mZ)&
	  -g**2/2.d0*sin(beta-alpha)**2*(2.d0*a0f(mW)-a0f(mch)+(2.d0*mch**2-mW**2+2.d0*qsq)*b0f(qsq,mW,mch))&
	  -gz**2/4.d0*sin(beta-alpha)**2*(2.d0*a0f(mZ)-a0f(mA)+(2.d0*mA**2-mZ**2+2.d0*qsq)*b0f(qsq,mZ,mA))&
	  -(cos(beta-alpha)**2+1.d0/2.d0)*(2.d0*g**2*mW**2+gz**2*mZ**2)&
	)&
!
	+1.d0/(16.d0*pi**2)*&
	(&
	  -2.d0*lam_HpHmbHbH(mch,mA,mbh,bmsq,alpha,beta)*a0f(mch)-2.d0*lam_AAbHbH(mch,mA,mbh,bmsq,alpha,beta)*a0f(mA)&
	 -12.d0*lam_bHbHbHbH(mch,mA,mbh,bmsq,alpha,beta)*a0f(mbH)-2.d0*lam_bHbHhh(mch,mA,mbh,bmsq,alpha,beta)*a0f(mh)&
	 -2.d0*lam_GpGmbHbH(mch,mA,mbh,bmsq,alpha,beta)*a0f(mw)-2.d0*lam_GGbHbH(mch,mA,mbh,bmsq,alpha,beta)*a0f(mz)&
	 +lam_HpHmbH(mch,mA,mbh,bmsq,alpha,beta)**2*b0f(qsq,mch,mch)+lam_GpGmbH(mch,mA,mbh,bmsq,alpha,beta)**2*b0f(qsq,mw,mw)&
 	 +2.d0*lam_HpGmbH(mch,mA,mbh,bmsq,alpha,beta)**2*b0f(qsq,mch,mw)+2.d0*lam_AAbH(mch,mA,mbh,bmsq,alpha,beta)**2*b0f(qsq,mA,mA)&
	 +2.d0*lam_GGbH(mch,mA,mbh,bmsq,alpha,beta)**2*b0f(qsq,mz,mz)+lam_AGbH(mch,mA,mbh,bmsq,alpha,beta)**2*b0f(qsq,mA,mz)&
	 +18.d0*lam_bHbHbH(mch,mA,mbh,bmsq,alpha,beta)**2*b0f(qsq,mbH,mbH)+2.d0*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)**2*b0f(qsq,mh,mh)&
	 +4.d0*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)**2*b0f(qsq,mbH,mh)&
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function PibHh_F(qsq,alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: qsq,alpha,beta

	PibHh_F=&
	 -4.d0*mt**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mt)&
	 +(2.d0*mt**2-qsq/2.d0)*b0f(qsq,mt,mt)&
	 )*&
	xiu(alpha,beta,n)*xiu_H(alpha,beta,n)&	
!
	 -4.d0*mc**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mc)&
	 +(2.d0*mc**2-qsq/2.d0)*b0f(qsq,mc,mc)&
	 )*&
	xiu(alpha,beta,n)*xiu_H(alpha,beta,n)&
!
	 -4.d0*mb**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mb)&
	 +(2.d0*mb**2-qsq/2.d0)*b0f(qsq,mb,mb)&
	 )*&
	xid(alpha,beta,n)*xid_H(alpha,beta,n)&
!
	 -4.d0*mtau**2/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mtau)&
	 +(2.d0*mtau**2-qsq/2.d0)*b0f(qsq,mtau,mtau)&
	 )*&
	xil(alpha,beta,n)*xil_H(alpha,beta,n)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function PibHh_B(qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq

	PibHh_B=&
	 1.d0/(16.d0*pi**2)*sin(beta-alpha)*cos(beta-alpha)*&
	(&
	  g**2*(3.d0*mw**2-qsq)*b0f(qsq,mW,mW)&
	  -g**2/2.d0*a0f(mW)&
	  +gz**2/2.d0*(3.d0*mZ**2-qsq)*b0f(qsq,mZ,mZ)&
	  -gz**2/4.d0*a0f(mZ)&
	  +g**2/2.d0*(2.d0*a0f(mW)-a0f(mch)+(2.d0*mch**2-mW**2+2.d0*qsq)*b0f(qsq,mW,mch))&
	  +gz**2/4.d0*(2.d0*a0f(mZ)-a0f(mA)+(2.d0*mA**2-mZ**2+2.d0*qsq)*b0f(qsq,mZ,mA))&
	  -(2.d0*g**2*mW**2+gz**2*mZ**2)&
	)&
!
	+1.d0/(16.d0*pi**2)*&
	(&
	  -lam_HpHmbHh(mch,mA,mbh,bmsq,alpha,beta)*a0f(mch)-lam_AAbHh(mch,mA,mbh,bmsq,alpha,beta)*a0f(mA)&
	 -3.d0*lam_bHbHbHh(mch,mA,mbh,bmsq,alpha,beta)*a0f(mbH)-3.d0*lam_bHhhh(mch,mA,mbh,bmsq,alpha,beta)*a0f(mh)&
	 -lam_GpGmbHh(mch,mA,mbh,bmsq,alpha,beta)*a0f(mw)-lam_GGbHh(mch,mA,mbh,bmsq,alpha,beta)*a0f(mz)&
	 +lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)*lam_HpHmbH(mch,mA,mbh,bmsq,alpha,beta)*b0f(qsq,mch,mch)&
	 +lam_GpGmbH(mch,mA,mbh,bmsq,alpha,beta)*lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*b0f(qsq,mw,mw)&
	 +2.d0*lam_HpGmbH(mch,mA,mbh,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)*b0f(qsq,mch,mw)&
	 +2.d0*lam_AAh(mch,mA,mbh,bmsq,alpha,beta)*lam_AAbH(mch,mA,mbh,bmsq,alpha,beta)*b0f(qsq,mA,mA)&
	 +2.d0*lam_GGh(mch,mA,mbh,bmsq,alpha,beta)*lam_GGbH(mch,mA,mbh,bmsq,alpha,beta)*b0f(qsq,mz,mz)&
	 +lam_AGh(mch,mA,mbh,bmsq,alpha,beta)*lam_AGbH(mch,mA,mbh,bmsq,alpha,beta)*b0f(qsq,mA,mz)&
	 +6.d0*lam_bHbHbH(mch,mA,mbh,bmsq,alpha,beta)*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*b0f(qsq,mbH,mbH)&
	 +6.d0*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*b0f(qsq,mh,mh)&
	 +4.d0*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*b0f(qsq,mbH,mh)&
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function PiAG_F(qsq,alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: qsq,alpha,beta

	PiAG_F=&
	 -8.d0*mt**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mt)&
	 -qsq/2.d0*b0f(qsq,mt,mt)&
	 )*&
	xiu_A(alpha,beta,n)*It&
!
	 -8.d0*mc**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mc)&
	 -qsq/2.d0*b0f(qsq,mc,mc)&
	 )*&
	xiu_A(alpha,beta,n)*It&	
!
	 -8.d0*mb**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mb)&
	 -qsq/2.d0*b0f(qsq,mb,mb)&
	 )*&
	(-xid_A(alpha,beta,n))*Ib&
!
	 -8.d0*mtau**2/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mtau)&
	 -qsq/2.d0*b0f(qsq,mtau,mtau)&
	 )*&
	(-xil_A(alpha,beta,n))*Ie
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function tildePiAG_F(qsq,alpha,beta,n)
	double precision, intent(in):: qsq,alpha,beta
	integer, intent(in):: n

	tildePiAG_F=PiAG_F(qsq,alpha,beta,n) &
        +sin(beta-alpha)*TbH_F(alpha,beta,n)/vev & 
        -cos(beta-alpha)*Th_F(alpha,beta,n)/vev
	 	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function PiAG_B(qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq

	PiAG_B=&
	  1.d0/(16.d0*pi**2)*sin(beta-alpha)*cos(beta-alpha)*&
	 (&
	   -gz**2/4.d0*(2.d0*a0f(mZ)-a0f(mh)+(2.d0*mh**2-mZ**2+2.d0*qsq)*b0f(qsq,mZ,mh))&
	   +gz**2/4.d0*(2.d0*a0f(mZ)-a0f(mbH)+(2.d0*mbH**2-mZ**2+2.d0*qsq)*b0f(qsq,mZ,mbH))&
	 )&
!
	+1.d0/(16.d0*pi**2)*&
	(&
	 -lam_GpGmAG(mch,mA,mbh,bmsq,alpha,beta)*a0f(mw)-3.d0*lam_AGGG(mch,mA,mbh,bmsq,alpha,beta)*a0f(mz)&
	   -lam_HpHmAG(mch,mA,mbh,bmsq,alpha,beta)*a0f(mch)&
	  -3.d0*lam_AAAG(mch,mA,mbh,bmsq,alpha,beta)*a0f(mA)&
	  -lam_AGbHbH(mch,mA,mbh,bmsq,alpha,beta)*a0f(mbH)&
          -lam_AGhh(mch,mA,mbh,bmsq,alpha,beta)*a0f(mh)&
	  +2.d0*lam_AAh(mch,mA,mbh,bmsq,alpha,beta)*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)*b0f(qsq,mA,mh)&
	  +2.d0*lam_AAbH(mch,mA,mbh,bmsq,alpha,beta)*lam_AGbH(mch,mA,mbh,bmsq,alpha,beta)*b0f(qsq,mA,mbH)&
	  +2.d0*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)*lam_GGh(mch,mA,mbh,bmsq,alpha,beta)*b0f(qsq,mz,mh)&
	  +2.d0*lam_AGbH(mch,mA,mbh,bmsq,alpha,beta)*lam_GGbH(mch,mA,mbh,bmsq,alpha,beta)*b0f(qsq,mz,mbH)&
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function tildePiAG_B(qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq

	tildePiAG_B=PiAG_B(qsq,mch,mA,mbh,bmsq,alpha,beta) &
        +sin(beta-alpha)*TbH_B(mch,mA,mbh,bmsq,alpha,beta)/vev & 
        -cos(beta-alpha)*Th_B(mch,mA,mbh,bmsq,alpha,beta)/vev
	 	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function Del_PiAG_B(qsq,mch,mA,mbh,bmsq,alpha,beta) ! The expression for (Landau Gauge - Feynman Gauge)
        ! Del_PiAG_B + PiAG_B gives the AG mixing in the Ladau-Gauge, and if we take qsq = 0, it becomes 0. 
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq

              Del_PiAG_B = gz**2/(64.d0*pi**2)*sin(beta-alpha)*cos(beta-alpha)/mz**2*&
                           (&
                             + (qsq*(qsq-2.d0*mh**2 )  + mh**2* mA**2)*(B0f(qsq,mz,mh)  - B0f(qsq,0.d0,mh )) &
                             - (qsq*(qsq-2.d0*mbH**2)  + mbH**2*mA**2)*(B0f(qsq,mz,mbh) - B0f(qsq,0.d0,mbh)) &
                           ) 

 	 end function
!---------------------------------------------
	complex (kind(0d0)) function GamAZ_B(qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq

	GamAZ_B= 1.d0/(16.d0*pi**2)*(& 
        +2.d0/vev*lam_AAbh(mch,mA,mbh,bmsq,alpha,beta)*sin(beta-alpha)*(2.d0*b1f(qsq,mA,mbh)+b0f(qsq,mA,mbh)) &
        -2.d0/vev*lam_AAh(mch,mA,mbh,bmsq,alpha,beta)*cos(beta-alpha)*(2.d0*b1f(qsq,mA,mh)+b0f(qsq,mA,mh)) &
        -1.d0/vev*lam_AGbh(mch,mA,mbh,bmsq,alpha,beta)*cos(beta-alpha)*(2.d0*b1f(qsq,mz,mbh)+b0f(qsq,mz,mbh)) &
        -1.d0/vev*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)*sin(beta-alpha)*(2.d0*b1f(qsq,mz,mh)+b0f(qsq,mz,mh)) &
       +gz**2/2.d0*sin(beta-alpha)*cos(beta-alpha)*&
         ( b1f(qsq,mz,mbh)+2.d0*b0f(qsq,mz,mbh)-( b1f(qsq,mz,mh)+2.d0*b0f(qsq,mz,mh) ) )&
        )
	 	
	 end function
!===========================================
	complex (kind(0d0)) function dPihh_F(qsq,alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: qsq,alpha,beta

	dPihh_F=&
	 -4.d0*mt**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	 +(2.d0*mt**2-qsq/2.d0)*db0f(qsq,mt,mt)&
	 +(-1.d0/2.d0)*b0f(qsq,mt,mt)&
	 )*&
	xiu(alpha,beta,n)**2&
!
	 -4.d0*mc**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	 +(2.d0*mc**2-qsq/2.d0)*db0f(qsq,mc,mc)&
	 +(-1.d0/2.d0)*b0f(qsq,mc,mc)&
	 )*&
	xiu(alpha,beta,n)**2&	
!
	 -4.d0*mb**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	 +(2.d0*mb**2-qsq/2.d0)*db0f(qsq,mb,mb)&
	 +(-1.d0/2.d0)*b0f(qsq,mb,mb)&
	 )*&
	xid(alpha,beta,n)**2&
!
	 -4.d0*mtau**2*1.d0/(16.d0*pi**2*vev**2)*&
	(&
	 +(2.d0*mtau**2-qsq/2.d0)*db0f(qsq,mtau,mtau)&
	 +(-1.d0/2.d0)*b0f(qsq,mtau,mtau)&
	 )*&
	xil(alpha,beta,n)**2
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function dPihh_B(qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq

	dPihh_B=&
	 1.d0/(16.d0*pi**2)*&
	(&
	  g**2*sin(beta-alpha)**2*(3.d0*mw**2-qsq)*db0f(qsq,mW,mW)&
	  +g**2*sin(beta-alpha)**2*(-1.d0)*b0f(qsq,mW,mW)&
	  +gz**2/2.d0*sin(beta-alpha)**2*(3.d0*mz**2-qsq)*db0f(qsq,mZ,mZ)&
	  +gz**2/2.d0*sin(beta-alpha)**2*(-1.d0)*b0f(qsq,mZ,mZ)&
	  -g**2/2.d0*cos(beta-alpha)**2*(2.d0*mch**2-mW**2+2.d0*qsq)*db0f(qsq,mW,mch)&
	  -g**2/2.d0*cos(beta-alpha)**2*2.d0*b0f(qsq,mW,mch)&
	  -gz**2/4.d0*cos(beta-alpha)**2*(2.d0*mA**2-mZ**2+2.d0*qsq)*db0f(qsq,mZ,mA)&
	  -gz**2/4.d0*cos(beta-alpha)**2*2.d0*b0f(qsq,mZ,mA)&
	)&
!
	+1.d0/(16.d0*pi**2)*&
	(&
	 +lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)**2*db0f(qsq,mch,mch)&
	 +lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)**2*db0f(qsq,mw,mw)&
	 +2.d0*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)**2*db0f(qsq,mch,mw)&
	 +2.d0*lam_AAh(mch,mA,mbh,bmsq,alpha,beta)**2*db0f(qsq,mA,mA)&
	 +2.d0*lam_GGh(mch,mA,mbh,bmsq,alpha,beta)**2*db0f(qsq,mz,mz)&
	 +lam_AGh(mch,mA,mbh,bmsq,alpha,beta)**2*db0f(qsq,mA,mz)&
	 +2.d0*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)**2*db0f(qsq,mbH,mbH)&
 	 +18.d0*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)**2*db0f(qsq,mh,mh)&
	 +4.d0*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)**2*db0f(qsq,mbH,mh)&
	)
	
	 end function
!====== Fermion two-point functions ========
	complex (kind(0d0)) function Pitt_S(qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Pitt_S= -1.d0/(16.d0*pi**2)*(&
	2.d0*(g*sw)**2*Qt**2*(2.d0*b0f(qsq,mt,mphoton)-1.d0)&
	+2.d0*gz**2*(vt**2-at**2)*(2.d0*b0f(qsq,mt,mZ)-1.d0)&
	+mt**2/vev**2*(b0f(qsq,mt,mz)+xiu_A(alpha,beta,n)**2*b0f(qsq,mt,mA)&
	-xiu(alpha,beta,n)**2*b0f(qsq,mt,mh)-xiu_H(alpha,beta,n)**2*b0f(qsq,mt,mbH)&
	+2.d0*mb**2/mt**2*b0f(qsq,mb,mw)-2.d0*mb**2/mt**2*xiu_A(alpha,beta,n)*(-xid_A(alpha,beta,n))*b0f(qsq,mb,mch)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function Picc_S(qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Picc_S= -1.d0/(16.d0*pi**2)*(&
	2.d0*(g*sw)**2*Qt**2*(2.d0*b0f(qsq,mc,mphoton)-1.d0)&
	+2.d0*gz**2*(vt**2-at**2)*(2.d0*b0f(qsq,mc,mZ)-1.d0)&
	+mc**2/vev**2*(b0f(qsq,mc,mz)+xiu_A(alpha,beta,n)**2*b0f(qsq,mc,mA)&
	-xiu(alpha,beta,n)**2*b0f(qsq,mc,mh)-xiu_H(alpha,beta,n)**2*b0f(qsq,mc,mbH)&
	+2.d0*ms**2/mc**2*b0f(qsq,ms,mw)-2.d0*ms**2/mc**2*xiu_A(alpha,beta,n)*(-xid_A(alpha,beta,n))*b0f(qsq,ms,mch)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function Pibb_S(qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Pibb_S= -1.d0/(16.d0*pi**2)*(&
	2.d0*(g*sw)**2*Qb**2*(2.d0*b0f(qsq,mb,mphoton)-1.d0)&
	+2.d0*gz**2*(vb**2-ab**2)*(2.d0*b0f(qsq,mb,mZ)-1.d0)&
	+mb**2/vev**2*(b0f(qsq,mb,mz)+(-xid_A(alpha,beta,n))**2*b0f(qsq,mb,mA)&
	-xid(alpha,beta,n)**2*b0f(qsq,mb,mh)-xid_H(alpha,beta,n)**2*b0f(qsq,mb,mbH)&
	+2.d0*mt**2/mb**2*b0f(qsq,mt,mw)-2.d0*mt**2/mb**2*(-xid_A(alpha,beta,n))*xiu_A(alpha,beta,n)*b0f(qsq,mt,mch)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function Pitautau_S(qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Pitautau_S= -1.d0/(16.d0*pi**2)*(&
	2.d0*(g*sw)**2*Qe**2*(2.d0*b0f(qsq,mtau,mphoton)-1.d0)&
	+2.d0*gz**2*(ve**2-ae**2)*(2.d0*b0f(qsq,mtau,mZ)-1.d0)&
	+mtau**2/vev**2*(b0f(qsq,mtau,mz)+(-xil_A(alpha,beta,n))**2*b0f(qsq,mtau,mA)&
	-xil(alpha,beta,n)**2*b0f(qsq,mtau,mh)-xil_H(alpha,beta,n)**2*b0f(qsq,mtau,mbH)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function Pitt_V(qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Pitt_V= -1.d0/(16.d0*pi**2)*(&
	(g*sw)**2*Qt**2*(2.d0*b1f(qsq,mt,mphoton)+1.d0)&
	+gz**2*(vt**2+at**2)*(2.d0*b1f(qsq,mt,mZ)+1.d0)&
	+g**2/4.d0*(2.d0*b1f(qsq,mb,mW)+1.d0)&
	+mt**2/vev**2*(xiu(alpha,beta,n)**2*b1f(qsq,mt,mh)+xiu_H(alpha,beta,n)**2*b1f(qsq,mt,mbH)&
	+b1f(qsq,mt,mz)+xiu_A(alpha,beta,n)**2*b1f(qsq,mt,mA)&
	+(mb**2+mt**2)/mt**2*b1f(qsq,mb,mw)+(mt**2*xiu_A(alpha,beta,n)**2+mb**2*(-xid_A(alpha,beta,n))**2)/mt**2*b1f(qsq,mb,mch)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function Picc_V(qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Picc_V= -1.d0/(16.d0*pi**2)*(&
	(g*sw)**2*Qt**2*(2.d0*b1f(qsq,mc,mphoton)+1.d0)&
	+gz**2*(vt**2+at**2)*(2.d0*b1f(qsq,mc,mZ)+1.d0)&
	+g**2/4.d0*(2.d0*b1f(qsq,ms,mW)+1.d0)&
	+mc**2/vev**2*(xiu(alpha,beta,n)**2*b1f(qsq,mc,mh)+xiu_H(alpha,beta,n)**2*b1f(qsq,mc,mbH)&
	+b1f(qsq,mc,mz)+xiu_A(alpha,beta,n)**2*b1f(qsq,mc,mA)&
	+(ms**2+mc**2)/mc**2*b1f(qsq,ms,mw)+(mc**2*xiu_A(alpha,beta,n)**2+ms**2*(-xid_A(alpha,beta,n))**2)/mc**2*b1f(qsq,ms,mch)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function Pibb_V(qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Pibb_V= -1.d0/(16.d0*pi**2)*(&
	(g*sw)**2*Qb**2*(2.d0*b1f(qsq,mb,mphoton)+1.d0)&
	+gz**2*(vb**2+ab**2)*(2.d0*b1f(qsq,mb,mZ)+1.d0)&
	+g**2/4.d0*(2.d0*b1f(qsq,mt,mW)+1.d0)&
	+mb**2/vev**2*(xid(alpha,beta,n)**2*b1f(qsq,mb,mh)+xid_H(alpha,beta,n)**2*b1f(qsq,mb,mbH)&
	+b1f(qsq,mb,mz)+(-xid_A(alpha,beta,n))**2*b1f(qsq,mb,mA)&
	+(mb**2+mt**2)/mb**2*b1f(qsq,mt,mw)+(mt**2*xiu_A(alpha,beta,n)**2+mb**2*(-xid_A(alpha,beta,n))**2)/mb**2*b1f(qsq,mt,mch)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function Pitautau_V(qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Pitautau_V= -1.d0/(16.d0*pi**2)*(&
	(g*sw)**2*Qe**2*(2.d0*b1f(qsq,mtau,mphoton)+1.d0)&
	+gz**2*(ve**2+ae**2)*(2.d0*b1f(qsq,mtau,mZ)+1.d0)&
	+g**2/4.d0*(2.d0*b1f(qsq,m0,mW)+1.d0)&
	+mtau**2/vev**2*(xil(alpha,beta,n)**2*b1f(qsq,mtau,mh)+xil_H(alpha,beta,n)**2*b1f(qsq,mtau,mbH)&
	+b1f(qsq,mtau,mz)+(-xil_A(alpha,beta,n))**2*b1f(qsq,mtau,mA)&
	+b1f(qsq,m0,mw)+mtau**2*(-xil_A(alpha,beta,n))**2/mtau**2*b1f(qsq,m0,mch)&	        
	)&
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function Pitt_A(qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Pitt_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*vt*at*(2.d0*b1f(qsq,mt,mZ)+1.d0)&
	-g**2/4.d0*(2.d0*b1f(qsq,mb,mW)+1.d0)&
	+(mt**2-mb**2)/vev**2*b1f(qsq,mb,mw)+(mt**2*xiu_A(alpha,beta,n)**2-mb**2*(-xid_A(alpha,beta,n))**2)/vev**2*b1f(qsq,mb,mch)&	
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function Picc_A(qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Picc_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*vt*at*(2.d0*b1f(qsq,mc,mZ)+1.d0)&
	-g**2/4.d0*(2.d0*b1f(qsq,ms,mW)+1.d0)&
	+(mc**2-ms**2)/vev**2*b1f(qsq,ms,mw)+(mc**2*xiu_A(alpha,beta,n)**2-ms**2*(-xid_A(alpha,beta,n))**2)/vev**2*b1f(qsq,ms,mch)&	
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function Pibb_A(qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Pibb_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*vb*ab*(2.d0*b1f(qsq,mb,mZ)+1.d0)&
	-g**2/4.d0*(2.d0*b1f(qsq,mt,mW)+1.d0)&
	+(mb**2-mt**2)/vev**2*b1f(qsq,mt,mw)+(mb**2*(-xid_A(alpha,beta,n))**2-mt**2*xiu_A(alpha,beta,n)**2)/vev**2*b1f(qsq,mt,mch)&	
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function Pitautau_A(qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Pitautau_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*ve*ae*(2.d0*b1f(qsq,mtau,mZ)+1.d0)&
	-g**2/4.d0*(2.d0*b1f(qsq,m0,mW)+1.d0)&
	+mtau**2/vev**2*b1f(qsq,m0,mw)+(mtau**2*(-xil_A(alpha,beta,n))**2)/vev**2*b1f(qsq,m0,mch)&	
	)
	
	 end function
!===================================================
	complex (kind(0d0)) function dPitt_S(qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPitt_S= -1.d0/(16.d0*pi**2)*(&
	2.d0*(g*sw)**2*Qt**2*(2.d0*db0f(qsq,mt,mphoton))&
	+2.d0*gz**2*(vt**2-at**2)*(2.d0*db0f(qsq,mt,mZ))&
	+mt**2/vev**2*(db0f(qsq,mt,mz)+xiu_A(alpha,beta,n)**2*db0f(qsq,mt,mA)&
	-xiu(alpha,beta,n)**2*db0f(qsq,mt,mh)-xiu_H(alpha,beta,n)**2*db0f(qsq,mt,mbH)&
	+2.d0*mb**2/mt**2*db0f(qsq,mb,mw)-2.d0*mb**2/mt**2*xiu_A(alpha,beta,n)*(-xid_A(alpha,beta,n))*db0f(qsq,mb,mch)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function dPicc_S(qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPicc_S= -1.d0/(16.d0*pi**2)*(&
	2.d0*(g*sw)**2*Qt**2*(2.d0*db0f(qsq,mc,mphoton))&
	+2.d0*gz**2*(vt**2-at**2)*(2.d0*db0f(qsq,mc,mZ))&
	+mc**2/vev**2*(db0f(qsq,mc,mz)+xiu_A(alpha,beta,n)**2*db0f(qsq,mc,mA)&
	-xiu(alpha,beta,n)**2*db0f(qsq,mc,mh)-xiu_H(alpha,beta,n)**2*db0f(qsq,mc,mbH)&
	+2.d0*ms**2/mc**2*db0f(qsq,ms,mw)-2.d0*ms**2/mc**2*xiu_A(alpha,beta,n)*(-xid_A(alpha,beta,n))*db0f(qsq,ms,mch)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function dPibb_S(qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPibb_S= -1.d0/(16.d0*pi**2)*(&
	2.d0*(g*sw)**2*Qb**2*(2.d0*db0f(qsq,mb,mphoton))&
	+2.d0*gz**2*(vb**2-ab**2)*(2.d0*db0f(qsq,mb,mZ))&
	+mb**2/vev**2*(db0f(qsq,mb,mz)+(-xid_A(alpha,beta,n))**2*db0f(qsq,mb,mA)&
	-xid(alpha,beta,n)**2*db0f(qsq,mb,mh)-xid_H(alpha,beta,n)**2*db0f(qsq,mb,mbH)&
	+2.d0*mt**2/mb**2*db0f(qsq,mt,mw)-2.d0*mt**2/mb**2*(-xid_A(alpha,beta,n))*xiu_A(alpha,beta,n)*db0f(qsq,mt,mch)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function dPitautau_S(qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPitautau_S= -1.d0/(16.d0*pi**2)*(&
	2.d0*(g*sw)**2*Qe**2*(2.d0*db0f(qsq,mtau,mphoton))&
	+2.d0*gz**2*(ve**2-ae**2)*(2.d0*db0f(qsq,mtau,mZ))&
	+mtau**2/vev**2*(db0f(qsq,mtau,mz)+(-xil_A(alpha,beta,n))**2*db0f(qsq,mtau,mA)&
	-xil(alpha,beta,n)**2*db0f(qsq,mtau,mh)-xil_H(alpha,beta,n)**2*db0f(qsq,mtau,mbH)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function dPitt_V(qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPitt_V= -1.d0/(16.d0*pi**2)*(&
	(g*sw)**2*Qt**2*(2.d0*db1f(qsq,mt,mphoton))&
	+gz**2*(vt**2+at**2)*(2.d0*db1f(qsq,mt,mZ))&
	+g**2/4.d0*(2.d0*db1f(qsq,mb,mW))&
	+mt**2/vev**2*(xiu(alpha,beta,n)**2*db1f(qsq,mt,mh)+xiu_H(alpha,beta,n)**2*db1f(qsq,mt,mbH)&
	+db1f(qsq,mt,mz)+xiu_A(alpha,beta,n)**2*db1f(qsq,mt,mA)&
	+(mb**2+mt**2)/mt**2*db1f(qsq,mb,mw)+(mt**2*xiu_A(alpha,beta,n)**2+mb**2*(-xid_A(alpha,beta,n))**2)/mt**2*db1f(qsq,mb,mch)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function dPicc_V(qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPicc_V= -1.d0/(16.d0*pi**2)*(&
	(g*sw)**2*Qt**2*(2.d0*db1f(qsq,mc,mphoton))&
	+gz**2*(vt**2+at**2)*(2.d0*db1f(qsq,mc,mZ))&
	+g**2/4.d0*(2.d0*db1f(qsq,ms,mW))&
	+mc**2/vev**2*(xiu(alpha,beta,n)**2*db1f(qsq,mc,mh)+xiu_H(alpha,beta,n)**2*db1f(qsq,mc,mbH)&
	+db1f(qsq,mc,mz)+xiu_A(alpha,beta,n)**2*db1f(qsq,mc,mA)&
	+(ms**2+mc**2)/mc**2*db1f(qsq,ms,mw)+(mc**2*xiu_A(alpha,beta,n)**2+ms**2*(-xid_A(alpha,beta,n))**2)/mc**2*db1f(qsq,ms,mch)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function dPibb_V(qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPibb_V= -1.d0/(16.d0*pi**2)*(&
	(g*sw)**2*Qb**2*(2.d0*db1f(qsq,mb,mphoton))&
	+gz**2*(vb**2+ab**2)*(2.d0*db1f(qsq,mb,mZ))&
	+g**2/4.d0*(2.d0*db1f(qsq,mt,mW))&
	+mb**2/vev**2*(xid(alpha,beta,n)**2*db1f(qsq,mb,mh)+xid_H(alpha,beta,n)**2*db1f(qsq,mb,mbH)&
	+db1f(qsq,mb,mz)+(-xid_A(alpha,beta,n))**2*db1f(qsq,mb,mA)&
	+(mb**2+mt**2)/mb**2*db1f(qsq,mt,mw)+(mt**2*xiu_A(alpha,beta,n)**2+mb**2*(-xid_A(alpha,beta,n))**2)/mb**2*db1f(qsq,mt,mch)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function dPitautau_V(qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPitautau_V= -1.d0/(16.d0*pi**2)*(&
	(g*sw)**2*Qe**2*(2.d0*db1f(qsq,mtau,mphoton))&
	+gz**2*(ve**2+ae**2)*(2.d0*db1f(qsq,mtau,mZ))&
	+g**2/4.d0*(2.d0*db1f(qsq,m0,mW))&
	+mtau**2/vev**2*(xil(alpha,beta,n)**2*db1f(qsq,mtau,mh)+xil_H(alpha,beta,n)**2*db1f(qsq,mtau,mbH)&
	+db1f(qsq,mtau,mz)+(-xil_A(alpha,beta,n))**2*db1f(qsq,mtau,mA)&
	+db1f(qsq,m0,mw)+(-xil_A(alpha,beta,n))**2*db1f(qsq,m0,mch)&	
	            )&
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function dPitt_A(qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPitt_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*vt*at*(2.d0*db1f(qsq,mt,mZ))&
	-g**2/4.d0*(2.d0*db1f(qsq,mb,mW))&
	+(mt**2-mb**2)/vev**2*db1f(qsq,mb,mw)+(mt**2*xiu_A(alpha,beta,n)**2-mb**2*(-xid_A(alpha,beta,n))**2)/vev**2*db1f(qsq,mb,mch)&	
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function dPicc_A(qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPicc_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*vt*at*(2.d0*db1f(qsq,mc,mZ))&
	-g**2/4.d0*(2.d0*db1f(qsq,ms,mW))&
	+(mc**2-ms**2)/vev**2*db1f(qsq,ms,mw)+(mc**2*xiu_A(alpha,beta,n)**2-ms**2*(-xid_A(alpha,beta,n))**2)/vev**2*db1f(qsq,ms,mch)&	
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function dPibb_A(qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPibb_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*vb*ab*(2.d0*db1f(qsq,mb,mZ))&
	-g**2/4.d0*(2.d0*db1f(qsq,mt,mW))&
	+(mb**2-mt**2)/vev**2*db1f(qsq,mt,mw)+(mb**2*(-xid_A(alpha,beta,n))**2-mt**2*xiu_A(alpha,beta,n)**2)/vev**2*db1f(qsq,mt,mch)&	
	)
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function dPitautau_A(qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPitautau_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*ve*ae*(2.d0*db1f(qsq,mtau,mZ))&
	-g**2/4.d0*(2.d0*db1f(qsq,m0,mW))&
	+mtau**2/vev**2*db1f(qsq,m0,mw)+mtau**2*(-xil_A(alpha,beta,n))**2/vev**2*db1f(qsq,m0,mch)&	
	)
	
	 end function
!--------------- Pinch-Term ------------------------------
	complex (kind(0d0)) function PiAG_PT(qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,qsq

	PiAG_PT = gz**2/(64.d0*pi**2)*(2.d0*qsq-ma**2)*sin(beta-alpha)*cos(beta-alpha)*(&
                  B0f(qsq,mz,mbH) - B0f(qsq,mz,mh) ) 
	
	 end function
!====== hff 1PI  ========================================
	complex (kind(0d0)) function Fhff_S(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,p1sq,p2sq,qsq,mf
	double precision:: vf,af,qf,mfp,xiA,xiAp,xih,xihp,xibH,xibHp
	integer, intent(in):: n

        if (mf .eq. mt) then 
        vf = vt;af = at;qf = qt;mfp = mb;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
        xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
        elseif (mf .eq. mc) then 
        vf = vt;af = at;qf = qt;mfp = ms;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
        xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
        elseif (mf .eq. mb) then 
        vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
        xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)
        elseif (mf .eq. mtau) then 
        vf = ve;af = ae;qf = qe;mfp = 0.d0
        xih=xil(alpha,beta,n);xiA=xil_A(alpha,beta,n);xibH=xil_H(alpha,beta,n)
        xihp=0.d0;xiAp=0.d0;xibHp=0.d0
        endif

	Fhff_S = 1.d0/(16.d0*pi**2)*mf/vev*(&
	-4.d0*xih*gz**2*(vf**2-af**2)*Chff_FVF(p1sq,p2sq,qsq,mf,mZ)&
	-4.d0*xih*(g*sw)**2*Qf**2*Chff_FVF(p1sq,p2sq,qsq,mf,mphoton)&
	+xih**3*mf**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mf,mh)&
	+xih*xibH**2*mf**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mf,mbH)&
	-xih*mf**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mf,mz)&
	-xih*xiA**2*mf**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mf,mA)&
	-xihp*2.d0*mfp**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mfp,mw)&
	-xihp*xiA*xiAp*2.d0*mfp**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mfp,mch)&
!!
	-2.d0*sin(beta-alpha)*gz**4*vev**2*(vf**2-af**2)*c0f(p1sq,p2sq,qsq,mZ,mf,mZ)&
	-6.d0*xih**2*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev*c0f(p1sq,p2sq,qsq,mh,mf,mh)&
	-2.d0*xibH**2*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev*c0f(p1sq,p2sq,qsq,mbH,mf,mbH)&
	-2.d0*xih*xibH*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev*&
		(c0f(p1sq,p2sq,qsq,mbH,mf,mh) + c0f(p1sq,p2sq,qsq,mh,mf,mbH))&
	+2.d0*lam_GGh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev*c0f(p1sq,p2sq,qsq,mz,mf,mz)&
	+2.d0*xiA**2*lam_AAh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev*c0f(p1sq,p2sq,qsq,mA,mf,mA)&
	+xiA*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev*&
		(c0f(p1sq,p2sq,qsq,mA,mf,mz)+c0f(p1sq,p2sq,qsq,mz,mf,mA))&
	+lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*2.d0*mfp**2/vev*c0f(p1sq,p2sq,qsq,mw,mfp,mw)&
!!
	+xiA*xiAp*lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)*2.d0*mfp**2/vev*c0f(p1sq,p2sq,qsq,mch,mfp,mch)&
	+lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)*mfp**2/vev*(xiA+xiAp)*&
		(c0f(p1sq,p2sq,qsq,mw,mfp,mch)+c0f(p1sq,p2sq,qsq,mch,mfp,mw))&
!
	-g**2/4.d0*sin(beta-alpha)*Chff_VFS(p1sq,p2sq,qsq,mW,mfp,mw)&
	-g**2/4.d0*xiA*cos(beta-alpha)*Chff_VFS(p1sq,p2sq,qsq,mW,mfp,mch)&
	-g**2/4.d0*sin(beta-alpha)*Chff_SFV(p1sq,p2sq,qsq,mw,mfp,mW)&
	-g**2/4.d0*xiA*cos(beta-alpha)*Chff_SFV(p1sq,p2sq,qsq,mch,mfp,mW)&
	-gz**2/8.d0*sin(beta-alpha)*Chff_VFS(p1sq,p2sq,qsq,mZ,mf,mz)&
	-gz**2/8.d0*xiA*cos(beta-alpha)*Chff_VFS(p1sq,p2sq,qsq,mZ,mf,mA)&
	-gz**2/8.d0*sin(beta-alpha)*Chff_SFV(p1sq,p2sq,qsq,mz,mf,mZ)&
	-gz**2/8.d0*xiA*cos(beta-alpha)*Chff_SFV(p1sq,p2sq,qsq,mA,mf,mZ)&
	)
	
	 end function
!===============================================================================================
	complex (kind(0d0)) function Fhff_P(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,mf
	double precision:: vf,af,qf,mfp,xiA,xiAp,xih,xihp,xibH,xibHp
	integer, intent(in):: n

        if (mf .eq. mt) then 
        vf = vt;af = at;qf = qt;mfp = mb;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
        xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
        elseif (mf .eq. mc) then 
        vf = vt;af = at;qf = qt;mfp = mb;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
        xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
        elseif (mf .eq. mb) then 
        vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
        xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)
        elseif (mf .eq. mtau) then 
        vf = ve;af = ae;qf = qe;mfp = 0.d0;xiA=xil_A(alpha,beta,n)
        xih=xil(alpha,beta,n);xibH=xil_H(alpha,beta,n)
        endif

    Fhff_P = 1.d0/(16.d0*pi**2)*mf/vev*sin(beta-alpha)*(& 
           -g**2/4.d0*(Chff_VFS(p1sq,p2sq,qsq,mW,mfp,mw)&
                      -Chff_SFV(p1sq,p2sq,qsq,mw,mfp,mW))&
           -2.d0*gz**2*vf*af*(Chff_VFS(p1sq,p2sq,qsq,mZ,mf,mz)&
                      -Chff_SFV(p1sq,p2sq,qsq,mz,mf,mZ))&              
                                       )&
         +1.d0/(16.d0*pi**2)*mf/vev*cos(beta-alpha)*xiA*(& 
           -g**2/4.d0*(Chff_VFS(p1sq,p2sq,qsq,mW,mfp,mch)&
                      -Chff_SFV(p1sq,p2sq,qsq,mch,mfp,mW))&
           -2.d0*gz**2*vf*af*(Chff_VFS(p1sq,p2sq,qsq,mZ,mf,mA)&
                      -Chff_SFV(p1sq,p2sq,qsq,mA,mf,mZ))&              
                                       )

	 end function
!------------------------------------------------------------
 	complex (kind(0d0)) function Fhff_V1(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)
 	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,mf
	double precision:: vf,af,qf,mfp,xiA,xiAp,xih,xihp,xibH,xibHp
	integer, intent(in):: n

        if (mf .eq. mt) then 
        vf = vt;af = at;qf = qt;mfp = mb;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
        xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
        elseif (mf .eq. mc) then 
        vf = vt;af = at;qf = qt;mfp = ms;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
        xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
        elseif (mf .eq. mb) then 
        vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
        xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)
        elseif (mf .eq. mtau) then 
        vf = ve;af = ae;qf = qe;mfp = 0.d0;xiA=xil_A(alpha,beta,n)
        xih=xil(alpha,beta,n);xibH=xil_H(alpha,beta,n)
        endif

    Fhff_V1 = 1.d0/(16.d0*pi**2)*(& 
             xih*2.d0*gz**2*(vf**2 + af**2)*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mZ,mf)&
                                              +2.d0*c11f(p1sq,p2sq,qsq,mf,mZ,mf))&
            +xih*2.d0*(g*sw)**2*Qf**2*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mphoton,mf)&
                                      +2.d0*c11f(p1sq,p2sq,qsq,mf,mphoton,mf))&
            +xihp*g**2/2.d0*mfp**2/vev*(c0f(p1sq,p2sq,qsq,mfp,mW,mfp)&
                            +2.d0*c11f(p1sq,p2sq,qsq,mfp,mW,mfp))&
!
             +xih**3*mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mh,mf)&
                             +2.d0*c11f(p1sq,p2sq,qsq,mf,mh,mf))&
             +xih*xibH**2*mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mbH,mf)&
                             +2.d0*c11f(p1sq,p2sq,qsq,mf,mbH,mf))&
             +xih*mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mz,mf)&
                             +2.d0*c11f(p1sq,p2sq,qsq,mf,mz,mf))&
             +xih*xiA**2*mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mA,mf)&
                             +2.d0*c11f(p1sq,p2sq,qsq,mf,mA,mf))&
             +xihp*mfp**2/vev**3*(mf**2+mfp**2)*(c0f(p1sq,p2sq,qsq,mfp,mw,mfp)&
                              +2.d0*c11f(p1sq,p2sq,qsq,mfp,mw,mfp))&
             +xihp*mfp**2/vev**3*(mf**2*xiA**2+mfp**2*xiAp**2)*(c0f(p1sq,p2sq,qsq,mfp,mch,mfp)&
                              +2.d0*c11f(p1sq,p2sq,qsq,mfp,mch,mfp))&
!
             -sin(beta-alpha)*gz**4*vev*(vf**2 + af**2)*(c0f(p1sq,p2sq,qsq,mZ,mf,mZ) + c11f(p1sq,p2sq,qsq,mZ,mf,mZ))&
             -sin(beta-alpha)*g**4/4.d0*vev*(c0f(p1sq,p2sq,qsq,mW,mfp,mW) + c11f(p1sq,p2sq,qsq,mW,mfp,mW))&
!
             -6.d0*xih**2*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(c0f(p1sq,p2sq,qsq,mh,mf,mh)&
                            +c11f(p1sq,p2sq,qsq,mh,mf,mh))&
             -2.d0*xibH**2*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(c0f(p1sq,p2sq,qsq,mbH,mf,mbH)&
                            +c11f(p1sq,p2sq,qsq,mbH,mf,mbH))&
             -2.d0*xih*xibH*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(c0f(p1sq,p2sq,qsq,mbH,mf,mh)&
                            +c11f(p1sq,p2sq,qsq,mbH,mf,mh) + c0f(p1sq,p2sq,qsq,mh,mf,mbH) + c11f(p1sq,p2sq,qsq,mh,mf,mbH))&
             -2.d0*lam_GGh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(c0f(p1sq,p2sq,qsq,mz,mf,mz)&
                            +c11f(p1sq,p2sq,qsq,mz,mf,mz))&
             -2.d0*xiA**2*lam_AAh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(c0f(p1sq,p2sq,qsq,mA,mf,mA)&
                            +c11f(p1sq,p2sq,qsq,mA,mf,mA))&
             -1.d0*xiA*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(c0f(p1sq,p2sq,qsq,mA,mf,mz)&
                            +c11f(p1sq,p2sq,qsq,mA,mf,mz))&
             -1.d0*xiA*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(c0f(p1sq,p2sq,qsq,mz,mf,mA)&
                            +c11f(p1sq,p2sq,qsq,mz,mf,mA))&
             -1.d0*lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*(mf**2+mfp**2)/vev**2*(c0f(p1sq,p2sq,qsq,mw,mfp,mw)&
                            +c11f(p1sq,p2sq,qsq,mw,mfp,mw))&
             -1.d0*lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)*(xiA**2*mf**2+xiAp**2*mfp**2)/vev**2*(c0f(p1sq,p2sq,qsq,mch,mfp,mch)&
                            +c11f(p1sq,p2sq,qsq,mch,mfp,mch))&
             -1.d0*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)*(xiA*mf**2+xiAp*mfp**2)/vev**2*(c0f(p1sq,p2sq,qsq,mch,mfp,mw)&
                            +c11f(p1sq,p2sq,qsq,mch,mfp,mw))&
             -1.d0*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)*(xiA*mf**2+xiAp*mfp**2)/vev**2*(c0f(p1sq,p2sq,qsq,mw,mfp,mch)&
                            +c11f(p1sq,p2sq,qsq,mw,mfp,mch))&
!
             -sin(beta-alpha)*g**2/4.d0*mfp**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                        +c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                   -c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                   +c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                   )&
             -cos(beta-alpha)*g**2/4.d0*mfp**2*xiAp/vev*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mch)&
                                        +c11f(p1sq,p2sq,qsq,mW,mfp,mch)&
                                   -c0f(p1sq,p2sq,qsq,mch,mfp,mW)&
                                   +c11f(p1sq,p2sq,qsq,mch,mfp,mW)&
                                   )&
             -sin(beta-alpha)*gz**2/8.d0*mf**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                        +c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                   -c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                   +c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                   )&
             -cos(beta-alpha)*gz**2/8.d0*mf**2*xiA/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mA)&
                                        +c11f(p1sq,p2sq,qsq,mZ,mf,mA)&
                                   -c0f(p1sq,p2sq,qsq,mA,mf,mZ)&
                                   +c11f(p1sq,p2sq,qsq,mA,mf,mZ)&
                                   )&
                                       )

	 end function
!------------------------------------------------------------
 	complex (kind(0d0)) function Fhff_V2(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)
 	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,mf
	double precision:: vf,af,qf,mfp,xiA,xiAp,xih,xihp,xibH,xibHp
	integer, intent(in):: n

        if (mf .eq. mt) then 
        vf = vt;af = at;qf = qt;mfp = mb;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
        xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
        elseif (mf .eq. mc) then 
        vf = vt;af = at;qf = qt;mfp = ms;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
        xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
        elseif (mf .eq. mb) then 
        vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
        xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)
        elseif (mf .eq. mtau) then 
        vf = ve;af = ae;qf = qe;mfp = 0.d0;xiA=xil_A(alpha,beta,n)
        xih=xil(alpha,beta,n);xibH=xil_H(alpha,beta,n)
        endif

    Fhff_V2 = 1.d0/(16.d0*pi**2)*(& 
             xih*2.d0*gz**2*(vf**2 + af**2)*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mZ,mf)&
                                              +2.d0*c12f(p1sq,p2sq,qsq,mf,mZ,mf))&
            +xih*2.d0*(g*sw)**2*Qf**2*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mphoton,mf)&
                                      +2.d0*c12f(p1sq,p2sq,qsq,mf,mphoton,mf))&
            +xihp*g**2/2.d0*mfp**2/vev*(c0f(p1sq,p2sq,qsq,mfp,mW,mfp)&
                            +2.d0*c12f(p1sq,p2sq,qsq,mfp,mW,mfp))&
!
             +xih**3*mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mh,mf)&
                             +2.d0*c12f(p1sq,p2sq,qsq,mf,mh,mf))&
             +xih*xibH**2*mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mbH,mf)&
                             +2.d0*c12f(p1sq,p2sq,qsq,mf,mbH,mf))&
             +xih*mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mz,mf)&
                             +2.d0*c12f(p1sq,p2sq,qsq,mf,mz,mf))&
             +xih*xiA**2*mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mA,mf)&
                             +2.d0*c12f(p1sq,p2sq,qsq,mf,mA,mf))&
             +xihp*mfp**2/vev**3*(mf**2+mfp**2)*(c0f(p1sq,p2sq,qsq,mfp,mw,mfp)&
                              +2.d0*c12f(p1sq,p2sq,qsq,mfp,mw,mfp))&
             +xihp*mfp**2/vev**3*(mf**2*xiA**2+mfp**2*xiAp**2)*(c0f(p1sq,p2sq,qsq,mfp,mch,mfp)&
                              +2.d0*c12f(p1sq,p2sq,qsq,mfp,mch,mfp))&
!
             -sin(beta-alpha)*gz**4*vev*(vf**2 + af**2)*(c12f(p1sq,p2sq,qsq,mZ,mf,mZ))&
             -sin(beta-alpha)*g**4/4.d0*vev*(c12f(p1sq,p2sq,qsq,mW,mfp,mW))&
!
             -6.d0*xih**2*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mh,mf,mh))&
             -2.d0*xibH**2*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mbH,mf,mbH))&
             -2.d0*xih*xibH*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mbH,mf,mh) &
                                                                             + c12f(p1sq,p2sq,qsq,mh,mf,mbH))&
             -2.d0*lam_GGh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mz,mf,mz))&
             -2.d0*xiA**2*lam_AAh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mA,mf,mA))&
             -1.d0*xiA*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mA,mf,mz))&
             -1.d0*xiA*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mz,mf,mA))&
             -1.d0*lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*(mf**2+mfp**2)/vev**2*(c12f(p1sq,p2sq,qsq,mw,mfp,mw))&
             -1.d0*lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)*(xiA**2*mf**2+xiAp**2*mfp**2)/vev**2*(c12f(p1sq,p2sq,qsq,mch,mfp,mch))&
             -1.d0*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)*(xiA*mf**2+xiAp*mfp**2)/vev**2*(c12f(p1sq,p2sq,qsq,mch,mfp,mw))&
             -1.d0*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)*(xiA*mf**2+xiAp*mfp**2)/vev**2*(c12f(p1sq,p2sq,qsq,mw,mfp,mch))&
!
             -sin(beta-alpha)*g**2/4.d0*mfp**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                        +c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                   -c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                   +c12f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                   )&
             -cos(beta-alpha)*g**2/4.d0*mfp**2*xiAp/vev*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mch)&
                                        +c12f(p1sq,p2sq,qsq,mW,mfp,mch)&
                                   -c0f(p1sq,p2sq,qsq,mch,mfp,mW)&
                                   +c12f(p1sq,p2sq,qsq,mch,mfp,mW)&
                                   )&
             -sin(beta-alpha)*gz**2/8.d0*mf**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                        +c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                   -c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                   +c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                   )&
             -cos(beta-alpha)*gz**2/8.d0*mf**2*xiA/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mA)&
                                        +c12f(p1sq,p2sq,qsq,mZ,mf,mA)&
                                   -c0f(p1sq,p2sq,qsq,mA,mf,mZ)&
                                   +c12f(p1sq,p2sq,qsq,mA,mf,mZ)&
                                   )&
                                       )

	 end function
!------------------------------------------------------------
 	complex (kind(0d0)) function Fhff_A1(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)
 	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,mf
	double precision:: vf,af,qf,mfp,xiA,xiAp,xih,xihp,xibH,xibHp
	integer, intent(in):: n

        if (mf .eq. mt) then 
        vf = vt;af = at;qf = qt;mfp = mb;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
        xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
        elseif (mf .eq. mc) then 
        vf = vt;af = at;qf = qt;mfp = ms;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
        xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
        elseif (mf .eq. mb) then 
        vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
        xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)
        elseif (mf .eq. mtau) then 
        vf = ve;af = ae;qf = qe;mfp = 0.d0;xiA=xil_A(alpha,beta,n)
        xih=xil(alpha,beta,n);xibH=xil_H(alpha,beta,n)
        endif

     Fhff_A1 = 1.d0/(16.d0*pi**2)*(& 
             -xih*4.d0*gz**2*vf*af*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mZ,mf)&
                                    +2.d0*c11f(p1sq,p2sq,qsq,mf,mZ,mf))&   
             -xihp*g**2/2.d0*mfp**2/vev*(c0f(p1sq,p2sq,qsq,mfp,mW,mfp)&
                                    +2.d0*c11f(p1sq,p2sq,qsq,mfp,mW,mfp))&
              +xihp*mfp**2*(mf**2 - mfp**2)/vev**3*(c0f(p1sq,p2sq,qsq,mfp,mw,mfp)&
                                    +2.d0*c11f(p1sq,p2sq,qsq,mfp,mw,mfp))&
               +xihp*mfp**2*(mf**2*xiA**2 - mfp**2*xiAp**2)/vev**3*(c0f(p1sq,p2sq,qsq,mfp,mch,mfp)&
                                      +2.d0*c11f(p1sq,p2sq,qsq,mfp,mch,mfp))&
!
               +sin(beta-alpha)*2.d0*gz**4*vf*af*vev*(c0f(p1sq,p2sq,qsq,mZ,mf,mZ) + c11f(p1sq,p2sq,qsq,mZ,mf,mZ))&
               +sin(beta-alpha)*g**4/4.d0*vev*(c0f(p1sq,p2sq,qsq,mW,mfp,mW) + c11f(p1sq,p2sq,qsq,mW,mfp,mW))&
!
               -lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*(mf**2-mfp**2)/vev**2*(c0f(p1sq,p2sq,qsq,mw,mfp,mw)&
                                    +c11f(p1sq,p2sq,qsq,mw,mfp,mw))&
               -lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)*(mf**2*xiA**2-mfp**2*xiAp**2)/vev**2*(c0f(p1sq,p2sq,qsq,mch,mfp,mch)&
                                     +c11f(p1sq,p2sq,qsq,mch,mfp,mch))&
               -lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)*(mf**2*xiA-mfp**2*xiAp)/vev**2*(c0f(p1sq,p2sq,qsq,mch,mfp,mw)&
                                     +c11f(p1sq,p2sq,qsq,mch,mfp,mw))&
               -lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)*(mf**2*xiA-mfp**2*xiAp)/vev**2*(c0f(p1sq,p2sq,qsq,mw,mfp,mch)&
                                     +c11f(p1sq,p2sq,qsq,mw,mfp,mch))&
!
              +sin(beta-alpha)*g**2*mfp**2/(4.d0*vev)*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                       +c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                       -c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                        +c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                       )&
              +cos(beta-alpha)*g**2*mfp**2*xiAp/(4.d0*vev)*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mch)&
                                       +c11f(p1sq,p2sq,qsq,mW,mfp,mch)&
                                       -c0f(p1sq,p2sq,qsq,mch,mfp,mW)&
                                        +c11f(p1sq,p2sq,qsq,mch,mfp,mW)&
                                       )&
              +sin(beta-alpha)*2.d0*gz**2*vf*af*mf**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                       +c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                       -c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                        +c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                       )&
              +cos(beta-alpha)*2.d0*gz**2*vf*af*mf**2*xiA/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mA)&
                                       +c11f(p1sq,p2sq,qsq,mZ,mf,mA)&
                                       -c0f(p1sq,p2sq,qsq,mA,mf,mZ)&
                                        +c11f(p1sq,p2sq,qsq,mA,mf,mZ)&
                                       )&
         )

	 end function
!------------------------------------------------------------
 	complex (kind(0d0)) function Fhff_A2(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)
 	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,mf
	double precision:: vf,af,qf,mfp,xiA,xiAp,xih,xihp,xibH,xibHp
	integer, intent(in):: n

        if (mf .eq. mt) then 
        vf = vt;af = at;qf = qt;mfp = mb;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
        xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
        elseif (mf .eq. mc) then 
        vf = vt;af = at;qf = qt;mfp = ms;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
        xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
        elseif (mf .eq. mb) then 
        vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
        xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)
        elseif (mf .eq. mtau) then 
        vf = ve;af = ae;qf = qe;mfp = 0.d0;xiA=xil_A(alpha,beta,n)
        xih=xil(alpha,beta,n);xibH=xil_H(alpha,beta,n)
        endif

     Fhff_A2 = 1.d0/(16.d0*pi**2)*(& 
             -xih*4.d0*gz**2*vf*af*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mZ,mf)&
                                    +2.d0*c12f(p1sq,p2sq,qsq,mf,mZ,mf))&   
             -xihp*g**2/2.d0*mfp**2/vev*(c0f(p1sq,p2sq,qsq,mfp,mW,mfp)&
                                    +2.d0*c12f(p1sq,p2sq,qsq,mfp,mW,mfp))&
              +xihp*mfp**2*(mf**2 - mfp**2)/vev**3*(c0f(p1sq,p2sq,qsq,mfp,mw,mfp)&
                                    +2.d0*c12f(p1sq,p2sq,qsq,mfp,mw,mfp))&
               +xihp*mfp**2*(mf**2*xiA**2 - mfp**2*xiAp**2)/vev**3*(c0f(p1sq,p2sq,qsq,mfp,mch,mfp)&
                                      +2.d0*c12f(p1sq,p2sq,qsq,mfp,mch,mfp))&
!
               +sin(beta-alpha)*2.d0*gz**4*vf*af*vev*(c12f(p1sq,p2sq,qsq,mZ,mf,mZ))&
               +sin(beta-alpha)*g**4/4.d0*vev*(c12f(p1sq,p2sq,qsq,mW,mfp,mW))&
!
               -lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*(mf**2-mfp**2)/vev**2*(c12f(p1sq,p2sq,qsq,mw,mfp,mw))&
               -lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)*(mf**2*xiA**2-mfp**2*xiAp**2)/vev**2*(&
                                     +c12f(p1sq,p2sq,qsq,mch,mfp,mch))&
               -lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)*(mf**2*xiA-mfp**2*xiAp)/vev**2*(&
                                     +c12f(p1sq,p2sq,qsq,mch,mfp,mw))&
               -lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)*(mf**2*xiA-mfp**2*xiAp)/vev**2*(&
                                     +c12f(p1sq,p2sq,qsq,mw,mfp,mch))&
!
              +sin(beta-alpha)*g**2*mfp**2/(4.d0*vev)*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                       +c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                       -c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                        +c12f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                       )&
              +cos(beta-alpha)*g**2*mfp**2*xiAp/(4.d0*vev)*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mch)&
                                       +c12f(p1sq,p2sq,qsq,mW,mfp,mch)&
                                       -c0f(p1sq,p2sq,qsq,mch,mfp,mW)&
                                        +c12f(p1sq,p2sq,qsq,mch,mfp,mW)&
                                       )&
              +sin(beta-alpha)*2.d0*gz**2*vf*af*mf**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                       +c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                       -c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                        +c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                       )&
              +cos(beta-alpha)*2.d0*gz**2*vf*af*mf**2*xiA/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mA)&
                                       +c12f(p1sq,p2sq,qsq,mZ,mf,mA)&
                                       -c0f(p1sq,p2sq,qsq,mA,mf,mZ)&
                                        +c12f(p1sq,p2sq,qsq,mA,mf,mZ)&
                                       )&
         )

	 end function
!------------------------------------------------------------
 	complex (kind(0d0)) function Fhff_T(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)
 	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,mf
	double precision:: vf,af,qf,mfp,xiA,xiAp,xih,xihp,xibH,xibHp
	integer, intent(in):: n

        if (mf .eq. mt) then 
        vf = vt;af = at;qf = qt;mfp = mb;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
        xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
        elseif (mf .eq. mc) then 
        vf = vt;af = at;qf = qt;mfp = ms;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
        xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
        elseif (mf .eq. mb) then 
        vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
        xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)
        elseif (mf .eq. mtau) then 
        vf = ve;af = ae;qf = qe;mfp = 0.d0;xiA=xil_A(alpha,beta,n)
        xih=xil(alpha,beta,n);xibH=xil_H(alpha,beta,n)
        endif


       Fhff_T = 1.d0/(16.d0*pi**2)*(mf/vev)*(&
            xih**3*mf**2/vev**2*(c11f(p1sq,p2sq,qsq,mf,mh,mf)-c12f(p1sq,p2sq,qsq,mf,mh,mf))&
            +xih*xibH**2*mf**2/vev**2*(c11f(p1sq,p2sq,qsq,mf,mbH,mf)-c12f(p1sq,p2sq,qsq,mf,mbH,mf))&
           -xih*mf**2/vev**2*(c11f(p1sq,p2sq,qsq,mf,mz,mf)-c12f(p1sq,p2sq,qsq,mf,mz,mf))&
           -xih*xiA**2*mf**2/vev**2*(c11f(p1sq,p2sq,qsq,mf,mA,mf)-c12f(p1sq,p2sq,qsq,mf,mA,mf))&
           -xihp*2.d0*mfp**2/vev**2*(c11f(p1sq,p2sq,qsq,mfp,mw,mfp)-c12f(p1sq,p2sq,qsq,mfp,mw,mfp))&
           -xihp*2.d0*mfp**2*xiAp*xiA/vev**2*(c11f(p1sq,p2sq,qsq,mfp,mch,mfp)-c12f(p1sq,p2sq,qsq,mfp,mch,mfp))&
           +sin(beta-alpha)*g**2/4.d0*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      +1.d0*c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                      +1.d0*c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
                      -2.d0*c12f(p1sq,p2sq,qsq,mw,mfp,mW) )&
           +cos(beta-alpha)*xiA*g**2/4.d0*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mch)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mch)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mW,mfp,mch)&
                      +1.d0*c0f(p1sq,p2sq,qsq,mch,mfp,mW)&
                      +1.d0*c11f(p1sq,p2sq,qsq,mch,mfp,mW)&
                      -2.d0*c12f(p1sq,p2sq,qsq,mch,mfp,mW) )&
           +sin(beta-alpha)*gz**2/8.d0*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      +1.d0*c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      +1.d0*c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      -2.d0*c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      )&
           +cos(beta-alpha)*gz**2*xiA/8.d0*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mA)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mA)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mZ,mf,mA)&
                      +1.d0*c0f(p1sq,p2sq,qsq,mA,mf,mZ)&
                      +1.d0*c11f(p1sq,p2sq,qsq,mA,mf,mZ)&
                      -2.d0*c12f(p1sq,p2sq,qsq,mA,mf,mZ)&
                      )&
                      )
 
	 end function
!------------------------------------------------------------
 	complex (kind(0d0)) function Fhff_PT(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)
 	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,mf
	double precision:: vf,af,qf,mfp,xiA,xiAp,xih,xihp,xibH,xibHp
	integer, intent(in):: n

        if (mf .eq. mt) then 
        vf = vt;af = at;qf = qt;mfp = mb;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
        xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
        elseif (mf .eq. mc) then 
        vf = vt;af = at;qf = qt;mfp = ms;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
        xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
        elseif (mf .eq. mb) then 
        vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
        xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)
        elseif (mf .eq. mtau) then 
        vf = ve;af = ae;qf = qe;mfp = 0.d0;xiA=xil_A(alpha,beta,n)
        xih=xil(alpha,beta,n);xibH=xil_H(alpha,beta,n)
        endif

    Fhff_PT = 1.d0/(16.d0*pi**2)*(mf/vev)*sin(beta-alpha)*(&
           +g**2/4.d0*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      -1.d0*c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                      -1.d0*c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
                      +2.d0*c12f(p1sq,p2sq,qsq,mw,mfp,mW) )&
           +2.d0*gz**2*af*vf*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      -1.d0*c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      -1.d0*c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      +2.d0*c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      )&
                      )&
!
           +1.d0/(16.d0*pi**2)*(mf/vev)*cos(beta-alpha)*xiA*(&
           +g**2/4.d0*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mch)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mch)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mW,mfp,mch)&
                      -1.d0*c0f(p1sq,p2sq,qsq,mch,mfp,mW)&
                      -1.d0*c11f(p1sq,p2sq,qsq,mch,mfp,mW)&
                      +2.d0*c12f(p1sq,p2sq,qsq,mch,mfp,mW) )&
           +2.d0*gz**2*af*vf*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mA)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mA)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mZ,mf,mA)&
                      -1.d0*c0f(p1sq,p2sq,qsq,mA,mf,mZ)&
                      -1.d0*c11f(p1sq,p2sq,qsq,mA,mf,mZ)&
                      +2.d0*c12f(p1sq,p2sq,qsq,mA,mf,mZ)&
                      )&
                      )

 
	 end function
!--------------------------------------------
        complex (kind(0d0)) function Gam_hhh_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in):: n
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	Gam_hhh_F = &
      -xiu(alpha,beta,n)**3*8.d0*mt**4*nc/(16.d0*pi**2)/vev**3*&
      (&
       b0f(p1sq,mt,mt)+b0f(p2sq,mt,mt)+b0f(qsq,mt,mt)&
      +(&
         ( 4.d0*mt**2-qsq+(qsq-p1sq-p2sq)/2.d0 )*c0f(p1sq,p2sq,qsq,mt,mt,mt)&
        )&
      )&
! 
      -xiu(alpha,beta,n)**3*8.d0*mc**4*nc/(16.d0*pi**2)/vev**3*&
      (&
       b0f(p1sq,mc,mc)+b0f(p2sq,mc,mc)+b0f(qsq,mc,mc)&
      +(&
         ( 4.d0*mc**2-qsq+(qsq-p1sq-p2sq)/2.d0 )*c0f(p1sq,p2sq,qsq,mc,mc,mc)&
        )&
      )&
!
      -xid(alpha,beta,n)**3*8.d0*mb**4*nc/(16.d0*pi**2)/vev**3*&
      (&
       b0f(p1sq,mb,mb)+b0f(p2sq,mb,mb)+b0f(qsq,mb,mb)&
      +(&
         ( 4.d0*mb**2-qsq+(qsq-p1sq-p2sq)/2.d0 )*c0f(p1sq,p2sq,qsq,mb,mb,mb)&
      )&
      )&
! 
      -xil(alpha,beta,n)**3*8.d0*mtau**4/(16.d0*pi**2)/vev**3*&
      (&
       b0f(p1sq,mtau,mtau)+b0f(p2sq,mtau,mtau)+b0f(qsq,mtau,mtau)&
      +(&
         ( 4.d0*mtau**2-qsq+(qsq-p1sq-p2sq)/2.d0 )*c0f(p1sq,p2sq,qsq,mtau,mtau,mtau)&
      )&
      )
	
	 end function
!---------------------------------------------
	complex (kind(0d0)) function Gam_hhh_B(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta

	Gam_hhh_B = &
      1.d0/(16.d0*pi**2)*(&
!~~~~~~~~~~~ 3-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
 	+8.d0*g**3*mw**3*sin(beta-alpha)**3*c0f(p1sq,p2sq,qsq,mW,mW,mW)&
 	+4.d0*gz**3*mZ**3*sin(beta-alpha)**3*c0f(p1sq,p2sq,qsq,mZ,mZ,mZ)&
 	-1.d0/2.d0*g**3*mW**3*sin(beta-alpha)**3*c0f(p1sq,p2sq,qsq,mw,mw,mw)&
 	-1.d0/4.d0*gz**3*mZ**3*sin(beta-alpha)**3*c0f(p1sq,p2sq,qsq,mz,mz,mz)&	
!~~~~~~~~~~~ 2-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
       -1.d0/2.d0*sin(beta-alpha)**3*g**3*mw*Chhh_SVV(p1sq,p2sq,qsq,mw,mW,mW)&
       -1.d0/2.d0*sin(beta-alpha)*cos(beta-alpha)**2*g**3*mw*Chhh_SVV(p1sq,p2sq,qsq,mch,mW,mW)&
       -1.d0/4.d0*sin(beta-alpha)**3*gz**3*mz*Chhh_SVV(p1sq,p2sq,qsq,mz,mZ,mZ)&
       -1.d0/4.d0*sin(beta-alpha)*cos(beta-alpha)**2*gz**3*mz*Chhh_SVV(p1sq,p2sq,qsq,mA,mZ,mZ)&
!~~~~~~~~~~~ 1-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
       +1.d0/2.d0*sin(beta-alpha)**2*g**2*lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*Chhh_VSS(p1sq,p2sq,qsq,mW,mw,mw)&
       +1.d0/2.d0*cos(beta-alpha)**2*g**2*lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)*Chhh_VSS(p1sq,p2sq,qsq,mW,mch,mch)&
       +1.d0/2.d0*sin(beta-alpha)*cos(beta-alpha)*g**2*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)*&
 		(Chhh_VSS(p1sq,p2sq,qsq,mW,mw,mch) + Chhh_VSS(p1sq,p2sq,qsq,mW,mch,mw) )&
       +1.d0/2.d0*sin(beta-alpha)**2*gz**2*lam_GGh(mch,mA,mbh,bmsq,alpha,beta)*Chhh_VSS(p1sq,p2sq,qsq,mZ,mz,mz)&
       +1.d0/2.d0*cos(beta-alpha)**2*gz**2*lam_AAh(mch,mA,mbh,bmsq,alpha,beta)*Chhh_VSS(p1sq,p2sq,qsq,mZ,mA,mA)&
       +1.d0/4.d0*sin(beta-alpha)*cos(beta-alpha)*gz**2*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)*&
 		( Chhh_VSS(p1sq,p2sq,qsq,mZ,mz,mA) + Chhh_VSS(p1sq,p2sq,qsq,mZ,mA,mz) )&
!~~~~~~~~~~~ 0-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
       -2.d0*lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)**3*c0f(p1sq,p2sq,qsq,mw,mw,mw)&
       -2.d0*lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)**3*c0f(p1sq,p2sq,qsq,mch,mch,mch)&
       -8.d0*lam_GGh(mch,mA,mbh,bmsq,alpha,beta)**3*c0f(p1sq,p2sq,qsq,mz,mz,mz)&
       -8.d0*lam_AAh(mch,mA,mbh,bmsq,alpha,beta)**3*c0f(p1sq,p2sq,qsq,mA,mA,mA)&
       -8.d0*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)**3*c0f(p1sq,p2sq,qsq,mbH,mbH,mbH)&
       -216.d0*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)**3*c0f(p1sq,p2sq,qsq,mh,mh,mh)&
       -2.d0*lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)**2*(&
 	c0f(p1sq,p2sq,qsq,mw,mch,mch)+c0f(p1sq,p2sq,qsq,mch,mw,mch)+c0f(p1sq,p2sq,qsq,mch,mch,mw) )&
       -2.d0*lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)**2*(&
 	c0f(p1sq,p2sq,qsq,mch,mw,mw)+c0f(p1sq,p2sq,qsq,mw,mch,mw)+c0f(p1sq,p2sq,qsq,mw,mw,mch) )&
       -2.d0*lam_AAh(mch,mA,mbh,bmsq,alpha,beta)*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)**2*(&
 	c0f(p1sq,p2sq,qsq,mz,mA,mA)+c0f(p1sq,p2sq,qsq,mA,mz,mA)+c0f(p1sq,p2sq,qsq,mA,mA,mz) )&
       -2.d0*lam_GGh(mch,mA,mbh,bmsq,alpha,beta)*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)**2*(&
 	c0f(p1sq,p2sq,qsq,mA,mz,mz)+c0f(p1sq,p2sq,qsq,mz,mA,mz)+c0f(p1sq,p2sq,qsq,mz,mz,mA) )&
       -8.d0*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)**2*(&
 	c0f(p1sq,p2sq,qsq,mh,mbH,mbH)+c0f(p1sq,p2sq,qsq,mbH,mbH,mh)+c0f(p1sq,p2sq,qsq,mbH,mh,mbH) )&
       -24.d0*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)**2*(&
 	c0f(p1sq,p2sq,qsq,mh,mh,mbH)+c0f(p1sq,p2sq,qsq,mh,mbH,mh)+c0f(p1sq,p2sq,qsq,mbH,mh,mh) )&
!~~~~~~~~~~~ B function-like ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
       +2.d0*sin(beta-alpha)*g**3*mw*(b0f(p1sq,mW,mW)+b0f(p2sq,mW,mW)+b0f(qsq,mW,mW))-3.d0*g**3*mW*sin(beta-alpha)&
       +sin(beta-alpha)*gz**3*mz*(b0f(p1sq,mZ,mZ)+b0f(p2sq,mZ,mZ)+b0f(qsq,mZ,mZ))-3.d0/2.d0*gz**3*mZ*sin(beta-alpha)&
       +2.d0*lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*lam_GpGmhh(mch,mA,mbh,bmsq,alpha,beta)*&
        ( b0f(p1sq,mw,mw)+b0f(p2sq,mw,mw)+b0f(qsq,mw,mw)  )&
       +2.d0*lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)*lam_HpHmhh(mch,mA,mbh,bmsq,alpha,beta)*&
        ( b0f(p1sq,mch,mch)+b0f(p2sq,mch,mch)+b0f(qsq,mch,mch)  )&
       +4.d0*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)*lam_HpGmhh(mch,mA,mbh,bmsq,alpha,beta)*&
        ( b0f(p1sq,mch,mw)+b0f(p2sq,mch,mw)+b0f(qsq,mch,mw)  )&
       +4.d0*lam_GGh(mch,mA,mbh,bmsq,alpha,beta)*lam_GGhh(mch,mA,mbh,bmsq,alpha,beta)*&
        ( b0f(p1sq,mz,mz)+b0f(p2sq,mz,mz)+b0f(qsq,mz,mz)  )&
       +4.d0*lam_AAh(mch,mA,mbh,bmsq,alpha,beta)*lam_AAhh(mch,mA,mbh,bmsq,alpha,beta)*&
        ( b0f(p1sq,mA,mA)+b0f(p2sq,mA,mA)+b0f(qsq,mA,mA)  )&
       +2.d0*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)*lam_AGhh(mch,mA,mbh,bmsq,alpha,beta)*&
        ( b0f(p1sq,mA,mz)+b0f(p2sq,mA,mz)+b0f(qsq,mA,mz)  )&
       +4.d0*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*lam_bHbHhh(mch,mA,mbh,bmsq,alpha,beta)*&
        ( b0f(p1sq,mbH,mbH)+b0f(p2sq,mbH,mbH)+b0f(qsq,mbH,mbH)  )&
       +12.d0*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*lam_bHhhh(mch,mA,mbh,bmsq,alpha,beta)*&
        ( b0f(p1sq,mh,mbH)+b0f(p2sq,mh,mbH)+b0f(qsq,mh,mbH)  )&
       +72.d0*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*lam_hhhh(mch,mA,mbh,bmsq,alpha,beta)*&
        ( b0f(p1sq,mh,mh)+b0f(p2sq,mh,mh)+b0f(qsq,mh,mh)  )&
        )

 	 end function
!--------------------------------------------
	complex (kind(0d0)) function Gam1_hZZ_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in):: n

	Gam1_hZZ_F = xiu(alpha,beta,n)*nc*Gam1_hZZ_fermion(p1sq,p2sq,qsq,mt)&
                   +xiu(alpha,beta,n)*nc*Gam1_hZZ_fermion(p1sq,p2sq,qsq,mc)&
                   +xid(alpha,beta,n)*nc*Gam1_hZZ_fermion(p1sq,p2sq,qsq,mb)&
                   +xil(alpha,beta,n)*Gam1_hZZ_fermion(p1sq,p2sq,qsq,mtau)
	
	 end function
!--------------------------------------------
	complex (kind(0d0)) function Gam2_hZZ_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in):: n

	Gam2_hZZ_F =  xiu(alpha,beta,n)*nc*Gam2_hZZ_fermion(p1sq,p2sq,qsq,mt)&
                   +xiu(alpha,beta,n)*nc*Gam2_hZZ_fermion(p1sq,p2sq,qsq,mc)&
                   +xid(alpha,beta,n)*nc*Gam2_hZZ_fermion(p1sq,p2sq,qsq,mb)&
                   +xil(alpha,beta,n)*Gam2_hZZ_fermion(p1sq,p2sq,qsq,mtau)
	
	 end function
!--------------------------------------------
	complex (kind(0d0)) function Gam3_hZZ_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in):: n

	Gam3_hZZ_F = xiu(alpha,beta,n)*nc*Gam3_hZZ_fermion(p1sq,p2sq,qsq,mt)&
                   +xiu(alpha,beta,n)*nc*Gam3_hZZ_fermion(p1sq,p2sq,qsq,mc)&
                   +xid(alpha,beta,n)*nc*Gam3_hZZ_fermion(p1sq,p2sq,qsq,mb)&
                   +xil(alpha,beta,n)*Gam3_hZZ_fermion(p1sq,p2sq,qsq,mtau)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function Gam1_hZZ_B(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta)  
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta
	double precision:: p12
	p12=(qsq-p1sq-p2sq)/2.d0

	Gam1_hZZ_B =1.d0/(16.d0*pi**2)*(&
!~~~~~~~~~~~ 3-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	 +sin(beta-alpha)*2.d0*g**3*mw*cw**2*ChVV1_VVV(p1sq,p2sq,qsq,mW,mW,mW)&		! W-W-W
	 -2.d0*sin(beta-alpha)*g**3*cw**2*mw*c24f(p1sq,p2sq,qsq,mw,mw,mw)&		! c+-c+-c+
!~~~~~~~~~~~ 2-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	 +sin(beta-alpha)*g**3*mw*sw**2*ChVV1_SVV(p1sq,p2sq,qsq,mw,mW,mW)&		! G+-W-W
	 +sin(beta-alpha)*g**3*mw*sw**2*ChVV1_VVS(p1sq,p2sq,qsq,mW,mW,mw)&	 	! W-W-G+
	 -sin(beta-alpha)*2.d0*g**3*mw**3/cw**2*sw**4*c0f(p1sq,p2sq,qsq,mW,mw,mW)&	! W-G+-W
	 -sin(beta-alpha)**3*gz**3*mz**3*c0f(p1sq,p2sq,qsq,mZ,mh,mZ)&			! Z-h-Z
	 -sin(beta-alpha)*cos(beta-alpha)**2*gz**3*mz**3*c0f(p1sq,p2sq,qsq,mZ,mbH,mZ)&	! Z-H-Z
!~~~~~~~~~~~ 1-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	 -sin(beta-alpha)*g**3*mw/cw**2*(cw**2-sw**2)*sw**2*&
	   ( c24f(p1sq,p2sq,qsq,mW,mw,mw)+c24f(p1sq,p2sq,qsq,mw,mw,mW) )&		! G+-G+-W + W-G+-G+
	 +sin(beta-alpha)**3*gz**3/2.d0*mz*&
	   (c24f(p1sq,p2sq,qsq,mz,mh,mZ)+c24f(p1sq,p2sq,qsq,mZ,mh,mz))&			! G0-h-Z + Z-h-G0
	 +sin(beta-alpha)*cos(beta-alpha)**2*gz**3/2.d0*mz*&
	   (c24f(p1sq,p2sq,qsq,mA,mh,mZ)+c24f(p1sq,p2sq,qsq,mZ,mh,mA))&	                ! A-h-Z + Z-h-A
	 +sin(beta-alpha)*cos(beta-alpha)**2*gz**3/2.d0*mz*&
	   (c24f(p1sq,p2sq,qsq,mz,mbH,mZ)+c24f(p1sq,p2sq,qsq,mZ,mbH,mz))&               ! G0-H-Z + Z-H-G0
	 -sin(beta-alpha)*cos(beta-alpha)**2*gz**3/2.d0*mz*&
	   (c24f(p1sq,p2sq,qsq,mA,mbH,mZ)+c24f(p1sq,p2sq,qsq,mZ,mbH,mA))&               ! A-H-Z + Z-H-A
	 +2.d0*gz**2*lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*&
	    mw**2*sw**4*c0f(p1sq,p2sq,qsq,mw,mW,mw)&					! G+-W-G+
	 +6.d0*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*sin(beta-alpha)**2*&
	    gz**2*mz**2*c0f(p1sq,p2sq,qsq,mh,mZ,mh)&					! h-Z-h
	 +2.d0*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*cos(beta-alpha)**2*&
	    gz**2*mz**2*c0f(p1sq,p2sq,qsq,mbH,mZ,mbH)&					! H-Z-H
	 +2.d0*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*&
	    gz**2*mz**2*(c0f(p1sq,p2sq,qsq,mbH,mZ,mh)+c0f(p1sq,p2sq,qsq,mh,mZ,mbH))&	! H-Z-h + h-Z-H
!~~~~~~~~~~~ 0-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	 -2.d0*gz**2*lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*&
	   (cw**2-sw**2)**2*c24f(p1sq,p2sq,qsq,mw,mw,mw)&				! G+-G+-G+
	 -2.d0*gz**2*lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)*&
	   (cw**2-sw**2)**2*c24f(p1sq,p2sq,qsq,mch,mch,mch)&				! H+-H+-H+
	 -sin(beta-alpha)**2*6.d0*gz**2*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*&
		c24f(p1sq,p2sq,qsq,mh,mz,mh)&						! h-G0-h
	 -cos(beta-alpha)**2*2.d0*gz**2*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*&
		c24f(p1sq,p2sq,qsq,mbH,mz,mbH)&						! H-G0-H
	 -cos(beta-alpha)*sin(beta-alpha)*2.d0*gz**2*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*&
		( c24f(p1sq,p2sq,qsq,mh,mz,mbH)+c24f(p1sq,p2sq,qsq,mbH,mz,mh) )&	! h-G0-H + H-G0-h
	 -cos(beta-alpha)**2*6.d0*gz**2*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*&
		c24f(p1sq,p2sq,qsq,mh,mA,mh)&						! h-A-h
	 -sin(beta-alpha)**2*2.d0*gz**2*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*&
		c24f(p1sq,p2sq,qsq,mbH,mA,mbH)&						! H-A-H
	 +cos(beta-alpha)*sin(beta-alpha)*2.d0*gz**2*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*&
		( c24f(p1sq,p2sq,qsq,mh,mA,mbH)+c24f(p1sq,p2sq,qsq,mbH,mA,mh) )&	! h-A-H + H-A-h
!
	 -sin(beta-alpha)**2*2.d0*gz**2*lam_GGh(mch,mA,mbh,bmsq,alpha,beta)*&
		c24f(p1sq,p2sq,qsq,mz,mh,mz)&						! G0-h-G0
	 -cos(beta-alpha)**2*2.d0*gz**2*lam_AAh(mch,mA,mbh,bmsq,alpha,beta)*&
		c24f(p1sq,p2sq,qsq,mA,mh,mA)&						! A-h-A
	 -cos(beta-alpha)*sin(beta-alpha)*gz**2*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)*&
		( c24f(p1sq,p2sq,qsq,mA,mh,mz)+c24f(p1sq,p2sq,qsq,mz,mh,mA) )&		! A-h-G0 + G0-h-A
!
	 -cos(beta-alpha)**2*2.d0*gz**2*lam_GGh(mch,mA,mbh,bmsq,alpha,beta)*&
		c24f(p1sq,p2sq,qsq,mz,mbH,mz)&						! G0-H-G0
	 -sin(beta-alpha)**2*2.d0*gz**2*lam_AAh(mch,mA,mbh,bmsq,alpha,beta)*&
		c24f(p1sq,p2sq,qsq,mA,mbH,mA)&						! A-H-A
	 +cos(beta-alpha)*sin(beta-alpha)*gz**2*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)*&
		( c24f(p1sq,p2sq,qsq,mA,mbH,mz)+c24f(p1sq,p2sq,qsq,mz,mbH,mA) )&	! A-H-G0 + G0-H-A
!~~~~~~~~~~~ B function-like ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	 -sin(beta-alpha)*6.d0*g**3*cw**2*mW*b0f(qsq,mW,mW)&
	 +sin(beta-alpha)*4.d0*g**3*cw**2*mW&						! W-W
	 +1.d0/2.d0*lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*gz**2*(cw**2-sw**2)**2*b0f(qsq,mw,mw)&	! G+-G+
	 +1.d0/2.d0*lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)*gz**2*(cw**2-sw**2)**2*b0f(qsq,mch,mch)&	! H+-H+
	 +1.d0/2.d0*lam_GGh(mch,mA,mbh,bmsq,alpha,beta)*gz**2*b0f(qsq,mz,mz)&			! G0-G0
	 +1.d0/2.d0*lam_AAh(mch,mA,mbh,bmsq,alpha,beta)*gz**2*b0f(qsq,mA,mA)&			! A-A
	 +1.d0/2.d0*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*gz**2*b0f(qsq,mbH,mbH)&			! H-H
	 +3.d0/2.d0*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*gz**2*b0f(qsq,mh,mh)&			! h-h
	 -sin(beta-alpha)*g**3/cw**2*mw*sw**4*( b0f(p2sq,mW,mw)+b0f(p1sq,mw,mW) )&	! G+-W
	 -sin(beta-alpha)*1.d0/2.d0*gz**3*mz*( b0f(p1sq,mh,mZ)+b0f(p2sq,mh,mZ))&	! h-Z
	 )

	 end function
!--------------------------------------------
	complex (kind(0d0)) function Gam2_hZZ_B(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta
	double precision:: p12
	p12=(qsq-p1sq-p2sq)/2.d0

	Gam2_hZZ_B = gz**2/(16.d0*pi**2)*mz**2*(&
                   +sin(beta-alpha)*2.d0*g*mw*cw**4*(ChVV2_VVV(p1sq,p2sq,qsq,mW,mW,mW) - C1223(p1sq,p2sq,qsq,mw,mw,mw)) &
!
                     +sin(beta-alpha)*g*mw*sw**2*cw**2*ChVV2_SVV(p1sq,p2sq,qsq,mw,mW,mW)&
                     +sin(beta-alpha)*g*mw*sw**2*cw**2*ChVV2_VVS(p1sq,p2sq,qsq,mW,mW,mw)&
!
                     -sin(beta-alpha)*g*mw*(cw**2-sw**2)*sw**2*ChVV2_VSS(p1sq,p2sq,qsq,mW,mw,mw)&
                     -sin(beta-alpha)*g*mw*(cw**2-sw**2)*sw**2*ChVV2_SSV(p1sq,p2sq,qsq,mw,mw,mW)&
                     +sin(beta-alpha)**3*gz/2.d0*mz*ChVV2_VSS(p1sq,p2sq,qsq,mZ,mh,mz)&
                     +sin(beta-alpha)**3*gz/2.d0*mz*ChVV2_SSV(p1sq,p2sq,qsq,mz,mh,mZ)&
                     +sin(beta-alpha)*cos(beta-alpha)**2*gz/2.d0*mz*ChVV2_VSS(p1sq,p2sq,qsq,mZ,mbH,mz)&
                     +sin(beta-alpha)*cos(beta-alpha)**2*gz/2.d0*mz*ChVV2_SSV(p1sq,p2sq,qsq,mz,mbH,mZ)&
                     +sin(beta-alpha)*cos(beta-alpha)**2*gz/2.d0*mz*ChVV2_VSS(p1sq,p2sq,qsq,mZ,mh,mA)&
                     +sin(beta-alpha)*cos(beta-alpha)**2*gz/2.d0*mz*ChVV2_SSV(p1sq,p2sq,qsq,mA,mh,mZ)&
                     -sin(beta-alpha)*cos(beta-alpha)**2*gz/2.d0*mz*ChVV2_VSS(p1sq,p2sq,qsq,mZ,mbH,mA)&
                     -sin(beta-alpha)*cos(beta-alpha)**2*gz/2.d0*mz*ChVV2_SSV(p1sq,p2sq,qsq,mA,mbH,mZ)&
! 
                     -2.d0*lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*(cw**2-sw**2)**2*c1223(p1sq,p2sq,qsq,mw,mw,mw)&  
                     -2.d0*sin(beta-alpha)**2*lam_GGh(mch,mA,mbh,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mz,mh,mz)&
                     -2.d0*cos(beta-alpha)**2*lam_GGh(mch,mA,mbh,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mz,mbH,mz)&

                    -2.d0*lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)*(cw**2-sw**2)**2*c1223(p1sq,p2sq,qsq,mch,mch,mch)&
                    -2.d0*cos(beta-alpha)**2*lam_AAh(mch,mA,mbh,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mA,mh,mA)&
                    -2.d0*sin(beta-alpha)**2*lam_AAh(mch,mA,mbh,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mA,mbH,mA)&
                    -6.d0*sin(beta-alpha)**2*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mh,mz,mh)&
                    -6.d0*cos(beta-alpha)**2*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mh,mA,mh)&
                     -2.d0*cos(beta-alpha)**2*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mbH,mz,mbH)&
                     -2.d0*sin(beta-alpha)**2*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mbH,mA,mbH)&
                     -2.d0*cos(beta-alpha)*sin(beta-alpha)*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mbH,mz,mh)&
                     -2.d0*cos(beta-alpha)*sin(beta-alpha)*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mh,mz,mbH)&
                     +2.d0*cos(beta-alpha)*sin(beta-alpha)*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mbH,mA,mh)&
                     +2.d0*cos(beta-alpha)*sin(beta-alpha)*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mh,mA,mbH)&
                     -1.d0*sin(beta-alpha)*cos(beta-alpha)*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mA,mh,mz)&
                     -1.d0*sin(beta-alpha)*cos(beta-alpha)*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mz,mh,mA)&
                     +1.d0*sin(beta-alpha)*cos(beta-alpha)*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mA,mbh,mz)&
                     +1.d0*sin(beta-alpha)*cos(beta-alpha)*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mz,mbh,mA)&
                    )

	 end function
!--------------------------------------------
	complex (kind(0d0)) function Gam1_hWW_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in):: n

	Gam1_hWW_F = xiu(alpha,beta,n)*nc*Gam1_hWW_fermion(p1sq,p2sq,qsq,mt)&
                   +xid(alpha,beta,n)*nc*Gam1_hWW_fermion(p1sq,p2sq,qsq,mb)&
                   +xiu(alpha,beta,n)*nc*Gam1_hWW_fermion(p1sq,p2sq,qsq,mc)&
                   +xid(alpha,beta,n)*nc*Gam1_hWW_fermion(p1sq,p2sq,qsq,ms)&
                   +xil(alpha,beta,n)*Gam1_hWW_fermion(p1sq,p2sq,qsq,mtau)

	 end function
!--------------------------------------------
	complex (kind(0d0)) function Gam2_hWW_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in):: n

	Gam2_hWW_F = xiu(alpha,beta,n)*nc*Gam2_hWW_fermion(p1sq,p2sq,qsq,mt)&
                   +xid(alpha,beta,n)*nc*Gam2_hWW_fermion(p1sq,p2sq,qsq,mb)&
                   +xiu(alpha,beta,n)*nc*Gam2_hWW_fermion(p1sq,p2sq,qsq,mc)&
                   +xid(alpha,beta,n)*nc*Gam2_hWW_fermion(p1sq,p2sq,qsq,ms)&
                   +xil(alpha,beta,n)*Gam2_hWW_fermion(p1sq,p2sq,qsq,mtau)

	 end function
!--------------------------------------------
	complex (kind(0d0)) function Gam3_hWW_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in):: n

	Gam3_hWW_F = xiu(alpha,beta,n)*nc*Gam3_hWW_fermion(p1sq,p2sq,qsq,mt)&
                   +xid(alpha,beta,n)*nc*Gam3_hWW_fermion(p1sq,p2sq,qsq,mb)&
                   +xiu(alpha,beta,n)*nc*Gam3_hWW_fermion(p1sq,p2sq,qsq,mc)&
                   +xid(alpha,beta,n)*nc*Gam3_hWW_fermion(p1sq,p2sq,qsq,ms)&
                   +xil(alpha,beta,n)*Gam3_hWW_fermion(p1sq,p2sq,qsq,mtau)

	 end function
!--------------------------------------------
	complex (kind(0d0)) function Gam1_hWW_B(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta) 
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta
	double precision:: p12
	p12=(qsq-p1sq-p2sq)/2.d0
!
	Gam1_hWW_B =1.d0/(16.d0*pi**2)*&
	 (&
!~~~~~~~~~~~ 3-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	 +sin(beta-alpha)*g**3*cw*mz*ChVV1_VVV(p1sq,p2sq,qsq,mZ,mW,mZ)&
	 +sin(beta-alpha)*g**3*cw**2*mw*ChVV1_VVV(p1sq,p2sq,qsq,mW,mZ,mW)&
	 +sin(beta-alpha)*g**3*sw**2*mw*ChVV1_VVV(p1sq,p2sq,qsq,mW,mphoton,mW)&
	 -sin(beta-alpha)*g**3*sw**2*mw*c24f(p1sq,p2sq,qsq,mw,mphoton,mw)& ! Ghost
	 -sin(beta-alpha)*g**3*cw*mz*c24f(p1sq,p2sq,qsq,mz,mw,mz)&     ! Ghost
	 -sin(beta-alpha)*g**3*cw**2*mw*c24f(p1sq,p2sq,qsq,mw,mz,mw)&  ! Ghost
!~~~~~~~~~~~ 2-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	 -sin(beta-alpha)*1.d0/2.d0*g**3*mw*sw**2*(ChVV1_SVV(p1sq,p2sq,qsq,mw,mZ,mW)-ChVV1_SVV(p1sq,p2sq,qsq,mw,mphoton,mW))& 
	 -sin(beta-alpha)*1.d0/2.d0*g**3*mw*sw**2*(ChVV1_VVS(p1sq,p2sq,qsq,mW,mZ,mw)-ChVV1_VVS(p1sq,p2sq,qsq,mW,mphoton,mw))& 
	 -sin(beta-alpha)*g**3/cw**3*mw**2*mZ*sw**4*c0f(p1sq,p2sq,qsq,mZ,mw,mZ)&
	 -sin(beta-alpha)**3*g**3*mw**3*c0f(p1sq,p2sq,qsq,mW,mh,mW)&
	 -sin(beta-alpha)*cos(beta-alpha)**2*g**3*mw**3*c0f(p1sq,p2sq,qsq,mW,mbh,mW)&
!~~~~~~~~~~~ 1-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	 +lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*g**2*mw**2*sw**4/cw**2*c0f(p1sq,p2sq,qsq,mw,mZ,mw)&
	 +lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*g**2*sw**2*mw**2*c0f(p1sq,p2sq,qsq,mw,mphoton,mw)&
	 +sin(beta-alpha)**2*6.d0*g**2*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*mw**2*c0f(p1sq,p2sq,qsq,mh,mW,mh)& 
	 +cos(beta-alpha)**2*2.d0*g**2*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*mw**2*c0f(p1sq,p2sq,qsq,mbH,mW,mbH)& 
	 +cos(beta-alpha)*sin(beta-alpha)*2.d0*g**2*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*&
	   mw**2*(c0f(p1sq,p2sq,qsq,mh,mW,mbH)+c0f(p1sq,p2sq,qsq,mbH,mW,mh))& 
	 +sin(beta-alpha)**3*1.d0/2.d0*g**3*mw*( c24f(p1sq,p2sq,qsq,mW,mh,mw) + c24f(p1sq,p2sq,qsq,mw,mh,mW) )&
	 +sin(beta-alpha)*cos(beta-alpha)**2*1.d0/2.d0*g**3*mw*&
	    ( c24f(p1sq,p2sq,qsq,mW,mbH,mw) + c24f(p1sq,p2sq,qsq,mw,mbH,mW) )&
	 +sin(beta-alpha)*cos(beta-alpha)**2*1.d0/2.d0*g**3*mw*&
	    ( c24f(p1sq,p2sq,qsq,mW,mh,mch) + c24f(p1sq,p2sq,qsq,mch,mh,mW) )&
	 -sin(beta-alpha)*cos(beta-alpha)**2*1.d0/2.d0*g**3*mw*&
	    ( c24f(p1sq,p2sq,qsq,mW,mbh,mch) + c24f(p1sq,p2sq,qsq,mch,mbh,mW) )&
	 +sin(beta-alpha)*1.d0/2.d0*g**3*sw**2/cw**2*mw*&
	    ( c24f(p1sq,p2sq,qsq,mz,mw,mZ) + c24f(p1sq,p2sq,qsq,mZ,mw,mz) )&
!~~~~~~~~~~~ 0-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	 -sin(beta-alpha)**2*lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*g**2*( c24f(p1sq,p2sq,qsq,mw,mh,mw) )&
	 -cos(beta-alpha)**2*lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*g**2*( c24f(p1sq,p2sq,qsq,mw,mbh,mw) )&
	 -lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*g**2*( c24f(p1sq,p2sq,qsq,mw,mz,mw) )&
	 -cos(beta-alpha)**2*lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)*g**2*( c24f(p1sq,p2sq,qsq,mch,mh,mch) )&
	 -sin(beta-alpha)**2*lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)*g**2*( c24f(p1sq,p2sq,qsq,mch,mbh,mch) )&
	 -lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)*g**2*( c24f(p1sq,p2sq,qsq,mch,mA,mch) )&
!
	 -sin(beta-alpha)*cos(beta-alpha)*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)*g**2*&
	    ( c24f(p1sq,p2sq,qsq,mw,mh,mch)+c24f(p1sq,p2sq,qsq,mch,mh,mw) )&
	 +sin(beta-alpha)*cos(beta-alpha)*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)*g**2*&
	    ( c24f(p1sq,p2sq,qsq,mw,mbh,mch)+c24f(p1sq,p2sq,qsq,mch,mbh,mw) )&
	 -sin(beta-alpha)**2*6.d0*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*g**2*(c24f(p1sq,p2sq,qsq,mh,mw,mh) )&
	 -cos(beta-alpha)**2*2.d0*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*g**2*(c24f(p1sq,p2sq,qsq,mbh,mw,mbh) )&
	 -cos(beta-alpha)*sin(beta-alpha)*2.d0*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*g**2*&
	    (c24f(p1sq,p2sq,qsq,mh,mw,mbh)+c24f(p1sq,p2sq,qsq,mbh,mw,mh))&
!
	 -cos(beta-alpha)**2*6.d0*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*g**2*(c24f(p1sq,p2sq,qsq,mh,mch,mh) )&
	 -sin(beta-alpha)**2*2.d0*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*g**2*(c24f(p1sq,p2sq,qsq,mbh,mch,mbh) )&
	 +cos(beta-alpha)*sin(beta-alpha)*2.d0*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*g**2*&
	    (c24f(p1sq,p2sq,qsq,mh,mch,mbh)+c24f(p1sq,p2sq,qsq,mbh,mch,mh))&
!
	 -2.d0*lam_GGh(mch,mA,mbh,bmsq,alpha,beta)*g**2*c24f(p1sq,p2sq,qsq,mz,mw,mz)&
	 -2.d0*lam_AAh(mch,mA,mbh,bmsq,alpha,beta)*g**2*c24f(p1sq,p2sq,qsq,mA,mch,mA)&
!~~~~~~~~~~~ B function-like ~~~~~~~~~~~~~~~~~~~~~~!
	 -sin(beta-alpha)*3.d0*g**3*mw*b0f(qsq,mW,mW)+sin(beta-alpha)*2.d0*g**3*mW&
	 -sin(beta-alpha)*3.d0*g**3*cw*mz*b0f(qsq,mZ,mZ)+sin(beta-alpha)*2.d0*g**3*cw*mZ&
	 +1.d0/2.d0*lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*g**2*b0f(qsq,mw,mw)&
	 +1.d0/2.d0*lam_GGh(mch,mA,mbh,bmsq,alpha,beta)*g**2*b0f(qsq,mz,mz)&
	 +3.d0/2.d0*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*g**2*b0f(qsq,mh,mh)&
	 +1.d0/2.d0*lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)*g**2*b0f(qsq,mch,mch)&
	 +1.d0/2.d0*lam_AAh(mch,mA,mbh,bmsq,alpha,beta)*g**2*b0f(qsq,mA,mA)&
	 +1.d0/2.d0*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*g**2*b0f(qsq,mbh,mbh)&
	 -sin(beta-alpha)*1.d0/2.d0*g**3*mw*( b0f(p1sq,mW,mh) + b0f(p2sq,mW,mh) )&
	 -sin(beta-alpha)*1.d0/2.d0*g**3*mw*sw**4/cw**2*( b0f(p1sq,mZ,mw) + b0f(p2sq,mZ,mw) )&
	 -sin(beta-alpha)*1.d0/2.d0*g**3*sw**2*mw*( b0f(p1sq,mphoton,mw) + b0f(p2sq,mphoton,mw) )&
	 )

	 end function
!--------------------------------------------
	complex (kind(0d0)) function Gam2_hWW_B(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta
	double precision:: p12
	p12=(qsq-p1sq-p2sq)/2.d0

	Gam2_hWW_B = g**2/(16.d0*pi**2)*mw**2*(&
                    +sin(beta-alpha)*g*cw*mz*(ChVV2_VVV(p1sq,p2sq,qsq,mZ,mW,mZ) - c1223(p1sq,p2sq,qsq,mz,mw,mz)) &
                    +sin(beta-alpha)*g*mw*cw**2*(ChVV2_VVV(p1sq,p2sq,qsq,mW,mZ,mW)-c1223(p1sq,p2sq,qsq,mw,mz,mw))& 
                    +sin(beta-alpha)*g*mw*sw**2*(ChVV2_VVV(p1sq,p2sq,qsq,mW,mphoton,mW)-c1223(p1sq,p2sq,qsq,mw,mphoton,mw)) &
!
          -sin(beta-alpha)*g/2.d0*mw*(sw**2*ChVV2_SVV(p1sq,p2sq,qsq,mw,mZ,mW) - sw**2*ChVV2_SVV(p1sq,p2sq,qsq,mw,mphoton,mW))&
          -sin(beta-alpha)*g/2.d0*mw*(sw**2*ChVV2_VVS(p1sq,p2sq,qsq,mW,mZ,mw) - sw**2*ChVV2_VVS(p1sq,p2sq,qsq,mW,mphoton,mw))&
!
                   +sin(beta-alpha)**3*g/2.d0*mw*ChVV2_VSS(p1sq,p2sq,qsq,mW,mh,mw)&
                   +sin(beta-alpha)**3*g/2.d0*mw*ChVV2_SSV(p1sq,p2sq,qsq,mw,mh,mW)&
                   +sin(beta-alpha)*cos(beta-alpha)**2*g/2.d0*mw*ChVV2_VSS(p1sq,p2sq,qsq,mW,mbH,mw)&
                   +sin(beta-alpha)*cos(beta-alpha)**2*g/2.d0*mw*ChVV2_SSV(p1sq,p2sq,qsq,mw,mbH,mW)&
                   +sin(beta-alpha)*g/2.d0*mw*sw**2/cw**2*ChVV2_VSS(p1sq,p2sq,qsq,mZ,mw,mz)&
                   +sin(beta-alpha)*g/2.d0*mw*sw**2/cw**2*ChVV2_SSV(p1sq,p2sq,qsq,mz,mw,mZ)&
                   +sin(beta-alpha)*cos(beta-alpha)**2*g/2.d0*mw*ChVV2_VSS(p1sq,p2sq,qsq,mW,mh,mch)&
                   +sin(beta-alpha)*cos(beta-alpha)**2*g/2.d0*mw*ChVV2_SSV(p1sq,p2sq,qsq,mch,mh,mW)&
                   -sin(beta-alpha)*cos(beta-alpha)**2*g/2.d0*mw*ChVV2_VSS(p1sq,p2sq,qsq,mW,mbH,mch)&
                   -sin(beta-alpha)*cos(beta-alpha)**2*g/2.d0*mw*ChVV2_SSV(p1sq,p2sq,qsq,mch,mbH,mW)&
!
                   -2.d0*lam_GGh(mch,mA,mbh,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mz,mw,mz)&
                   -1.d0*lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*sin(beta-alpha)**2*c1223(p1sq,p2sq,qsq,mw,mh,mw)&
                   -1.d0*lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*cos(beta-alpha)**2*c1223(p1sq,p2sq,qsq,mw,mbH,mw)&
                   -1.d0*lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mw,mz,mw)&
                   -2.d0*lam_AAh(mch,mA,mbh,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mA,mch,mA)&
                   -1.d0*lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)*cos(beta-alpha)**2*c1223(p1sq,p2sq,qsq,mch,mh,mch)&
                   -1.d0*lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)*sin(beta-alpha)**2*c1223(p1sq,p2sq,qsq,mch,mbH,mch)&
                   -1.d0*lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mch,mA,mch)&
                   -6.d0*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*sin(beta-alpha)**2*c1223(p1sq,p2sq,qsq,mh,mw,mh)&
                   -6.d0*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*cos(beta-alpha)**2*c1223(p1sq,p2sq,qsq,mh,mch,mh)&
                   -2.d0*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*cos(beta-alpha)**2*c1223(p1sq,p2sq,qsq,mbH,mw,mbH)&
                   -2.d0*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*sin(beta-alpha)**2*c1223(p1sq,p2sq,qsq,mbH,mch,mbH)&
                   -2.d0*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*c1223(p1sq,p2sq,qsq,mbH,mw,mh)&
                   -2.d0*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*c1223(p1sq,p2sq,qsq,mh,mw,mbH)&
                   +2.d0*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*c1223(p1sq,p2sq,qsq,mbH,mch,mh)&
                   +2.d0*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*c1223(p1sq,p2sq,qsq,mh,mch,mbH)&
!
                    -1.d0*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*c1223(p1sq,p2sq,qsq,mw,mh,mch)&
                    -1.d0*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*c1223(p1sq,p2sq,qsq,mch,mh,mw)&
                    +1.d0*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*c1223(p1sq,p2sq,qsq,mw,mbH,mch)&
                    +1.d0*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*c1223(p1sq,p2sq,qsq,mch,mbH,mw)&
                    )

	 end function
!==================================
!    SECTION IV COUNTER TERMS     !
!==================================

!========================================================
	complex (kind(0d0)) function del_swsq_F(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	del_swsq_F = cw**2*(PiZZ_F(mz**2)/mz**2-PiWW_F(mw**2)/mw**2)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_swsq_B(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	del_swsq_B = cw**2*(PiZZ_B(mz**2,mch,mA,mbh,bmsq,alpha,beta)/mz**2-PiWW_B(mw**2,mch,mA,mbh,bmsq,alpha,beta)/mw**2)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_swsq(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in):: n

	del_swsq = del_swsq_F(alpha,beta,n)+del_swsq_B(mch,mA,mbh,bmsq,alpha,beta)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_v_F(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	del_v_F = &
	 vev/2.d0*(&
	 PiWW_F(mw**2)/mw**2&
	 +del_swsq_F(alpha,beta,n)/sw**2&
	 -delta_alpha &
	 -dPiGG_F(mz**2)&
	 -2.d0*sw/cw*PiZG_F(0.d0)/mz**2)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_v_B(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	del_v_B=&
	 vev/2.d0*(&
	 PiWW_B(mw**2,mch,mA,mbh,bmsq,alpha,beta)/mw**2&
	 +del_swsq_B(mch,mA,mbh,bmsq,alpha,beta)/sw**2&
	 -dPiGG_B(mz**2,mch,mA,mbh,bmsq,alpha,beta)&
	 -2.d0*sw/cw*PiZG_B(0.d0,mch,mA,mbh,bmsq,alpha,beta)/mz**2)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_v(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in):: n

	del_v = del_v_F(alpha,beta,n)+del_v_B(mch,mA,mbh,bmsq,alpha,beta)

	 end function
!--------------------------------------------
  	complex (kind(0d0)) function del_mZsq_F(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta
	
	del_mZsq_F = PiZZ_F(mz**2)

	 end function
!--------------------------------------------
  	complex (kind(0d0)) function del_mZsq_B(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	
	del_mZsq_B = PiZZ_B(mz**2,mch,mA,mbh,bmsq,alpha,beta)

	 end function
!--------------------------------------------
 	complex (kind(0d0)) function del_mWsq_F(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	del_mWsq_F = PiWW_F(mw**2)

	 end function
!--------------------------------------------
  	complex (kind(0d0)) function del_mWsq_B(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	
	del_mWsq_B = PiWW_B(mw**2,mch,mA,mbh,bmsq,alpha,beta)

	 end function
!----------------------------------------------
  	complex (kind(0d0)) function del_ZZ_F(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	del_ZZ_F =& 
	 -delta_alpha-dPiGG_F(mz**2)&
	   -2.d0*(cw**2-sw**2)/(cw*sw)*PiZG_F(0.d0)/mz**2&
	 +(cw**2-sw**2)/cw**2*&
	 del_swsq_F(alpha,beta,n)/sw**2

	 end function
!--------------------------------------------
  	complex (kind(0d0)) function del_ZZ_B(mch,mA,mbh,bmsq,alpha,beta)
  	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	
	del_ZZ_B = -(dPiGG_B(mz**2,mch,mA,mbh,bmsq,alpha,beta)-dPiGG_pinch(mz**2))&
	   +2.d0*(cw**2-sw**2)/(cw*sw)*( PiZG_B(0.d0,mch,mA,mbh,bmsq,alpha,beta)-PiZG_pinch(0.d0) )/mz**2&
	 +(cw**2-sw**2)/cw**2*&
	 del_swsq_B(mch,mA,mbh,bmsq,alpha,beta)/sw**2

	 end function
!--------------------------------------------
  	complex (kind(0d0)) function del_ZW_F(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	del_ZW_F =&
	 -delta_alpha-dPiGG_F(mz**2)&
	   +2.d0*cw/sw*&
	 PiZG_F(0.d0)/mz**2&
	 +del_swsq_F(alpha,beta,n)/sw**2

	 end function
!--------------------------------------------
  	complex (kind(0d0)) function del_ZW_B(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	
	del_ZW_B =&
	   -(dPiGG_B(mz**2,mch,mA,mbh,bmsq,alpha,beta) -dPiGG_pinch(mz**2))&
	   +2.d0*cw/sw*(PiZG_B(0.d0,mch,mA,mbh,bmsq,alpha,beta)-PiZG_pinch(0.d0))/mz**2&
	   +del_swsq_B(mch,mA,mbh,bmsq,alpha,beta)/sw**2

	 end function
!=========================================================
	complex (kind(0d0)) function del_mt(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	del_mt =&
	mt*( Pitt_V(mt**2,mch,mA,mbh,bmsq,alpha,beta,n)+Pitt_S(mt**2,mch,mA,mbh,bmsq,alpha,beta,n) )

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_mc(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	del_mc =&
	mc*( Picc_V(mc**2,mch,mA,mbh,bmsq,alpha,beta,n)+Picc_S(mc**2,mch,mA,mbh,bmsq,alpha,beta,n) )

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_mb(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	del_mb =&
	mb*( Pibb_V(mb**2,mch,mA,mbh,bmsq,alpha,beta,n)+Pibb_S(mb**2,mch,mA,mbh,bmsq,alpha,beta,n) )

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_mtau(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	del_mtau =&
	mtau*( Pitautau_V(mtau**2,mch,mA,mbh,bmsq,alpha,beta,n)+Pitautau_S(mtau**2,mch,mA,mbh,bmsq,alpha,beta,n) )

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_ZVt(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	del_ZVt =&
	-Pitt_V(mt**2,mch,mA,mbh,bmsq,alpha,beta,n)&
	-2.d0*mt**2*(dPitt_V(mt**2,mch,mA,mbh,bmsq,alpha,beta,n)+dPitt_S(mt**2,mch,mA,mbh,bmsq,alpha,beta,n))

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_ZVc(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	del_ZVc =&
	-Picc_V(mc**2,mch,mA,mbh,bmsq,alpha,beta,n)-2.d0*mc**2*&
	(dPicc_V(mc**2,mch,mA,mbh,bmsq,alpha,beta,n)+dPicc_S(mc**2,mch,mA,mbh,bmsq,alpha,beta,n))

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_ZVb(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	del_ZVb =&
	-Pibb_V(mb**2,mch,mA,mbh,bmsq,alpha,beta,n)-2.d0*mb**2*&
	(dPibb_V(mb**2,mch,mA,mbh,bmsq,alpha,beta,n)+dPibb_S(mb**2,mch,mA,mbh,bmsq,alpha,beta,n))

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_ZVtau(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n


	del_ZVtau =&
	-Pitautau_V(mtau**2,mch,mA,mbh,bmsq,alpha,beta,n)&
	-2.d0*mtau**2*(dPitautau_V(mtau**2,mch,mA,mbh,bmsq,alpha,beta,n)+dPitautau_S(mtau**2,mch,mA,mbh,bmsq,alpha,beta,n))

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_T1_F(alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta

	del_T1_F = -cos(alpha)*TbH_F(alpha,beta,n)+sin(alpha)*Th_F(alpha,beta,n)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_T1_B(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	del_T1_B = -cos(alpha)*TbH_B(mch,mA,mbh,bmsq,alpha,beta)+sin(alpha)*Th_B(mch,mA,mbh,bmsq,alpha,beta)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_T1(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	del_T1 = del_T1_F(alpha,beta,n) + del_T1_B(mch,mA,mbh,bmsq,alpha,beta)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_T2_F(alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta

	del_T2_F = -sin(alpha)*TbH_F(alpha,beta,n) -cos(alpha)*Th_F(alpha,beta,n)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_T2_B(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	del_T2_B = -sin(alpha)*TbH_B(mch,mA,mbh,bmsq,alpha,beta) -cos(alpha)*Th_B(mch,mA,mbh,bmsq,alpha,beta)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_T2(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	del_T2 = del_T2_F(alpha,beta,n) + del_T2_B(mch,mA,mbh,bmsq,alpha,beta)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_Zh_F(alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta

	del_Zh_F = -dPihh_F(mh**2,alpha,beta,n)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_Zh_B(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	del_Zh_B = -dPihh_B(mh**2,mch,mA,mbh,bmsq,alpha,beta)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_mhsq_F(alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta

	del_mhsq_F = Pihh_F(mh**2,alpha,beta,n)+sin(alpha)**2/(cos(beta)*vev)*del_T1_F(alpha,beta,n)&
	+cos(alpha)**2*del_T2_F(alpha,beta,n)/(sin(beta)*vev)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_mhsq_B(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	del_mhsq_B =  Pihh_B(mh**2.d0,mch,mA,mbh,bmsq,alpha,beta)+sin(alpha)**2.d0/(cos(beta)*vev)*del_T1_B(mch,mA,mbh,bmsq,alpha,beta)&
	+cos(alpha)**2.d0*del_T2_B(mch,mA,mbh,bmsq,alpha,beta)/(sin(beta)*vev)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_Zh(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	del_Zh = del_Zh_F(alpha,beta,n)+del_Zh_B(mch,mA,mbh,bmsq,alpha,beta)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_alpha_F(mbh,alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: mbh,alpha,beta

	del_alpha_F = 1.d0/2.d0/(mbH**2-mh**2)*(&
	+PibHh_F(mh**2,alpha,beta,n)+PibHh_F(mbH**2,alpha,beta,n)&
	-2.d0*sin(alpha)*cos(alpha)*(del_T1_F(alpha,beta,n)/(cos(beta)*vev)-del_T2_F(alpha,beta,n)/(sin(beta)*vev) )&
	)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_alpha_B(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	del_alpha_B = 1.d0/2.d0/(mbH**2-mh**2)*(&
	+PibHh_B(mh**2,mch,mA,mbh,bmsq,alpha,beta)+PibHh_B(mbH**2,mch,mA,mbh,bmsq,alpha,beta)&
	-2.d0*sin(alpha)*cos(alpha)*(del_T1_B(mch,mA,mbh,bmsq,alpha,beta)/(cos(beta)*vev)&
	-del_T2_B(mch,mA,mbh,bmsq,alpha,beta)/(sin(beta)*vev) )&
	)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_alpha(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	del_alpha = del_alpha_F(mbh,alpha,beta,n)+del_alpha_B(mch,mA,mbh,bmsq,alpha,beta)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_Ch_F(mbh,alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: mbh,alpha,beta

	del_Ch_F = 1.d0/2.d0/(mbH**2-mh**2)*(&
	+PibHh_F(mh**2,alpha,beta,n)-PibHh_F(mbH**2,alpha,beta,n)&
	)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_Ch_B(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	del_Ch_B = 1.d0/2.d0/(mbH**2-mh**2)*(&
	+PibHh_B(mh**2,mch,mA,mbh,bmsq,alpha,beta)-PibHh_B(mbH**2,mch,mA,mbh,bmsq,alpha,beta)&
	)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_Ch(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	del_Ch = del_Ch_F(mbh,alpha,beta,n)+del_Ch_B(mch,mA,mbh,bmsq,alpha,beta)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_beta_F(mA,alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: mA,alpha,beta

	 del_beta_F = -1.d0/(2.d0*mA**2)*tildePiAG_F(mA**2,alpha,beta,n)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_beta_B(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	 del_beta_B = -1.d0/(2.d0*mA**2)*tildePiAG_B(mA**2,mch,mA,mbh,bmsq,alpha,beta)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_beta(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	del_beta = del_beta_F(mA,alpha,beta,n)+del_beta_B(mch,mA,mbh,bmsq,alpha,beta)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_CA(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	del_CA = -1.d0/2.d0/mA**2*(&
	+PiAG_F(mA**2,alpha,beta,n)+PiAG_B(mA**2,mch,mA,mbh,bmsq,alpha,beta)&
	-PiAG_F(0.d0,alpha,beta,n)-PiAG_B(0.d0,mch,mA,mbh,bmsq,alpha,beta)&
	)

	 end function
!---------------------------------------------
	complex (kind(0d0)) function del_xiu(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	if (n.EQ.1) then
	del_xiu = -cos(alpha)/sin(beta)*&
	(1.d0/tan(beta)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n) + tan(alpha)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))
	elseif (n.EQ.2) then
	del_xiu = -cos(alpha)/sin(beta)*&
	(1.d0/tan(beta)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n) + tan(alpha)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))
	elseif (n.EQ.3) then
	del_xiu = -cos(alpha)/sin(beta)*&
	(1.d0/tan(beta)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n) + tan(alpha)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))
	elseif (n.EQ.4) then
	del_xiu = -cos(alpha)/sin(beta)*&
	(1.d0/tan(beta)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n) + tan(alpha)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))
	else
	del_xiu=0.00000000000001d0
	end if

	end function
!---------------------------------------------
	complex (kind(0d0)) function del_xid(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	if (n.EQ.1) then
	del_xid = -cos(alpha)/sin(beta)*&
	(1.d0/tan(beta)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n) + tan(alpha)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))
	elseif (n.EQ.2) then
	del_xid = -sin(alpha)/cos(beta)*&
	(tan(beta)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n) + 1.d0/tan(alpha)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))
	elseif (n.EQ.3) then
	del_xid = -cos(alpha)/sin(beta)*&
	(1.d0/tan(beta)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n) + tan(alpha)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))
	elseif (n.EQ.4) then
	del_xid = -sin(alpha)/cos(beta)*&
	(tan(beta)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n) + 1.d0/tan(alpha)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))
	else
	del_xid=0.00000000000001d0
	end if

	end function
!---------------------------------------------
	complex (kind(0d0)) function del_xil(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	if (n.EQ.1) then
	del_xil = -cos(alpha)/sin(beta)*&
	(1.d0/tan(beta)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n) + tan(alpha)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))
	elseif (n.EQ.2) then
	del_xil = -sin(alpha)/cos(beta)*&
	(tan(beta)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n) + 1.d0/tan(alpha)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))
	elseif (n.EQ.3) then
	del_xil = -sin(alpha)/cos(beta)*&
	(tan(beta)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n) + 1.d0/tan(alpha)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))
	elseif (n.EQ.4) then
	del_xil = -cos(alpha)/sin(beta)*&
	(1.d0/tan(beta)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n) + tan(alpha)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))
	else
	del_xil = 0.00000000000001d0
	end if

	end function
!---------------------------------------------
	complex (kind(0d0)) function del_bar_bmsq_F(alpha,beta,n)  ! Defined as del_M^2/M^2
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta

	del_bar_bmsq_F = 1.d0/(16.d0*pi**2*vev**2)*(&
	2.d0*nc*(mt**2*xiu_A(alpha,beta,n)**2 + mc**2*xiu_A(alpha,beta,n)**2 +mb**2*(-xid_A(alpha,beta,n))**2) &
	+2.d0*mtau**2*(-xil_A(alpha,beta,n))**2&
	)*div

	end function
!---------------------------------------------
	complex (kind(0d0)) function del_bar_bmsq_B(mch,mA,mbh,bmsq,alpha,beta)  ! Defined as del_M^2/M^2
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	del_bar_bmsq_B = 1.d0/(16.d0*pi**2*vev**2)*(&
	4.d0*bmsq -2.d0*mch**2-mA**2 +sin(2.d0*alpha)/sin(2.d0*beta)*(mbH**2-mh**2)&
        -3.d0*(2.d0*mw**2+mz**2)&
	)*div

	end function
!==============================================
  	complex (kind(0d0)) function del_lam_hhh_F(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	del_lam_hhh_F = &
	-lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*del_v_F(alpha,beta,n)/vev&
	+cos(beta-alpha)**2*cos(alpha+beta)/(vev*sin(2.d0*beta))*del_bar_bmsq_F(alpha,beta,n)*bmsq&
	-1.d0/(4.d0*vev*sin(2.d0*beta))*( cos(3.d0*alpha-beta)+3.d0*cos(alpha+beta))*del_mhsq_F(alpha,beta,n)&
	+cos(beta-alpha)/(2.d0*vev)*(3.d0*sin(2.d0*alpha)/sin(2.d0*beta)*(mh**2-bmsq)+bmsq)*del_alpha_F(mbh,alpha,beta,n)&
	+cos(beta-alpha)/(4.d0*vev*sin(2.d0*beta)**2)*(&
            (4.d0+4.d0*cos(2.d0*alpha)*cos(2.d0*beta)-2.d0*sin(2.d0*alpha)*sin(2.d0*beta))*mh**2&
	    -(5.d0-cos(4.d0*beta)+4.d0*cos(2.d0*alpha)*cos(2.d0*beta)-2.d0*sin(2.d0*alpha)*sin(2.d0*beta))*bmsq&
             )*del_beta_F(mA,alpha,beta,n)
	
	 end function
!---------------------------------------------------------------------
 	complex (kind(0d0)) function del_lam_hhh_B(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	del_lam_hhh_B = &
	-lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*del_v_B(mch,mA,mbh,bmsq,alpha,beta)/vev&
	+cos(beta-alpha)**2*cos(alpha+beta)/(vev*sin(2.d0*beta))*del_bar_bmsq_B(mch,mA,mbh,bmsq,alpha,beta)*bmsq&
	-1.d0/(4.d0*vev*sin(2.d0*beta))*( cos(3.d0*alpha-beta)+3.d0*cos(alpha+beta))*del_mhsq_B(mch,mA,mbh,bmsq,alpha,beta)&
	+cos(beta-alpha)/(2.d0*vev)*(3.d0*sin(2.d0*alpha)/sin(2.d0*beta)*(mh**2-bmsq)+bmsq)*del_alpha_B(mch,mA,mbh,bmsq,alpha,beta)&
	+cos(beta-alpha)/(4.d0*vev*sin(2.d0*beta)**2)*(&
            (4.d0+4.d0*cos(2.d0*alpha)*cos(2.d0*beta)-2.d0*sin(2.d0*alpha)*sin(2.d0*beta))*mh**2&
	    -(5.d0-cos(4.d0*beta)+4.d0*cos(2.d0*alpha)*cos(2.d0*beta)-2.d0*sin(2.d0*alpha)*sin(2.d0*beta))*bmsq&
             )*del_beta_B(mch,mA,mbh,bmsq,alpha,beta)
	
	 end function
!---------------------------------------------------------------------
  	complex (kind(0d0)) function del_Gam_hhh_F(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	del_Gam_hhh_F = &
	 6.d0*(&
	+del_lam_hhh_F(mch,mA,mbh,bmsq,alpha,beta,n)&
	+3.d0/2.d0*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*del_Zh_F(alpha,beta,n)&
	+lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*(del_alpha_F(mbh,alpha,beta,n)+del_Ch_F(mbh,alpha,beta,n))&
	)	

	 end function
!---------------------------------------------------------------------
  	complex (kind(0d0)) function del_Gam_hhh_B(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	del_Gam_hhh_B = &
	 6.d0*(&
	+del_lam_hhh_B(mch,mA,mbh,bmsq,alpha,beta)&
	+3.d0/2.d0*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*del_Zh_B(mch,mA,mbh,bmsq,alpha,beta)&
	+lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*(del_alpha_B(mch,mA,mbh,bmsq,alpha,beta)+del_Ch_B(mch,mA,mbh,bmsq,alpha,beta))&
	)	

	 end function
!==============================================
  	complex (kind(0d0)) function del_Gam1_hZZ_F(alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta

	del_Gam1_hZZ_F = &
	 2.d0*mz**2/vev*&
	 sin(beta-alpha)*(&
	                 +del_mzsq_F(alpha,beta,n)/mz**2&
	                 +1.d0/2.d0*( del_Zh_F(alpha,beta,n)+2.d0*del_ZZ_F(alpha,beta,n) )&
	                 -del_v_F(alpha,beta,n)/vev&
	                 )&
	+2.d0*mz**2/vev*cos(beta-alpha)*(del_beta_F(mA,alpha,beta,n)+del_Ch_F(mbh,alpha,beta,n))
	
	 end function
!--------------------------------------------
  	complex (kind(0d0)) function del_Gam1_hZZ_B(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	del_Gam1_hZZ_B = &
	 2.d0*mz**2/vev*&
	 sin(beta-alpha)*(&
	                 +del_mzsq_B(mch,mA,mbh,bmsq,alpha,beta)/mz**2&
	                 +1.d0/2.d0*( del_Zh_B(mch,mA,mbh,bmsq,alpha,beta)+2.d0*del_ZZ_B(mch,mA,mbh,bmsq,alpha,beta) )&
	                 -del_v_B(mch,mA,mbh,bmsq,alpha,beta)/vev&
	                 )&
	+2.d0*mz**2/vev*cos(beta-alpha)*(del_beta_B(mch,mA,mbh,bmsq,alpha,beta)+del_Ch_B(mch,mA,mbh,bmsq,alpha,beta))

	 end function
!--------------------------------------------
  	complex (kind(0d0)) function del_Gam1_hWW_F(alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta

	del_Gam1_hWW_F = &
	 2.d0*mW**2/vev*&
	 sin(beta-alpha)*(&
	                 +del_mWsq_F(alpha,beta,n)/mW**2&
	                 +1.d0/2.d0*( del_Zh_F(alpha,beta,n)+2.d0*del_ZW_F(alpha,beta,n) )&
	                 -del_v_F(alpha,beta,n)/vev&
	                 )&
	+2.d0*mW**2/vev*cos(beta-alpha)*(del_beta_F(mA,alpha,beta,n)+del_Ch_F(mbh,alpha,beta,n))
	
	 end function
!--------------------------------------------
 	complex (kind(0d0)) function del_Gam1_hWW_B(mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta

	del_Gam1_hWW_B = &
	 2.d0*mW**2/vev*&
	 sin(beta-alpha)*(&
	      +del_mWsq_B(mch,mA,mbh,bmsq,alpha,beta)/mW**2&
	      +1.d0/2.d0*( del_Zh_B(mch,mA,mbh,bmsq,alpha,beta)+2.d0*del_ZW_B(mch,mA,mbh,bmsq,alpha,beta) )&
	      -del_v_B(mch,mA,mbh,bmsq,alpha,beta)/vev&
	                 )&
	+2.d0*mW**2/vev*cos(beta-alpha)*(del_beta_B(mch,mA,mbh,bmsq,alpha,beta)&
	+del_Ch_B(mch,mA,mbh,bmsq,alpha,beta))
	
	 end function
!================================================
!    SECTION V RENORMALIZED HIGGS COUPLINGS     !
!================================================
!==========================================================================================
  	complex (kind(0d0)) function Gam1_hZZ_loop(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)
  	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n
	
	Gam1_hZZ_loop = &
	 +Gam1_hZZ_F(p1sq,p2sq,qsq,alpha,beta,n)&
	 +del_Gam1_hZZ_F(alpha,beta,n)&
	 +Gam1_hZZ_B(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta)&
	 +del_Gam1_hZZ_B(mch,mA,mbh,bmsq,alpha,beta)&
!........ Add the difference between the KOSY scheme and the PT scheme ................
        -mz**2/(vev*mA**2)*cos(beta-alpha)*(PiAG_PT(ma**2,mch,mA,mbh,bmsq,alpha,beta) + PiAG_PT(0.d0,mch,mA,mbh,bmsq,alpha,beta) )

	 end function
!--------------------------------------------
  	complex (kind(0d0)) function rGam1_hZZ(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)
  	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n
	
	rGam1_hZZ =2.d0*mZ**2/vev*sin(beta-alpha) + Gam1_hZZ_loop(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)

	 end function
!--------------------------------------------
	complex (kind(0d0)) function rGam2_hZZ(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

        rGam2_hZZ = Gam2_hzz_F(p1sq,p2sq,qsq,alpha,beta,n) + Gam2_hzz_B(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta) 

	end function
!------------------------------------------------------------------------------------------
	complex (kind(0d0)) function rGam3_hZZ(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

        rGam3_hZZ = Gam3_hzz_F(p1sq,p2sq,qsq,alpha,beta,n) 

	end function
!=========================================================================================
  	complex (kind(0d0)) function Gam1_hWW_loop(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n
!
 	 Gam1_hWW_loop = &
	 +Gam1_hWW_F(p1sq,p2sq,qsq,alpha,beta,n)&
	 +del_Gam1_hWW_F(alpha,beta,n)&
	 +Gam1_hWW_B(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta)&
	 +del_Gam1_hWW_B(mch,mA,mbh,bmsq,alpha,beta)&
!........ Add the difference between the KOSY scheme and the PT scheme ................
        -mw**2/(vev*mA**2)*cos(beta-alpha)*(PiAG_PT(ma**2,mch,mA,mbh,bmsq,alpha,beta) + PiAG_PT(0.d0,mch,mA,mbh,bmsq,alpha,beta) )

	 end function
!------------------------------------------------------------------------------------------
	complex (kind(0d0)) function rGam1_hWW(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	rGam1_hWW = 2.d0*mw**2/vev*sin(beta-alpha) + Gam1_hww_loop(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)

	end function
!------------------------------------------------------------------------------------------
	complex (kind(0d0)) function rGam2_hWW(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

        rGam2_hWW = Gam2_hWW_F(p1sq,p2sq,qsq,alpha,beta,n) + Gam2_hWW_B(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta) 

	end function
!------------------------------------------------------------------------------------------
	complex (kind(0d0)) function rGam3_hWW(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

        rGam3_hWW = Gam3_hWW_F(p1sq,p2sq,qsq,alpha,beta,n) 

	end function
!======================================
	complex (kind(0d0)) function hbb_tree(alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta

	hbb_tree = -mb/vev*xid(alpha,beta,n)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Gam_hbb_loop(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	Gam_hbb_loop =&
	+Fhff_S(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mb)&
	-mb/vev*xid(alpha,beta,n)*(&
	del_mb(mch,mA,mbh,bmsq,alpha,beta,n)/mb-del_v(mch,mA,mbh,bmsq,alpha,beta,n)/vev&
	+del_ZVb(mch,mA,mbh,bmsq,alpha,beta,n)+1.d0/2.d0*del_Zh(mch,mA,mbh,bmsq,alpha,beta,n)&
	+del_xid(mch,mA,mbh,bmsq,alpha,beta,n)/xid(alpha,beta,n)&
	+xid_H(alpha,beta,n)/xid(alpha,beta,n)*(del_Ch(mch,mA,mbh,bmsq,alpha,beta,n)+del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))&
	)&
!........ Add the difference between the KOSY scheme and the PT scheme ................
        -mb/(2.d0*vev*mA**2)*xid(alpha,beta,n)*xid_A(alpha,beta,n)*(&
         PiAG_PT(ma**2,mch,mA,mbh,bmsq,alpha,beta) + PiAG_PT(0.d0,mch,mA,mbh,bmsq,alpha,beta) )

	end function
!---------------------------------------------
	complex (kind(0d0)) function rGamS_hbb(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	rGamS_hbb = hbb_tree(alpha,beta,n) + Gam_hbb_loop(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)

	end function
!======================================================================================
	complex (kind(0d0)) function hcc_tree(alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta

	hcc_tree = -mc/vev*xiu(alpha,beta,n)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Gam_hcc_loop(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	Gam_hcc_loop =&
	+Fhff_S(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mc)&
	-mc/vev*xiu(alpha,beta,n)*(&
	del_mc(mch,mA,mbh,bmsq,alpha,beta,n)/mc-del_v(mch,mA,mbh,bmsq,alpha,beta,n)/vev&
	+del_ZVc(mch,mA,mbh,bmsq,alpha,beta,n)+1.d0/2.d0*del_Zh(mch,mA,mbh,bmsq,alpha,beta,n)&
	+del_xiu(mch,mA,mbh,bmsq,alpha,beta,n)/xiu(alpha,beta,n)&
	+xiu_H(alpha,beta,n)/xiu(alpha,beta,n)*(del_Ch(mch,mA,mbh,bmsq,alpha,beta,n)+del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))&
	)&
!........ Add the difference between the KOSY scheme and the PT scheme ................
        -mc/(2.d0*vev*mA**2)*xiu(alpha,beta,n)*xiu_A(alpha,beta,n)*(&
         PiAG_PT(ma**2,mch,mA,mbh,bmsq,alpha,beta) + PiAG_PT(0.d0,mch,mA,mbh,bmsq,alpha,beta) )

	end function
!---------------------------------------------
	complex (kind(0d0)) function rGamS_hcc(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	rGamS_hcc = hcc_tree(alpha,beta,n) + Gam_hcc_loop(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)

	end function
!====================================================================================================
	complex (kind(0d0)) function htt_tree(alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta

	htt_tree = -mt/vev*xiu(alpha,beta,n)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Gam_htt_loop(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	Gam_htt_loop =&
	+Fhff_S(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mt)&
	-mt/vev*xiu(alpha,beta,n)*(&
	del_mt(mch,mA,mbh,bmsq,alpha,beta,n)/mt-del_v(mch,mA,mbh,bmsq,alpha,beta,n)/vev&
	+del_ZVt(mch,mA,mbh,bmsq,alpha,beta,n)+1.d0/2.d0*del_Zh(mch,mA,mbh,bmsq,alpha,beta,n)&
	+del_xiu(mch,mA,mbh,bmsq,alpha,beta,n)/xiu(alpha,beta,n)&
	+xiu_H(alpha,beta,n)/xiu(alpha,beta,n)*(del_Ch(mch,mA,mbh,bmsq,alpha,beta,n)+del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))&
	)&
!........ Add the difference between the KOSY scheme and the PT scheme ................
       -mt/(2.d0*vev*mA**2)*xiu(alpha,beta,n)*xiu_A(alpha,beta,n)*(&
         PiAG_PT(ma**2,mch,mA,mbh,bmsq,alpha,beta) + PiAG_PT(0.d0,mch,mA,mbh,bmsq,alpha,beta) )

	end function
!-----------------------------------------------------------------------------------
	complex (kind(0d0)) function rGamS_htt(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	rGamS_htt = htt_tree(alpha,beta,n) + Gam_htt_loop(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)

	end function
!==================================================================================
	complex (kind(0d0)) function htautau_tree(alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta

	htautau_tree = -mtau/vev*xil(alpha,beta,n)

	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function Gam_htautau_loop(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	Gam_htautau_loop =&
	+Fhff_S(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mtau)&
	-mtau/vev*xil(alpha,beta,n)*(&
	del_mtau(mch,mA,mbh,bmsq,alpha,beta,n)/mtau&
	-del_v(mch,mA,mbh,bmsq,alpha,beta,n)/vev&
	+del_ZVtau(mch,mA,mbh,bmsq,alpha,beta,n)&
	+1.d0/2.d0*del_Zh(mch,mA,mbh,bmsq,alpha,beta,n)&
	+del_xil(mch,mA,mbh,bmsq,alpha,beta,n)/xil(alpha,beta,n)&
	+xil_H(alpha,beta,n)/xil(alpha,beta,n)*(del_Ch(mch,mA,mbh,bmsq,alpha,beta,n)&
	+del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))&
	)&
!........ Add the difference between the KOSY scheme and the PT scheme ................
        -mtau/(2.d0*vev*mA**2)*xil(alpha,beta,n)*xil_A(alpha,beta,n)*(&
         PiAG_PT(ma**2,mch,mA,mbh,bmsq,alpha,beta) + PiAG_PT(0.d0,mch,mA,mbh,bmsq,alpha,beta) )

	end function
!--------------------------------------------
	complex (kind(0d0)) function rGamS_htautau(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	rGamS_htautau = htautau_tree(alpha,beta,n) + Gam_htautau_loop(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)

	end function
!==========================================================================================
  	complex (kind(0d0)) function Gam_hhh_loop(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

         Gam_hhh_loop = &
	 +Gam_hhh_F(p1sq,p2sq,qsq,alpha,beta,n)&
	 +del_Gam_hhh_F(mch,mA,mbh,bmsq,alpha,beta,n)&
	 +Gam_hhh_B(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta)&
	 +del_Gam_hhh_B(mch,mA,mbh,bmsq,alpha,beta)

	 end function
!--------------------------------------------
	complex (kind(0d0)) function rGam_hhh(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	rGam_hhh = 6.d0*lam_hhh(mch,mA,mbh,bmsq,alpha,beta) &
                       + Gam_hhh_loop(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)

	end function
!=============================================================================
	double precision function Gam_hgamgam(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in):: n
	
	Gam_hgamgam=alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mh**3*&
	ABS(xiu(alpha,beta,n)*Nc*Qt**2*I_f(mh,mt)&
	+xid(alpha,beta,n)*Nc*Qb**2*I_f(mh,mb)&
	+xil(alpha,beta,n)*Qe**2*I_f(mh,mtau)&
	+I_W(mh)*dsin(beta-alpha)&
	-I_S(mh,mch)*lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)/vev&
	)**2

	 end function 
!----------------------------------------
	double precision function Gam_hgg(mch,mA,mbh,bm,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bm,alpha,beta
	integer, intent(in):: n

	Gam_hgg=sqrt(2.d0)*G_F*alpha_s**2*mh**3/(128.d0*pi**3)*&
	ABS(xiu(alpha,beta,n)*I_f(mh,mt)+xid(alpha,beta,n)*I_f(mh,mb))**2

	 end function 
!----------------------------------------
	double precision function Gam_hZgam(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in):: n
	double precision:: g_HpHmZ
	g_HpHmZ=gz/2.d0*(cw**2-sw**2)

	Gam_hZgam=dsqrt(2.d0)*G_F*alpha_em**2*mh**3/(128.d0*pi**3)*&
	(1.d0-mz**2/mh**2)**3*&
	abs(&
	-lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)/vev*g_HpHmZ*J_S(mh,mch)&
	+xiu(alpha,beta,n)*Nc*Qt*vt*J_f(mh,mt)&
	+xid(alpha,beta,n)*Nc*Qb*vb*J_f(mh,mb)&
	+xil(alpha,beta,n)*Qe*ve*J_f(mh,mtau)&
	+sin(beta-alpha)*J_W(mh)&
	)**2

	 end function 
!================================================
!    SECTION VI RGE                             !
!================================================
!--------- g1 ------------------
	double precision function g1(t0,t)
	double precision, intent(in)::  t0,t
	double precision c1

        c1= 20.d0/9.d0*ng+1.d0/6.d0*nh
        g1= gp/sqrt(1.d0-2.d0*c1*gp**2*(t-t0)/(16.d0*pi**2))

	end function
!--------- g2 ------------------
	double precision function g2(t0,t)
	double precision, intent(in)::  t0,t
	double precision c2

        c2=(-22.d0/3.d0+4.d0/3.d0*ng+1.d0/6.d0*nh)
        g2=g/sqrt(1.d0-2.d0*c2*g**2*(t-t0)/(16.d0*pi**2))

	end function
!--------- g3 ------------------
	double precision function g3(t0,t)
	double precision, intent(in)::  t0,t
	double precision c3

        c3=(-11.d0+4.d0/3.d0*ng)
        g3=gs/sqrt(1.d0-2.d0*c3*gs**2*(t-t0)/(16.d0*pi**2))

	end function
!--------- beta(lam1) ------------------
	double precision function beta_lam1(t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision, intent(in)::  t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt

	beta_lam1=1.d0/(16.d0*pi**2)*(&
                    12.d0*vlam1**2&
                    +4.d0*vlam3**2&
                    +2.d0*vlam4**2&
                    +4.d0*vlam3*vlam4&
                    +2.d0*vlam5**2&
                    +9.d0/4.d0*g2(t0,t)**4&
                    +3.d0/4.d0*g1(t0,t)**4&
                    +3.d0/2.d0*g1(t0,t)**2*g2(t0,t)**2&
                    -3.d0*vlam1*(3.d0*g2(t0,t)**2+g1(t0,t)**2)&
                   )

	end function
!--------- beta(lam2) ------------------
	double precision function beta_lam2(t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision, intent(in)::  t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt

	beta_lam2=1.d0/(16.d0*pi**2)*(&
                    12.d0*vlam2**2&
                    +4.d0*vlam3**2&
                    +2.d0*vlam4**2&
                    +4.d0*vlam3*vlam4&
                    +2.d0*vlam5**2&
                    -12.d0*vyt**4&
                    +9.d0/4.d0*g2(t0,t)**4&
                    +3.d0/4.d0*g1(t0,t)**4&
                    +3.d0/2.d0*g1(t0,t)**2*g2(t0,t)**2&
                    -3.d0*vlam2*(3.d0*g2(t0,t)**2+g1(t0,t)**2-4.d0*vyt**2)&
                   )

	end function
!--------- beta(lam3) ------------------
	double precision function beta_lam3(t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision, intent(in)::  t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt

        beta_lam3 = 1.d0/(16.d0*pi**2)*(&
                    2.d0*(vlam1+vlam2)*(3.d0*vlam3+vlam4)&
                    +4.d0*vlam3**2+2.d0*vlam4**2+2.d0*vlam5**2&
                    +9.d0/4.d0*g2(t0,t)**4&
                    +3.d0/4.d0*g1(t0,t)**4&
                    -3.d0/2.d0*g1(t0,t)**2*g2(t0,t)**2&       
                    -3.d0*vlam3*(3.d0*g2(t0,t)**2 +g1(t0,t)**2-2.d0*vyt**2)&
                    )

	end function
!--------- beta(lam4) ------------------
	double precision function beta_lam4(t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision, intent(in)::  t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt

        beta_lam4 = 1.d0/(16.d0*pi**2)*(&
                    2.d0*vlam4*(vlam1+vlam2+4.d0*vlam3+2.d0*vlam4)&
                    +8.d0*vlam5**2&
                    +3.d0*g1(t0,t)**2*g2(t0,t)**2&
                    -3.d0*vlam4*(3.d0*g2(t0,t)**2 +g1(t0,t)**2-2.d0*vyt**2)&
                    )

	end function
!--------- beta(lam5) ------------------
	double precision function beta_lam5(t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision, intent(in)::  t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt

        beta_lam5 = 1.d0/(16.d0*pi**2)*(&
                    2.d0*vlam5*(vlam1+vlam2+4.d0*vlam3+6.d0*vlam4)&
                    -3.d0*vlam5*(3.d0*g2(t0,t)**2 +g1(t0,t)**2-2.d0*vyt**2)&
                    )

	end function
!--------- beta(yt) ------------------
	double precision function beta_yt(t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision, intent(in)::  t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt

        beta_yt = 1.d0/(16.d0*pi**2)*(&
                  +9.d0/2.d0*vyt**3&
                 -vyt*(8.d0*g3(t0,t)**2+9.d0/4.d0*g2(t0,t)**2+17.d0/12.d0*g1(t0,t)**2)&
                 )

	end function
!================================================
!    SECTION VI SUBROOTINES                     !
!================================================
	subroutine RGE(t0,tfin,h,t,no,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision:: rk_lam1(4),rk_lam2(4), rk_lam3(4), rk_lam4(4), rk_lam5(4),rk_yt(4) 
	double precision, intent(in):: t0,tfin,t,h
	double precision :: vlam1,vlam2,vlam3,vlam4,vlam5,vyt
	integer, intent(in):: no
! ----------------------------------------------------------------------------------
           rk_lam1(1)   = beta_lam1  (t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
           rk_lam2(1)   = beta_lam2  (t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
           rk_lam3(1)   = beta_lam3  (t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
           rk_lam4(1)   = beta_lam4  (t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
           rk_lam5(1)   = beta_lam5  (t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
           rk_yt(1)     = beta_yt    (t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
!--------------- STEP 2 ----------------------------------------------------------------------------------
           rk_lam1(2)   = beta_lam1  &
           (t0,t+h/2.d0,vlam1+rk_lam1(1)/2.d0,vlam2+rk_lam2(1)/2.d0,vlam3+rk_lam3(1)/2.d0,vlam4+rk_lam4(1)/2.d0,&
            vlam5+rk_lam5(1)/2.d0,vyt+rk_yt(1)/2.d0)
           rk_lam2(2)   = beta_lam2  &
           (t0,t+h/2.d0,vlam1+rk_lam1(1)/2.d0,vlam2+rk_lam2(1)/2.d0,vlam3+rk_lam3(1)/2.d0,vlam4+rk_lam4(1)/2.d0,&
           vlam5+rk_lam5(1)/2.d0,vyt+rk_yt(1)/2.d0)
           rk_lam3(2)   = beta_lam3  &
           (t0,t+h/2.d0,vlam1+rk_lam1(1)/2.d0,vlam2+rk_lam2(1)/2.d0,vlam3+rk_lam3(1)/2.d0,vlam4+rk_lam4(1)/2.d0,&
           vlam5+rk_lam5(1)/2.d0,vyt+rk_yt(1)/2.d0)
           rk_lam4(2)   = beta_lam4  &
           (t0,t+h/2.d0,vlam1+rk_lam1(1)/2.d0,vlam2+rk_lam2(1)/2.d0,vlam3+rk_lam3(1)/2.d0,vlam4+rk_lam4(1)/2.d0,&
           vlam5+rk_lam5(1)/2.d0,vyt+rk_yt(1)/2.d0)
           rk_lam5(2)   = beta_lam5  &
           (t0,t+h/2.d0,vlam1+rk_lam1(1)/2.d0,vlam2+rk_lam2(1)/2.d0,vlam3+rk_lam3(1)/2.d0,vlam4+rk_lam4(1)/2.d0,&
           vlam5+rk_lam5(1)/2.d0,vyt+rk_yt(1)/2.d0)
           rk_yt  (2)   = beta_yt    &
           (t0,t+h/2.d0,vlam1+rk_lam1(1)/2.d0,vlam2+rk_lam2(1)/2.d0,vlam3+rk_lam3(1)/2.d0,vlam4+rk_lam4(1)/2.d0,&
           vlam5+rk_lam5(1)/2.d0,vyt+rk_yt(1)/2.d0)
!--------------- STEP 3 ----------------------------------------------------------------------------------
           rk_lam1(3)   = beta_lam1  &
           (t0,t+h/2.d0,vlam1+rk_lam1(2)/2.d0,vlam2+rk_lam2(2)/2.d0,vlam3+rk_lam3(2)/2.d0,vlam4+rk_lam4(2)/2.d0,&
           vlam5+rk_lam5(2)/2.d0,vyt+rk_yt(2)/2.d0)
           rk_lam2(3)   = beta_lam2  &
           (t0,t+h/2.d0,vlam1+rk_lam1(2)/2.d0,vlam2+rk_lam2(2)/2.d0,vlam3+rk_lam3(2)/2.d0,vlam4+rk_lam4(2)/2.d0,&
           vlam5+rk_lam5(2)/2.d0,vyt+rk_yt(2)/2.d0)
           rk_lam3(3)   = beta_lam3  &
           (t0,t+h/2.d0,vlam1+rk_lam1(2)/2.d0,vlam2+rk_lam2(2)/2.d0,vlam3+rk_lam3(2)/2.d0,vlam4+rk_lam4(2)/2.d0,&
           vlam5+rk_lam5(2)/2.d0,vyt+rk_yt(2)/2.d0)
           rk_lam4(3)   = beta_lam4  &
           (t0,t+h/2.d0,vlam1+rk_lam1(2)/2.d0,vlam2+rk_lam2(2)/2.d0,vlam3+rk_lam3(2)/2.d0,vlam4+rk_lam4(2)/2.d0,&
           vlam5+rk_lam5(2)/2.d0,vyt+rk_yt(2)/2.d0)
           rk_lam5(3)   = beta_lam5  &
           (t0,t+h/2.d0,vlam1+rk_lam1(2)/2.d0,vlam2+rk_lam2(2)/2.d0,vlam3+rk_lam3(2)/2.d0,vlam4+rk_lam4(2)/2.d0,&
           vlam5+rk_lam5(2)/2.d0,vyt+rk_yt(2)/2.d0)
           rk_yt  (3)   = beta_yt    &
           (t0,t+h/2.d0,vlam1+rk_lam1(2)/2.d0,vlam2+rk_lam2(2)/2.d0,vlam3+rk_lam3(2)/2.d0,vlam4+rk_lam4(2)/2.d0,&
           vlam5+rk_lam5(2)/2.d0,vyt+rk_yt(2)/2.d0)
!--------------- STEP 4 ----------------------------------------------------------------------------------
           rk_lam1(4)   = beta_lam1  &
           (t0,t+h,vlam1+rk_lam1(3),vlam2+rk_lam2(3),vlam3+rk_lam3(3),vlam4+rk_lam4(3),vlam5+rk_lam5(3),vyt+rk_yt(3))
           rk_lam2(4)   = beta_lam2  &
           (t0,t+h,vlam1+rk_lam1(3),vlam2+rk_lam2(3),vlam3+rk_lam3(3),vlam4+rk_lam4(3),vlam5+rk_lam5(3),vyt+rk_yt(3))
           rk_lam3(4)   = beta_lam3  &
           (t0,t+h,vlam1+rk_lam1(3),vlam2+rk_lam2(3),vlam3+rk_lam3(3),vlam4+rk_lam4(3),vlam5+rk_lam5(3),vyt+rk_yt(3))
           rk_lam4(4)   = beta_lam4  &
           (t0,t+h,vlam1+rk_lam1(3),vlam2+rk_lam2(3),vlam3+rk_lam3(3),vlam4+rk_lam4(3),vlam5+rk_lam5(3),vyt+rk_yt(3))
           rk_lam5(4)   = beta_lam5  &
           (t0,t+h,vlam1+rk_lam1(3),vlam2+rk_lam2(3),vlam3+rk_lam3(3),vlam4+rk_lam4(3),vlam5+rk_lam5(3),vyt+rk_yt(3))
           rk_yt(4)     = beta_yt    &
           (t0,t+h,vlam1+rk_lam1(3),vlam2+rk_lam2(3),vlam3+rk_lam3(3),vlam4+rk_lam4(3),vlam5+rk_lam5(3),vyt+rk_yt(3))
!--------------- SUM ----------------------------------------------------------------------------------
           vlam1   = vlam1   + h/6.d0*(rk_lam1(1)   +2.d0*rk_lam1(2)   +2.d0*rk_lam1(3)   + rk_lam1(4))
           vlam2   = vlam2   + h/6.d0*(rk_lam2(1)   +2.d0*rk_lam2(2)   +2.d0*rk_lam2(3)   + rk_lam2(4))
           vlam3   = vlam3   + h/6.d0*(rk_lam3(1)   +2.d0*rk_lam3(2)   +2.d0*rk_lam3(3)   + rk_lam3(4))
           vlam4   = vlam4   + h/6.d0*(rk_lam4(1)   +2.d0*rk_lam4(2)   +2.d0*rk_lam4(3)   + rk_lam4(4))
           vlam5   = vlam5   + h/6.d0*(rk_lam5(1)   +2.d0*rk_lam5(2)   +2.d0*rk_lam5(3)   + rk_lam5(4))
           vyt     = vyt     + h/6.d0*(rk_yt  (1)   +2.d0*rk_yt  (2)   +2.d0*rk_yt  (3)   + rk_yt  (4))
	end subroutine 

	end program HCOUP_THDM

